/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/uri","vs/base/common/errors","vs/base/common/path","vs/platform/log/common/log","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/network","vs/base/common/resources","vs/base/common/arrays","vs/base/common/types","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/common/objects","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/productService","vs/base/common/uuid","vs/base/common/process","os","vs/base/parts/ipc/common/ipc","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/base/common/json","child_process","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/base/common/extpath","vs/base/common/map","vs/platform/product/common/product","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/codicons","vs/base/common/stream","fs","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/userDataSync/common/content","vs/base/common/iterator","net","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/remote/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/normalization","vs/base/common/glob","vs/base/node/decoder","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensions","crypto","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensions/common/extensionHostStarter","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/extensions/node/extensionHostStarter","vs/platform/localizations/node/localizations","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","util","minimist","assert","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],ne=function(J){for(var e=[],R=0,k=J.length;R<k;R++)e[R]=te[J[R]];return e};define(te[96],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function R(k,D){if(!k)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=R}),define(te[65],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const R=Object.prototype.hasOwnProperty;function k(i){const C=[];for(let g in i)R.call(i,g)&&C.push(i[g]);return C}e.values=k;function D(i,C){for(let g in i)if(R.call(i,g)&&C({key:g,value:i[g]},function(){delete i[g]})===!1)return}e.forEach=D;function T(i,C){const g=Object.create(null);for(const E of i){const u=C(E);let p=g[u];p||(p=g[u]=[]),p.push(E)}return g}e.groupBy=T;function L(i){const C=Object.create(null);return i&&i.forEach((g,E)=>{C[E]=g}),C}e.fromMap=L;function P(i,C){const g=[],E=[];for(let u of i)C.has(u)||g.push(u);for(let u of C)i.has(u)||E.push(u);return{removed:g,added:E}}e.diffSets=P;function y(i,C){const g=[],E=[];for(let[u,p]of i)C.has(u)||g.push(p);for(let[u,p]of C)i.has(u)||E.push(p);return{removed:g,added:E}}e.diffMaps=y;class I{constructor(){this.map=new Map}add(C,g){let E=this.map.get(C);E||(E=new Set,this.map.set(C,E)),E.add(g)}delete(C,g){const E=this.map.get(C);!E||(E.delete(g),E.size===0&&this.map.delete(C))}forEach(C,g){const E=this.map.get(C);!E||E.forEach(g)}}e.SetMap=I}),define(te[66],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function R(L){return(P,y,I)=>{let i=null,C=null;if(typeof I.value=="function"?(i="value",C=I.value):typeof I.get=="function"&&(i="get",C=I.get),!C)throw new Error("not supported");I[i]=L(C,y)}}e.createDecorator=R;function k(L,P,y){let I=null,i=null;if(typeof y.value=="function"?(I="value",i=y.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(I="get",i=y.get),!i)throw new Error("not supported");const C=`$memoize$${P}`;y[I]=function(...g){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,g)}),this[C]}}e.memoize=k;function D(L,P,y){return R((I,i)=>{const C=`$debounce$${i}`,g=`$debounce$result$${i}`;return function(...E){this[g]||(this[g]=y?y():void 0),clearTimeout(this[C]),P&&(this[g]=P(this[g],...E),E=[this[g]]),this[C]=setTimeout(()=>{I.apply(this,E),this[g]=y?y():void 0},L)}})}e.debounce=D;function T(L,P,y){return R((I,i)=>{const C=`$throttle$timer$${i}`,g=`$throttle$result$${i}`,E=`$throttle$lastRun$${i}`,u=`$throttle$pending$${i}`;return function(...p){if(this[g]||(this[g]=y?y():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),P&&(this[g]=P(this[g],...p)),this[u])return;const f=this[E]+L;f<=Date.now()?(this[E]=Date.now(),I.apply(this,[this[g]]),this[g]=y?y():void 0):(this[u]=!0,this[C]=setTimeout(()=>{this[u]=!1,this[E]=Date.now(),I.apply(this,[this[g]]),this[g]=y?y():void 0},f-Date.now()))}})}e.throttle=T}),define(te[8],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class R{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(s=>{s(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=R,e.errorHandler=new R;function k(a){e.errorHandler.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=k;function D(a){y(a)||e.errorHandler.onUnexpectedError(a)}e.onUnexpectedError=D;function T(a){y(a)||e.errorHandler.onUnexpectedExternalError(a)}e.onUnexpectedExternalError=T;function L(a){if(a instanceof Error){let{name:t,message:s}=a;const n=a.stacktrace||a.stack;return{$isError:!0,name:t,message:s,stack:n}}return a}e.transformErrorForSerialization=L;const P="Canceled";function y(a){return a instanceof Error&&a.name===P&&a.message===P}e.isPromiseCanceledError=y;class I extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=I;function i(){const a=new Error(P);return a.name=a.message,a}e.canceled=i;function C(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.illegalArgument=C;function g(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.illegalState=g;function E(a){return a?new Error(`readonly property '${a} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=E;function u(a){const t=new Error(`${a} has been disposed`);return t.name="DISPOSED",t}e.disposed=u;function p(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.getErrorMessage=p;class f extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=f;class b extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=b;class v extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=v;function S(a){const t=a;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=S;function c(a,t=Object.create(null)){const s=new Error(a);return t.actions&&(s.actions=t.actions),s}e.createErrorWithActions=c}),define(te[17],ne([0,1,8]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function k(N,W=0){return N[N.length-(1+W)]}e.tail=k;function D(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}e.tail2=D;function T(N,W,X=(Z,B)=>Z===B){if(N===W)return!0;if(!N||!W||N.length!==W.length)return!1;for(let Z=0,B=N.length;Z<B;Z++)if(!X(N[Z],W[Z]))return!1;return!0}e.equals=T;function L(N,W,X){let Z=0,B=N.length-1;for(;Z<=B;){const H=(Z+B)/2|0,ie=X(N[H],W);if(ie<0)Z=H+1;else if(ie>0)B=H-1;else return H}return-(Z+1)}e.binarySearch=L;function P(N,W){let X=0,Z=N.length;if(Z===0)return 0;for(;X<Z;){const B=Math.floor((X+Z)/2);W(N[B])?Z=B:X=B+1}return X}e.findFirstInSorted=P;function y(N,W,X){if(N=N|0,N>=W.length)throw new TypeError("invalid index");let Z=W[Math.floor(W.length*Math.random())],B=[],H=[],ie=[];for(let re of W){const ae=X(re,Z);ae<0?B.push(re):ae>0?H.push(re):ie.push(re)}return N<B.length?y(N,B,X):N<B.length+ie.length?ie[0]:y(N-(B.length+ie.length),H,X)}e.quickSelect=y;function I(N,W){const X=[];let Z;for(const B of N.slice(0).sort(W))!Z||W(Z[0],B)!==0?(Z=[B],X.push(Z)):Z.push(B);return X}e.groupBy=I;function i(N,W,X){const Z=[];function B(re,ae,ue){if(ae===0&&ue.length===0)return;const fe=Z[Z.length-1];fe&&fe.start+fe.deleteCount===re?(fe.deleteCount+=ae,fe.toInsert.push(...ue)):Z.push({start:re,deleteCount:ae,toInsert:ue})}let H=0,ie=0;for(;;){if(H===N.length){B(H,0,W.slice(ie));break}if(ie===W.length){B(H,N.length-H,[]);break}const re=N[H],ae=W[ie],ue=X(re,ae);ue===0?(H+=1,ie+=1):ue<0?(B(H,1,[]),H+=1):ue>0&&(B(H,0,[ae]),ie+=1)}return Z}e.sortedDiff=i;function C(N,W,X){const Z=i(N,W,X),B=[],H=[];for(const ie of Z)B.push(...N.slice(ie.start,ie.start+ie.deleteCount)),H.push(...ie.toInsert);return{removed:B,added:H}}e.delta=C;function g(N,W,X){if(X===0)return[];const Z=N.slice(0,X).sort(W);return u(N,W,Z,X,N.length),Z}e.top=g;function E(N,W,X,Z,B){return X===0?Promise.resolve([]):new Promise((H,ie)=>{(async()=>{const re=N.length,ae=N.slice(0,X).sort(W);for(let ue=X,fe=Math.min(X+Z,re);ue<re;ue=fe,fe=Math.min(fe+Z,re)){if(ue>X&&await new Promise(ge=>setTimeout(ge)),B&&B.isCancellationRequested)throw(0,R.canceled)();u(N,W,ae,ue,fe)}return ae})().then(H,ie)})}e.topAsync=E;function u(N,W,X,Z,B){for(const H=X.length;Z<B;Z++){const ie=N[Z];if(W(ie,X[H-1])<0){X.pop();const re=P(X,ae=>W(ie,ae)<0);X.splice(re,0,ie)}}}function p(N){return N.filter(W=>!!W)}e.coalesce=p;function f(N){let W=0;for(let X=0;X<N.length;X++)N[X]&&(N[W]=N[X],W+=1);N.length=W}e.coalesceInPlace=f;function b(N,W,X){N.splice(X,0,N.splice(W,1)[0])}e.move=b;function v(N){return!Array.isArray(N)||N.length===0}e.isFalsyOrEmpty=v;function S(N){return Array.isArray(N)&&N.length>0}e.isNonEmptyArray=S;function c(N,W){if(!W)return N.filter((Z,B)=>N.indexOf(Z)===B);const X=Object.create(null);return N.filter(Z=>{const B=W(Z);return X[B]?!1:(X[B]=!0,!0)})}e.distinct=c;function a(N){const W=new Set;return N.filter(X=>W.has(X)?!1:(W.add(X),!0))}e.distinctES6=a;function t(N){const W=Object.create(null);return X=>{const Z=N(X);return W[Z]?!1:(W[Z]=!0,!0)}}e.uniqueFilter=t;function s(N,W){const X=n(N,W);if(X!==-1)return N[X]}e.findLast=s;function n(N,W){for(let X=N.length-1;X>=0;X--){const Z=N[X];if(W(Z))return X}return-1}e.lastIndex=n;function r(N,W){return N.length>0?N[0]:W}e.firstOrDefault=r;function o(N,W,X=(Z,B)=>Z===B){let Z=0;for(let B=0,H=Math.min(N.length,W.length);B<H&&X(N[B],W[B]);B++)Z++;return Z}e.commonPrefixLength=o;function l(N){return[].concat(...N)}e.flatten=l;function h(N,W){let X=typeof W=="number"?N:0;typeof W=="number"?X=N:(X=0,W=N);const Z=[];if(X<=W)for(let B=X;B<W;B++)Z.push(B);else for(let B=X;B>W;B--)Z.push(B);return Z}e.range=h;function d(N,W,X){return N.reduce((Z,B)=>(Z[W(B)]=X?X(B):B,Z),Object.create(null))}e.index=d;function m(N,W){return N.push(W),()=>A(N,W)}e.insert=m;function A(N,W){const X=N.indexOf(W);if(X>-1)return N.splice(X,1),W}e.remove=A;function _(N,W,X){const Z=N.slice(0,W),B=N.slice(W);return Z.concat(X,B)}e.arrayInsert=_;function w(N,W){let X;if(typeof W=="number"){let Z=W;X=()=>{const B=Math.sin(Z++)*179426549;return B-Math.floor(B)}}else X=Math.random;for(let Z=N.length-1;Z>0;Z-=1){const B=Math.floor(X()*(Z+1)),H=N[Z];N[Z]=N[B],N[B]=H}}e.shuffle=w;function O(N,W){const X=N.indexOf(W);X>-1&&(N.splice(X,1),N.unshift(W))}e.pushToStart=O;function U(N,W){const X=N.indexOf(W);X>-1&&(N.splice(X,1),N.push(W))}e.pushToEnd=U;function $(N,W){return Array.isArray(N)?N.map(W):W(N)}e.mapArrayOrNot=$;function Y(N){return Array.isArray(N)?N:[N]}e.asArray=Y;function M(N){return N[Math.floor(Math.random()*N.length)]}e.getRandomElement=M;function V(N,W){for(const X of N){const Z=W(X);if(Z!==void 0)return Z}}e.mapFind=V;function j(N,W,X){const Z=q(N,W),B=N.length,H=X.length;N.length=B+H;for(let ie=B-1;ie>=Z;ie--)N[ie+H]=N[ie];for(let ie=0;ie<H;ie++)N[ie+Z]=X[ie]}e.insertInto=j;function z(N,W,X,Z){const B=q(N,W),H=N.splice(B,X);return j(N,B,Z),H}e.splice=z;function q(N,W){return W<0?Math.max(W+N.length,0):Math.min(W,N.length)}function F(N,W){let X=Number.MAX_SAFE_INTEGER,Z=0;return N.forEach((B,H)=>{const ie=W(B);ie<X&&(X=ie,Z=H)}),Z}e.minIndex=F;function G(N,W){let X=Number.MIN_SAFE_INTEGER,Z=0;return N.forEach((B,H)=>{const ie=W(B);ie>X&&(X=ie,Z=H)}),Z}e.maxIndex=G;class x{constructor(W){this.items=W,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(W){let X=this.firstIdx;for(;X<this.items.length&&W(this.items[X]);)X++;const Z=X===this.firstIdx?null:this.items.slice(this.firstIdx,X);return this.firstIdx=X,Z}takeFromEndWhile(W){let X=this.lastIdx;for(;X>=0&&W(this.items[X]);)X--;const Z=X===this.lastIdx?null:this.items.slice(X+1,this.lastIdx+1);return this.lastIdx=X,Z}peek(){return this.items[this.firstIdx]}}e.ArrayQueue=x}),define(te[67],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function R(k){const D=this;let T=!1,L;return function(){return T||(T=!0,L=k.apply(D,arguments)),L}}e.once=R}),define(te[55],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var R;(function(k){function D(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}k.is=D;const T=Object.freeze([]);function L(){return T}k.empty=L;function*P(a){yield a}k.single=P;function y(a){return a||T}k.from=y;function I(a){return!a||a[Symbol.iterator]().next().done===!0}k.isEmpty=I;function i(a){return a[Symbol.iterator]().next().value}k.first=i;function C(a,t){for(const s of a)if(t(s))return!0;return!1}k.some=C;function g(a,t){for(const s of a)if(t(s))return s}k.find=g;function*E(a,t){for(const s of a)t(s)&&(yield s)}k.filter=E;function*u(a,t){let s=0;for(const n of a)yield t(n,s++)}k.map=u;function*p(...a){for(const t of a)for(const s of t)yield s}k.concat=p;function*f(a){for(const t of a)for(const s of t)yield s}k.concatNested=f;function b(a,t,s){let n=s;for(const r of a)n=t(n,r);return n}k.reduce=b;function*v(a,t,s=a.length){for(t<0&&(t+=a.length),s<0?s+=a.length:s>a.length&&(s=a.length);t<s;t++)yield a[t]}k.slice=v;function S(a,t=Number.POSITIVE_INFINITY){const s=[];if(t===0)return[s,a];const n=a[Symbol.iterator]();for(let r=0;r<t;r++){const o=n.next();if(o.done)return[s,k.empty()];s.push(o.value)}return[s,{[Symbol.iterator](){return n}}]}k.consume=S;function c(a,t,s=(n,r)=>n===r){const n=a[Symbol.iterator](),r=t[Symbol.iterator]();for(;;){const o=n.next(),l=r.next();if(o.done!==l.done)return!1;if(o.done)return!0;if(!s(o.value,l.value))return!1}}k.equals=c})(R=e.Iterable||(e.Iterable={}))}),define(te[36],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var R;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(R=e.ScanError||(e.ScanError={}));var k;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(k=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function L(t,s=!1){let n=0,r=t.length,o="",l=0,h=16,d=0;function m(Y){let M=0,V=0;for(;M<Y;){const j=t.charCodeAt(n);if(j>=48&&j<=57)V=V*16+j-48;else if(j>=65&&j<=70)V=V*16+j-65+10;else if(j>=97&&j<=102)V=V*16+j-97+10;else break;n++,M++}return M<Y&&(V=-1),V}function A(Y){n=Y,o="",l=0,h=16,d=0}function _(){const Y=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&I(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&I(t.charCodeAt(n)))for(n++;n<t.length&&I(t.charCodeAt(n));)n++;else return d=3,t.substring(Y,n);let M=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&I(t.charCodeAt(n))){for(n++;n<t.length&&I(t.charCodeAt(n));)n++;M=n}else d=3;return t.substring(Y,M)}function w(){let Y="",M=n;for(;;){if(n>=r){Y+=t.substring(M,n),d=2;break}const V=t.charCodeAt(n);if(V===34){Y+=t.substring(M,n),n++;break}if(V===92){if(Y+=t.substring(M,n),n++,n>=r){d=2;break}switch(t.charCodeAt(n++)){case 34:Y+='"';break;case 92:Y+="\\";break;case 47:Y+="/";break;case 98:Y+="\b";break;case 102:Y+="\f";break;case 110:Y+=`
`;break;case 114:Y+="\r";break;case 116:Y+="	";break;case 117:const z=m(4);z>=0?Y+=String.fromCharCode(z):d=4;break;default:d=5}M=n;continue}if(V>=0&&V<=31)if(y(V)){Y+=t.substring(M,n),d=2;break}else d=6;n++}return Y}function O(){if(o="",d=0,l=n,n>=r)return l=r,h=17;let Y=t.charCodeAt(n);if(P(Y)){do n++,o+=String.fromCharCode(Y),Y=t.charCodeAt(n);while(P(Y));return h=15}if(y(Y))return n++,o+=String.fromCharCode(Y),Y===13&&t.charCodeAt(n)===10&&(n++,o+=`
`),h=14;switch(Y){case 123:return n++,h=1;case 125:return n++,h=2;case 91:return n++,h=3;case 93:return n++,h=4;case 58:return n++,h=6;case 44:return n++,h=5;case 34:return n++,o=w(),h=10;case 47:const M=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<r&&!y(t.charCodeAt(n));)n++;return o=t.substring(M,n),h=12}if(t.charCodeAt(n+1)===42){n+=2;const V=r-1;let j=!1;for(;n<V;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,j=!0;break}n++}return j||(n++,d=1),o=t.substring(M,n),h=13}return o+=String.fromCharCode(Y),n++,h=16;case 45:if(o+=String.fromCharCode(Y),n++,n===r||!I(t.charCodeAt(n)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=_(),h=11;default:for(;n<r&&U(Y);)n++,Y=t.charCodeAt(n);if(l!==n){switch(o=t.substring(l,n),o){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return o+=String.fromCharCode(Y),n++,h=16}}function U(Y){if(P(Y)||y(Y))return!1;switch(Y){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function $(){let Y;do Y=O();while(Y>=12&&Y<=15);return Y}return{setPosition:A,getPosition:()=>n,scan:s?$:O,getToken:()=>h,getTokenValue:()=>o,getTokenOffset:()=>l,getTokenLength:()=>n-l,getTokenError:()=>d}}e.createScanner=L;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function I(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function C(t,s){const n=[],r=new Object;let o;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function d(m,A,_,w){l.value=m,l.offset=A,l.length=_,l.type=w,l.colonOffset=void 0,o=l}try{S(t,{onObjectBegin:(m,A)=>{if(s<=m)throw r;o=void 0,h=s>m,n.push("")},onObjectProperty:(m,A,_)=>{if(s<A||(d(m,A,_,"property"),n[n.length-1]=m,s<=A+_))throw r},onObjectEnd:(m,A)=>{if(s<=m)throw r;o=void 0,n.pop()},onArrayBegin:(m,A)=>{if(s<=m)throw r;o=void 0,n.push(0)},onArrayEnd:(m,A)=>{if(s<=m)throw r;o=void 0,n.pop()},onLiteralValue:(m,A,_)=>{if(s<A||(d(m,A,_,a(m)),s<=A+_))throw r},onSeparator:(m,A,_)=>{if(s<=A)throw r;if(m===":"&&o&&o.type==="property")o.colonOffset=A,h=!1,o=void 0;else if(m===","){const w=n[n.length-1];typeof w=="number"?n[n.length-1]=w+1:(h=!0,n[n.length-1]=""),o=void 0}}})}catch(m){if(m!==r)throw m}return{path:n,previousNode:o,isAtPropertyKey:h,matches:m=>{let A=0;for(let _=0;A<m.length&&_<n.length;_++)if(m[A]===n[_]||m[A]==="*")A++;else if(m[A]!=="**")return!1;return A===m.length}}}e.getLocation=C;function g(t,s=[],n=T.DEFAULT){let r=null,o=[];const l=[];function h(m){Array.isArray(o)?o.push(m):r!==null&&(o[r]=m)}return S(t,{onObjectBegin:()=>{const m={};h(m),l.push(o),o=m,r=null},onObjectProperty:m=>{r=m},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{const m=[];h(m),l.push(o),o=m,r=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:h,onError:(m,A,_)=>{s.push({error:m,offset:A,length:_})}},n),o[0]}e.parse=g;function E(t,s=[],n=T.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(m){r.type==="property"&&(r.length=m-r.offset,r=r.parent)}function l(m){return r.children.push(m),m}S(t,{onObjectBegin:m=>{r=l({type:"object",offset:m,length:-1,parent:r,children:[]})},onObjectProperty:(m,A,_)=>{r=l({type:"property",offset:A,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:m,offset:A,length:_,parent:r})},onObjectEnd:(m,A)=>{r.length=m+A-r.offset,r=r.parent,o(m+A)},onArrayBegin:(m,A)=>{r=l({type:"array",offset:m,length:-1,parent:r,children:[]})},onArrayEnd:(m,A)=>{r.length=m+A-r.offset,r=r.parent,o(m+A)},onLiteralValue:(m,A,_)=>{l({type:a(m),offset:A,length:_,parent:r,value:m}),o(A+_)},onSeparator:(m,A,_)=>{r.type==="property"&&(m===":"?r.colonOffset=A:m===","&&o(A))},onError:(m,A,_)=>{s.push({error:m,offset:A,length:_})}},n);const d=r.children[0];return d&&delete d.parent,d}e.parseTree=E;function u(t,s){if(!t)return;let n=t;for(let r of s)if(typeof r=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let o=!1;for(const l of n.children)if(Array.isArray(l.children)&&l.children[0].value===r){n=l.children[1],o=!0;break}if(!o)return}else{const o=r;if(n.type!=="array"||o<0||!Array.isArray(n.children)||o>=n.children.length)return;n=n.children[o]}return n}e.findNodeAtLocation=u;function p(t){if(!t.parent||!t.parent.children)return[];const s=p(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;s.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&s.push(n)}return s}e.getNodePath=p;function f(t){switch(t.type){case"array":return t.children.map(f);case"object":const s=Object.create(null);for(let n of t.children){const r=n.children[1];r&&(s[n.children[0].value]=f(r))}return s;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=f;function b(t,s,n=!1){return s>=t.offset&&s<t.offset+t.length||n&&s===t.offset+t.length}e.contains=b;function v(t,s,n=!1){if(b(t,s,n)){const r=t.children;if(Array.isArray(r))for(let o=0;o<r.length&&r[o].offset<=s;o++){const l=v(r[o],s,n);if(l)return l}return t}}e.findNodeAtOffset=v;function S(t,s,n=T.DEFAULT){const r=L(t,!1);function o(W){return W?()=>W(r.getTokenOffset(),r.getTokenLength()):()=>!0}function l(W){return W?X=>W(X,r.getTokenOffset(),r.getTokenLength()):()=>!0}const h=o(s.onObjectBegin),d=l(s.onObjectProperty),m=o(s.onObjectEnd),A=o(s.onArrayBegin),_=o(s.onArrayEnd),w=l(s.onLiteralValue),O=l(s.onSeparator),U=o(s.onComment),$=l(s.onError),Y=n&&n.disallowComments,M=n&&n.allowTrailingComma;function V(){for(;;){const W=r.scan();switch(r.getTokenError()){case 4:j(14);break;case 5:j(15);break;case 3:j(13);break;case 1:Y||j(11);break;case 2:j(12);break;case 6:j(16);break}switch(W){case 12:case 13:Y?j(10):U();break;case 16:j(1);break;case 15:case 14:break;default:return W}}}function j(W,X=[],Z=[]){if($(W),X.length+Z.length>0){let B=r.getToken();for(;B!==17;){if(X.indexOf(B)!==-1){V();break}else if(Z.indexOf(B)!==-1)break;B=V()}}}function z(W){const X=r.getTokenValue();return W?w(X):d(X),V(),!0}function q(){switch(r.getToken()){case 11:let W=0;try{W=JSON.parse(r.getTokenValue()),typeof W!="number"&&(j(2),W=0)}catch(X){j(2)}w(W);break;case 7:w(null);break;case 8:w(!0);break;case 9:w(!1);break;default:return!1}return V(),!0}function F(){return r.getToken()!==10?(j(3,[],[2,5]),!1):(z(!1),r.getToken()===6?(O(":"),V(),N()||j(4,[],[2,5])):j(5,[],[2,5]),!0)}function G(){h(),V();let W=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(W||j(4,[],[]),O(","),V(),r.getToken()===2&&M)break}else W&&j(6,[],[]);F()||j(4,[],[2,5]),W=!0}return m(),r.getToken()!==2?j(7,[2],[]):V(),!0}function x(){A(),V();let W=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(W||j(4,[],[]),O(","),V(),r.getToken()===4&&M)break}else W&&j(6,[],[]);N()||j(4,[],[4,5]),W=!0}return _(),r.getToken()!==4?j(8,[4],[]):V(),!0}function N(){switch(r.getToken()){case 3:return x();case 1:return G();case 10:return z(!0);default:return q()}}return V(),r.getToken()===17?n.allowEmptyContent?!0:(j(4,[],[]),!1):N()?(r.getToken()!==17&&j(9,[],[]),!0):(j(4,[],[]),!1)}e.visit=S;function c(t,s){let n=L(t),r=[],o,l=0,h;do switch(h=n.getPosition(),o=n.scan(),o){case 12:case 13:case 17:l!==h&&r.push(t.substring(l,h)),s!==void 0&&r.push(n.getTokenValue().replace(/[^\r\n]/g,s)),l=n.getPosition();break}while(o!==17);return r.join("")}e.stripComments=c;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=a}),define(te[48],ne([0,1,36]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function k(y,I,i){let C,g,E,u,p;if(I){for(u=I.offset,p=u+I.length,E=u;E>0&&!P(y,E-1);)E--;let l=p;for(;l<y.length&&!P(y,l);)l++;g=y.substring(E,l),C=T(g,i)}else g=y,C=0,E=0,u=0,p=y.length;const f=L(i,y);let b=!1,v=0,S;i.insertSpaces?S=D(" ",i.tabSize||4):S="	";const c=(0,R.createScanner)(g,!1);let a=!1;function t(){return f+D(S,C+v)}function s(){let l=c.scan();for(b=!1;l===15||l===14;)b=b||l===14,l=c.scan();return a=l===16||c.getTokenError()!==0,l}const n=[];function r(l,h,d){!a&&h<p&&d>u&&y.substring(h,d)!==l&&n.push({offset:h,length:d-h,content:l})}let o=s();if(o!==17){const l=c.getTokenOffset()+E,h=D(S,C);r(h,E,l)}for(;o!==17;){let l=c.getTokenOffset()+c.getTokenLength()+E,h=s(),d="";for(;!b&&(h===12||h===13);){const A=c.getTokenOffset()+E;r(" ",l,A),l=c.getTokenOffset()+c.getTokenLength()+E,d=h===12?t():"",h=s()}if(h===2)o!==1&&(v--,d=t());else if(h===4)o!==3&&(v--,d=t());else{switch(o){case 3:case 1:v++,d=t();break;case 5:case 12:d=t();break;case 13:b?d=t():d=" ";break;case 6:d=" ";break;case 10:if(h===6){d="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?d=" ":h!==5&&h!==17&&(a=!0);break;case 16:a=!0;break}b&&(h===12||h===13)&&(d=t())}const m=c.getTokenOffset()+E;r(d,l,m),o=h}return n}e.format=k;function D(y,I){let i="";for(let C=0;C<I;C++)i+=y;return i}function T(y,I){let i=0,C=0;const g=I.tabSize||4;for(;i<y.length;){const E=y.charAt(i);if(E===" ")C++;else if(E==="	")C+=g;else break;i++}return Math.floor(C/g)}function L(y,I){for(let i=0;i<I.length;i++){const C=I.charAt(i);if(C==="\r")return i+1<I.length&&I.charAt(i+1)===`
`?`\r
`:"\r";if(C===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=L;function P(y,I){return`\r
`.indexOf(y.charAt(I))!==-1}e.isEOL=P}),define(te[44],ne([0,1,36,48]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(I,i,C){return T(I,i,void 0,C)}e.removeProperty=D;function T(I,i,C,g,E){const u=i.slice(),p=[],f=(0,R.parseTree)(I,p);let b,v;for(;u.length>0&&(v=u.pop(),b=(0,R.findNodeAtLocation)(f,u),b===void 0&&C!==void 0);)typeof v=="string"?C={[v]:C}:C=[C];if(b)if(b.type==="object"&&typeof v=="string"&&Array.isArray(b.children)){const S=(0,R.findNodeAtLocation)(b,[v]);if(S!==void 0)if(C===void 0){if(!S.parent)throw new Error("Malformed AST");const c=b.children.indexOf(S.parent);let a,t=S.parent.offset+S.parent.length;if(c>0){const s=b.children[c-1];a=s.offset+s.length}else a=b.offset+1,b.children.length>1&&(t=b.children[1].offset);return L(I,{offset:a,length:t-a,content:""},g)}else return L(I,{offset:S.offset,length:S.length,content:JSON.stringify(C)},g);else{if(C===void 0)return[];const c=`${JSON.stringify(v)}: ${JSON.stringify(C)}`,a=E?E(b.children.map(s=>s.children[0].value)):b.children.length;let t;if(a>0){const s=b.children[a-1];t={offset:s.offset+s.length,length:0,content:","+c}}else b.children.length===0?t={offset:b.offset+1,length:0,content:c}:t={offset:b.offset+1,length:0,content:c+","};return L(I,t,g)}}else if(b.type==="array"&&typeof v=="number"&&Array.isArray(b.children))if(C!==void 0){const S=`${JSON.stringify(C)}`;let c;if(b.children.length===0||v===0)c={offset:b.offset+1,length:0,content:b.children.length===0?S:S+","};else{const a=v===-1||v>b.children.length?b.children.length:v,t=b.children[a-1];c={offset:t.offset+t.length,length:0,content:","+S}}return L(I,c,g)}else{const S=v,c=b.children[S];let a;if(b.children.length===1)a={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===S){const t=b.children[S-1],s=t.offset+t.length,n=b.offset+b.length;a={offset:s,length:n-2-s,content:""}}else a={offset:c.offset,length:b.children[S+1].offset-c.offset,content:""};return L(I,a,g)}else throw new Error(`Can not add ${typeof v!="number"?"index":"property"} to parent of type ${b.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return L(I,{offset:f?f.offset:0,length:f?f.length:0,content:JSON.stringify(C)},g)}}e.setProperty=T;function L(I,i,C){let g=P(I,i),E=i.offset,u=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;E>0&&!(0,k.isEOL)(g,E-1);)E--;for(;u<g.length&&!(0,k.isEOL)(g,u);)u++}const p=(0,k.format)(g,{offset:E,length:u-E},C);for(let b=p.length-1;b>=0;b--){const v=p[b];g=P(g,v),E=Math.min(E,v.offset),u=Math.max(u,v.offset+v.length),u+=v.content.length-v.length}const f=I.length-(g.length-u)-E;return[{offset:E,length:f,content:g.substring(E,u)}]}e.withFormatting=L;function P(I,i){return I.substring(0,i.offset)+i.content+I.substring(i.offset+i.length)}e.applyEdit=P;function y(I,i){let C=i.slice(0).sort((E,u)=>{const p=E.offset-u.offset;return p===0?E.length-u.length:p}),g=I.length;for(let E=C.length-1;E>=0;E--){let u=C[E];if(u.offset+u.length<=g)I=P(I,u);else throw new Error("Overlapping edit");g=u.offset}return I}e.applyEdits=y}),define(te[2],ne([0,1,67,55]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let T=null;function L(r){T=r}if(e.setDisposableTracker=L,D){const r="__is_disposable_tracked__";L(new class{trackDisposable(o){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[r]||console.log(l)},3e3)}setParent(o,l){if(o&&o!==v.None)try{o[r]=!0}catch{}}markAsDisposed(o){if(o&&o!==v.None)try{o[r]=!0}catch{}}markAsSingleton(o){}})}function P(r){return T?.trackDisposable(r),r}function y(r){T?.markAsDisposed(r)}function I(r,o){T?.setParent(r,o)}function i(r,o){if(!!T)for(const l of r)T.setParent(l,o)}function C(r){return T?.markAsSingleton(r),r}e.markAsSingleton=C;class g extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=g;function E(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=E;function u(r){if(k.Iterable.is(r)){let o=[];for(const l of r)if(l)try{l.dispose()}catch(h){o.push(h)}if(o.length===1)throw o[0];if(o.length>1)throw new g(o);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=u;function p(...r){const o=f(()=>u(r));return i(r,o),o}e.combinedDisposable=p;function f(r){const o=P({dispose:(0,R.once)(()=>{y(o),r()})});return o}e.toDisposable=f;class b{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(y(this),this._isDisposed=!0,this.clear())}clear(){try{u(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return I(o,this),this._isDisposed?b.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=b,b.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this._store=new b,P(this),I(this._store,this)}dispose(){y(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=v,v.None=Object.freeze({dispose(){}});class S{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&I(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,y(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&I(o,null),o}}e.MutableDisposable=S;class c{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class a{constructor(){this.references=new Map}acquire(o,...l){let h=this.references.get(o);h||(h={counter:0,object:this.createReferencedObject(o,...l)},this.references.set(o,h));const{object:d}=h,m=(0,R.once)(()=>{--h.counter==0&&(this.destroyReferencedObject(o,h.object),this.references.delete(o))});return h.counter++,{object:d,dispose:m}}}e.ReferenceCollection=a;class t{constructor(o){this.referenceCollection=o}async acquire(o,...l){const h=this.referenceCollection.acquire(o,...l);try{return{object:await h.object,dispose:()=>h.dispose()}}catch(d){throw h.dispose(),d}}}e.AsyncReferenceCollection=t;class s{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=s;function n(r){const o=new b;try{r(o)}finally{o.dispose()}}e.disposeOnReturn=n}),define(te[97],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class R{constructor(T){this.element=T,this.next=R.Undefined,this.prev=R.Undefined}}R.Undefined=new R(void 0);class k{constructor(){this._first=R.Undefined,this._last=R.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===R.Undefined}clear(){let T=this._first;for(;T!==R.Undefined;){const L=T.next;T.prev=R.Undefined,T.next=R.Undefined,T=L}this._first=R.Undefined,this._last=R.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,L){const P=new R(T);if(this._first===R.Undefined)this._first=P,this._last=P;else if(L){const I=this._last;this._last=P,P.prev=I,I.next=P}else{const I=this._first;this._first=P,P.next=I,I.prev=P}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(P))}}shift(){if(this._first!==R.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==R.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==R.Undefined&&T.next!==R.Undefined){const L=T.prev;L.next=T.next,T.next.prev=L}else T.prev===R.Undefined&&T.next===R.Undefined?(this._first=R.Undefined,this._last=R.Undefined):T.next===R.Undefined?(this._last=this._last.prev,this._last.next=R.Undefined):T.prev===R.Undefined&&(this._first=this._first.next,this._first.prev=R.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==R.Undefined;)yield T.element,T=T.next}}e.LinkedList=k}),function(){function J(D){const T=[];typeof D=="number"&&T.push("code/timeOrigin",D);function L(y){T.push(y,Date.now())}function P(){const y=[];for(let I=0;I<T.length;I+=2)y.push({name:T[I],startTime:T[I+1]});return y}return{mark:L,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const L of performance.getEntriesByType("mark"))T.push({name:L.name,startTime:Math.round(D+L.startTime)});return T}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function R(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var k;typeof global=="object"?k=global:typeof self=="object"?k=self:k={},typeof define=="function"?define("vs/base/common/performance",[],function(){return R(k)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=R(k):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),k.perf=R(k))}(),define(te[4],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const R="en";let k=!1,D=!1,T=!1,L=!1,P=!1,y=!1,I=!1,i,C=R,g,E;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?u=e.globals.vscode.process:typeof process!="undefined"&&(u=process);const p=typeof u?.versions?.electron=="string"&&u.type==="renderer";if(e.isElectronSandboxed=p&&u?.sandboxed,typeof navigator=="object"&&!p)E=navigator.userAgent,k=E.indexOf("Windows")>=0,D=E.indexOf("Macintosh")>=0,I=(E.indexOf("Macintosh")>=0||E.indexOf("iPad")>=0||E.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=E.indexOf("Linux")>=0,y=!0,i=navigator.language,C=i;else if(typeof u=="object"){k=u.platform==="win32",D=u.platform==="darwin",T=u.platform==="linux",L=T&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,i=R,C=R;const n=u.env.VSCODE_NLS_CONFIG;if(n)try{const r=JSON.parse(n),o=r.availableLanguages["*"];i=r.locale,C=o||R,g=r._translationsConfigFile}catch(r){}P=!0}else console.error("Unable to resolve platform.");var f;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(f=e.Platform||(e.Platform={}));function b(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let v=0;D?v=1:k?v=3:T&&(v=2),e.isWindows=k,e.isMacintosh=D,e.isLinux=T,e.isLinuxSnap=L,e.isNative=P,e.isWeb=y,e.isIOS=I,e.platform=v,e.userAgent=E,e.language=C;var S;(function(n){function r(){return e.language}n.value=r;function o(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=o;function l(){return e.language==="en"}n.isDefault=l})(S=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=g,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let o=[];e.globals.addEventListener("message",h=>{if(h.data&&h.data.vscodeSetImmediateId)for(let d=0,m=o.length;d<m;d++){const A=o[d];if(A.id===h.data.vscodeSetImmediateId){o.splice(d,1),A.callback();return}}});let l=0;return h=>{const d=++l;o.push({id:d,callback:h}),e.globals.postMessage({vscodeSetImmediateId:d},"*")}}if(typeof u?.nextTick=="function")return u.nextTick.bind(u);const r=Promise.resolve();return o=>r.then(o)}();var c;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(c=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||I?2:k?1:3;let a=!0,t=!1;function s(){if(!t){t=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,a=new Uint16Array(n.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=s}),define(te[31],ne([0,1,4]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let k;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.process!="undefined"){const D=R.globals.vscode.process;k={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()},nextTick(T){return(0,R.setImmediate)(T)}}}else typeof process!="undefined"?k={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}}:k={get platform(){return R.isWindows?"win32":R.isMacintosh?"darwin":"linux"},get arch(){},nextTick(D){return(0,R.setImmediate)(D)},get env(){return{}},cwd(){return"/"}};e.cwd=k.cwd,e.env=k.env,e.platform=k.platform,e.nextTick=k.nextTick,e.arch=k.arch}),define(te[9],ne([0,1,31]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const k=65,D=97,T=90,L=122,P=46,y=47,I=92,i=58,C=63;class g extends Error{constructor(c,a,t){let s;typeof a=="string"&&a.indexOf("not ")===0?(s="must not be",a=a.replace(/^not /,"")):s="must be";const n=c.indexOf(".")!==-1?"property":"argument";let r=`The "${c}" ${n} ${s} of type ${a}`;r+=`. Received type ${typeof t}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function E(S,c){if(typeof S!="string")throw new g(c,"string",S)}function u(S){return S===y||S===I}function p(S){return S===y}function f(S){return S>=k&&S<=T||S>=D&&S<=L}function b(S,c,a,t){let s="",n=0,r=-1,o=0,l=0;for(let h=0;h<=S.length;++h){if(h<S.length)l=S.charCodeAt(h);else{if(t(l))break;l=y}if(t(l)){if(!(r===h-1||o===1))if(o===2){if(s.length<2||n!==2||s.charCodeAt(s.length-1)!==P||s.charCodeAt(s.length-2)!==P){if(s.length>2){const d=s.lastIndexOf(a);d===-1?(s="",n=0):(s=s.slice(0,d),n=s.length-1-s.lastIndexOf(a)),r=h,o=0;continue}else if(s.length!==0){s="",n=0,r=h,o=0;continue}}c&&(s+=s.length>0?`${a}..`:"..",n=2)}else s.length>0?s+=`${a}${S.slice(r+1,h)}`:s=S.slice(r+1,h),n=h-r-1;r=h,o=0}else l===P&&o!==-1?++o:o=-1}return s}function v(S,c){if(c===null||typeof c!="object")throw new g("pathObject","Object",c);const a=c.dir||c.root,t=c.base||`${c.name||""}${c.ext||""}`;return a?a===c.root?`${a}${t}`:`${a}${S}${t}`:t}e.win32={resolve(...S){let c="",a="",t=!1;for(let s=S.length-1;s>=-1;s--){let n;if(s>=0){if(n=S[s],E(n,"path"),n.length===0)continue}else c.length===0?n=R.cwd():(n=R.env[`=${c}`]||R.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==c.toLowerCase()&&n.charCodeAt(2)===I)&&(n=`${c}\\`));const r=n.length;let o=0,l="",h=!1;const d=n.charCodeAt(0);if(r===1)u(d)&&(o=1,h=!0);else if(u(d))if(h=!0,u(n.charCodeAt(1))){let m=2,A=m;for(;m<r&&!u(n.charCodeAt(m));)m++;if(m<r&&m!==A){const _=n.slice(A,m);for(A=m;m<r&&u(n.charCodeAt(m));)m++;if(m<r&&m!==A){for(A=m;m<r&&!u(n.charCodeAt(m));)m++;(m===r||m!==A)&&(l=`\\\\${_}\\${n.slice(A,m)}`,o=m)}}}else o=1;else f(d)&&n.charCodeAt(1)===i&&(l=n.slice(0,2),o=2,r>2&&u(n.charCodeAt(2))&&(h=!0,o=3));if(l.length>0)if(c.length>0){if(l.toLowerCase()!==c.toLowerCase())continue}else c=l;if(t){if(c.length>0)break}else if(a=`${n.slice(o)}\\${a}`,t=h,h&&c.length>0)break}return a=b(a,!t,"\\",u),t?`${c}\\${a}`:`${c}${a}`||"."},normalize(S){E(S,"path");const c=S.length;if(c===0)return".";let a=0,t,s=!1;const n=S.charCodeAt(0);if(c===1)return p(n)?"\\":S;if(u(n))if(s=!0,u(S.charCodeAt(1))){let o=2,l=o;for(;o<c&&!u(S.charCodeAt(o));)o++;if(o<c&&o!==l){const h=S.slice(l,o);for(l=o;o<c&&u(S.charCodeAt(o));)o++;if(o<c&&o!==l){for(l=o;o<c&&!u(S.charCodeAt(o));)o++;if(o===c)return`\\\\${h}\\${S.slice(l)}\\`;o!==l&&(t=`\\\\${h}\\${S.slice(l,o)}`,a=o)}}}else a=1;else f(n)&&S.charCodeAt(1)===i&&(t=S.slice(0,2),a=2,c>2&&u(S.charCodeAt(2))&&(s=!0,a=3));let r=a<c?b(S.slice(a),!s,"\\",u):"";return r.length===0&&!s&&(r="."),r.length>0&&u(S.charCodeAt(c-1))&&(r+="\\"),t===void 0?s?`\\${r}`:r:s?`${t}\\${r}`:`${t}${r}`},isAbsolute(S){E(S,"path");const c=S.length;if(c===0)return!1;const a=S.charCodeAt(0);return u(a)||c>2&&f(a)&&S.charCodeAt(1)===i&&u(S.charCodeAt(2))},join(...S){if(S.length===0)return".";let c,a;for(let n=0;n<S.length;++n){const r=S[n];E(r,"path"),r.length>0&&(c===void 0?c=a=r:c+=`\\${r}`)}if(c===void 0)return".";let t=!0,s=0;if(typeof a=="string"&&u(a.charCodeAt(0))){++s;const n=a.length;n>1&&u(a.charCodeAt(1))&&(++s,n>2&&(u(a.charCodeAt(2))?++s:t=!1))}if(t){for(;s<c.length&&u(c.charCodeAt(s));)s++;s>=2&&(c=`\\${c.slice(s)}`)}return e.win32.normalize(c)},relative(S,c){if(E(S,"from"),E(c,"to"),S===c)return"";const a=e.win32.resolve(S),t=e.win32.resolve(c);if(a===t||(S=a.toLowerCase(),c=t.toLowerCase(),S===c))return"";let s=0;for(;s<S.length&&S.charCodeAt(s)===I;)s++;let n=S.length;for(;n-1>s&&S.charCodeAt(n-1)===I;)n--;const r=n-s;let o=0;for(;o<c.length&&c.charCodeAt(o)===I;)o++;let l=c.length;for(;l-1>o&&c.charCodeAt(l-1)===I;)l--;const h=l-o,d=r<h?r:h;let m=-1,A=0;for(;A<d;A++){const w=S.charCodeAt(s+A);if(w!==c.charCodeAt(o+A))break;w===I&&(m=A)}if(A!==d){if(m===-1)return t}else{if(h>d){if(c.charCodeAt(o+A)===I)return t.slice(o+A+1);if(A===2)return t.slice(o+A)}r>d&&(S.charCodeAt(s+A)===I?m=A:A===2&&(m=3)),m===-1&&(m=0)}let _="";for(A=s+m+1;A<=n;++A)(A===n||S.charCodeAt(A)===I)&&(_+=_.length===0?"..":"\\..");return o+=m,_.length>0?`${_}${t.slice(o,l)}`:(t.charCodeAt(o)===I&&++o,t.slice(o,l))},toNamespacedPath(S){if(typeof S!="string")return S;if(S.length===0)return"";const c=e.win32.resolve(S);if(c.length<=2)return S;if(c.charCodeAt(0)===I){if(c.charCodeAt(1)===I){const a=c.charCodeAt(2);if(a!==C&&a!==P)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(f(c.charCodeAt(0))&&c.charCodeAt(1)===i&&c.charCodeAt(2)===I)return`\\\\?\\${c}`;return S},dirname(S){E(S,"path");const c=S.length;if(c===0)return".";let a=-1,t=0;const s=S.charCodeAt(0);if(c===1)return u(s)?S:".";if(u(s)){if(a=t=1,u(S.charCodeAt(1))){let o=2,l=o;for(;o<c&&!u(S.charCodeAt(o));)o++;if(o<c&&o!==l){for(l=o;o<c&&u(S.charCodeAt(o));)o++;if(o<c&&o!==l){for(l=o;o<c&&!u(S.charCodeAt(o));)o++;if(o===c)return S;o!==l&&(a=t=o+1)}}}}else f(s)&&S.charCodeAt(1)===i&&(a=c>2&&u(S.charCodeAt(2))?3:2,t=a);let n=-1,r=!0;for(let o=c-1;o>=t;--o)if(u(S.charCodeAt(o))){if(!r){n=o;break}}else r=!1;if(n===-1){if(a===-1)return".";n=a}return S.slice(0,n)},basename(S,c){c!==void 0&&E(c,"ext"),E(S,"path");let a=0,t=-1,s=!0,n;if(S.length>=2&&f(S.charCodeAt(0))&&S.charCodeAt(1)===i&&(a=2),c!==void 0&&c.length>0&&c.length<=S.length){if(c===S)return"";let r=c.length-1,o=-1;for(n=S.length-1;n>=a;--n){const l=S.charCodeAt(n);if(u(l)){if(!s){a=n+1;break}}else o===-1&&(s=!1,o=n+1),r>=0&&(l===c.charCodeAt(r)?--r==-1&&(t=n):(r=-1,t=o))}return a===t?t=o:t===-1&&(t=S.length),S.slice(a,t)}for(n=S.length-1;n>=a;--n)if(u(S.charCodeAt(n))){if(!s){a=n+1;break}}else t===-1&&(s=!1,t=n+1);return t===-1?"":S.slice(a,t)},extname(S){E(S,"path");let c=0,a=-1,t=0,s=-1,n=!0,r=0;S.length>=2&&S.charCodeAt(1)===i&&f(S.charCodeAt(0))&&(c=t=2);for(let o=S.length-1;o>=c;--o){const l=S.charCodeAt(o);if(u(l)){if(!n){t=o+1;break}continue}s===-1&&(n=!1,s=o+1),l===P?a===-1?a=o:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||s===-1||r===0||r===1&&a===s-1&&a===t+1?"":S.slice(a,s)},format:v.bind(null,"\\"),parse(S){E(S,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(S.length===0)return c;const a=S.length;let t=0,s=S.charCodeAt(0);if(a===1)return u(s)?(c.root=c.dir=S,c):(c.base=c.name=S,c);if(u(s)){if(t=1,u(S.charCodeAt(1))){let m=2,A=m;for(;m<a&&!u(S.charCodeAt(m));)m++;if(m<a&&m!==A){for(A=m;m<a&&u(S.charCodeAt(m));)m++;if(m<a&&m!==A){for(A=m;m<a&&!u(S.charCodeAt(m));)m++;m===a?t=m:m!==A&&(t=m+1)}}}}else if(f(s)&&S.charCodeAt(1)===i){if(a<=2)return c.root=c.dir=S,c;if(t=2,u(S.charCodeAt(2))){if(a===3)return c.root=c.dir=S,c;t=3}}t>0&&(c.root=S.slice(0,t));let n=-1,r=t,o=-1,l=!0,h=S.length-1,d=0;for(;h>=t;--h){if(s=S.charCodeAt(h),u(s)){if(!l){r=h+1;break}continue}o===-1&&(l=!1,o=h+1),s===P?n===-1?n=h:d!==1&&(d=1):n!==-1&&(d=-1)}return o!==-1&&(n===-1||d===0||d===1&&n===o-1&&n===r+1?c.base=c.name=S.slice(r,o):(c.name=S.slice(r,n),c.base=S.slice(r,o),c.ext=S.slice(n,o))),r>0&&r!==t?c.dir=S.slice(0,r-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...S){let c="",a=!1;for(let t=S.length-1;t>=-1&&!a;t--){const s=t>=0?S[t]:R.cwd();E(s,"path"),s.length!==0&&(c=`${s}/${c}`,a=s.charCodeAt(0)===y)}return c=b(c,!a,"/",p),a?`/${c}`:c.length>0?c:"."},normalize(S){if(E(S,"path"),S.length===0)return".";const c=S.charCodeAt(0)===y,a=S.charCodeAt(S.length-1)===y;return S=b(S,!c,"/",p),S.length===0?c?"/":a?"./":".":(a&&(S+="/"),c?`/${S}`:S)},isAbsolute(S){return E(S,"path"),S.length>0&&S.charCodeAt(0)===y},join(...S){if(S.length===0)return".";let c;for(let a=0;a<S.length;++a){const t=S[a];E(t,"path"),t.length>0&&(c===void 0?c=t:c+=`/${t}`)}return c===void 0?".":e.posix.normalize(c)},relative(S,c){if(E(S,"from"),E(c,"to"),S===c||(S=e.posix.resolve(S),c=e.posix.resolve(c),S===c))return"";const a=1,t=S.length,s=t-a,n=1,r=c.length-n,o=s<r?s:r;let l=-1,h=0;for(;h<o;h++){const m=S.charCodeAt(a+h);if(m!==c.charCodeAt(n+h))break;m===y&&(l=h)}if(h===o)if(r>o){if(c.charCodeAt(n+h)===y)return c.slice(n+h+1);if(h===0)return c.slice(n+h)}else s>o&&(S.charCodeAt(a+h)===y?l=h:h===0&&(l=0));let d="";for(h=a+l+1;h<=t;++h)(h===t||S.charCodeAt(h)===y)&&(d+=d.length===0?"..":"/..");return`${d}${c.slice(n+l)}`},toNamespacedPath(S){return S},dirname(S){if(E(S,"path"),S.length===0)return".";const c=S.charCodeAt(0)===y;let a=-1,t=!0;for(let s=S.length-1;s>=1;--s)if(S.charCodeAt(s)===y){if(!t){a=s;break}}else t=!1;return a===-1?c?"/":".":c&&a===1?"//":S.slice(0,a)},basename(S,c){c!==void 0&&E(c,"ext"),E(S,"path");let a=0,t=-1,s=!0,n;if(c!==void 0&&c.length>0&&c.length<=S.length){if(c===S)return"";let r=c.length-1,o=-1;for(n=S.length-1;n>=0;--n){const l=S.charCodeAt(n);if(l===y){if(!s){a=n+1;break}}else o===-1&&(s=!1,o=n+1),r>=0&&(l===c.charCodeAt(r)?--r==-1&&(t=n):(r=-1,t=o))}return a===t?t=o:t===-1&&(t=S.length),S.slice(a,t)}for(n=S.length-1;n>=0;--n)if(S.charCodeAt(n)===y){if(!s){a=n+1;break}}else t===-1&&(s=!1,t=n+1);return t===-1?"":S.slice(a,t)},extname(S){E(S,"path");let c=-1,a=0,t=-1,s=!0,n=0;for(let r=S.length-1;r>=0;--r){const o=S.charCodeAt(r);if(o===y){if(!s){a=r+1;break}continue}t===-1&&(s=!1,t=r+1),o===P?c===-1?c=r:n!==1&&(n=1):c!==-1&&(n=-1)}return c===-1||t===-1||n===0||n===1&&c===t-1&&c===a+1?"":S.slice(c,t)},format:v.bind(null,"/"),parse(S){E(S,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(S.length===0)return c;const a=S.charCodeAt(0)===y;let t;a?(c.root="/",t=1):t=0;let s=-1,n=0,r=-1,o=!0,l=S.length-1,h=0;for(;l>=t;--l){const d=S.charCodeAt(l);if(d===y){if(!o){n=l+1;break}continue}r===-1&&(o=!1,r=l+1),d===P?s===-1?s=l:h!==1&&(h=1):s!==-1&&(h=-1)}if(r!==-1){const d=n===0&&a?1:n;s===-1||h===0||h===1&&s===r-1&&s===n+1?c.base=c.name=S.slice(d,r):(c.name=S.slice(d,s),c.base=S.slice(d,r),c.ext=S.slice(s,r))}return n>0?c.dir=S.slice(0,n-1):a&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=R.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=R.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=R.platform==="win32"?e.win32.join:e.posix.join,e.resolve=R.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=R.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=R.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=R.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=R.platform==="win32"?e.win32.extname:e.posix.extname,e.format=R.platform==="win32"?e.win32.format:e.posix.format,e.parse=R.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=R.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=R.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=R.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var R=e();for(var k in R)(typeof exports=="object"?exports:J)[k]=R[k]}}(typeof self!="undefined"?self:this,function(){return function(J){var e={};function R(k){if(e[k])return e[k].exports;var D=e[k]={i:k,l:!1,exports:{}};return J[k].call(D.exports,D,D.exports,R),D.l=!0,D.exports}return R.m=J,R.c=e,R.d=function(k,D,T){R.o(k,D)||Object.defineProperty(k,D,{enumerable:!0,get:T})},R.r=function(k){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(k,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(k,"__esModule",{value:!0})},R.t=function(k,D){if(1&D&&(k=R(k)),8&D||4&D&&typeof k=="object"&&k&&k.__esModule)return k;var T=Object.create(null);if(R.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:k}),2&D&&typeof k!="string")for(var L in k)R.d(T,L,function(P){return k[P]}.bind(null,L));return T},R.n=function(k){var D=k&&k.__esModule?function(){return k.default}:function(){return k};return R.d(D,"a",D),D},R.o=function(k,D){return Object.prototype.hasOwnProperty.call(k,D)},R.p="",R(R.s=0)}([function(J,e,R){(function(k){var D;e=J.exports=Z,D=typeof k=="object"&&k.env&&k.env.NODE_DEBUG&&/\bsemver\b/i.test(k.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],y=e.src=[],I=0,i=I++;y[i]="0|[1-9]\\d*";var C=I++;y[C]="[0-9]+";var g=I++;y[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=I++;y[E]="("+y[i]+")\\.("+y[i]+")\\.("+y[i]+")";var u=I++;y[u]="("+y[C]+")\\.("+y[C]+")\\.("+y[C]+")";var p=I++;y[p]="(?:"+y[i]+"|"+y[g]+")";var f=I++;y[f]="(?:"+y[C]+"|"+y[g]+")";var b=I++;y[b]="(?:-("+y[p]+"(?:\\."+y[p]+")*))";var v=I++;y[v]="(?:-?("+y[f]+"(?:\\."+y[f]+")*))";var S=I++;y[S]="[0-9A-Za-z-]+";var c=I++;y[c]="(?:\\+("+y[S]+"(?:\\."+y[S]+")*))";var a=I++,t="v?"+y[E]+y[b]+"?"+y[c]+"?";y[a]="^"+t+"$";var s="[v=\\s]*"+y[u]+y[v]+"?"+y[c]+"?",n=I++;y[n]="^"+s+"$";var r=I++;y[r]="((?:<|>)?=?)";var o=I++;y[o]=y[C]+"|x|X|\\*";var l=I++;y[l]=y[i]+"|x|X|\\*";var h=I++;y[h]="[v=\\s]*("+y[l]+")(?:\\.("+y[l]+")(?:\\.("+y[l]+")(?:"+y[b]+")?"+y[c]+"?)?)?";var d=I++;y[d]="[v=\\s]*("+y[o]+")(?:\\.("+y[o]+")(?:\\.("+y[o]+")(?:"+y[v]+")?"+y[c]+"?)?)?";var m=I++;y[m]="^"+y[r]+"\\s*"+y[h]+"$";var A=I++;y[A]="^"+y[r]+"\\s*"+y[d]+"$";var _=I++;y[_]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var w=I++;y[w]="(?:~>?)";var O=I++;y[O]="(\\s*)"+y[w]+"\\s+",P[O]=new RegExp(y[O],"g");var U=I++;y[U]="^"+y[w]+y[h]+"$";var $=I++;y[$]="^"+y[w]+y[d]+"$";var Y=I++;y[Y]="(?:\\^)";var M=I++;y[M]="(\\s*)"+y[Y]+"\\s+",P[M]=new RegExp(y[M],"g");var V=I++;y[V]="^"+y[Y]+y[h]+"$";var j=I++;y[j]="^"+y[Y]+y[d]+"$";var z=I++;y[z]="^"+y[r]+"\\s*("+s+")$|^$";var q=I++;y[q]="^"+y[r]+"\\s*("+t+")$|^$";var F=I++;y[F]="(\\s*)"+y[r]+"\\s*("+s+"|"+y[h]+")",P[F]=new RegExp(y[F],"g");var G=I++;y[G]="^\\s*("+y[h]+")\\s+-\\s+("+y[h]+")\\s*$";var x=I++;y[x]="^\\s*("+y[d]+")\\s+-\\s+("+y[d]+")\\s*$";var N=I++;y[N]="(<|>)?=?\\s*\\*";for(var W=0;W<35;W++)D(W,y[W]),P[W]||(P[W]=new RegExp(y[W]));function X(ee,oe){if(ee instanceof Z)return ee;if(typeof ee!="string"||ee.length>T||!(oe?P[n]:P[a]).test(ee))return null;try{return new Z(ee,oe)}catch(ce){return null}}function Z(ee,oe){if(ee instanceof Z){if(ee.loose===oe)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof Z))return new Z(ee,oe);D("SemVer",ee,oe),this.loose=oe;var ce=ee.trim().match(oe?P[n]:P[a]);if(!ce)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+ce[1],this.minor=+ce[2],this.patch=+ce[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");ce[4]?this.prerelease=ce[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var Se=+ye;if(Se>=0&&Se<L)return Se}return ye}):this.prerelease=[],this.build=ce[5]?ce[5].split("."):[],this.format()}e.parse=X,e.valid=function(ee,oe){var ce=X(ee,oe);return ce?ce.version:null},e.clean=function(ee,oe){var ce=X(ee.trim().replace(/^[=v]+/,""),oe);return ce?ce.version:null},e.SemVer=Z,Z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Z.prototype.toString=function(){return this.version},Z.prototype.compare=function(ee){return D("SemVer.compare",this.version,this.loose,ee),ee instanceof Z||(ee=new Z(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},Z.prototype.compareMain=function(ee){return ee instanceof Z||(ee=new Z(ee,this.loose)),H(this.major,ee.major)||H(this.minor,ee.minor)||H(this.patch,ee.patch)},Z.prototype.comparePre=function(ee){if(ee instanceof Z||(ee=new Z(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var oe=0;do{var ce=this.prerelease[oe],ye=ee.prerelease[oe];if(D("prerelease compare",oe,ce,ye),ce===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(ce===void 0)return-1;if(ce!==ye)return H(ce,ye)}while(++oe)},Z.prototype.inc=function(ee,oe){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",oe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",oe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",oe),this.inc("pre",oe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",oe),this.inc("pre",oe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ce=this.prerelease.length;--ce>=0;)typeof this.prerelease[ce]=="number"&&(this.prerelease[ce]++,ce=-2);ce===-1&&this.prerelease.push(0)}oe&&(this.prerelease[0]===oe?isNaN(this.prerelease[1])&&(this.prerelease=[oe,0]):this.prerelease=[oe,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,oe,ce,ye){typeof ce=="string"&&(ye=ce,ce=void 0);try{return new Z(ee,ce).inc(oe,ye).version}catch(Se){return null}},e.diff=function(ee,oe){if(ue(ee,oe))return null;var ce=X(ee),ye=X(oe);if(ce.prerelease.length||ye.prerelease.length){for(var Se in ce)if((Se==="major"||Se==="minor"||Se==="patch")&&ce[Se]!==ye[Se])return"pre"+Se;return"prerelease"}for(var Se in ce)if((Se==="major"||Se==="minor"||Se==="patch")&&ce[Se]!==ye[Se])return Se},e.compareIdentifiers=H;var B=/^[0-9]+$/;function H(ee,oe){var ce=B.test(ee),ye=B.test(oe);return ce&&ye&&(ee=+ee,oe=+oe),ce&&!ye?-1:ye&&!ce?1:ee<oe?-1:ee>oe?1:0}function ie(ee,oe,ce){return new Z(ee,ce).compare(new Z(oe,ce))}function re(ee,oe,ce){return ie(ee,oe,ce)>0}function ae(ee,oe,ce){return ie(ee,oe,ce)<0}function ue(ee,oe,ce){return ie(ee,oe,ce)===0}function fe(ee,oe,ce){return ie(ee,oe,ce)!==0}function ge(ee,oe,ce){return ie(ee,oe,ce)>=0}function Ie(ee,oe,ce){return ie(ee,oe,ce)<=0}function Pe(ee,oe,ce,ye){var Se;switch(oe){case"===":typeof ee=="object"&&(ee=ee.version),typeof ce=="object"&&(ce=ce.version),Se=ee===ce;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof ce=="object"&&(ce=ce.version),Se=ee!==ce;break;case"":case"=":case"==":Se=ue(ee,ce,ye);break;case"!=":Se=fe(ee,ce,ye);break;case">":Se=re(ee,ce,ye);break;case">=":Se=ge(ee,ce,ye);break;case"<":Se=ae(ee,ce,ye);break;case"<=":Se=Ie(ee,ce,ye);break;default:throw new TypeError("Invalid operator: "+oe)}return Se}function Ee(ee,oe){if(ee instanceof Ee){if(ee.loose===oe)return ee;ee=ee.value}if(!(this instanceof Ee))return new Ee(ee,oe);D("comparator",ee,oe),this.loose=oe,this.parse(ee),this.semver===_e?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ee,oe){return H(oe,ee)},e.major=function(ee,oe){return new Z(ee,oe).major},e.minor=function(ee,oe){return new Z(ee,oe).minor},e.patch=function(ee,oe){return new Z(ee,oe).patch},e.compare=ie,e.compareLoose=function(ee,oe){return ie(ee,oe,!0)},e.rcompare=function(ee,oe,ce){return ie(oe,ee,ce)},e.sort=function(ee,oe){return ee.sort(function(ce,ye){return e.compare(ce,ye,oe)})},e.rsort=function(ee,oe){return ee.sort(function(ce,ye){return e.rcompare(ce,ye,oe)})},e.gt=re,e.lt=ae,e.eq=ue,e.neq=fe,e.gte=ge,e.lte=Ie,e.cmp=Pe,e.Comparator=Ee;var _e={};function De(ee,oe){if(ee instanceof De)return ee.loose===oe?ee:new De(ee.raw,oe);if(ee instanceof Ee)return new De(ee.value,oe);if(!(this instanceof De))return new De(ee,oe);if(this.loose=oe,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(ce){return this.parseRange(ce.trim())},this).filter(function(ce){return ce.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function Te(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function Fe(ee,oe,ce,ye,Se,Oe,ke,Ue,Ae,K,se,le,de){return((oe=Te(ce)?"":Te(ye)?">="+ce+".0.0":Te(Se)?">="+ce+"."+ye+".0":">="+oe)+" "+(Ue=Te(Ae)?"":Te(K)?"<"+(+Ae+1)+".0.0":Te(se)?"<"+Ae+"."+(+K+1)+".0":le?"<="+Ae+"."+K+"."+se+"-"+le:"<="+Ue)).trim()}function Ne(ee,oe){for(var ce=0;ce<ee.length;ce++)if(!ee[ce].test(oe))return!1;if(oe.prerelease.length){for(ce=0;ce<ee.length;ce++)if(D(ee[ce].semver),ee[ce].semver!==_e&&ee[ce].semver.prerelease.length>0){var ye=ee[ce].semver;if(ye.major===oe.major&&ye.minor===oe.minor&&ye.patch===oe.patch)return!0}return!1}return!0}function ze(ee,oe,ce){try{oe=new De(oe,ce)}catch(ye){return!1}return oe.test(ee)}function xe(ee,oe,ce,ye){var Se,Oe,ke,Ue,Ae;switch(ee=new Z(ee,ye),oe=new De(oe,ye),ce){case">":Se=re,Oe=Ie,ke=ae,Ue=">",Ae=">=";break;case"<":Se=ae,Oe=ge,ke=re,Ue="<",Ae="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(ee,oe,ye))return!1;for(var K=0;K<oe.set.length;++K){var se=oe.set[K],le=null,de=null;if(se.forEach(function(me){me.semver===_e&&(me=new Ee(">=0.0.0")),le=le||me,de=de||me,Se(me.semver,le.semver,ye)?le=me:ke(me.semver,de.semver,ye)&&(de=me)}),le.operator===Ue||le.operator===Ae||(!de.operator||de.operator===Ue)&&Oe(ee,de.semver)||de.operator===Ae&&ke(ee,de.semver))return!1}return!0}Ee.prototype.parse=function(ee){var oe=this.loose?P[z]:P[q],ce=ee.match(oe);if(!ce)throw new TypeError("Invalid comparator: "+ee);this.operator=ce[1],this.operator==="="&&(this.operator=""),ce[2]?this.semver=new Z(ce[2],this.loose):this.semver=_e},Ee.prototype.toString=function(){return this.value},Ee.prototype.test=function(ee){return D("Comparator.test",ee,this.loose),this.semver===_e||(typeof ee=="string"&&(ee=new Z(ee,this.loose)),Pe(ee,this.operator,this.semver,this.loose))},Ee.prototype.intersects=function(ee,oe){if(!(ee instanceof Ee))throw new TypeError("a Comparator is required");var ce;if(this.operator==="")return ce=new De(ee.value,oe),ze(this.value,ce,oe);if(ee.operator==="")return ce=new De(this.value,oe),ze(ee.semver,ce,oe);var ye=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),Se=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),Oe=this.semver.version===ee.semver.version,ke=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),Ue=Pe(this.semver,"<",ee.semver,oe)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),Ae=Pe(this.semver,">",ee.semver,oe)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return ye||Se||Oe&&ke||Ue||Ae},e.Range=De,De.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},De.prototype.toString=function(){return this.range},De.prototype.parseRange=function(ee){var oe=this.loose;ee=ee.trim(),D("range",ee,oe);var ce=oe?P[x]:P[G];ee=ee.replace(ce,Fe),D("hyphen replace",ee),ee=ee.replace(P[F],"$1$2$3"),D("comparator trim",ee,P[F]),ee=(ee=(ee=ee.replace(P[O],"$1~")).replace(P[M],"$1^")).split(/\s+/).join(" ");var ye=oe?P[z]:P[q],Se=ee.split(" ").map(function(Oe){return function(ke,Ue){return D("comp",ke),ke=function(Ae,K){return Ae.trim().split(/\s+/).map(function(se){return function(le,de){D("caret",le,de);var me=de?P[j]:P[V];return le.replace(me,function(be,pe,we,Ce,Re){var Le;return D("caret",le,be,pe,we,Ce,Re),Te(pe)?Le="":Te(we)?Le=">="+pe+".0.0 <"+(+pe+1)+".0.0":Te(Ce)?Le=pe==="0"?">="+pe+"."+we+".0 <"+pe+"."+(+we+1)+".0":">="+pe+"."+we+".0 <"+(+pe+1)+".0.0":Re?(D("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Le=pe==="0"?we==="0"?">="+pe+"."+we+"."+Ce+Re+" <"+pe+"."+we+"."+(+Ce+1):">="+pe+"."+we+"."+Ce+Re+" <"+pe+"."+(+we+1)+".0":">="+pe+"."+we+"."+Ce+Re+" <"+(+pe+1)+".0.0"):(D("no pr"),Le=pe==="0"?we==="0"?">="+pe+"."+we+"."+Ce+" <"+pe+"."+we+"."+(+Ce+1):">="+pe+"."+we+"."+Ce+" <"+pe+"."+(+we+1)+".0":">="+pe+"."+we+"."+Ce+" <"+(+pe+1)+".0.0"),D("caret return",Le),Le})}(se,K)}).join(" ")}(ke,Ue),D("caret",ke),ke=function(Ae,K){return Ae.trim().split(/\s+/).map(function(se){return function(le,de){var me=de?P[$]:P[U];return le.replace(me,function(be,pe,we,Ce,Re){var Le;return D("tilde",le,be,pe,we,Ce,Re),Te(pe)?Le="":Te(we)?Le=">="+pe+".0.0 <"+(+pe+1)+".0.0":Te(Ce)?Le=">="+pe+"."+we+".0 <"+pe+"."+(+we+1)+".0":Re?(D("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Le=">="+pe+"."+we+"."+Ce+Re+" <"+pe+"."+(+we+1)+".0"):Le=">="+pe+"."+we+"."+Ce+" <"+pe+"."+(+we+1)+".0",D("tilde return",Le),Le})}(se,K)}).join(" ")}(ke,Ue),D("tildes",ke),ke=function(Ae,K){return D("replaceXRanges",Ae,K),Ae.split(/\s+/).map(function(se){return function(le,de){le=le.trim();var me=de?P[A]:P[m];return le.replace(me,function(be,pe,we,Ce,Re,Le){D("xRange",le,be,pe,we,Ce,Re,Le);var nt=Te(we),He=nt||Te(Ce),je=He||Te(Re);return pe==="="&&je&&(pe=""),nt?be=pe===">"||pe==="<"?"<0.0.0":"*":pe&&je?(He&&(Ce=0),je&&(Re=0),pe===">"?(pe=">=",He?(we=+we+1,Ce=0,Re=0):je&&(Ce=+Ce+1,Re=0)):pe==="<="&&(pe="<",He?we=+we+1:Ce=+Ce+1),be=pe+we+"."+Ce+"."+Re):He?be=">="+we+".0.0 <"+(+we+1)+".0.0":je&&(be=">="+we+"."+Ce+".0 <"+we+"."+(+Ce+1)+".0"),D("xRange return",be),be})}(se,K)}).join(" ")}(ke,Ue),D("xrange",ke),ke=function(Ae,K){return D("replaceStars",Ae,K),Ae.trim().replace(P[N],"")}(ke,Ue),D("stars",ke),ke}(Oe,oe)}).join(" ").split(/\s+/);return this.loose&&(Se=Se.filter(function(Oe){return!!Oe.match(ye)})),Se=Se.map(function(Oe){return new Ee(Oe,oe)})},De.prototype.intersects=function(ee,oe){if(!(ee instanceof De))throw new TypeError("a Range is required");return this.set.some(function(ce){return ce.every(function(ye){return ee.set.some(function(Se){return Se.every(function(Oe){return ye.intersects(Oe,oe)})})})})},e.toComparators=function(ee,oe){return new De(ee,oe).set.map(function(ce){return ce.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},De.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new Z(ee,this.loose));for(var oe=0;oe<this.set.length;oe++)if(Ne(this.set[oe],ee))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(ee,oe,ce){var ye=null,Se=null;try{var Oe=new De(oe,ce)}catch(ke){return null}return ee.forEach(function(ke){Oe.test(ke)&&(ye&&Se.compare(ke)!==-1||(Se=new Z(ye=ke,ce)))}),ye},e.minSatisfying=function(ee,oe,ce){var ye=null,Se=null;try{var Oe=new De(oe,ce)}catch(ke){return null}return ee.forEach(function(ke){Oe.test(ke)&&(ye&&Se.compare(ke)!==1||(Se=new Z(ye=ke,ce)))}),ye},e.validRange=function(ee,oe){try{return new De(ee,oe).range||"*"}catch(ce){return null}},e.ltr=function(ee,oe,ce){return xe(ee,oe,"<",ce)},e.gtr=function(ee,oe,ce){return xe(ee,oe,">",ce)},e.outside=xe,e.prerelease=function(ee,oe){var ce=X(ee,oe);return ce&&ce.prerelease.length?ce.prerelease:null},e.intersects=function(ee,oe,ce){return ee=new De(ee,ce),oe=new De(oe,ce),ee.intersects(oe)},e.coerce=function(ee){if(ee instanceof Z)return ee;if(typeof ee!="string")return null;var oe=ee.match(P[_]);return oe==null?null:X((oe[1]||"0")+"."+(oe[2]||"0")+"."+(oe[3]||"0"))}}).call(this,R(1))},function(J,e){var R,k,D=J.exports={};function T(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function P(f){if(R===setTimeout)return setTimeout(f,0);if((R===T||!R)&&setTimeout)return R=setTimeout,setTimeout(f,0);try{return R(f,0)}catch(b){try{return R.call(null,f,0)}catch(v){return R.call(this,f,0)}}}(function(){try{R=typeof setTimeout=="function"?setTimeout:T}catch(f){R=T}try{k=typeof clearTimeout=="function"?clearTimeout:L}catch(f){k=L}})();var y,I=[],i=!1,C=-1;function g(){i&&y&&(i=!1,y.length?I=y.concat(I):C=-1,I.length&&E())}function E(){if(!i){var f=P(g);i=!0;for(var b=I.length;b;){for(y=I,I=[];++C<b;)y&&y[C].run();C=-1,b=I.length}y=null,i=!1,function(v){if(k===clearTimeout)return clearTimeout(v);if((k===L||!k)&&clearTimeout)return k=clearTimeout,clearTimeout(v);try{k(v)}catch(S){try{return k.call(null,v)}catch(c){return k.call(this,v)}}}(f)}}function u(f,b){this.fun=f,this.array=b}function p(){}D.nextTick=function(f){var b=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)b[v-1]=arguments[v];I.push(new u(f,b)),I.length!==1||i||P(E)},u.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=p,D.addListener=p,D.once=p,D.off=p,D.removeListener=p,D.removeAllListeners=p,D.emit=p,D.prependListener=p,D.prependOnceListener=p,D.listeners=function(f){return[]},D.binding=function(f){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(f){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(te[98],ne([0,1,4]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const k=R.globals.performance&&typeof R.globals.performance.now=="function";class D{constructor(L){this._highResolution=k&&L,this._startTime=this._now(),this._stopTime=-1}static create(L=!0){return new D(L)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?R.globals.performance.now():Date.now()}}e.StopWatch=D}),define(te[3],ne([0,1,8,67,2,97,98]),function(J,e,R,k,D,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(c){c.None=()=>D.Disposable.None;function a(M){return(V,j=null,z)=>{let q=!1,F;return F=M(G=>{if(!q)return F?F.dispose():q=!0,V.call(j,G)},null,z),q&&F.dispose(),F}}c.once=a;function t(M,V){return h((j,z=null,q)=>M(F=>j.call(z,V(F)),null,q))}c.map=t;function s(M,V){return h((j,z=null,q)=>M(F=>{V(F),j.call(z,F)},null,q))}c.forEach=s;function n(M,V){return h((j,z=null,q)=>M(F=>V(F)&&j.call(z,F),null,q))}c.filter=n;function r(M){return M}c.signal=r;function o(...M){return(V,j=null,z)=>(0,D.combinedDisposable)(...M.map(q=>q(F=>V.call(j,F),null,z)))}c.any=o;function l(M,V,j){let z=j;return t(M,q=>(z=V(z,q),z))}c.reduce=l;function h(M){let V;const j=new g({onFirstListenerAdd(){V=M(j.fire,j)},onLastListenerRemove(){V.dispose()}});return j.event}function d(M,V,j=100,z=!1,q){let F,G,x,N=0;const W=new g({leakWarningThreshold:q,onFirstListenerAdd(){F=M(X=>{N++,G=V(G,X),z&&!x&&(W.fire(G),G=void 0),clearTimeout(x),x=setTimeout(()=>{const Z=G;G=void 0,x=void 0,(!z||N>1)&&W.fire(Z),N=0},j)})},onLastListenerRemove(){F.dispose()}});return W.event}c.debounce=d;function m(M,V=(j,z)=>j===z){let j=!0,z;return n(M,q=>{const F=j||!V(q,z);return j=!1,z=q,F})}c.latch=m;function A(M,V){return[c.filter(M,V),c.filter(M,j=>!V(j))]}c.split=A;function _(M,V=!1,j=[]){let z=j.slice(),q=M(x=>{z?z.push(x):G.fire(x)});const F=()=>{z&&z.forEach(x=>G.fire(x)),z=null},G=new g({onFirstListenerAdd(){q||(q=M(x=>G.fire(x)))},onFirstListenerDidAdd(){z&&(V?setTimeout(F):F())},onLastListenerRemove(){q&&q.dispose(),q=null}});return G.event}c.buffer=_;class w{constructor(V){this.event=V}map(V){return new w(t(this.event,V))}forEach(V){return new w(s(this.event,V))}filter(V){return new w(n(this.event,V))}reduce(V,j){return new w(l(this.event,V,j))}latch(){return new w(m(this.event))}debounce(V,j=100,z=!1,q){return new w(d(this.event,V,j,z,q))}on(V,j,z){return this.event(V,j,z)}once(V,j,z){return a(this.event)(V,j,z)}}function O(M){return new w(M)}c.chain=O;function U(M,V,j=z=>z){const z=(...x)=>G.fire(j(...x)),q=()=>M.on(V,z),F=()=>M.removeListener(V,z),G=new g({onFirstListenerAdd:q,onLastListenerRemove:F});return G.event}c.fromNodeEventEmitter=U;function $(M,V,j=z=>z){const z=(...x)=>G.fire(j(...x)),q=()=>M.addEventListener(V,z),F=()=>M.removeEventListener(V,z),G=new g({onFirstListenerAdd:q,onLastListenerRemove:F});return G.event}c.fromDOMEventEmitter=$;function Y(M){return new Promise(V=>a(M)(V))}c.toPromise=Y})(P=e.Event||(e.Event={}));class y{constructor(a){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${a}_${y._idPool++}`}start(a){this._stopWatch=new L.StopWatch(!0),this._listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this._elapsedOverall+=a,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${a.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let I=-1;function i(c){const a=I;return I=c,{dispose(){I=a}}}e.setGlobalLeakWarningThreshold=i;class C{constructor(a,t=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=t,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a){let t=I;if(typeof this.customThreshold=="number"&&(t=this.customThreshold),t<=0||a<t)return;this._stacks||(this._stacks=new Map);const s=new Error().stack.split(`
`).slice(3).join(`
`),n=this._stacks.get(s)||0;if(this._stacks.set(s,n+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=t*.5;let r,o=0;for(const[l,h]of this._stacks)(!r||o<h)&&(r=l,o=h);console.warn(`[${this.name}] potential listener LEAK detected, having ${a} listeners already. MOST frequent listener (${o}):`),console.warn(r)}return()=>{const r=this._stacks.get(s)||0;this._stacks.set(s,r-1)}}}class g{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=I>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(a,t,s)=>{this._listeners||(this._listeners=new T.LinkedList);const n=this._listeners.isEmpty();n&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(t?[a,t]:a);n&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,t);const o=this._leakageMon?.check(this._listeners.size),l=(0,D.toDisposable)(()=>{o&&o(),this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return s instanceof D.DisposableStore?s.add(l):Array.isArray(s)&&s.push(l),l}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,a]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[t,s]=this._deliveryQueue.shift();try{typeof t=="function"?t.call(void 0,s):t[0].call(t[1],s)}catch(n){(0,R.onUnexpectedError)(n)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=g;class E extends g{async fireAsync(a,t,s){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const n of this._listeners)this._asyncDeliveryQueue.push([n,a]);for(;this._asyncDeliveryQueue.size>0&&!t.isCancellationRequested;){const[n,r]=this._asyncDeliveryQueue.shift(),o=[],l={...r,waitUntil:h=>{if(Object.isFrozen(o))throw new Error("waitUntil can NOT be called asynchronous");s&&(h=s(h,typeof n=="function"?n:n[0])),o.push(h)}};try{typeof n=="function"?n.call(void 0,l):n[0].call(n[1],l)}catch(h){(0,R.onUnexpectedError)(h);continue}Object.freeze(o),await Promise.allSettled(o).then(h=>{for(const d of h)d.status==="rejected"&&(0,R.onUnexpectedError)(d.reason)})}}}}e.AsyncEmitter=E;class u extends g{constructor(a){super(a);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=u;class p extends u{constructor(a){super(a);this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=p;class f extends g{constructor(a){super(a);this._queuedEvents=[],this._mergeFn=a?.merge}fire(a){this._queuedEvents.push(a),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(t=>super.fire(t)),this._queuedEvents=[]})}}e.MicrotaskEmitter=f;class b{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new g({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const t={event:a,listener:null};this.events.push(t),this.hasListeners&&this.hook(t);const s=()=>{this.hasListeners&&this.unhook(t);const n=this.events.indexOf(t);this.events.splice(n,1)};return(0,D.toDisposable)((0,k.once)(s))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(t=>this.emitter.fire(t))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=b;class v{constructor(){this.buffers=[]}wrapEvent(a){return(t,s,n)=>a(r=>{const o=this.buffers[this.buffers.length-1];o?o.push(()=>t.call(s,r)):t.call(s,r)},void 0,n)}bufferEvents(a){const t=[];this.buffers.push(t);const s=a();return this.buffers.pop(),t.forEach(n=>n()),s}}e.EventBufferer=v;class S{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=D.Disposable.None,this.emitter=new g({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=S}),define(te[27],ne([0,1,3]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const k=Object.freeze(function(P,y){const I=setTimeout(P.bind(y),0);return{dispose(){clearTimeout(I)}}});var D;(function(P){function y(I){return I===P.None||I===P.Cancelled||I instanceof T?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}P.isCancellationToken=y,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:R.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:k})})(D=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?k:(this._emitter||(this._emitter=new R.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class L{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=D.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=L}),define(te[49],ne([0,1,3]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class k{constructor(){this._icons=new Map,this._onDidRegister=new R.Emitter}add(C){const g=this._icons.get(C.id);g?C.description?g.description=C.description:console.error(`Duplicate registration of codicon ${C.id}`):(this._icons.set(C.id,C),this._onDidRegister.fire(C))}get(C){return this._icons.get(C)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new k;e.iconRegistry=D;function T(i,C){return new P(i,C)}e.registerCodicon=T;function L(i){return i?i.replace(/\$\((.*?)\)/g,(C,g)=>` ${g} `).trim():""}e.getCodiconAriaLabel=L;class P{constructor(C,g,E){this.id=C,this.definition=g,this.description=E,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function y(i,C){const g=["codicon","codicon-"+i];return C&&g.push("codicon-modifier-"+C),g}e.getClassNamesArray=y;var I;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const C=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function g(p){if(p instanceof P)return["codicon","codicon-"+p.id];const f=C.exec(p.id);if(!f)return g(P.error);let[,b,v]=f;const S=["codicon","codicon-"+b];return v&&S.push("codicon-modifier-"+v.substr(1)),S}i.asClassNameArray=g;function E(p){return g(p).join(" ")}i.asClassName=E;function u(p){return"."+g(p).join(".")}i.asCSSSelector=u})(I=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(P=e.Codicon||(e.Codicon={}))}),define(te[50],ne([0,1,8,2]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(S){const c=S;return c?[c.on,c.pause,c.resume,c.destroy].every(a=>typeof a=="function"):!1}e.isReadableStream=D;function T(S){const c=S;return c?D(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=T;function L(S,c){return new P(S,c)}e.newWriteableStream=L;class P{constructor(c,a){this.reducer=c,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(a=>a(c))}emitError(c){this.listeners.error.length===0?(0,R.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(a=>a(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,a){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(c,a){if(this.state.destroyed)return;let t;switch(c){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const s=t.indexOf(a);s>=0&&t.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(S,c){const a=[];let t;for(;(t=S.read())!==null;)a.push(t);return c(a)}e.consumeReadable=y;function I(S,c,a){const t=[];let s;for(;(s=S.read())!==null&&t.length<a;)t.push(s);return s===null&&t.length>0?c(t):{read:()=>{if(t.length>0)return t.shift();if(typeof s!="undefined"){const n=s;return s=void 0,n}return S.read()}}}e.peekReadable=I;function i(S,c){return new Promise((a,t)=>{const s=[];C(S,{onData:n=>{c&&s.push(n)},onError:n=>{c?t(n):a(void 0)},onEnd:()=>{a(c?c(s):void 0)}})})}e.consumeStream=i;function C(S,c){S.on("error",a=>c.onError(a)),S.on("end",()=>c.onEnd()),S.on("data",a=>c.onData(a))}e.listenStream=C;function g(S,c){return new Promise((a,t)=>{const s=new k.DisposableStore,n=[],r=h=>{if(n.push(h),n.length>c)return s.dispose(),S.pause(),a({stream:S,buffer:n,ended:!1})},o=h=>t(h),l=()=>a({stream:S,buffer:n,ended:!0});s.add((0,k.toDisposable)(()=>S.removeListener("error",o))),S.on("error",o),s.add((0,k.toDisposable)(()=>S.removeListener("end",l))),S.on("end",l),s.add((0,k.toDisposable)(()=>S.removeListener("data",r))),S.on("data",r)})}e.peekStream=g;function E(S,c){const a=L(c);return a.end(S),a}e.toStream=E;function u(){const S=L(()=>{throw new Error("not supported")});return S.end(),S}e.emptyStream=u;function p(S){let c=!1;return{read:()=>c?null:(c=!0,S)}}e.toReadable=p;function f(S,c,a){const t=L(a);return C(S,{onData:s=>t.write(c.data(s)),onError:s=>t.error(c.error?c.error(s):s),onEnd:()=>t.end()}),t}e.transform=f;function b(S,c,a){let t=!1;return{read:()=>{const s=c.read();return t?s:(t=!0,s!==null?a([S,s]):S)}}}e.prefixedReadable=b;function v(S,c,a){let t=!1;const s=L(a);return C(c,{onData:n=>t?s.write(n):(t=!0,s.write(a([S,n]))),onError:n=>s.error(n),onEnd:()=>{t||(t=!0,s.write(S)),s.end()}}),s}e.prefixedStream=v}),define(te[21],ne([0,1,50]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const k=typeof Buffer!="undefined";let D,T;class L{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return k?new L(Buffer.allocUnsafe(r)):new L(new Uint8Array(r))}static wrap(r){return k&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new L(r)}static fromString(r,o){return!(o?.dontUseNodeBuffer||!1)&&k?new L(Buffer.from(r)):(D||(D=new TextEncoder),new L(D.encode(r)))}static concat(r,o){if(typeof o=="undefined"){o=0;for(let d=0,m=r.length;d<m;d++)o+=r[d].byteLength}const l=L.alloc(o);let h=0;for(let d=0,m=r.length;d<m;d++){const A=r[d];l.set(A,h),h+=A.byteLength}return l}toString(){return k?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(r,o){return new L(this.buffer.subarray(r,o))}set(r,o){r instanceof L?this.buffer.set(r.buffer,o):this.buffer.set(r,o)}readUInt32BE(r){return I(this.buffer,r)}writeUInt32BE(r,o){i(this.buffer,r,o)}readUInt32LE(r){return C(this.buffer,r)}writeUInt32LE(r,o){g(this.buffer,r,o)}readUInt8(r){return E(this.buffer,r)}writeUInt8(r,o){u(this.buffer,r,o)}}e.VSBuffer=L;function P(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0}e.readUInt16LE=P;function y(n,r,o){n[o+0]=r&255,r=r>>>8,n[o+1]=r&255}e.writeUInt16LE=y;function I(n,r){return n[r]*2**24+n[r+1]*2**16+n[r+2]*2**8+n[r+3]}e.readUInt32BE=I;function i(n,r,o){n[o+3]=r,r=r>>>8,n[o+2]=r,r=r>>>8,n[o+1]=r,r=r>>>8,n[o]=r}e.writeUInt32BE=i;function C(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0|n[r+2]<<16>>>0|n[r+3]<<24>>>0}e.readUInt32LE=C;function g(n,r,o){n[o+0]=r&255,r=r>>>8,n[o+1]=r&255,r=r>>>8,n[o+2]=r&255,r=r>>>8,n[o+3]=r&255}e.writeUInt32LE=g;function E(n,r){return n[r]}e.readUInt8=E;function u(n,r,o){n[o]=r}e.writeUInt8=u;function p(n){return R.consumeReadable(n,r=>L.concat(r))}e.readableToBuffer=p;function f(n){return R.toReadable(n)}e.bufferToReadable=f;function b(n){return R.consumeStream(n,r=>L.concat(r))}e.streamToBuffer=b;async function v(n){return n.ended?L.concat(n.buffer):L.concat([...n.buffer,await b(n.stream)])}e.bufferedStreamToBuffer=v;function S(n){return R.toStream(n,r=>L.concat(r))}e.bufferToStream=S;function c(n){return R.transform(n,{data:r=>typeof r=="string"?L.fromString(r):L.wrap(r)},r=>L.concat(r))}e.streamToBufferReadableStream=c;function a(n){return R.newWriteableStream(r=>L.concat(r),n)}e.newWriteableBufferStream=a;function t(n,r){return R.prefixedReadable(n,r,o=>L.concat(o))}e.prefixedBufferReadable=t;function s(n,r){return R.prefixedStream(n,r,o=>L.concat(o))}e.prefixedBufferStream=s}),define(te[25],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=R;const k=/{(\d+)}/g;function D(K,...se){return se.length===0?K:K.replace(k,function(le,de){const me=parseInt(de,10);return isNaN(me)||me<0||me>=se.length?le:se[me]})}e.format=D;const T=/{([^}]+)}/g;function L(K,se){return K.replace(T,(le,de)=>se[de]??le)}e.format2=L;function P(K){return K.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=P;function y(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function I(K,se){let le=0;const de=se.charCodeAt(0);for(let me=K.length-1;me>=0;me--)K.charCodeAt(me)===de&&le++;return le}e.count=I;function i(K,se,le="\u2026"){return K.length<=se?K:`${K.substr(0,se)}${le}`}e.truncate=i;function C(K,se=" "){const le=g(K,se);return E(le,se)}e.trim=C;function g(K,se){if(!K||!se)return K;const le=se.length;if(le===0||K.length===0)return K;let de=0;for(;K.indexOf(se,de)===de;)de=de+le;return K.substring(de)}e.ltrim=g;function E(K,se){if(!K||!se)return K;const le=se.length,de=K.length;if(le===0||de===0)return K;let me=de,be=-1;for(;be=K.lastIndexOf(se,me-1),!(be===-1||be+le!==me);){if(be===0)return"";me=be}return K.substring(0,me)}e.rtrim=E;function u(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function p(K){return K.replace(/\*/g,"")}e.stripWildcards=p;function f(K,se,le={}){if(!K)throw new Error("Cannot create regex from empty string");se||(K=y(K)),le.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let de="";return le.global&&(de+="g"),le.matchCase||(de+="i"),le.multiline&&(de+="m"),le.unicode&&(de+="u"),new RegExp(K,de)}e.createRegExp=f;function b(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=b;function v(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=v;function S(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=S;function c(K){return K.split(/\r\n|\r|\n/)}e.splitLines=c;function a(K){for(let se=0,le=K.length;se<le;se++){const de=K.charCodeAt(se);if(de!==32&&de!==9)return se}return-1}e.firstNonWhitespaceIndex=a;function t(K,se=0,le=K.length){for(let de=se;de<le;de++){const me=K.charCodeAt(de);if(me!==32&&me!==9)return K.substring(se,de)}return K.substring(se,le)}e.getLeadingWhitespace=t;function s(K,se=K.length-1){for(let le=se;le>=0;le--){const de=K.charCodeAt(le);if(de!==32&&de!==9)return le}return-1}e.lastNonWhitespaceIndex=s;function n(K,se){return K<se?-1:K>se?1:0}e.compare=n;function r(K,se,le=0,de=K.length,me=0,be=se.length){for(;le<de&&me<be;le++,me++){let Ce=K.charCodeAt(le),Re=se.charCodeAt(me);if(Ce<Re)return-1;if(Ce>Re)return 1}const pe=de-le,we=be-me;return pe<we?-1:pe>we?1:0}e.compareSubstring=r;function o(K,se){return l(K,se,0,K.length,0,se.length)}e.compareIgnoreCase=o;function l(K,se,le=0,de=K.length,me=0,be=se.length){for(;le<de&&me<be;le++,me++){let Ce=K.charCodeAt(le),Re=se.charCodeAt(me);if(Ce===Re)continue;const Le=Ce-Re;if(!(Le===32&&d(Re))&&!(Le===-32&&d(Ce)))return h(Ce)&&h(Re)?Le:r(K.toLowerCase(),se.toLowerCase(),le,de,me,be)}const pe=de-le,we=be-me;return pe<we?-1:pe>we?1:0}e.compareSubstringIgnoreCase=l;function h(K){return K>=97&&K<=122}e.isLowerAsciiLetter=h;function d(K){return K>=65&&K<=90}e.isUpperAsciiLetter=d;function m(K){return h(K)||d(K)}function A(K,se){return K.length===se.length&&_(K,se)}e.equalsIgnoreCase=A;function _(K,se,le=K.length){for(let de=0;de<le;de++){const me=K.charCodeAt(de),be=se.charCodeAt(de);if(me!==be){if(m(me)&&m(be)){const pe=Math.abs(me-be);if(pe!==0&&pe!==32)return!1}else if(String.fromCharCode(me).toLowerCase()!==String.fromCharCode(be).toLowerCase())return!1}}return!0}function w(K,se){const le=se.length;return se.length>K.length?!1:_(K,se,le)}e.startsWithIgnoreCase=w;function O(K,se){let le,de=Math.min(K.length,se.length);for(le=0;le<de;le++)if(K.charCodeAt(le)!==se.charCodeAt(le))return le;return de}e.commonPrefixLength=O;function U(K,se){let le,de=Math.min(K.length,se.length);const me=K.length-1,be=se.length-1;for(le=0;le<de;le++)if(K.charCodeAt(me-le)!==se.charCodeAt(be-le))return le;return de}e.commonSuffixLength=U;function $(K){return 55296<=K&&K<=56319}e.isHighSurrogate=$;function Y(K){return 56320<=K&&K<=57343}e.isLowSurrogate=Y;function M(K,se){return(K-55296<<10)+(se-56320)+65536}e.computeCodePoint=M;function V(K,se,le){const de=K.charCodeAt(le);if($(de)&&le+1<se){const me=K.charCodeAt(le+1);if(Y(me))return M(de,me)}return de}e.getNextCodePoint=V;function j(K,se){const le=K.charCodeAt(se-1);if(Y(le)&&se>1){const de=K.charCodeAt(se-2);if($(de))return M(de,le)}return le}function z(K,se){const le=ce.getInstance(),de=se,me=K.length,be=V(K,me,se);se+=be>=65536?2:1;let pe=le.getGraphemeBreakType(be);for(;se<me;){const we=V(K,me,se),Ce=le.getGraphemeBreakType(we);if(ee(pe,Ce))break;se+=we>=65536?2:1,pe=Ce}return se-de}e.nextCharLength=z;function q(K,se){const le=ce.getInstance(),de=se,me=j(K,se);se-=me>=65536?2:1;let be=le.getGraphemeBreakType(me);for(;se>0;){const pe=j(K,se),we=le.getGraphemeBreakType(pe);if(ee(we,be))break;se-=pe>=65536?2:1,be=we}return de-se}e.prevCharLength=q;function F(K,se){const le=ce.getInstance(),de=K.length,me=se,be=V(K,de,se),pe=le.getGraphemeBreakType(be);se+=be>=65536?2:1;let we=pe;for(;se<de;){const Re=V(K,de,se),Le=le.getGraphemeBreakType(Re);if(ee(we,Le))break;se+=Re>=65536?2:1,we=Le}const Ce=se;for(se=me,we=pe;se>0;){const Re=j(K,se),Le=le.getGraphemeBreakType(Re);if(ee(Le,we))break;se-=Re>=65536?2:1,we=Le}return[se,Ce]}function G(K,se){return se>0&&Y(K.charCodeAt(se))?F(K,se-1):F(K,se)}e.getCharContainingOffset=G;const x=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function N(K){return x.test(K)}e.containsRTL=N;const W=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function X(K){return W.test(K)}e.containsEmoji=X;const Z=/^[\t\n\r\x20-\x7E]*$/;function B(K){return Z.test(K)}e.isBasicASCII=B,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function H(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=H;function ie(K){for(let se=0,le=K.length;se<le;se++)if(re(K.charCodeAt(se)))return!0;return!1}e.containsFullWidthCharacter=ie;function re(K){return K=+K,K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=re;function ae(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129003||K>=129280&&K<=129535||K>=129648&&K<=129750}e.isEmojiImprecise=ae;function ue(K,se){if(K.length<se)return K;const le=/\b/g;let de=0;for(;le.test(K)&&!(K.length-le.lastIndex<se);)de=le.lastIndex,le.lastIndex+=1;return K.substring(de).replace(/^\s/,"")}e.lcut=ue;const fe=/\x1B\x5B[12]?K/g,ge=/\x1b\[\d+m/g,Ie=/\x1b\[0?m/g;function Pe(K){return K&&(K=K.replace(fe,""),K=K.replace(ge,""),K=K.replace(Ie,"")),K}e.removeAnsiEscapeCodes=Pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ee(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ee;function _e(K){return Ee(K)?K.substr(1):K}e.stripUTF8BOM=_e;function De(K,se){if(!K||!se||K.length<se.length)return!1;const le=se.length,de=K.toLowerCase();let me=0,be=-1;for(;me<le;){const pe=de.indexOf(se[me],be+1);if(pe<0)return!1;be=pe,me++}return!0}e.fuzzyContains=De;function Te(K,se=!1){return K?(se&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=Te;function Fe(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=Fe;function Ne(K,se=1){if(se===0)return"";let le=-1;do le=K.indexOf(`
`,le+1),se--;while(se>0&&le>=0);return le===-1?K:(K[le-1]==="\r"&&le--,K.substr(0,le))}e.getNLines=Ne;function ze(K){const se=90-65+1;return K=K%(2*se),K<se?String.fromCharCode(97+K):String.fromCharCode(65+K-se)}e.singleLetterHash=ze;function xe(K){return ce.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=xe;function ee(K,se){return K===0?se!==5&&se!==7:K===2&&se===3?!1:K===4||K===2||K===3||se===4||se===2||se===3?!0:!(K===8&&(se===8||se===9||se===11||se===12)||(K===11||K===9)&&(se===9||se===10)||(K===12||K===10)&&se===10||se===5||se===13||se===7||K===1||K===13&&se===14||K===6&&se===6)}e.breakBetweenGraphemeBreakType=ee;var oe;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(oe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ce{constructor(){this._data=ye()}static getInstance(){return ce._INSTANCE||(ce._INSTANCE=new ce),ce._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const le=this._data,de=le.length/3;let me=1;for(;me<=de;)if(se<le[3*me])me=2*me;else if(se>le[3*me+1])me=2*me+1;else return le[3*me+2];return 0}}ce._INSTANCE=null;function ye(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Se(K,se){if(K===0)return 0;const le=Oe(K,se);if(le!==void 0)return le;const de=j(se,K);return K-=ke(de),K}e.getLeftDeleteOffset=Se;function Oe(K,se){let le=j(se,K);for(K-=ke(le);Ue(le)||le===65039||le===8419;){if(K===0)return;le=j(se,K),K-=ke(le)}if(!!ae(le)){if(K>=0){const de=j(se,K);de===8205&&(K-=ke(de))}return K}}function ke(K){return K>=65536?2:1}function Ue(K){return 127995<=K&&K<=127999}var Ae;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(Ae||(Ae={}))}),define(te[18],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function R(d){return Array.isArray(d)}e.isArray=R;function k(d){return typeof d=="string"}e.isString=k;function D(d){return Array.isArray(d)&&d.every(m=>k(m))}e.isStringArray=D;function T(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}e.isObject=T;function L(d){return typeof d=="number"&&!isNaN(d)}e.isNumber=L;function P(d){return!!d&&typeof d[Symbol.iterator]=="function"}e.isIterable=P;function y(d){return d===!0||d===!1}e.isBoolean=y;function I(d){return typeof d=="undefined"}e.isUndefined=I;function i(d){return!C(d)}e.isDefined=i;function C(d){return I(d)||d===null}e.isUndefinedOrNull=C;function g(d,m){if(!d)throw new Error(m?`Unexpected type, expected '${m}'`:"Unexpected type")}e.assertType=g;function E(d){if(C(d))throw new Error("Assertion Failed: argument is undefined or null");return d}e.assertIsDefined=E;function u(...d){const m=[];for(let A=0;A<d.length;A++){const _=d[A];if(C(_))throw new Error(`Assertion Failed: argument at index ${A} is undefined or null`);m.push(_)}return m}e.assertAllDefined=u;const p=Object.prototype.hasOwnProperty;function f(d){if(!T(d))return!1;for(let m in d)if(p.call(d,m))return!1;return!0}e.isEmptyObject=f;function b(d){return typeof d=="function"}e.isFunction=b;function v(...d){return d.length>0&&d.every(b)}e.areFunctions=v;function S(d,m){const A=Math.min(d.length,m.length);for(let _=0;_<A;_++)c(d[_],m[_])}e.validateConstraints=S;function c(d,m){if(k(m)){if(typeof d!==m)throw new Error(`argument does not match constraint: typeof ${m}`)}else if(b(m)){try{if(d instanceof m)return}catch{}if(!C(d)&&d.constructor===m||m.length===1&&m.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function a(d){let m=[],A=Object.getPrototypeOf(d);for(;Object.prototype!==A;)m=m.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return m}e.getAllPropertyNames=a;function t(d){const m=[];for(const A of a(d))typeof d[A]=="function"&&m.push(A);return m}e.getAllMethodNames=t;function s(d,m){const A=w=>function(){const O=Array.prototype.slice.call(arguments,0);return m(w,O)};let _={};for(const w of d)_[w]=A(w);return _}e.createProxyObject=s;function n(d){return d===null?void 0:d}e.withNullAsUndefined=n;function r(d){return typeof d=="undefined"?null:d}e.withUndefinedAsNull=r;function o(d){return class{constructor(){return new Proxy({},{get(m,A){if(m[A])return m[A];throw new Error(`Not Implemented: ${d}->${String(A)}`)}})}}}e.NotImplementedProxy=o;function l(d,m="Unreachable"){throw new Error(m)}e.assertNever=l;function h(d){return!!d&&typeof d.then=="function"&&typeof d.catch=="function"}e.isPromise=h}),define(te[40],ne([0,1,9,4,25,18]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function L(n){return n===47||n===92}e.isPathSeparator=L;function P(n){return n.replace(/[\\/]/g,R.posix.sep)}e.toSlashes=P;function y(n){return n.indexOf("/")===-1&&(n=P(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=y;function I(n,r=R.posix.sep){if(!n)return"";const o=n.length,l=n.charCodeAt(0);if(L(l)){if(L(n.charCodeAt(1))&&!L(n.charCodeAt(2))){let d=3;const m=d;for(;d<o&&!L(n.charCodeAt(d));d++);if(m!==d&&!L(n.charCodeAt(d+1))){for(d+=1;d<o;d++)if(L(n.charCodeAt(d)))return n.slice(0,d+1).replace(/[\\/]/g,r)}}return r}else if(b(l)&&n.charCodeAt(1)===58)return L(n.charCodeAt(2))?n.slice(0,2)+r:n.slice(0,2);let h=n.indexOf("://");if(h!==-1){for(h+=3;h<o;h++)if(L(n.charCodeAt(h)))return n.slice(0,h+1)}return""}e.getRoot=I;function i(n){if(!k.isWindows||!n||n.length<5)return!1;let r=n.charCodeAt(0);if(r!==92||(r=n.charCodeAt(1),r!==92))return!1;let o=2;const l=o;for(;o<n.length&&(r=n.charCodeAt(o),r!==92);o++);return!(l===o||(r=n.charCodeAt(o+1),isNaN(r)||r===92))}e.isUNC=i;const C=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(n,r=k.isWindows){const o=r?C:g;return!(!n||n.length===0||/^\s+$/.test(n)||(o.lastIndex=0,o.test(n))||r&&E.test(n)||n==="."||n===".."||r&&n[n.length-1]==="."||r&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=u;function p(n,r,o){const l=n===r;return!o||l?l:!n||!r?!1:(0,D.equalsIgnoreCase)(n,r)}e.isEqual=p;function f(n,r,o,l=R.sep){if(n===r)return!0;if(!n||!r||r.length>n.length)return!1;if(o){if(!(0,D.startsWithIgnoreCase)(n,r))return!1;if(r.length===n.length)return!0;let d=r.length;return r.charAt(r.length-1)===l&&d--,n.charAt(d)===l}return r.charAt(r.length-1)!==l&&(r+=l),n.indexOf(r)===0}e.isEqualOrParent=f;function b(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=b;function v(n,r){return k.isWindows&&n.endsWith(":")&&(n+=R.sep),(0,R.isAbsolute)(n)||(n=(0,R.join)(r,n)),n=(0,R.normalize)(n),k.isWindows?(n=(0,D.rtrim)(n,R.sep),n.endsWith(":")&&(n+=R.sep)):(n=(0,D.rtrim)(n,R.sep),n||(n=R.sep)),n}e.sanitizeFilePath=v;function S(n){const r=(0,R.normalize)(n);return k.isWindows?n.length>3?!1:c(r)&&(n.length===2||r.charCodeAt(2)===92):r===R.posix.sep}e.isRootOrDriveLetter=S;function c(n){return k.isWindows?b(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function a(n){return c(n)?n[0]:void 0}e.getDriveLetter=a;function t(n,r,o){return r.length>n.length?-1:n===r?0:(o&&(n=n.toLowerCase(),r=r.toLowerCase()),n.indexOf(r))}e.indexOfPath=t;function s(n){const r=n.split(":");let o,l,h;if(r.forEach(d=>{const m=Number(d);(0,T.isNumber)(m)?l===void 0?l=m:h===void 0&&(h=m):o=o?[o,d].join(":"):d}),!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:l!==void 0?l:void 0,column:h!==void 0?h:l!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(te[26],ne([0,1,18]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function k(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const f=Array.isArray(p)?[]:{};return Object.keys(p).forEach(b=>{p[b]&&typeof p[b]=="object"?f[b]=k(p[b]):f[b]=p[b]}),f}e.deepClone=k;function D(p){if(!p||typeof p!="object")return p;const f=[p];for(;f.length>0;){const b=f.shift();Object.freeze(b);for(const v in b)if(T.call(b,v)){const S=b[v];typeof S=="object"&&!Object.isFrozen(S)&&f.push(S)}}return p}e.deepFreeze=D;const T=Object.prototype.hasOwnProperty;function L(p,f){return P(p,f,new Set)}e.cloneAndChange=L;function P(p,f,b){if((0,R.isUndefinedOrNull)(p))return p;const v=f(p);if(typeof v!="undefined")return v;if((0,R.isArray)(p)){const S=[];for(const c of p)S.push(P(c,f,b));return S}if((0,R.isObject)(p)){if(b.has(p))throw new Error("Cannot clone recursive data-structure");b.add(p);const S={};for(let c in p)T.call(p,c)&&(S[c]=P(p[c],f,b));return b.delete(p),S}return p}function y(p,f,b=!0){return(0,R.isObject)(p)?((0,R.isObject)(f)&&Object.keys(f).forEach(v=>{v in p?b&&((0,R.isObject)(p[v])&&(0,R.isObject)(f[v])?y(p[v],f[v],b):p[v]=f[v]):p[v]=f[v]}),p):f}e.mixin=y;function I(p,f){if(p===f)return!0;if(p==null||f===null||f===void 0||typeof p!=typeof f||typeof p!="object"||Array.isArray(p)!==Array.isArray(f))return!1;let b,v;if(Array.isArray(p)){if(p.length!==f.length)return!1;for(b=0;b<p.length;b++)if(!I(p[b],f[b]))return!1}else{const S=[];for(v in p)S.push(v);S.sort();const c=[];for(v in f)c.push(v);if(c.sort(),!I(S,c))return!1;for(b=0;b<S.length;b++)if(!I(p[S[b]],f[S[b]]))return!1}return!0}e.equals=I;function i(p){const f=new Set;return JSON.stringify(p,(b,v)=>{if((0,R.isObject)(v)||Array.isArray(v)){if(f.has(v))return"[Circular]";f.add(v)}return v})}e.safeStringify=i;function C(p,f,b){const v=f(p);return typeof v=="undefined"?b:v}e.getOrDefault=C;function g(p,f){const b=Object.create(null);return!p||!f||Object.keys(f).forEach(S=>{const c=p[S],a=f[S];I(c,a)||(b[S]=a)}),b}e.distinct=g;function E(p,f){const b=f.toLowerCase(),v=Object.keys(p).find(S=>S.toLowerCase()===b);return v?p[v]:p[f]}e.getCaseInsensitive=E;function u(p,f){const b=Object.create(null);for(const v of Object.keys(p))f(v,p[v])&&(b[v]=p[v]);return b}e.filter=u}),define(te[7],ne([0,1,9,4]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,T=/^\//,L=/^\/\//;function P(n,r){if(!n.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!D.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!T.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(n,r){return!n&&!r?"file":n}function I(n,r){switch(n){case"https":case"http":case"file":r?r[0]!==C&&(r=C+r):r=C;break}return r}const i="",C="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class E{constructor(r,o,l,h,d,m=!1){typeof r=="object"?(this.scheme=r.scheme||i,this.authority=r.authority||i,this.path=r.path||i,this.query=r.query||i,this.fragment=r.fragment||i):(this.scheme=y(r,m),this.authority=o||i,this.path=I(this.scheme,l||i),this.query=h||i,this.fragment=d||i,P(this,m))}static isUri(r){return r instanceof E?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return S(this,!1)}with(r){if(!r)return this;let{scheme:o,authority:l,path:h,query:d,fragment:m}=r;return o===void 0?o=this.scheme:o===null&&(o=i),l===void 0?l=this.authority:l===null&&(l=i),h===void 0?h=this.path:h===null&&(h=i),d===void 0?d=this.query:d===null&&(d=i),m===void 0?m=this.fragment:m===null&&(m=i),o===this.scheme&&l===this.authority&&h===this.path&&d===this.query&&m===this.fragment?this:new p(o,l,h,d,m)}static parse(r,o=!1){const l=g.exec(r);return l?new p(l[2]||i,s(l[4]||i),s(l[5]||i),s(l[7]||i),s(l[9]||i),o):new p(i,i,i,i,i)}static file(r){let o=i;if(k.isWindows&&(r=r.replace(/\\/g,C)),r[0]===C&&r[1]===C){const l=r.indexOf(C,2);l===-1?(o=r.substring(2),r=C):(o=r.substring(2,l),r=r.substring(l)||C)}return new p("file",o,r,i,i)}static from(r){const o=new p(r.scheme,r.authority,r.path,r.query,r.fragment);return P(o,!0),o}static joinPath(r,...o){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return k.isWindows&&r.scheme==="file"?l=E.file(R.win32.join(S(r,!0),...o)).path:l=R.posix.join(r.path,...o),r.with({path:l})}toString(r=!1){return c(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof E)return r;{const o=new p(r);return o._formatted=r.external,o._fsPath=r._sep===u?r.fsPath:null,o}}else return r}}e.URI=E;const u=k.isWindows?1:void 0;class p extends E{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=S(this,!1)),this._fsPath}toString(r=!1){return r?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=u),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const f={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(n,r){let o,l=-1;for(let h=0;h<n.length;h++){const d=n.charCodeAt(h);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||r&&d===47)l!==-1&&(o+=encodeURIComponent(n.substring(l,h)),l=-1),o!==void 0&&(o+=n.charAt(h));else{o===void 0&&(o=n.substr(0,h));const m=f[d];m!==void 0?(l!==-1&&(o+=encodeURIComponent(n.substring(l,h)),l=-1),o+=m):l===-1&&(l=h)}}return l!==-1&&(o+=encodeURIComponent(n.substring(l))),o!==void 0?o:n}function v(n){let r;for(let o=0;o<n.length;o++){const l=n.charCodeAt(o);l===35||l===63?(r===void 0&&(r=n.substr(0,o)),r+=f[l]):r!==void 0&&(r+=n[o])}return r!==void 0?r:n}function S(n,r){let o;return n.authority&&n.path.length>1&&n.scheme==="file"?o=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?r?o=n.path.substr(1):o=n.path[1].toLowerCase()+n.path.substr(2):o=n.path,k.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=S;function c(n,r){const o=r?v:b;let l="",{scheme:h,authority:d,path:m,query:A,fragment:_}=n;if(h&&(l+=h,l+=":"),(d||h==="file")&&(l+=C,l+=C),d){let w=d.indexOf("@");if(w!==-1){const O=d.substr(0,w);d=d.substr(w+1),w=O.indexOf(":"),w===-1?l+=o(O,!1):(l+=o(O.substr(0,w),!1),l+=":",l+=o(O.substr(w+1),!1)),l+="@"}d=d.toLowerCase(),w=d.indexOf(":"),w===-1?l+=o(d,!1):(l+=o(d.substr(0,w),!1),l+=d.substr(w))}if(m){if(m.length>=3&&m.charCodeAt(0)===47&&m.charCodeAt(2)===58){const w=m.charCodeAt(1);w>=65&&w<=90&&(m=`/${String.fromCharCode(w+32)}:${m.substr(3)}`)}else if(m.length>=2&&m.charCodeAt(1)===58){const w=m.charCodeAt(0);w>=65&&w<=90&&(m=`${String.fromCharCode(w+32)}:${m.substr(2)}`)}l+=o(m,!0)}return A&&(l+="?",l+=o(A,!1)),_&&(l+="#",l+=r?_:b(_,!1)),l}function a(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+a(n.substr(3)):n}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(n){return n.match(t)?n.replace(t,r=>a(r)):n}}),define(te[99],ne([0,1,7]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function k(I){const i=I;return i&&typeof i.type=="string"&&typeof i.severity=="string"}e.isRemoteConsoleLog=k;function D(I){const i=[];let C;try{const g=JSON.parse(I.arguments),E=g[g.length-1];E&&E.__$stack&&(g.pop(),C=E.__$stack),i.push(...g)}catch(g){i.push("Unable to log remote console arguments",I.arguments)}return{args:i,stack:C}}e.parse=D;function T(I){if(typeof I!="string")return T(D(I).stack);const i=I;if(i){const C=L(i),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(g&&g.length===4)return{uri:R.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.getFirstFrame=T;function L(I){if(!I)return I;const i=I.indexOf(`
`);return i===-1?I:I.substring(0,i)}function P(I,i){const{args:C,stack:g}=D(I),E=typeof C[0]=="string"&&C.length===1;let u=L(g);u&&(u=`(${u.trim()})`);let p=[];if(typeof C[0]=="string"?u&&E?p=[`%c[${i}] %c${C[0]} %c${u}`,y("blue"),y(""),y("grey")]:p=[`%c[${i}] %c${C[0]}`,y("blue"),y(""),...C.slice(1)]:p=[`%c[${i}]%`,y("blue"),...C],u&&!E&&p.push(u),typeof console[I.severity]!="function")throw new Error("Unknown console method");console[I.severity].apply(console,p)}e.log=P;function y(I){return`color: ${I}`}});var St=this&&this.__classPrivateFieldSet||function(J,e,R,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(J,R):D?D.value=R:e.set(J,R),R},We=this&&this.__classPrivateFieldGet||function(J,e,R,k){if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return R==="m"?k:R==="a"?k.call(J):k?k.value:e.get(J)};define(te[41],ne([0,1,17,25,7]),function(J,e,R,k,D){"use strict";var T,L,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function y(s,n,r){let o=s.get(n);return o===void 0&&(o=r,s.set(n,o)),o}e.getOrSet=y;function I(s){const n=[];return s.forEach((r,o)=>{n.push(`${o} => ${r}`)}),`Map(${s.size}) {${n.join(", ")}}`}e.mapToString=I;function i(s){const n=[];return s.forEach(r=>{n.push(r)}),`Set(${s.size}) {${n.join(", ")}}`}e.setToString=i;class C{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const r=n.charCodeAt(0),o=this._value.charCodeAt(this._pos);return r-o}value(){return this._value[this._pos]}}e.StringIterator=C;class g{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,k.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=g;class E{constructor(n=!0,r=!0){this._splitOnBackslash=n,this._caseSensitive=r}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,k.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=E;var u;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(u||(u={}));class p{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new E(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,k.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,k.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,k.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,k.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=p;class f{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class b{constructor(n){this._iter=n}static forUris(n=()=>!1){return new b(new p(n))}static forPaths(){return new b(new E)}static forStrings(){return new b(new C)}static forConfigKeys(){return new b(new g)}clear(){this._root=void 0}set(n,r){const o=this._iter.reset(n);let l;for(this._root||(this._root=new f,this._root.segment=o.value()),l=this._root;;){const d=o.cmp(l.segment);if(d>0)l.left||(l.left=new f,l.left.segment=o.value()),l=l.left;else if(d<0)l.right||(l.right=new f,l.right.segment=o.value()),l=l.right;else if(o.hasNext())o.next(),l.mid||(l.mid=new f,l.mid.segment=o.value()),l=l.mid;else break}const h=l.value;return l.value=r,l.key=n,h}fill(n,r){const o=r.slice(0);(0,R.shuffle)(o);for(let l of o)this.set(l,n)}get(n){return this._getNode(n)?.value}_getNode(n){const r=this._iter.reset(n);let o=this._root;for(;o;){const l=r.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else break}return o}has(n){const r=this._getNode(n);return!(r?.value===void 0&&r?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,r){const o=this._iter.reset(n),l=[];let h=this._root;for(;h;){const d=o.cmp(h.segment);if(d>0)l.push([1,h]),h=h.left;else if(d<0)l.push([-1,h]),h=h.right;else if(o.hasNext())o.next(),l.push([0,h]),h=h.mid;else{for(r?(h.left=void 0,h.mid=void 0,h.right=void 0):h.value=void 0;l.length>0&&h.isEmpty();){let[m,A]=l.pop();switch(m){case 1:A.left=void 0;break;case 0:A.mid=void 0;break;case-1:A.right=void 0;break}h=A}break}}}findSubstr(n){const r=this._iter.reset(n);let o=this._root,l;for(;o;){const h=r.cmp(o.segment);if(h>0)o=o.left;else if(h<0)o=o.right;else if(r.hasNext())r.next(),l=o.value||l,o=o.mid;else break}return o&&o.value||l}findSuperstr(n){const r=this._iter.reset(n);let o=this._root;for(;o;){const l=r.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(n){for(const[r,o]of this)n(o,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){if(!n)return;const r=[n];for(;r.length>0;){const o=r.pop();o&&(o.value&&(yield[o.key,o.value]),o.left&&r.push(o.left),o.mid&&r.push(o.mid),o.right&&r.push(o.right))}}}e.TernarySearchTree=b;class v{constructor(n,r){this[T]="ResourceMap",n instanceof v?(this.map=new Map(n.map),this.toKey=r??v.defaultToKey):(this.map=new Map,this.toKey=n??v.defaultToKey)}set(n,r){return this.map.set(this.toKey(n),r),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,r){typeof r!="undefined"&&(n=n.bind(r));for(let[o,l]of this.map)n(l,D.URI.parse(o),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield D.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[D.URI.parse(n[0]),n[1]]}*[(T=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[D.URI.parse(n[0]),n[1]]}}e.ResourceMap=v,v.defaultToKey=s=>s.toString();var S;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(S=e.Touch||(e.Touch={}));class c{constructor(){this[L]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,r=0){const o=this._map.get(n);if(!!o)return r!==0&&this.touch(o,r),o.value}set(n,r,o=0){let l=this._map.get(n);if(l)l.value=r,o!==0&&this.touch(l,o);else{switch(l={key:n,value:r,next:void 0,previous:void 0},o){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(n,l),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const r=this._map.get(n);if(!!r)return this._map.delete(n),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,r){const o=this._state;let l=this._head;for(;l;){if(r?n.bind(r)(l.value,l.key,this):n(l.value,l.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const n=this,r=this._state;let o=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const h={value:o.key,done:!1};return o=o.next,h}else return{value:void 0,done:!0}}};return l}values(){const n=this,r=this._state;let o=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const h={value:o.value,done:!1};return o=o.next,h}else return{value:void 0,done:!0}}};return l}entries(){const n=this,r=this._state;let o=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const h={value:[o.key,o.value],done:!1};return o=o.next,h}else return{value:void 0,done:!0}}};return l}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let r=this._head,o=this.size;for(;r&&o>n;)this._map.delete(r.key),r=r.next,o--;this._head=r,this._size=o,r&&(r.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const r=n.next,o=n.previous;if(!r||!o)throw new Error("Invalid list");r.previous=o,o.next=r}n.next=void 0,n.previous=void 0,this._state++}touch(n,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(n===this._head)return;const o=n.next,l=n.previous;n===this._tail?(l.next=void 0,this._tail=l):(o.previous=l,l.next=o),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(r===2){if(n===this._tail)return;const o=n.next,l=n.previous;n===this._head?(o.previous=void 0,this._head=o):(o.previous=l,l.next=o),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((r,o)=>{n.push([o,r])}),n}fromJSON(n){this.clear();for(const[r,o]of n)this.set(r,o)}}e.LinkedMap=c;class a extends c{constructor(n,r=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,r=2){return super.get(n,r)}peek(n){return super.get(n,0)}set(n,r){return super.set(n,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class t{constructor(n){P.set(this,void 0),St(this,P,n,"f")}get size(){return We(this,P,"f").size}forEach(n,r){We(this,P,"f").forEach(n,r)}get(n){return We(this,P,"f").get(n)}has(n){return We(this,P,"f").has(n)}entries(){return We(this,P,"f").entries()}keys(){return We(this,P,"f").keys()}values(){return We(this,P,"f").values()}[(P=new WeakMap,Symbol.iterator)](){return We(this,P,"f").entries()}}e.ReadonlyMapView=t}),define(te[100],ne([0,1,21,25,7]),function(J,e,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function T(i){return JSON.stringify(i,y)}e.stringify=T;function L(i){let C=JSON.parse(i);return C=I(C),C}e.parse=L;var P;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(P=e.MarshalledId||(e.MarshalledId={}));function y(i,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,k.regExpFlags)(C)}:C}function I(i,C=0){if(!i||C>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return D.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof R.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let g=0;g<i.length;++g)i[g]=I(i[g],C+1);else for(const g in i)Object.hasOwnProperty.call(i,g)&&(i[g]=I(i[g],C+1))}return i}e.revive=I}),define(te[15],ne([0,1,4,7]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp"})(D=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,I,i){this._hosts[y]=I,this._ports[y]=i}setConnectionToken(y,I){this._connectionTokens[y]=I}rewrite(y){if(this._delegate)return this._delegate(y);const I=y.authority;let i=this._hosts[I];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const C=this._ports[I],g=this._connectionTokens[I];let E=`path=${encodeURIComponent(y.path)}`;return typeof g=="string"&&(E+=`&tkn=${encodeURIComponent(g)}`),k.URI.from({scheme:R.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${i}:${C}`,path:"/vscode-remote-resource",query:E})}}e.RemoteAuthorities=new T;class L{asBrowserUri(y,I){const i=this.toUri(y,I);return i.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(i):i.scheme===D.file&&(R.isNative||typeof R.globals.importScripts=="function"&&R.globals.origin===`${D.vscodeFileResource}://${L.FALLBACK_AUTHORITY}`)?i.with({scheme:D.vscodeFileResource,authority:i.authority||L.FALLBACK_AUTHORITY,query:null,fragment:null}):i}asFileUri(y,I){const i=this.toUri(y,I);return i.scheme===D.vscodeFileResource?i.with({scheme:D.file,authority:i.authority!==L.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(y,I){return k.URI.isUri(y)?y:k.URI.parse(I.toUrl(y))}}L.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new L}),define(te[68],ne([0,1,41]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const k=new R.LRUCache(1e4);function D(I){return y(I,"NFC",k)}e.normalizeNFC=D;const T=new R.LRUCache(1e4);function L(I){return y(I,"NFD",T)}e.normalizeNFD=L;const P=/[^\u0000-\u0080]/;function y(I,i,C){if(!I)return I;const g=C.get(I);if(g)return g;let E;return P.test(I)?E=I.normalize(i):E=I,C.set(I,E),E}e.removeAccents=function(){const I=/[\u0300-\u036f]/g;return function(i){return L(i).replace(I,"")}}()}),define(te[16],ne([0,1,40,15,9,4,25,7]),function(J,e,R,k,D,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(E){return(0,P.uriToFsPath)(E,!0)}e.originalFSPath=y;class I{constructor(u){this._ignorePathCasing=u}compare(u,p,f=!1){return u===p?0:(0,L.compare)(this.getComparisonKey(u,f),this.getComparisonKey(p,f))}isEqual(u,p,f=!1){return u===p?!0:!u||!p?!1:this.getComparisonKey(u,f)===this.getComparisonKey(p,f)}getComparisonKey(u,p=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,p,f=!1){if(u.scheme===p.scheme){if(u.scheme===k.Schemas.file)return R.isEqualOrParent(y(u),y(p),this._ignorePathCasing(u))&&u.query===p.query&&(f||u.fragment===p.fragment);if((0,e.isEqualAuthority)(u.authority,p.authority))return R.isEqualOrParent(u.path,p.path,this._ignorePathCasing(u),"/")&&u.query===p.query&&(f||u.fragment===p.fragment)}return!1}joinPath(u,...p){return P.URI.joinPath(u,...p)}basenameOrAuthority(u){return(0,e.basename)(u)||u.authority}basename(u){return D.posix.basename(u.path)}extname(u){return D.posix.extname(u.path)}dirname(u){if(u.path.length===0)return u;let p;return u.scheme===k.Schemas.file?p=P.URI.file(D.dirname(y(u))).path:(p=D.posix.dirname(u.path),u.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),p="/")),u.with({path:p})}normalizePath(u){if(!u.path.length)return u;let p;return u.scheme===k.Schemas.file?p=P.URI.file(D.normalize(y(u))).path:p=D.posix.normalize(u.path),u.with({path:p})}relativePath(u,p){if(u.scheme!==p.scheme||!(0,e.isEqualAuthority)(u.authority,p.authority))return;if(u.scheme===k.Schemas.file){const v=D.relative(y(u),y(p));return T.isWindows?R.toSlashes(v):v}let f=u.path||"/",b=p.path||"/";if(this._ignorePathCasing(u)){let v=0;for(const S=Math.min(f.length,b.length);v<S&&!(f.charCodeAt(v)!==b.charCodeAt(v)&&f.charAt(v).toLowerCase()!==b.charAt(v).toLowerCase());v++);f=b.substr(0,v)+f.substr(v)}return D.posix.relative(f,b)}resolvePath(u,p){if(u.scheme===k.Schemas.file){const f=P.URI.file(D.resolve(y(u),p));return u.with({authority:f.authority,path:f.path})}return p=R.toPosixPath(p),u.with({path:D.posix.resolve(u.path,p)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,p){return u===p||(0,L.equalsIgnoreCase)(u,p)}hasTrailingPathSeparator(u,p=D.sep){if(u.scheme===k.Schemas.file){const f=y(u);return f.length>R.getRoot(f).length&&f[f.length-1]===p}else{const f=u.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,p=D.sep){return(0,e.hasTrailingPathSeparator)(u,p)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,p=D.sep){let f=!1;if(u.scheme===k.Schemas.file){const b=y(u);f=b!==void 0&&b.length===R.getRoot(b).length&&b[b.length-1]===p}else{p="/";const b=u.path;f=b.length===1&&b.charCodeAt(b.length-1)===47}return!f&&!(0,e.hasTrailingPathSeparator)(u,p)?u.with({path:u.path+"/"}):u}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(E=>E.scheme===k.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new I(E=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(E,u){const p=[];for(let f=0;f<E.length;f++){const b=u(E[f]);E.some((v,S)=>S===f?!1:(0,e.isEqualOrParent)(b,u(v)))||p.push(E[f])}return p}e.distinctParents=i;var C;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function u(p){const f=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(S=>{const[c,a]=S.split(":");c&&a&&f.set(c,a)});const v=p.path.substring(0,p.path.indexOf(";"));return v&&f.set(E.META_DATA_MIME,v),f}E.parseMetaData=u})(C=e.DataUri||(e.DataUri={}));function g(E,u,p){if(u){let f=E.path;return f&&f[0]!==D.posix.sep&&(f=D.posix.sep+f),E.with({scheme:p,authority:u,path:f})}return E.with({scheme:p})}e.toLocalResource=g}),define(te[6],ne([0,1,27,8,3,2,16]),function(J,e,R,k,D,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(j){return!!j&&typeof j.then=="function"}e.isThenable=P;function y(j){const z=new R.CancellationTokenSource,q=j(z.token),F=new Promise((G,x)=>{const N=z.token.onCancellationRequested(()=>{N.dispose(),z.dispose(),x((0,k.canceled)())});Promise.resolve(q).then(W=>{N.dispose(),z.dispose(),G(W)},W=>{N.dispose(),z.dispose(),x(W)})});return new class{cancel(){z.cancel()}then(G,x){return F.then(G,x)}catch(G){return this.then(void 0,G)}finally(G){return F.finally(G)}}}e.createCancelablePromise=y;function I(j,z,q){return Promise.race([j,new Promise(F=>z.onCancellationRequested(()=>F(q)))])}e.raceCancellation=I;async function i(j){let z=-1;const q=j.map((G,x)=>G.then(N=>(z=x,N))),F=await Promise.race(q);return j.forEach((G,x)=>{x!==z&&G.cancel()}),F}e.raceCancellablePromises=i;function C(j,z,q){let F;const G=setTimeout(()=>{F?.(void 0),q?.()},z);return Promise.race([j.finally(()=>clearTimeout(G)),new Promise(x=>F=x)])}e.raceTimeout=C;function g(j){return new Promise((z,q)=>{const F=j();P(F)?F.then(z,q):z(F)})}e.asPromise=g;class E{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(z){if(this.activePromise){if(this.queuedPromiseFactory=z,!this.queuedPromise){const q=()=>{this.queuedPromise=null;const F=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,F};this.queuedPromise=new Promise(F=>{this.activePromise.then(q,q).then(F)})}return new Promise((q,F)=>{this.queuedPromise.then(q,F)})}return this.activePromise=z(),new Promise((q,F)=>{this.activePromise.then(G=>{this.activePromise=null,q(G)},G=>{this.activePromise=null,F(G)})})}}e.Throttler=E;class u{constructor(){this.current=Promise.resolve(null)}queue(z){return this.current=this.current.then(()=>z(),()=>z())}}e.Sequencer=u;class p{constructor(){this.promiseMap=new Map}queue(z,q){const G=(this.promiseMap.get(z)??Promise.resolve()).catch(()=>{}).then(q).finally(()=>{this.promiseMap.get(z)===G&&this.promiseMap.delete(z)});return this.promiseMap.set(z,G),G}}e.SequencerByKey=p;class f{constructor(z){this.defaultDelay=z,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(z,q=this.defaultDelay){return this.task=z,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((F,G)=>{this.doResolve=F,this.doReject=G}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const F=this.task;return this.task=null,F()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},q),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,k.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=f;class b{constructor(z){this.delayer=new f(z),this.throttler=new E}trigger(z,q){return this.delayer.trigger(()=>this.throttler.queue(z),q)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class v{constructor(){this._isOpen=!1,this._promise=new Promise((z,q)=>{this._completePromise=z})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=v;class S extends v{constructor(z){super();this._timeout=setTimeout(()=>this.open(),z)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=S;function c(j,z){return z?new Promise((q,F)=>{const G=setTimeout(()=>{x.dispose(),q()},j),x=z.onCancellationRequested(()=>{clearTimeout(G),x.dispose(),F((0,k.canceled)())})}):y(q=>c(j,q))}e.timeout=c;function a(j,z=0){const q=setTimeout(j,z);return(0,T.toDisposable)(()=>clearTimeout(q))}e.disposableTimeout=a;function t(j){const z=[];let q=0;const F=j.length;function G(){return q<F?j[q++]():null}function x(N){N!=null&&z.push(N);const W=G();return W?W.then(x):Promise.resolve(z)}return Promise.resolve(null).then(x)}e.sequence=t;function s(j,z=F=>!!F,q=null){let F=0;const G=j.length,x=()=>{if(F>=G)return Promise.resolve(q);const N=j[F++];return Promise.resolve(N()).then(X=>z(X)?Promise.resolve(X):x())};return x()}e.first=s;function n(j,z=F=>!!F,q=null){if(j.length===0)return Promise.resolve(q);let F=j.length;const G=()=>{F=-1;for(const x of j)x.cancel?.()};return new Promise((x,N)=>{for(const W of j)W.then(X=>{--F>=0&&z(X)?(G(),x(X)):F===0&&x(q)}).catch(X=>{--F>=0&&(G(),N(X))})})}e.firstParallel=n;class r{constructor(z){this._size=0,this.maxDegreeOfParalellism=z,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(z){return this._size++,new Promise((q,F)=>{this.outstandingPromises.push({factory:z,c:q,e:F}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const z=this.outstandingPromises.shift();this.runningPromises++;const q=z.factory();q.then(z.c,z.e),q.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=r;class o extends r{constructor(){super(1)}}e.Queue=o;class l{constructor(){this.queues=new Map}queueFor(z,q=L.extUri){const F=q.getComparisonKey(z);let G=this.queues.get(F);return G||(G=new o,D.Event.once(G.onFinished)(()=>{G?.dispose(),this.queues.delete(F)}),this.queues.set(F,G)),G}dispose(){this.queues.forEach(z=>z.dispose()),this.queues.clear()}}e.ResourceQueue=l;class h{constructor(z,q){this._token=-1,typeof z=="function"&&typeof q=="number"&&this.setIfNotSet(z,q)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(z,q){this.cancel(),this._token=setTimeout(()=>{this._token=-1,z()},q)}setIfNotSet(z,q){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,z()},q))}}e.TimeoutTimer=h;class d{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(z,q){this.cancel(),this._token=setInterval(()=>{z()},q)}}e.IntervalTimer=d;class m{constructor(z,q){this.timeoutToken=-1,this.runner=z,this.timeout=q,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(z=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,z)}get delay(){return this.timeout}set delay(z){this.timeout=z}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=m;class A{constructor(z,q){q%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.runner=z,this.timeout=q,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(z=this.timeout){z%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(z/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=A;class _ extends m{constructor(z,q){super(z,q);this.units=[]}work(z){this.units.push(z),this.isScheduled()||this.schedule()}doRun(){const z=this.units;this.units=[],this.runner&&this.runner(z)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=_;class w extends T.Disposable{constructor(z,q,F,G){super();this.maxWorkChunkSize=z,this.maxPendingWork=q,this.throttleDelay=F,this.handler=G,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(z){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+z.length>this.maxPendingWork)return!1}else if(this.pending+z.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...z),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new m(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=w,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const j=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=z=>{const q=setTimeout(()=>z(j));let F=!1;return{dispose(){F||(F=!0,clearTimeout(q))}}}}else e.runWhenIdle=(j,z)=>{const q=requestIdleCallback(j,typeof z=="number"?{timeout:z}:void 0);let F=!1;return{dispose(){F||(F=!0,cancelIdleCallback(q))}}}}();class O{constructor(z){this._didRun=!1,this._executor=()=>{try{this._value=z()}catch(q){this._error=q}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=O;async function U(j,z,q){let F;for(let G=0;G<q;G++)try{return await j()}catch(x){F=x,await c(z)}throw F}e.retry=U;class ${hasPending(z){return this._pending?typeof z=="number"?this._pending.taskId===z:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(z,q,F){return this._pending={taskId:z,cancel:()=>F?.(),promise:q},q.then(()=>this.donePending(z),()=>this.donePending(z)),q}donePending(z){this._pending&&z===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const z=this._next;this._next=void 0,z.run().then(z.promiseResolve,z.promiseReject)}}setNext(z){if(this._next)this._next.run=z;else{let q,F;const G=new Promise((x,N)=>{q=x,F=N});this._next={run:z,promise:G,promiseResolve:q,promiseReject:F}}return this._next.promise}}e.TaskSequentializer=$;class Y{constructor(z){this.interval=z,this.lastIncrementTime=0,this.value=0}increment(){const z=Date.now();return z-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=z,this.value=0),this.value++,this.value}}e.IntervalCounter=Y;class M{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((z,q)=>{this.completeCallback=z,this.errorCallback=q})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(z){return new Promise(q=>{this.completeCallback(z),this.resolved=!0,q()})}error(z){return new Promise(q=>{this.errorCallback(z),this.rejected=!0,q()})}cancel(){new Promise(z=>{this.errorCallback((0,k.canceled)()),this.rejected=!0,z()})}}e.DeferredPromise=M;var V;(function(j){async function z(q){let F;const G=await Promise.all(q.map(x=>x.then(N=>N,N=>{F||(F=N)})));if(typeof F!="undefined")throw F;return G}j.settled=z})(V=e.Promises||(e.Promises={}))}),define(te[69],ne([0,1,6,40,41,9,25]),function(J,e,R,k,D,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const y="**",I="/",i="[/\\\\]",C="[^/\\\\]",g=/\//g;function E(F){switch(F){case 0:return"";case 1:return`${C}*?`;default:return`(?:${i}|${C}+${i}|${i}${C}+)*?`}}function u(F,G){if(!F)return[];const x=[];let N=!1,W=!1,X="";for(const Z of F){switch(Z){case G:if(!N&&!W){x.push(X),X="";continue}break;case"{":N=!0;break;case"}":N=!1;break;case"[":W=!0;break;case"]":W=!1;break}X+=Z}return X&&x.push(X),x}e.splitGlobAware=u;function p(F){if(!F)return"";let G="";const x=u(F,I);if(x.every(N=>N===y))G=".*";else{let N=!1;x.forEach((W,X)=>{if(W===y){N||(G+=E(2),N=!0);return}let Z=!1,B="",H=!1,ie="";for(const re of W){if(re!=="}"&&Z){B+=re;continue}if(H&&(re!=="]"||!ie)){let ae;re==="-"?ae=re:(re==="^"||re==="!")&&!ie?ae="^":re===I?ae="":ae=L.escapeRegExpCharacters(re),ie+=ae;continue}switch(re){case"{":Z=!0;continue;case"[":H=!0;continue;case"}":G+=`(?:${u(B,",").map(fe=>p(fe)).join("|")})`,Z=!1,B="";break;case"]":G+="["+ie+"]",H=!1,ie="";break;case"?":G+=C;continue;case"*":G+=E(1);continue;default:G+=L.escapeRegExpCharacters(re)}}X<x.length-1&&(x[X+1]!==y||X+2<x.length)&&(G+=i),N=!1})}return G}const f=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,S=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new D.LRUCache(1e4),s=function(){return!1},n=function(){return null};function r(F,G){if(!F)return n;let x;typeof F!="string"?x=F.pattern:x=F,x=x.trim();const N=`${x}_${!!G.trimForExclusions}`;let W=t.get(N);if(W)return o(W,F);let X;if(f.test(x)){const Z=x.substr(4);W=function(B,H){return typeof B=="string"&&B.endsWith(Z)?x:null}}else(X=b.exec(l(x,G)))?W=h(X[1],x):(G.trimForExclusions?S:v).test(x)?W=d(x,G):(X=c.exec(l(x,G)))?W=m(X[1].substr(1),x,!0):(X=a.exec(l(x,G)))?W=m(X[1],x,!1):W=A(x);return t.set(N,W),o(W,F)}function o(F,G){return typeof G=="string"?F:function(x,N){return k.isEqualOrParent(x,G.base)?F(T.relative(G.base,x),N):null}}function l(F,G){return G.trimForExclusions&&F.endsWith("/**")?F.substr(0,F.length-2):F}function h(F,G){const x=`/${F}`,N=`\\${F}`,W=function(Z,B){return typeof Z!="string"?null:B?B===F?G:null:Z===F||Z.endsWith(x)||Z.endsWith(N)?G:null},X=[F];return W.basenames=X,W.patterns=[G],W.allBasenames=X,W}function d(F,G){const x=q(F.slice(1,-1).split(",").map(B=>r(B,G)).filter(B=>B!==n),F),N=x.length;if(!N)return n;if(N===1)return x[0];const W=function(B,H){for(let ie=0,re=x.length;ie<re;ie++)if(x[ie](B,H))return F;return null},X=x.find(B=>!!B.allBasenames);X&&(W.allBasenames=X.allBasenames);const Z=x.reduce((B,H)=>H.allPaths?B.concat(H.allPaths):B,[]);return Z.length&&(W.allPaths=Z),W}function m(F,G,x){const N=T.sep===T.posix.sep,W=N?F:F.replace(g,T.sep),X=T.sep+W,Z=T.posix.sep+F,B=x?function(H,ie){return typeof H=="string"&&(H===W||H.endsWith(X)||!N&&(H===F||H.endsWith(Z)))?G:null}:function(H,ie){return typeof H=="string"&&(H===W||!N&&H===F)?G:null};return B.allPaths=[(x?"*/":"./")+F],B}function A(F){try{const G=new RegExp(`^${p(F)}$`);return function(x){return G.lastIndex=0,typeof x=="string"&&G.test(x)?F:null}}catch(G){return n}}function _(F,G,x){return!F||typeof G!="string"?!1:w(F)(G,void 0,x)}e.match=_;function w(F,G={}){if(!F)return s;if(typeof F=="string"||Y(F)){const x=r(F,G);if(x===n)return s;const N=function(W,X){return!!x(W,X)};return x.allBasenames&&(N.allBasenames=x.allBasenames),x.allPaths&&(N.allPaths=x.allPaths),N}return j(F,G)}e.parse=w;function O(F){if(!F)return;let G;return x=>(G||(G=(F()||Promise.resolve([])).then(N=>N?$(N):{})),G.then(N=>!!N[x]))}e.hasSiblingPromiseFn=O;function U(F){if(!F)return;let G;return x=>{if(!G){const N=F();G=N?$(N):{}}return!!G[x]}}e.hasSiblingFn=U;function $(F){const G={};for(const x of F)G[x]=!0;return G}function Y(F){const G=F;return G&&typeof G.base=="string"&&typeof G.pattern=="string"}e.isRelativePattern=Y;function M(F){return F.allBasenames||[]}e.getBasenameTerms=M;function V(F){return F.allPaths||[]}e.getPathTerms=V;function j(F,G){const x=q(Object.getOwnPropertyNames(F).map(B=>z(B,F[B],G)).filter(B=>B!==n)),N=x.length;if(!N)return n;if(!x.some(B=>!!B.requiresSiblings)){if(N===1)return x[0];const B=function(re,ae){for(let ue=0,fe=x.length;ue<fe;ue++){const ge=x[ue](re,ae);if(ge)return ge}return null},H=x.find(re=>!!re.allBasenames);H&&(B.allBasenames=H.allBasenames);const ie=x.reduce((re,ae)=>ae.allPaths?re.concat(ae.allPaths):re,[]);return ie.length&&(B.allPaths=ie),B}const W=function(B,H,ie){let re;for(let ae=0,ue=x.length;ae<ue;ae++){const fe=x[ae];fe.requiresSiblings&&ie&&(H||(H=T.basename(B)),re||(re=H.substr(0,H.length-T.extname(B).length)));const ge=fe(B,H,re,ie);if(ge)return ge}return null},X=x.find(B=>!!B.allBasenames);X&&(W.allBasenames=X.allBasenames);const Z=x.reduce((B,H)=>H.allPaths?B.concat(H.allPaths):B,[]);return Z.length&&(W.allPaths=Z),W}function z(F,G,x){if(G===!1)return n;const N=r(F,x);if(N===n)return n;if(typeof G=="boolean")return N;if(G){const W=G.when;if(typeof W=="string"){const X=(Z,B,H,ie)=>{if(!ie||!N(Z,B))return null;const re=W.replace("$(basename)",H),ae=ie(re);return(0,R.isThenable)(ae)?ae.then(ue=>ue?F:null):ae?F:null};return X.requiresSiblings=!0,X}}return N}function q(F,G){const x=F.filter(B=>!!B.basenames);if(x.length<2)return F;const N=x.reduce((B,H)=>{const ie=H.basenames;return ie?B.concat(ie):B},[]);let W;if(G){W=[];for(let B=0,H=N.length;B<H;B++)W.push(G)}else W=x.reduce((B,H)=>{const ie=H.patterns;return ie?B.concat(ie):B},[]);const X=function(B,H){if(typeof B!="string")return null;if(!H){let re;for(re=B.length;re>0;re--){const ae=B.charCodeAt(re-1);if(ae===47||ae===92)break}H=B.substr(re)}const ie=N.indexOf(H);return ie!==-1?W[ie]:null};X.basenames=N,X.patterns=W,X.allBasenames=N;const Z=F.filter(B=>!B.basenames);return Z.push(X),Z}}),define(te[101],ne([0,1,69,15,9,16,25]),function(J,e,R,k,D,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var P;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown",r.latex="text/latex"})(P=e.Mimes||(e.Mimes={}));let y=[],I=[],i=[];function C(r,o=!1){const l=g(r);y.push(l),l.userConfigured?i.push(l):I.push(l),o&&!l.userConfigured&&y.forEach(h=>{h.mime===l.mime||h.userConfigured||(l.extension&&h.extension===l.extension&&console.warn(`Overwriting extension <<${l.extension}>> to now point to mime <<${l.mime}>>`),l.filename&&h.filename===l.filename&&console.warn(`Overwriting filename <<${l.filename}>> to now point to mime <<${l.mime}>>`),l.filepattern&&h.filepattern===l.filepattern&&console.warn(`Overwriting filepattern <<${l.filepattern}>> to now point to mime <<${l.mime}>>`),l.firstline&&h.firstline===l.firstline&&console.warn(`Overwriting firstline <<${l.firstline}>> to now point to mime <<${l.mime}>>`))})}e.registerTextMime=C;function g(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?(0,R.parse)(r.filepattern.toLowerCase()):void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(D.posix.sep)>=0:!1}}function E(r){r?(y=y.filter(o=>!o.userConfigured),i=[]):(y=[],I=[],i=[])}e.clearTextMimes=E;function u(r,o){let l;if(r)switch(r.scheme){case k.Schemas.file:l=r.fsPath;break;case k.Schemas.data:l=T.DataUri.parseMetaData(r).get(T.DataUri.META_DATA_LABEL);break;default:l=r.path}if(!l)return[P.unknown];l=l.toLowerCase();const h=(0,D.basename)(l),d=p(l,h,i);if(d)return[d,P.text];const m=p(l,h,I);if(m)return[m,P.text];if(o){const A=f(o);if(A)return[A,P.text]}return[P.unknown]}e.guessMimeTypes=u;function p(r,o,l){let h=null,d=null,m=null;for(let A=l.length-1;A>=0;A--){const _=l[A];if(o===_.filenameLowercase){h=_;break}if(_.filepattern&&(!d||_.filepattern.length>d.filepattern.length)){const w=_.filepatternOnPath?r:o;_.filepatternLowercase?.(w)&&(d=_)}_.extension&&(!m||_.extension.length>m.extension.length)&&o.endsWith(_.extensionLowercase)&&(m=_)}return h?h.mime:d?d.mime:m?m.mime:null}function f(r){if((0,L.startsWithUTF8BOM)(r)&&(r=r.substr(1)),r.length>0)for(let o=y.length-1;o>=0;o--){const l=y[o];if(!l.firstline)continue;const h=r.match(l.firstline);if(h&&h.length>0)return l.mime}return null}function b(r){return r?typeof r=="string"?r===P.binary||r===P.text||r===P.unknown:r.length===1&&b(r[0]):!0}e.isUnspecific=b;const v={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},S={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function c(r){const o=(0,D.extname)(r),l=v[o.toLowerCase()];return l!==void 0?l:a(r)}e.getMediaOrTextMime=c;function a(r){const o=(0,D.extname)(r);return S[o.toLowerCase()]}e.getMediaMime=a;function t(r){for(const o in S)if(S[o]===r)return o}e.getExtensionForMimeType=t;const s=/^(.+)\/(.+?)(;.+)?$/;function n(r,o){const l=s.exec(r);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:o?void 0:r}e.normalizeMimeType=n}),define(te[102],ne([0,1,7]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function k(i){return i.toJSON()}class D{constructor(C){this._uriTransformer=C}transformIncoming(C){const g=this._uriTransformer.transformIncoming(C);return g===C?C:k(R.URI.from(g))}transformOutgoing(C){const g=this._uriTransformer.transformOutgoing(C);return g===C?C:k(R.URI.from(g))}transformOutgoingURI(C){const g=this._uriTransformer.transformOutgoing(C);return g===C?C:R.URI.from(g)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function T(i,C,g){if(!i||g>200)return null;if(typeof i=="object"){if(i instanceof R.URI)return C.transformOutgoing(i);for(let E in i)if(Object.hasOwnProperty.call(i,E)){const u=T(i[E],C,g+1);u!==null&&(i[E]=u)}}return null}function L(i,C){const g=T(i,C,0);return g===null?i:g}e.transformOutgoingURIs=L;function P(i,C,g,E){if(!i||E>200)return null;if(typeof i=="object"){if(i.$mid===1)return g?R.URI.revive(C.transformIncoming(i)):C.transformIncoming(i);for(let u in i)if(Object.hasOwnProperty.call(i,u)){const p=P(i[u],C,g,E+1);p!==null&&(i[u]=p)}}return null}function y(i,C){const g=P(i,C,!1,0);return g===null?i:g}e.transformIncomingURIs=y;function I(i,C){const g=P(i,C,!0,0);return g===null?i:g}e.transformAndReviveIncomingURIs=I}),define(te[30],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const R=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(y){return R.test(y)}e.isUUID=k;const D=new Uint8Array(16),T=[];for(let y=0;y<256;y++)T.push(y.toString(16).padStart(2,"0"));let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(y){for(let I=0;I<y.length;I++)y[I]=Math.floor(Math.random()*256);return y};function P(){L(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let y=0,I="";return I+=T[D[y++]],I+=T[D[y++]],I+=T[D[y++]],I+=T[D[y++]],I+="-",I+=T[D[y++]],I+=T[D[y++]],I+="-",I+=T[D[y++]],I+=T[D[y++]],I+="-",I+=T[D[y++]],I+=T[D[y++]],I+="-",I+=T[D[y++]],I+=T[D[y++]],I+=T[D[y++]],I+=T[D[y++]],I+=T[D[y++]],I+=T[D[y++]],I}e.generateUuid=P}),define(te[70],ne([0,1,103]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class k{constructor(T="utf8"){this.stringDecoder=new R.StringDecoder(T),this.remaining=null}write(T){const L=[],P=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(P.length<1)return L;let y=0,I,i=y;for(;i<P.length;)if(I=P.charCodeAt(i),I===13||I===10){if(L.push(P.substring(y,i)),i++,i<P.length){const C=I;I=P.charCodeAt(i),(C===13&&I===10||C===10&&I===13)&&i++}y=i}else i++;return this.remaining=y<P.length?P.substr(y):null,L}end(){return this.remaining}}e.LineDecoder=k}),define(te[104],ne([0,1,32]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const k=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(P){const y=P.replace(/\-/g,":").toLowerCase();return!k.has(y)}function T(){return new Promise(async(P,y)=>{const I=setTimeout(()=>y("Unable to retrieve mac address (timeout after 10s)"),1e4);try{P(await L())}catch(i){y(i)}finally{clearTimeout(I)}})}e.getMac=T;function L(){return new Promise((P,y)=>{try{const I=(0,R.networkInterfaces)();for(let i in I){const C=I[i];if(C){for(const{mac:g}of C)if(D(g))return P(g)}}y("Unable to retrieve mac address (unexpected format)")}catch(I){y(I)}})}}),define(te[105],ne([0,1,32,8,41,30,104]),function(J,e,R,k,D,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(i){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(i)}value(){if(this._value===void 0){let i=0,C=0;const g=(0,R.networkInterfaces)();for(let E in g){const u=g[E];if(u)for(const{mac:p,internal:f}of u)f||(C+=1,this._isVirtualMachineMacAddress(p.toUpperCase())&&(i+=1))}this._value=C>0?i/C:0}return this._value}};let P;async function y(){return P||(P=(async()=>await I()||T.generateUuid())()),P}e.getMachineId=y;async function I(){try{const i=await new Promise((g,E)=>{J(["crypto"],g,E)}),C=await(0,L.getMac)();return i.createHash("sha256").update(C,"utf8").digest("hex")}catch(i){k.onUnexpectedError(i);return}}}),define(te[19],ne([0,1,51,32,234,6,40,68,9,4,16,7,30]),function(J,e,R,k,D,T,L,P,y,I,i,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function u(M,V=E.UNLINK){if((0,L.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return V===E.UNLINK?f(M):p(M)}async function p(M){try{const V=(0,y.join)((0,k.tmpdir)(),(0,g.generateUuid)());try{await e.Promises.rename(M,V)}catch(j){return f(M)}f(V).catch(j=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function f(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function b(M){if((0,L.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");R.rmdirSync(M,{recursive:!0})}e.rimrafSync=b;async function v(M,V){return a(await(V?S(M):(0,D.promisify)(R.readdir)(M)))}async function S(M){try{return await(0,D.promisify)(R.readdir)(M,{withFileTypes:!0})}catch(z){console.warn("[node.js fs] readdir with filetypes failed with error: ",z)}const V=[],j=await v(M);for(const z of j){let q=!1,F=!1,G=!1;try{const x=await e.Promises.lstat((0,y.join)(M,z));q=x.isFile(),F=x.isDirectory(),G=x.isSymbolicLink()}catch(x){console.warn("[node.js fs] unexpected error from lstat after readdir: ",x)}V.push({name:z,isFile:()=>q,isDirectory:()=>F,isSymbolicLink:()=>G})}return V}function c(M){return a(R.readdirSync(M))}e.readdirSync=c;function a(M){return M.map(V=>typeof V=="string"?I.isMacintosh?(0,P.normalizeNFC)(V):V:(V.name=I.isMacintosh?(0,P.normalizeNFC)(V.name):V.name,V))}async function t(M){const V=await v(M),j=[];for(const z of V)await n.existsDirectory((0,y.join)(M,z))&&j.push(z);return j}function s(M,V=1e3){return new Promise(j=>{let z=!1;const q=setInterval(()=>{z||(z=!0,R.access(M,F=>{z=!1,F&&(clearInterval(q),j(void 0))}))},V)})}e.whenDeleted=s;var n;(function(M){async function V(q){let F;try{if(F=await e.Promises.lstat(q),!F.isSymbolicLink())return{stat:F}}catch(G){}try{return{stat:await e.Promises.stat(q),symbolicLink:F?.isSymbolicLink()?{dangling:!1}:void 0}}catch(G){if(G.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};if(I.isWindows&&G.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(x){if(x.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};throw x}throw G}}M.stat=V;async function j(q){try{const{stat:F,symbolicLink:G}=await M.stat(q);return F.isFile()&&G?.dangling!==!0}catch(F){}return!1}M.existsFile=j;async function z(q){try{const{stat:F,symbolicLink:G}=await M.stat(q);return F.isDirectory()&&G?.dangling!==!0}catch(F){}return!1}M.existsDirectory=z})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new T.ResourceQueue;function o(M,V,j){return r.queueFor(C.URI.file(M),i.extUriBiasedIgnorePathCase).queue(()=>{const z=m(j);return new Promise((q,F)=>h(M,V,z,G=>G?F(G):q()))})}let l=!0;function h(M,V,j,z){if(!l)return R.writeFile(M,V,{mode:j.mode,flag:j.flag},z);R.open(M,j.flag,j.mode,(q,F)=>{if(q)return z(q);R.writeFile(F,V,G=>{if(G)return R.close(F,()=>z(G));R.fdatasync(F,x=>(x&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",x),l=!1),R.close(F,N=>z(N))))})})}function d(M,V,j){const z=m(j);if(!l)return R.writeFileSync(M,V,{mode:z.mode,flag:z.flag});const q=R.openSync(M,z.flag,z.mode);try{R.writeFileSync(q,V);try{R.fdatasyncSync(q)}catch(F){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",F),l=!1}}finally{R.closeSync(q)}}e.writeFileSync=d;function m(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function A(M,V){if(M===V)return;async function j(z){try{const q=await e.Promises.lstat(z);if(q.isDirectory()||q.isSymbolicLink())return;await e.Promises.utimes(z,q.atime,new Date)}catch(q){}}try{await e.Promises.rename(M,V),await j(V)}catch(z){if(M.toLowerCase()!==V.toLowerCase()&&z.code==="EXDEV"||M.endsWith("."))await _(M,V,{preserveSymlinks:!1}),await u(M,E.MOVE),await j(V);else throw z}}async function _(M,V,j){return O(M,V,{root:{source:M,target:V},options:j,handledSourcePaths:new Set})}const w=511;async function O(M,V,j){if(j.handledSourcePaths.has(M))return;j.handledSourcePaths.add(M);const{stat:z,symbolicLink:q}=await n.stat(M);if(q){if(j.options.preserveSymlinks)try{return await Y(M,V,j)}catch(F){console.warn("[node.js fs] copy of symlink failed: ",F)}if(q.dangling)return}return z.isDirectory()?U(M,V,z.mode&w,j):$(M,V,z.mode&w)}async function U(M,V,j,z){await e.Promises.mkdir(V,{recursive:!0,mode:j});const q=await v(M);for(const F of q)await O((0,y.join)(M,F),(0,y.join)(V,F),z)}async function $(M,V,j){await e.Promises.copyFile(M,V),await e.Promises.chmod(V,j)}async function Y(M,V,j){let z=await e.Promises.readlink(M);(0,L.isEqualOrParent)(z,j.root.source,!I.isLinux)&&(z=(0,y.join)(j.root.target,z.substr(j.root.source.length+1))),await e.Promises.symlink(z,V)}e.Promises=new class{get access(){return(0,D.promisify)(R.access)}get stat(){return(0,D.promisify)(R.stat)}get lstat(){return(0,D.promisify)(R.lstat)}get utimes(){return(0,D.promisify)(R.utimes)}get read(){return(0,D.promisify)(R.read)}get readFile(){return(0,D.promisify)(R.readFile)}get write(){return(0,D.promisify)(R.write)}get appendFile(){return(0,D.promisify)(R.appendFile)}get fdatasync(){return(0,D.promisify)(R.fdatasync)}get truncate(){return(0,D.promisify)(R.truncate)}get rename(){return(0,D.promisify)(R.rename)}get copyFile(){return(0,D.promisify)(R.copyFile)}get open(){return(0,D.promisify)(R.open)}get close(){return(0,D.promisify)(R.close)}get symlink(){return(0,D.promisify)(R.symlink)}get readlink(){return(0,D.promisify)(R.readlink)}get chmod(){return(0,D.promisify)(R.chmod)}get mkdir(){return(0,D.promisify)(R.mkdir)}get unlink(){return(0,D.promisify)(R.unlink)}get rmdir(){return(0,D.promisify)(R.rmdir)}get realpath(){return(0,D.promisify)(R.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return v}get readDirsInDir(){return t}get writeFile(){return o}get rm(){return u}get move(){return A}get copy(){return _}}}),define(te[106],ne([0,1,51,9,25,19]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function L(i){const C=(0,k.dirname)(i);if(i===C)return i;const g=((0,k.basename)(i)||i).toLowerCase();try{const u=(0,T.readdirSync)(C).filter(p=>p.toLowerCase()===g);if(u.length===1){const p=L(C);if(p)return(0,k.join)(p,u[0])}else if(u.length>1){const p=u.indexOf(g);if(p>=0){const f=L(C);if(f)return(0,k.join)(f,u[p])}}}catch(E){}return null}e.realcaseSync=L;async function P(i){try{return await T.Promises.realpath(i)}catch(C){const g=I(i);return await T.Promises.access(g,R.constants.R_OK),g}}e.realpath=P;function y(i){try{return R.realpathSync(i)}catch(C){const g=I(i);return R.accessSync(g,R.constants.R_OK),g}}e.realpathSync=y;function I(i){return(0,D.rtrim)((0,k.normalize)(i),k.sep)}}),define(te[107],ne([0,1,56]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function k(P,y,I,i=1){let C=!1;return new Promise(g=>{const E=setTimeout(()=>{if(!C)return C=!0,g(0)},I);D(P,y,i,u=>{if(!C)return C=!0,clearTimeout(E),g(u)})})}e.findFreePort=k;function D(P,y,I,i){if(y===0)return i(0);const C=new R.Socket;C.once("connect",()=>(L(C),D(P+I,y-1,I,i))),C.once("data",()=>{}),C.once("error",g=>(L(C),g.code!=="ECONNREFUSED"?D(P+I,y-1,I,i):i(P))),C.connect(P,"127.0.0.1")}function T(P,y,I){let i=!1,C,g=1;const E=R.createServer({pauseOnConnect:!0});function u(p,f){i||(i=!0,E.removeAllListeners(),E.close(),C&&clearTimeout(C),f(p))}return new Promise(p=>{C=setTimeout(()=>{u(0,p)},I),E.on("listening",()=>{u(P,p)}),E.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&g<y?(P++,g++,E.listen(P,"127.0.0.1")):u(0,p)}),E.on("close",()=>{u(0,p)}),E.listen(P,"127.0.0.1")})}e.findFreePortFaster=T;function L(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(y){console.error(y)}}}),define(te[71],ne([0,1,32,9,19]),function(J,e,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,L=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var y;(function(c){c[c.x64=0]="x64",c[c.x86=1]="x86",c[c.ARM=2]="ARM"})(y||(y={}));let I;switch(process.arch){case"ia32":case"x32":I=1;break;case"arm":case"arm64":I=2;break;default:I=0;break}let i;process.env.PROCESSOR_ARCHITEW6432?i=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?i=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?i=1:i=0;class C{constructor(a,t,s){this.exePath=a,this.displayName=t,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:c=!1}={}){return c?I===0?process.env["ProgramFiles(x86)"]||null:i===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function E({useAlternateBitness:c=!1,findPreview:a=!1}={}){const t=g({useAlternateBitness:c});if(!t)return null;const s=k.join(t,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(s))return null;let n=-1,r=null;for(const h of await D.Promises.readdir(s)){let d=-1;if(a){const A=h.indexOf("-");if(A<0)continue;const _=h.substring(0,A);if(!T.test(_)||h.substring(A+1)!=="preview")continue;d=parseInt(_,10)}else{if(!T.test(h))continue;d=parseInt(h,10)}if(d<=n)continue;const m=k.join(s,h,"pwsh.exe");!await D.SymlinkSupport.existsFile(m)||(r=m,n=d)}if(!r)return null;const o=t.includes("x86")?" (x86)":"",l=a?" Preview":"";return new C(r,`PowerShell${l}${o}`,!0)}async function u({findPreview:c}={}){if(!process.env.LOCALAPPDATA)return null;const a=k.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:s}=c?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const n of await D.Promises.readdir(a))if(t.test(n)){const r=k.join(a,n,"pwsh.exe");return new C(r,s)}return null}function p(){const c=k.join(R.homedir(),".dotnet","tools","pwsh.exe");return new C(c,".NET Core PowerShell Global Tool")}function f(){const c=k.join(process.env.windir,I===1&&i!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(c,"Windows PowerShell",!0)}async function*b(){let c=await E();c&&(yield c),c=await E({useAlternateBitness:!0}),c&&(yield c),c=await u(),c&&(yield c),c=p(),c&&(yield c),c=await E({findPreview:!0}),c&&(yield c),c=await u({findPreview:!0}),c&&(yield c),c=await E({useAlternateBitness:!0,findPreview:!0}),c&&(yield c),c=f(),c&&(yield c)}async function*v(){for await(const c of b())await c.exists()&&(yield c)}e.enumeratePowerShellInstallations=v;async function S(){for await(const c of v())return c;return null}e.getFirstAvailablePowerShellInstallation=S}),define(te[108],ne([0,1,37,15]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(L){return new Promise((P,y)=>{let I;const i=new Map;function C(E,u,p,f,b){const v=i.get(u);if(E===L||v){const S={name:g(p),cmd:p,pid:E,ppid:u,load:f,mem:b};i.set(E,S),E===L&&(I=S),v&&(v.children||(v.children=[]),v.children.push(S),v.children.length>1&&(v.children=v.children.sort((c,a)=>c.pid-a.pid)))}}function g(E){const u=/--disable-blink-features=Auxclick/,p=/\\watcher\\win32\\CodeHelper\.exe/,f=/--crashes-directory/,b=/\\pipe\\winpty-control/,v=/conhost\.exe/,S=/--type=([a-zA-Z-]+)/;if(p.exec(E))return"watcherService ";if(f.exec(E))return"electron-crash-reporter";if(b.exec(E))return"winpty-process";if(v.exec(E))return"console-window-host (Windows internal process)";let c=S.exec(E);if(c&&c.length===2)return c[1]==="renderer"?u.exec(E)?"shared-process":"window":c[1];const a=/[a-zA-Z-]+\.js/g;let t="";do c=a.exec(E),c&&(t+=c+" ");while(c);return t&&E.indexOf("node ")<0&&E.indexOf("node.exe")<0?`electron_node ${t}`:E}if(process.platform==="win32"){const E=u=>u.indexOf("\\\\?\\")===0||u.indexOf("\\??\\")===0?u.substr(4):u.indexOf('"\\\\?\\')===0||u.indexOf('"\\??\\')===0?'"'+u.substr(5):u;new Promise((u,p)=>{J(["windows-process-tree"],u,p)}).then(u=>{u.getProcessList(L,p=>{u.getProcessCpuUsage(p,f=>{const b=new Map;f.forEach(v=>{const S=E(v.commandLine||"");b.set(v.pid,{name:g(S),cmd:S,pid:v.pid,ppid:v.ppid,load:v.cpu||0,mem:v.memory||0})}),I=b.get(L),I?(b.forEach(v=>{const S=b.get(v.ppid);S&&(S.children||(S.children=[]),S.children.push(v))}),b.forEach(v=>{v.children&&(v.children=v.children.sort((S,c)=>S.pid-c.pid))}),P(I)):y(new Error(`Root process ${L} not found`))})},u.ProcessDataFlag.CommandLine|u.ProcessDataFlag.Memory)})}else{let E=function(){let u=[I];const p=[];for(;u.length;){const b=u.shift();b&&(p.push(b.pid),b.children&&(u=u.concat(b.children)))}let f=JSON.stringify(k.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",J).fsPath);f+=" "+p.join(" "),(0,R.exec)(f,{},(b,v,S)=>{if(b||S)y(b||new Error(S.toString()));else{const c=v.toString().split(`
`);for(let a=0;a<p.length;a++){const t=i.get(p[a]);t.load=parseFloat(c[a])}if(!I){y(new Error(`Root process ${L} not found`));return}P(I)}})};(0,R.exec)("which ps",{},(u,p,f)=>{if(u||f)if(process.platform!=="linux")y(u||new Error(f.toString()));else{const b=JSON.stringify(k.FileAccess.asFileUri("vs/base/node/ps.sh",J).fsPath);(0,R.exec)(b,{},(v,S,c)=>{v||c?y(v||new Error(c.toString())):(T(S,C),E())})}else{const b=p.toString().trim(),v="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,R.exec)(`${b} ${v}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(S,c,a)=>{S||a&&!a.includes("screen size is bogus")?y(S||new Error(a.toString())):(T(c,C),process.platform==="linux"?E():I?P(I):y(new Error(`Root process ${L} not found`)))})}})}})}e.listProcesses=D;function T(L,P){const y=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,I=L.toString().split(`
`);for(const i of I){const C=y.exec(i.trim());C&&C.length===6&&P(parseInt(C[1]),parseInt(C[2]),C[5],parseFloat(C[3]),parseFloat(C[4]))}}}),define(te[109],ne([0,1,51,27,40,2,68,9,4,19]),function(J,e,R,k,D,T,L,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function i(u,p,f){return g({path:u,isDirectory:!1},p,f)}e.watchFile=i;function C(u,p,f){return g({path:u,isDirectory:!0},p,f)}e.watchFolder=C,e.CHANGE_BUFFER_DELAY=100;function g(u,p,f){if(y.isMacintosh&&(0,D.isEqualOrParent)(u.path,"/Volumes/"))return f(`Refusing to watch ${u.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),T.Disposable.None;const b=(0,P.basename)(u.path),v=new Map;let S=!1,c=[(0,T.toDisposable)(()=>{v.forEach(a=>(0,T.dispose)(a)),v.clear()})];try{const a=(0,R.watch)(u.path);c.push((0,T.toDisposable)(()=>{a.removeAllListeners(),a.close()}));const t=new Set;u.isDirectory&&I.Promises.readdir(u.path).then(s=>s.forEach(n=>t.add(n))),a.on("error",(s,n)=>{S||f(`Failed to watch ${u.path} for changes using fs.watch() (${s}, ${n})`)}),a.on("change",(s,n)=>{if(S)return;let r="";if(n&&(r=n.toString(),y.isMacintosh&&(r=(0,L.normalizeNFC)(r))),!r||s!=="change"&&s!=="rename")return;const o=u.isDirectory?(0,P.join)(u.path,r):u.path;if(u.isDirectory)if(s==="rename"){const l=v.get(o);l&&(0,T.dispose)(l);const h=setTimeout(async()=>{v.delete(o);const d=await I.Promises.exists(o);if(S)return;let m;d?t.has(r)?m="changed":(m="added",t.add(r)):(t.delete(r),m="deleted"),p(m,o)},e.CHANGE_BUFFER_DELAY);v.set(o,(0,T.toDisposable)(()=>clearTimeout(h)))}else{let l;t.has(r)?l="changed":(l="added",t.add(r)),p(l,o)}else if(s==="rename"||r!==b){const l=setTimeout(async()=>{const h=await I.Promises.exists(o);S||(h?(p("changed",o),c=[g(u,p,f)]):p("deleted",o))},e.CHANGE_BUFFER_DELAY);(0,T.dispose)(c),c=[(0,T.toDisposable)(()=>clearTimeout(l))]}else p("changed",o)})}catch(a){I.Promises.exists(u.path).then(t=>{t&&!S&&f(`Failed to watch ${u.path} for changes using fs.watch() (${a.toString()})`)})}return(0,T.toDisposable)(()=>{S=!0,c=(0,T.dispose)(c)})}async function E(u,p,f,b=512){const v=await I.Promises.open(u,"r"),S=Buffer.allocUnsafe(b),c=new k.CancellationTokenSource(f);let a,t=!1;const s=i(u,async n=>{if(n==="changed"){if(t)return;t=!0;try{for(;!c.token.isCancellationRequested;){const{bytesRead:r}=await I.Promises.read(v,S,0,b,null);if(!r||c.token.isCancellationRequested)break;p(S.slice(0,r))}}catch(r){a=new Error(r),c.dispose(!0)}finally{t=!1}}},n=>{a=new Error(n),c.dispose(!0)});return new Promise((n,r)=>{c.token.onCancellationRequested(async()=>{s.dispose(),await I.Promises.close(v),a?r(a):n()})})}e.watchFileContents=E});var he=this&&this.__decorate||function(J,e,R,k){var D=arguments.length,T=D<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,R):k,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(J,e,R,k);else for(var P=J.length-1;P>=0;P--)(L=J[P])&&(T=(D<3?L(T):D>3?L(e,R,T):L(e,R))||T);return D>3&&T&&Object.defineProperty(e,R,T),T};define(te[33],ne([0,1,17,6,21,27,66,8,3,2,100,25,18]),function(J,e,R,k,D,T,L,P,y,I,i,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var E;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(E=e.RequestType||(e.RequestType={}));function u(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(p=e.ResponseType||(e.ResponseType={}));function f(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(b||(b={}));class v{constructor(F){this.buffer=F,this.pos=0}read(F){const G=this.buffer.slice(this.pos,this.pos+F);return this.pos+=G.byteLength,G}}class S{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(F){this.buffers.push(F)}}var c;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object"})(c||(c={}));function a(q){const F=D.VSBuffer.alloc(4);return F.writeUInt32BE(q,0),F}function t(q){return q.read(4).readUInt32BE(0)}function s(q){const F=D.VSBuffer.alloc(1);return F.writeUInt8(q,0),F}const n={Undefined:s(c.Undefined),String:s(c.String),Buffer:s(c.Buffer),VSBuffer:s(c.VSBuffer),Array:s(c.Array),Object:s(c.Object)},r=typeof Buffer!="undefined";function o(q,F){if(typeof F=="undefined")q.write(n.Undefined);else if(typeof F=="string"){const G=D.VSBuffer.fromString(F);q.write(n.String),q.write(a(G.byteLength)),q.write(G)}else if(r&&Buffer.isBuffer(F)){const G=D.VSBuffer.wrap(F);q.write(n.Buffer),q.write(a(G.byteLength)),q.write(G)}else if(F instanceof D.VSBuffer)q.write(n.VSBuffer),q.write(a(F.byteLength)),q.write(F);else if(Array.isArray(F)){q.write(n.Array),q.write(a(F.length));for(const G of F)o(q,G)}else{const G=D.VSBuffer.fromString(JSON.stringify(F));q.write(n.Object),q.write(a(G.byteLength)),q.write(G)}}function l(q){switch(q.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return q.read(t(q)).toString();case c.Buffer:return q.read(t(q)).buffer;case c.VSBuffer:return q.read(t(q));case c.Array:{const G=t(q),x=[];for(let N=0;N<G;N++)x.push(l(q));return x}case c.Object:return JSON.parse(q.read(t(q)).toString())}}class h{constructor(F,G,x=null,N=1e3){this.protocol=F,this.ctx=G,this.logger=x,this.timeoutDelay=N,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(W=>this.onRawMessage(W)),this.sendResponse({type:200})}registerChannel(F,G){this.channels.set(F,G),setTimeout(()=>this.flushPendingRequests(F),0)}sendResponse(F){switch(F.type){case 200:{const G=this.send([F.type]);this.logger&&this.logger.logOutgoing(G,0,1,f(F.type));return}case 201:case 202:case 204:case 203:{const G=this.send([F.type,F.id],F.data);this.logger&&this.logger.logOutgoing(G,F.id,1,f(F.type),F.data);return}}}send(F,G=void 0){const x=new S;return o(x,F),o(x,G),this.sendBuffer(x.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch(G){return 0}}onRawMessage(F){const G=new v(F),x=l(G),N=l(G),W=x[0];switch(W){case 100:return this.logger&&this.logger.logIncoming(F.byteLength,x[1],1,`${u(W)}: ${x[2]}.${x[3]}`,N),this.onPromise({type:W,id:x[1],channelName:x[2],name:x[3],arg:N});case 102:return this.logger&&this.logger.logIncoming(F.byteLength,x[1],1,`${u(W)}: ${x[2]}.${x[3]}`,N),this.onEventListen({type:W,id:x[1],channelName:x[2],name:x[3],arg:N});case 101:return this.logger&&this.logger.logIncoming(F.byteLength,x[1],1,`${u(W)}`),this.disposeActiveRequest({type:W,id:x[1]});case 103:return this.logger&&this.logger.logIncoming(F.byteLength,x[1],1,`${u(W)}`),this.disposeActiveRequest({type:W,id:x[1]})}}onPromise(F){const G=this.channels.get(F.channelName);if(!G){this.collectPendingRequest(F);return}const x=new T.CancellationTokenSource;let N;try{N=G.call(this.ctx,F.name,F.arg,x.token)}catch(Z){N=Promise.reject(Z)}const W=F.id;N.then(Z=>{this.sendResponse({id:W,data:Z,type:201}),this.activeRequests.delete(F.id)},Z=>{Z instanceof Error?this.sendResponse({id:W,data:{message:Z.message,name:Z.name,stack:Z.stack?Z.stack.split?Z.stack.split(`
`):Z.stack:void 0},type:202}):this.sendResponse({id:W,data:Z,type:203}),this.activeRequests.delete(F.id)});const X=(0,I.toDisposable)(()=>x.cancel());this.activeRequests.set(F.id,X)}onEventListen(F){const G=this.channels.get(F.channelName);if(!G){this.collectPendingRequest(F);return}const x=F.id,W=G.listen(this.ctx,F.name,F.arg)(X=>this.sendResponse({id:x,data:X,type:204}));this.activeRequests.set(F.id,W)}disposeActiveRequest(F){const G=this.activeRequests.get(F.id);G&&(G.dispose(),this.activeRequests.delete(F.id))}collectPendingRequest(F){let G=this.pendingRequests.get(F.channelName);G||(G=[],this.pendingRequests.set(F.channelName,G));const x=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.sendResponse({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);G.push({request:F,timeoutTimer:x})}flushPendingRequests(F){const G=this.pendingRequests.get(F);if(G){for(const x of G)switch(clearTimeout(x.timeoutTimer),x.request.type){case 100:this.onPromise(x.request);break;case 102:this.onEventListen(x.request);break}this.pendingRequests.delete(F)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}e.ChannelServer=h;var d;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class m{constructor(F,G=null){this.protocol=F,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new y.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(x=>this.onBuffer(x)),this.logger=G}getChannel(F){const G=this;return{call(x,N,W){return G.isDisposed?Promise.reject(P.canceled()):G.requestPromise(F,x,N,W)},listen(x,N){return G.isDisposed?Promise.reject(P.canceled()):G.requestEvent(F,x,N)}}}requestPromise(F,G,x,N=T.CancellationToken.None){const W=this.lastRequestId++,Z={id:W,type:100,channelName:F,name:G,arg:x};if(N.isCancellationRequested)return Promise.reject(P.canceled());let B;return new Promise((ie,re)=>{if(N.isCancellationRequested)return re(P.canceled());const ae=()=>{const Ie=Pe=>{switch(Pe.type){case 201:this.handlers.delete(W),ie(Pe.data);break;case 202:this.handlers.delete(W);const Ee=new Error(Pe.data.message);Ee.stack=Pe.data.stack,Ee.name=Pe.data.name,re(Ee);break;case 203:this.handlers.delete(W),re(Pe.data);break}};this.handlers.set(W,Ie),this.sendRequest(Z)};let ue=null;this.state===b.Idle?ae():(ue=(0,k.createCancelablePromise)(Ie=>this.whenInitialized()),ue.then(()=>{ue=null,ae()}));const fe=()=>{ue?(ue.cancel(),ue=null):this.sendRequest({id:W,type:101}),re(P.canceled())},ge=N.onCancellationRequested(fe);B=(0,I.combinedDisposable)((0,I.toDisposable)(fe),ge),this.activeRequests.add(B)}).finally(()=>{this.activeRequests.delete(B)})}requestEvent(F,G,x){const N=this.lastRequestId++,X={id:N,type:102,channelName:F,name:G,arg:x};let Z=null;const B=new y.Emitter({onFirstListenerAdd:()=>{Z=(0,k.createCancelablePromise)(ie=>this.whenInitialized()),Z.then(()=>{Z=null,this.activeRequests.add(B),this.sendRequest(X)})},onLastListenerRemove:()=>{Z?(Z.cancel(),Z=null):(this.activeRequests.delete(B),this.sendRequest({id:N,type:103}))}}),H=ie=>B.fire(ie.data);return this.handlers.set(N,H),B.event}sendRequest(F){switch(F.type){case 100:case 102:{const G=this.send([F.type,F.id,F.channelName,F.name],F.arg);this.logger&&this.logger.logOutgoing(G,F.id,0,`${u(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const G=this.send([F.type,F.id]);this.logger&&this.logger.logOutgoing(G,F.id,0,u(F.type));return}}}send(F,G=void 0){const x=new S;return o(x,F),o(x,G),this.sendBuffer(x.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch(G){return 0}}onBuffer(F){const G=new v(F),x=l(G),N=l(G),W=x[0];switch(W){case 200:return this.logger&&this.logger.logIncoming(F.byteLength,0,0,f(W)),this.onResponse({type:x[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(F.byteLength,x[1],0,f(W),N),this.onResponse({type:x[0],id:x[1],data:N})}}onResponse(F){if(F.type===200){this.state=b.Idle,this._onDidInitialize.fire();return}const G=this.handlers.get(F.id);G&&G(F)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}he([L.memoize],m.prototype,"onDidInitializePromise",null),e.ChannelClient=m;class A{constructor(F){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new y.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new y.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,F(({protocol:G,onDidClientDisconnect:x})=>{y.Event.once(G.onMessage)(W=>{const X=new v(W),Z=l(X),B=new h(G,Z),H=new m(G);this.channels.forEach((re,ae)=>B.registerChannel(ae,re));const ie={channelServer:B,channelClient:H,ctx:Z};this._connections.add(ie),this._onDidAddConnection.fire(ie),x(()=>{B.dispose(),H.dispose(),this._connections.delete(ie),this._onDidRemoveConnection.fire(ie)})})})}get connections(){const F=[];return this._connections.forEach(G=>F.push(G)),F}getChannel(F,G){const x=this;return{call(N,W,X){let Z;if((0,g.isFunction)(G)){let H=(0,R.getRandomElement)(x.connections.filter(G));Z=H?Promise.resolve(H):y.Event.toPromise(y.Event.filter(x.onDidAddConnection,G))}else Z=G.routeCall(x,N,W);const B=Z.then(H=>H.channelClient.getChannel(F));return w(B).call(N,W,X)},listen(N,W){if((0,g.isFunction)(G))return x.getMulticastEvent(F,G,N,W);const X=G.routeEvent(x,N,W).then(Z=>Z.channelClient.getChannel(F));return w(X).listen(N,W)}}}getMulticastEvent(F,G,x,N){const W=this;let X=new I.DisposableStore;const Z=new y.Emitter({onFirstListenerAdd:()=>{X=new I.DisposableStore;const B=new y.EventMultiplexer,H=new Map,ie=ae=>{const fe=ae.channelClient.getChannel(F).listen(x,N),ge=B.add(fe);H.set(ae,ge)},re=ae=>{const ue=H.get(ae);!ue||(ue.dispose(),H.delete(ae))};W.connections.filter(G).forEach(ie),y.Event.filter(W.onDidAddConnection,G)(ie,void 0,X),W.onDidRemoveConnection(re,void 0,X),B.event(Z.fire,Z,X),X.add(B)},onLastListenerRemove:()=>{X.dispose()}});return Z.event}registerChannel(F,G){this.channels.set(F,G),this._connections.forEach(x=>{x.channelServer.registerChannel(F,G)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class _{constructor(F,G,x=null){const N=new S;o(N,G),F.send(N.buffer),this.channelClient=new m(F,x),this.channelServer=new h(F,G,x)}getChannel(F){return this.channelClient.getChannel(F)}registerChannel(F,G){this.channelServer.registerChannel(F,G)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=_;function w(q){return{call(F,G,x){return q.then(N=>N.call(F,G,x))},listen(F,G){const x=new y.Relay;return q.then(N=>x.input=N.listen(F,G)),x.event}}}e.getDelayedChannel=w;function O(q){let F=!1;return{call(G,x,N){return F?q.call(G,x,N):(0,k.timeout)(0).then(()=>F=!0).then(()=>q.call(G,x,N))},listen(G,x){if(F)return q.listen(G,x);const N=new y.Relay;return(0,k.timeout)(0).then(()=>F=!0).then(()=>N.input=q.listen(G,x)),N.event}}}e.getNextTickChannel=O;class U{constructor(F){this.fn=F}routeCall(F){return this.route(F)}routeEvent(F){return this.route(F)}async route(F){for(const G of F.connections)if(await Promise.resolve(this.fn(G.ctx)))return Promise.resolve(G);return await y.Event.toPromise(F.onDidAddConnection),await this.route(F)}}e.StaticRouter=U;var $;(function(q){function F(W,X){const Z=W,B=X&&X.disableMarshalling,H=new Map;for(const ie in Z)x(ie)&&H.set(ie,y.Event.buffer(Z[ie],!0));return new class{listen(ie,re,ae){const ue=H.get(re);if(ue)return ue;if(N(re)){const fe=Z[re];if(typeof fe=="function")return fe.call(Z,ae)}throw new Error(`Event not found: ${re}`)}call(ie,re,ae){const ue=Z[re];if(typeof ue=="function"){if(!B&&Array.isArray(ae))for(let fe=0;fe<ae.length;fe++)ae[fe]=(0,i.revive)(ae[fe]);return ue.apply(Z,ae)}throw new Error(`Method not found: ${re}`)}}}q.fromService=F;function G(W,X){const Z=X&&X.disableMarshalling;return new Proxy({},{get(B,H){if(typeof H=="string")return X?.properties?.has(H)?X.properties.get(H):N(H)?function(ie){return W.listen(H,ie)}:x(H)?W.listen(H):async function(...ie){let re;X&&!(0,g.isUndefinedOrNull)(X.context)?re=[X.context,...ie]:re=ie;const ae=await W.call(H,re);return Z?ae:(0,i.revive)(ae)};throw new Error(`Property not found: ${String(H)}`)}})}q.toService=G;function x(W){return W[0]==="o"&&W[1]==="n"&&C.isUpperAsciiLetter(W.charCodeAt(2))}function N(W){return/^onDynamic/.test(W)&&C.isUpperAsciiLetter(W.charCodeAt(9))}})($=e.ProxyChannel||(e.ProxyChannel={}));const Y=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){let F=q.toString();if(F!=="[object Object]")return F}return q}function V(q){return Array.isArray(q)?q.map(M):M(q)}function j(q,F,G,x,N,W,X){X=V(X);const Z=Y[N],B=Z[x%Z.length];let H=[`%c[${q}]%c[${String(F).padStart(7," ")}]%c[len: ${String(G).padStart(5," ")}]%c${String(x).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(W)?(H=H.concat(X),H.push(")")):H.push(X),console.log.apply(console,H)}e.logWithColors=j;class z{constructor(F,G){this._outgoingPrefix=F,this._incomingPrefix=G,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(F,G,x,N,W){this._totalOutgoing+=F,j(this._outgoingPrefix,this._totalOutgoing,F,G,x,N,W)}logIncoming(F,G,x,N,W){this._totalIncoming+=F,j(this._incomingPrefix,this._totalIncoming,F,G,x,N,W)}}e.IPCLogger=z}),define(te[110],ne([0,1,21,3,33]),function(J,e,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class T{constructor(y){this.port=y,this.onMessage=k.Event.fromDOMEventEmitter(this.port,"message",I=>R.VSBuffer.wrap(I.data)),y.start()}send(y){this.port.postMessage(y.buffer)}disconnect(){this.port.close()}}e.Protocol=T;class L extends D.IPCClient{constructor(y,I){const i=new T(y);super(i,I);this.protocol=i}dispose(){this.protocol.disconnect()}}e.Client=L}),define(te[72],ne([0,1,21,3,2,4,31,33]),function(J,e,R,k,D,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var y;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(y=e.SocketCloseEventType||(e.SocketCloseEventType={}));let I=null;function i(){return I||(I=R.VSBuffer.alloc(0)),I}class C{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,o){if(r===0)return i();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const m=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=r),m}if(this._chunks[0].byteLength>r){const m=this._chunks[0].slice(0,r);return o&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),m}let l=R.VSBuffer.alloc(r),h=0,d=0;for(;r>0;){const m=this._chunks[d];if(m.byteLength>r){const A=m.slice(0,r);l.set(A,h),h+=r,o&&(this._chunks[d]=m.slice(r),this._totalLength-=r),r-=r}else l.set(m,h),h+=m.byteLength,o?(this._chunks.shift(),this._totalLength-=m.byteLength):d++,r-=m.byteLength}return l}}e.ChunkStream=C;var g;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.KeepAlive=4]="KeepAlive",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest"})(g||(g={}));var E;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",n[n.KeepAliveTime=5e3]="KeepAliveTime",n[n.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(E=e.ProtocolConstants||(e.ProtocolConstants={}));class u{constructor(r,o,l,h){this.type=r,this.id=o,this.ack=l,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends D.Disposable{constructor(r){super();this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new C,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5);else{const l=this._state.messageType,h=this._state.id,d=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new u(l,h,d,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class f{constructor(r){this._isDisposed=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(r){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=R.VSBuffer.alloc(13);o.writeUInt8(r.type,0),o.writeUInt32BE(r.id,1),o.writeUInt32BE(r.ack,5),o.writeUInt32BE(r.data.byteLength,9),this._writeSoon(o,r.data)}_bufferAdd(r,o){const l=this._totalLength===0;return this._data.push(r,o),this._totalLength+=r.byteLength+o.byteLength,l}_bufferTake(){const r=R.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,o){this._bufferAdd(r,o)&&T.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class b extends D.Disposable{constructor(r){super();this._onMessage=new k.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new k.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new f(this._socket)),this._socketReader=this._register(new p(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new u(1,0,0,r))}}e.Protocol=b;class v extends P.IPCClient{constructor(r,o,l=null){super(r,o,l);this.protocol=r}static fromSocket(r,o){return new v(new b(r),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=v;class S{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new k.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,L.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=S;class c{constructor(r){this.data=r,this.next=null}}class a{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],o=0,l=this._first;for(;l;)r[o++]=l.data,l=l.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const o=new c(r);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class t{constructor(){this.lastRuns=[];const r=Date.now();for(let o=0;o<t._HISTORY_LENGTH;o++)this.lastRuns[o]=r-1e3*o;setInterval(()=>{for(let o=t._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const r=Date.now(),o=(1+t._HISTORY_LENGTH)*1e3;let l=0;for(let h=0;h<t._HISTORY_LENGTH;h++)r-this.lastRuns[h]<=o&&l++;return 1-l/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class s{constructor(r,o=null,l=t.getInstance()){this._onControlMessage=new S,this.onControlMessage=this._onControlMessage.event,this._onMessage=new S,this.onMessage=this._onMessage.event,this._onDidDispose=new S,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new S,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new S,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=l,this._isReconnecting=!1,this._outgoingUnackMsg=new a,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=r,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),o&&this._socketReader.acceptChunk(o),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new u(5,0,0,i());this._socketWriter.write(r),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const r=Date.now()-this._socketWriter.lastWriteTime;if(r>=5e3){const o=new u(4,0,0,i());this._socketWriter.write(o),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-r+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const r=Date.now()-this._socketReader.lastReadTime;if(r>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-r,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,o){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=r,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1;const r=this._outgoingUnackMsg.toArray();for(let o=0,l=r.length;o<l;o++)this._socketWriter.write(r[o]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(r.type===1){if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new u(6,0,0,i())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data)}else if(r.type===2)this._onControlMessage.fire(r.data);else if(r.type===5)this._onDidDispose.fire();else if(r.type===6){const o=this._outgoingUnackMsg.toArray();for(let l=0,h=o.length;l<h;l++)this._socketWriter.write(o[l]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const l=new u(1,o,this._incomingAckId,r);this._outgoingUnackMsg.push(l),this._isReconnecting||(this._socketWriter.write(l),this._recvAckCheck())}sendControl(r){const o=new u(2,0,0,r);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),o=Date.now()-r.writtenTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-o,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new u(3,0,this._incomingAckId,i());this._socketWriter.write(r)}}e.PersistentProtocol=s}),define(te[111],ne([0,1,112,3,33,110]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class L extends D.IPCServer{static getOnDidClientConnect(){const y=k.Event.fromNodeEventEmitter(R.ipcRenderer,"vscode:createMessageChannel",(I,i)=>i);return k.Event.map(y,I=>{const{port1:i,port2:C}=new MessageChannel,E={protocol:new T.Protocol(i),onDidClientDisconnect:k.Event.fromDOMEventEmitter(i,"close")};return R.ipcRenderer.postMessage("vscode:createMessageChannelResult",I,[C]),E})}constructor(){super(L.getOnDidClientConnect())}}e.Server=L}),define(te[113],ne([0,1,21,8]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function D(P,y){P.proxyAuthorization&&(P.headers={...P.headers||{},"Proxy-Authorization":P.proxyAuthorization});const I=new XMLHttpRequest;return new Promise((i,C)=>{I.open(P.type||"GET",P.url||"",!0,P.user,P.password),T(I,P),I.responseType="arraybuffer",I.onerror=g=>C(new Error(I.statusText&&"XHR failed: "+I.statusText||"XHR failed")),I.onload=g=>{i({res:{statusCode:I.status,headers:L(I)},stream:(0,R.bufferToStream)(R.VSBuffer.wrap(new Uint8Array(I.response)))})},I.ontimeout=g=>C(new Error(`XHR timeout: ${P.timeout}ms`)),P.timeout&&(I.timeout=P.timeout),I.send(P.data),y.onCancellationRequested(()=>{I.abort(),C((0,k.canceled)())})})}e.request=D;function T(P,y){if(y.headers){e:for(let I in y.headers){switch(I){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}P.setRequestHeader(I,y.headers[I])}}}function L(P){const y=Object.create(null);for(const I of P.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(I){const i=I.indexOf(":");y[I.substr(0,i).trim().toLowerCase()]=I.substr(i+1).trim()}return y}}),define(te[73],ne([0,1,6,3,2,18]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var L;(function(C){C[C.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(L=e.StorageHint||(e.StorageHint={}));function P(C){const g=C;return g?.changed instanceof Map||g?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var y;(function(C){C[C.None=0]="None",C[C.Initialized=1]="Initialized",C[C.Closed=2]="Closed"})(y||(y={}));class I extends D.Disposable{constructor(g,E=Object.create(null)){super();this.database=g,this.options=E,this._onDidChangeStorage=this._register(new k.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=y.None,this.cache=new Map,this.flushDelayer=new R.ThrottledDelayer(I.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(g=>this.onDidChangeItemsExternal(g)))}onDidChangeItemsExternal(g){g.changed?.forEach((E,u)=>this.accept(u,E)),g.deleted?.forEach(E=>this.accept(E,void 0))}accept(g,E){if(this.state===y.Closed)return;let u=!1;(0,T.isUndefinedOrNull)(E)?u=this.cache.delete(g):this.cache.get(g)!==E&&(this.cache.set(g,E),u=!0),u&&this._onDidChangeStorage.fire(g)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===y.None&&(this.state=y.Initialized,this.options.hint!==L.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(g,E){const u=this.cache.get(g);return(0,T.isUndefinedOrNull)(u)?E:u}getBoolean(g,E){const u=this.get(g);return(0,T.isUndefinedOrNull)(u)?E:u==="true"}getNumber(g,E){const u=this.get(g);return(0,T.isUndefinedOrNull)(u)?E:parseInt(u,10)}async set(g,E){if(this.state===y.Closed)return;if((0,T.isUndefinedOrNull)(E))return this.delete(g);const u=String(E);if(this.cache.get(g)!==u)return this.cache.set(g,u),this.pendingInserts.set(g,u),this.pendingDeletes.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}async delete(g){if(!(this.state===y.Closed||!this.cache.delete(g)))return this.pendingDeletes.has(g)||this.pendingDeletes.add(g),this.pendingInserts.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=y.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(g){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const g={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(g).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(g=>this.whenFlushedCallbacks.push(g))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=I,I.DEFAULT_FLUSH_DELAY=100;class i{constructor(){this.onDidChangeItemsExternal=k.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(g){g.insert&&g.insert.forEach((E,u)=>this.items.set(u,E)),g.delete&&g.delete.forEach(E=>this.items.delete(E))}async close(){}}e.InMemoryStorageDatabase=i}),define(te[114],ne([11,12]),function(J,e){return J.create("vs/base/common/date",e)}),define(te[57],ne([0,1,114]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const k=60,D=k*60,T=D*24,L=T*7,P=T*30,y=T*365;function I(C,g){typeof C!="number"&&(C=C.getTime());const E=Math.round((new Date().getTime()-C)/1e3);if(E<-30)return(0,R.localize)(0,null,I(new Date().getTime()+E*1e3,!1));if(E<30)return(0,R.localize)(1,null);let u;return E<k?(u=E,g?u===1?(0,R.localize)(2,null,u):(0,R.localize)(3,null,u):u===1?(0,R.localize)(4,null,u):(0,R.localize)(5,null,u)):E<D?(u=Math.floor(E/k),g?u===1?(0,R.localize)(6,null,u):(0,R.localize)(7,null,u):u===1?(0,R.localize)(8,null,u):(0,R.localize)(9,null,u)):E<T?(u=Math.floor(E/D),g?u===1?(0,R.localize)(10,null,u):(0,R.localize)(11,null,u):u===1?(0,R.localize)(12,null,u):(0,R.localize)(13,null,u)):E<L?(u=Math.floor(E/T),g?u===1?(0,R.localize)(14,null,u):(0,R.localize)(15,null,u):u===1?(0,R.localize)(16,null,u):(0,R.localize)(17,null,u)):E<P?(u=Math.floor(E/L),g?u===1?(0,R.localize)(18,null,u):(0,R.localize)(19,null,u):u===1?(0,R.localize)(20,null,u):(0,R.localize)(21,null,u)):E<y?(u=Math.floor(E/P),g?u===1?(0,R.localize)(22,null,u):(0,R.localize)(23,null,u):u===1?(0,R.localize)(24,null,u):(0,R.localize)(25,null,u)):(u=Math.floor(E/y),g?u===1?(0,R.localize)(26,null,u):(0,R.localize)(27,null,u):u===1?(0,R.localize)(28,null,u):(0,R.localize)(29,null,u))}e.fromNow=I;function i(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(te[115],ne([11,12]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(te[38],ne([0,1,17,18,115]),function(J,e,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(I,i){return i&&(I.stack||I.stacktrace)?D.localize(0,null,P(I),L(I.stack)||L(I.stacktrace)):P(I)}function L(I){return Array.isArray(I)?I.join(`
`):I}function P(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?D.localize(1,null,I.message):I.message||D.localize(2,null)}function y(I=null,i=!1){if(!I)return D.localize(3,null);if(Array.isArray(I)){const C=R.coalesce(I),g=y(C[0],i);return C.length>1?D.localize(4,null,g,C.length):g}if(k.isString(I))return I;if(I.detail){const C=I.detail;if(C.error)return T(C.error,i);if(C.exception)return T(C.exception,i)}return I.stack?T(I,i):I.message?I.message:D.localize(5,null)}e.toErrorMessage=y}),define(te[116],ne([11,12]),function(J,e){return J.create("vs/base/node/processes",e)}),define(te[74],ne([0,1,37,40,15,26,9,4,31,18,70,19,116]),function(J,e,R,k,D,T,L,P,y,I,i,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function E(c){switch(c){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function u(c,a){if(P.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};a&&(t.cwd=a);const s=R.execFile("taskkill",["/T","/F","/PID",c.pid.toString()],t);return new Promise(n=>{s.once("error",r=>{n({success:!1,error:r})}),s.once("exit",(r,o)=>{n(r===0?{success:!0}:{success:!1,code:r!==null?r:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?E(t.status):1})}else if(P.isLinux||P.isMacintosh)try{const t=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(s=>{R.execFile(t,[c.pid.toString()],{encoding:"utf8",shell:!0},(n,r,o)=>{s(n?{success:!1,error:n}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else c.kill("SIGKILL");return Promise.resolve({success:!0})}function p(c=y.env){return c.comspec||"cmd.exe"}e.getWindowsShell=p;class f{constructor(a,t,s,n){if(t!==void 0&&s!==void 0&&n!==void 0)this.cmd=a,this.args=t,this.shell=s,this.options=n;else{const r=a;this.cmd=r.command,this.shell=r.isShellCommand,this.args=r.args.slice(0),this.options=r.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const r=Object.create(null);Object.keys(y.env).forEach(o=>{r[o]=y.env[o]}),Object.keys(this.options.env).forEach(o=>{r[o]=this.options.env[o]}),this.options.env=r}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const t=a.lastIndexOf(L.sep);return t!==-1&&(a=a.substring(t+1)),f.WellKnowCommands[a]?a:"other"}start(a){return P.isWindows&&(this.options&&this.options.cwd&&k.isUNC(this.options.cwd)||!this.options&&k.isUNC(y.cwd()))?Promise.reject(new Error(g.localize(0,null))):this.useExec().then(t=>{let s,n;const r=new Promise((o,l)=>{s=o,n=l});if(t){let o=this.cmd;this.args&&(o=o+" "+this.args.join(" ")),this.childProcess=R.exec(o,this.options,(l,h,d)=>{this.childProcess=null;const m=l;m&&m.killed?n({killed:this.terminateRequested,stdout:h.toString(),stderr:d.toString()}):this.handleExec(s,a,l,h,d)})}else{let o=null;const l=h=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(h,s,a,n);const d={terminated:this.terminateRequested};I.isNumber(h)&&(d.cmdCode=h),s(d)};if(this.shell&&P.isWindows){const h=T.deepClone(this.options);h.windowsVerbatimArguments=!0,h.detached=!1;let d=!1,m=!1;const A=[];let _=this.ensureQuotes(this.cmd);A.push(_.value),d=_.quoted,this.args&&this.args.forEach(O=>{_=this.ensureQuotes(O),A.push(_.value),m=m&&_.quoted});const w=["/s","/c"];d?m?w.push('"'+A.join(" ")+'"'):A.length>1?w.push('"'+A[0]+'" '+A.slice(1).join(" ")):w.push('"'+A[0]+'"'):w.push(A.join(" ")),o=R.spawn(p(),w,h)}else this.cmd&&(o=R.spawn(this.cmd,this.args,this.options));o&&(this.childProcess=o,this.childProcessPromise=Promise.resolve(o),this.pidResolve&&(this.pidResolve(I.isNumber(o.pid)?o.pid:-1),this.pidResolve=void 0),o.on("error",h=>{this.childProcess=null,n({terminated:this.terminateRequested,error:h})}),o.pid&&(this.childProcess.on("close",l),this.handleSpawn(o,s,a,n,!0)))}return r})}handleClose(a,t,s,n){}ensureQuotes(a){return f.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,u(a,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!P.isWindows)return a(!1);const t=R.spawn(p(),["/s","/c"]);t.on("error",s=>a(!0)),t.on("exit",s=>a(!1))})}}e.AbstractProcess=f,f.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},f.regexp=/^[^"].* .*[^"]/;class b extends f{constructor(a,t,s,n){super(a,t,s,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,t,s,n,r){[n,r].forEach((o,l)=>{const h=new i.LineDecoder;h.write(o).forEach(A=>{t({line:A,source:l===0?0:1})});const m=h.end();m&&t({line:m,source:l===0?0:1})}),a({terminated:this.terminateRequested,error:s})}handleSpawn(a,t,s,n,r){const o=new i.LineDecoder,l=new i.LineDecoder;a.stdout.on("data",h=>{o.write(h).forEach(m=>s({line:m,source:0}))}),a.stderr.on("data",h=>{l.write(h).forEach(m=>s({line:m,source:1}))}),this.stdoutLineDecoder=o,this.stderrLineDecoder=l}handleClose(a,t,s,n){const r=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;r&&s({line:r,source:0});const o=this.stderrLineDecoder?this.stderrLineDecoder.end():null;o&&s({line:o,source:1})}}e.LineProcess=b;function v(c){let a=[],t=!1;const s=function(n){if(t){a.push(n);return}(!c.send(n,o=>{if(o&&console.error(o),t=!1,a.length>0){const l=a.slice(0);a=[],l.forEach(h=>s(h))}})||P.isWindows)&&(t=!0)};return{send:s}}e.createQueuedSender=v;var S;(function(c){async function a(t,s,n){if(L.isAbsolute(t))return t;if(s===void 0&&(s=y.cwd()),L.dirname(t)!=="."||(n===void 0&&I.isString(y.env.PATH)&&(n=y.env.PATH.split(L.delimiter)),n===void 0||n.length===0))return L.join(s,t);async function o(l){if(await C.Promises.exists(l)){let h;try{h=await C.Promises.stat(l)}catch(d){d.message.startsWith("EACCES")&&(h=await C.Promises.lstat(l))}return h?!h.isDirectory():!1}return!1}for(let l of n){let h;if(L.isAbsolute(l)?h=L.join(l,t):h=L.join(s,l,t),await o(h))return h;let d=h+".com";if(await o(d)||(d=h+".exe",await o(d)))return d}return L.join(s,t)}c.findExecutable=a})(S=e.win32||(e.win32={}))}),define(te[117],ne([0,1,32,4,71,74]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function L(E,u){return E===1?k.isWindows?C():T.getWindowsShell(u):I(E,u)}e.getSystemShell=L;function P(E,u){return E===1?k.isWindows?g(u):T.getWindowsShell(u):I(E,u)}e.getSystemShellSync=P;let y=null;function I(E,u){if(k.isLinux&&E===2||k.isMacintosh&&E===3)return"/bin/bash";if(!y){let p;if(k.isWindows)p="/bin/bash";else{if(p=u.SHELL,!p)try{p=(0,R.userInfo)().shell}catch(f){}p||(p="sh"),p==="/bin/false"&&(p="/bin/bash")}y=p}return y}let i=null;async function C(){return i||(i=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),i}function g(E){if(i)return i;const u=k.isWindows&&parseFloat((0,R.release)())>=10,p=E.hasOwnProperty("PROCESSOR_ARCHITEW6432"),f=`${E.windir}\\${p?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?f:T.getWindowsShell(E)}}),define(te[52],ne([0,1,37,6,21,27,99,8,3,2,26,4,74,33]),function(J,e,R,k,D,T,L,P,y,I,i,C,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class u extends E.ChannelServer{constructor(b){super({send:v=>{try{process.send&&process.send(v.buffer.toString("base64"))}catch(S){}},onMessage:y.Event.fromNodeEventEmitter(process,"message",v=>D.VSBuffer.wrap(Buffer.from(v,"base64")))},b);process.once("disconnect",()=>this.dispose())}}e.Server=u;class p{constructor(b,v){this.modulePath=b,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new y.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const S=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new k.Delayer(S),this.child=null,this._client=null}getChannel(b){const v=this;return{call(S,c,a){return v.requestPromise(b,S,c,a)},listen(S,c){return v.requestEvent(b,S,c)}}}requestPromise(b,v,S,c=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(b),t=(0,k.createCancelablePromise)(r=>a.call(v,S,r)),s=c.onCancellationRequested(()=>t.cancel()),n=(0,I.toDisposable)(()=>t.cancel());return this.activeRequests.add(n),t.finally(()=>{s.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(b,v,S){if(!this.disposeDelayer)return y.Event.None;this.disposeDelayer.cancel();let c;const a=new y.Emitter({onFirstListenerAdd:()=>{c=this.getCachedChannel(b).listen(v,S)(a.fire,a),this.activeRequests.add(c)},onLastListenerRemove:()=>{this.activeRequests.delete(c),c.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const b=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,i.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),C.isMacintosh&&v.env&&delete v.env.DYLD_LIBRARY_PATH,this.child=(0,R.fork)(this.modulePath,b,v);const S=new y.Emitter;y.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,L.isRemoteConsoleLog)(o)){(0,L.log)(o,`IPC Library: ${this.options.serverName}`);return}S.fire(D.VSBuffer.wrap(Buffer.from(o,"base64")))});const a=this.options.useQueue?(0,g.createQueuedSender)(this.child):this.child,t=o=>this.child&&this.child.connected&&a.send(o.buffer.toString("base64")),s=S.event,n={send:t,onMessage:s};this._client=new E.ChannelClient(n);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,l)=>{process.removeListener("exit",r),this.activeRequests.forEach(h=>(0,I.dispose)(h)),this.activeRequests.clear(),o!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+l),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:l})})}return this._client}getCachedChannel(b){let v=this.channels.get(b);return v||(v=this.client.getChannel(b),this.channels.set(b,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=p}),define(te[118],ne([11,12]),function(J,e){return J.create("vs/base/node/zip",e)}),define(te[119],ne([11,12]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[120],ne([11,12]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(te[121],ne([11,12]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(te[122],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[123],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[124],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(te[125],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[126],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[127],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(te[128],ne([11,12]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[129],ne([11,12]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(te[130],ne([11,12]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(te[131],ne([11,12]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(te[132],ne([11,12]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[133],ne([11,12]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(te[134],ne([11,12]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[135],ne([11,12]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[136],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(te[137],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(te[138],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/settingsSync",e)}),define(te[139],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(te[140],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSync",e)}),define(te[141],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(te[75],ne([0,1,57,66,15,9,31,16,7]),function(J,e,R,k,D,T,L,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class I{constructor(p,f,b){this._args=p,this.paths=f,this.productService=b}get appRoot(){return(0,T.dirname)(D.FileAccess.asFileUri("",J).fsPath)}get userHome(){return y.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return y.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return y.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const p=(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",p)}return this.args.logsPath}get userDataSyncLogResource(){return y.URI.file((0,T.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(y.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return y.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return y.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const p=L.env.VSCODE_PORTABLE;return p?y.URI.file((0,T.join)(p,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,P.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return y.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,T.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const p=this.args["builtin-extensions-dir"];return p?(0,T.resolve)(p):(0,T.normalize)((0,T.join)(D.FileAccess.asFileUri("",J).fsPath,"..","extensions"))}get extensionsDownloadPath(){const p=this.args["extensions-download-dir"];return p?(0,T.resolve)(p):(0,T.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const p=this.args["extensions-dir"];if(p)return(0,T.resolve)(p);const f=L.env.VSCODE_EXTENSIONS;if(f)return f;const b=L.env.VSCODE_PORTABLE;return b?(0,T.join)(b,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const p=this.args.extensionDevelopmentPath;if(Array.isArray(p))return p.map(f=>/^[^:/?#]+?:\/\//.test(f)?y.URI.parse(f):y.URI.file((0,T.normalize)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(p=>p==="ui"||p==="workspace"||p==="web"?p:"workspace")}get extensionTestsLocationURI(){const p=this.args.extensionTestsPath;if(p)return/^[^:/?#]+?:\/\//.test(p)?y.URI.parse(p):y.URI.file((0,T.normalize)(p))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const p=this.args["disable-extension"];if(p){if(typeof p=="string")return[p];if(Array.isArray(p)&&p.length>0)return p}return!1}get debugExtensionHost(){return i(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(y.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return y.URI.file((0,T.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([k.memoize],I.prototype,"appRoot",null),he([k.memoize],I.prototype,"userHome",null),he([k.memoize],I.prototype,"userDataPath",null),he([k.memoize],I.prototype,"appSettingsHome",null),he([k.memoize],I.prototype,"tmpDir",null),he([k.memoize],I.prototype,"userRoamingDataHome",null),he([k.memoize],I.prototype,"settingsResource",null),he([k.memoize],I.prototype,"userDataSyncHome",null),he([k.memoize],I.prototype,"userDataSyncLogResource",null),he([k.memoize],I.prototype,"sync",null),he([k.memoize],I.prototype,"machineSettingsResource",null),he([k.memoize],I.prototype,"globalStorageHome",null),he([k.memoize],I.prototype,"workspaceStorageHome",null),he([k.memoize],I.prototype,"keybindingsResource",null),he([k.memoize],I.prototype,"keyboardLayoutResource",null),he([k.memoize],I.prototype,"argvResource",null),he([k.memoize],I.prototype,"snippetsHome",null),he([k.memoize],I.prototype,"isExtensionDevelopment",null),he([k.memoize],I.prototype,"untitledWorkspacesHome",null),he([k.memoize],I.prototype,"installSourcePath",null),he([k.memoize],I.prototype,"builtinExtensionsPath",null),he([k.memoize],I.prototype,"extensionsPath",null),he([k.memoize],I.prototype,"extensionDevelopmentLocationURI",null),he([k.memoize],I.prototype,"extensionDevelopmentKind",null),he([k.memoize],I.prototype,"extensionTestsLocationURI",null),he([k.memoize],I.prototype,"debugExtensionHost",null),he([k.memoize],I.prototype,"serviceMachineIdResource",null),he([k.memoize],I.prototype,"telemetryLogResource",null),he([k.memoize],I.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=I;function i(u,p){return E(u["inspect-extensions"],u["inspect-brk-extensions"],5870,p,u.debugId)}e.parseExtensionHostPort=i;function C(u,p){return E(u["inspect-search"],u["inspect-brk-search"],5876,p)}e.parseSearchPort=C;function g(u,p){return E(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,p)}e.parsePtyHostPort=g;function E(u,p,f,b,v){const c=Number(p||u)||(b?null:f),a=c?Boolean(!!p):!1;return{port:c,break:a,debugId:v}}}),define(te[142],ne([0,1,235,4,120]),function(J,e,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const T={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,D.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(14,null)},category:{type:"string",cat:"e",description:(0,D.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,D.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,D.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,D.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,D.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,D.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const L={onUnknownOption:()=>{},onMultipleValues:()=>{}};function P(u,p,f=L){const b={},v=[],S=[];for(let s in p){const n=p[s];n.alias&&(b[s]=n.alias),n.type==="string"||n.type==="string[]"?(v.push(s),n.deprecates&&v.push(n.deprecates)):n.type==="boolean"&&(S.push(s),n.deprecates&&S.push(n.deprecates))}const c=R(u,{string:v,boolean:S,alias:b}),a={},t=c;a._=c._.map(s=>String(s)).filter(s=>s.length>0),delete t._;for(let s in p){const n=p[s];n.alias&&delete t[n.alias];let r=t[s];n.deprecates&&t.hasOwnProperty(n.deprecates)&&(r||(r=t[n.deprecates]),delete t[n.deprecates]),typeof r!="undefined"&&(n.type==="string[]"?r&&!Array.isArray(r)&&(r=[r]):n.type==="string"&&Array.isArray(r)&&(r=r.pop(),f.onMultipleValues(s,r)),a[s]=r),delete t[s]}for(let s in t)f.onUnknownOption(s);return a}e.parseArgs=P;function y(u,p){let f="";return p.args&&(Array.isArray(p.args)?f=` <${p.args.join("> <")}>`:f=` <${p.args}>`),p.alias?`-${p.alias} --${u}${f}`:`--${u}${f}`}function I(u,p){let f=0,b=[];for(const a in u){const t=u[a],s=y(a,t);f=Math.max(f,s.length),b.push([s,t.description])}let v=f+2+1;if(p-v<25)return b.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let S=p-v-1,c=[];for(const a of b){let t=a[0],s=C(a[1],S),n=i(v-t.length-2);c.push("  "+t+n+s[0]);for(let r=1;r<s.length;r++)c.push(i(v)+s[r])}return c}e.formatOptions=I;function i(u){return" ".repeat(u)}function C(u,p){let f=[];for(;u.length;){let b=u.length<p?u.length:u.lastIndexOf(" ",p),v=u.slice(0,b).trim();u=u.slice(b),f.push(v)}return f}function g(u,p,f,b,v=!0){const S=process.stdout.isTTY&&process.stdout.columns||80;let c=[`${u} ${f}`];c.push(""),c.push(`${(0,D.localize)(32,null)}: ${p} [${(0,D.localize)(33,null)}][${(0,D.localize)(34,null)}...]`),c.push(""),v&&(k.isWindows?c.push((0,D.localize)(35,null,p)):c.push((0,D.localize)(36,null,p)),c.push(""));const a={};for(const t in b){const s=b[t];if(s.description&&s.cat){let n=a[s.cat];n||(a[s.cat]=n={}),n[t]=s}}for(let t in a){const s=t;let n=a[s];n&&(c.push(T[s]),c.push(...I(n,S)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=g;function E(u,p){return`${u||(0,D.localize)(37,null)}
${p||(0,D.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=E}),function(){"use strict";function J(e,R,k,D){function T(P){const y=L(P),I=[y];return e.isAbsolute(y)||I.unshift(D),e.resolve(...I)}function L(P){const y=process.env.VSCODE_PORTABLE;if(y)return e.join(y,"user-data");let I=process.env.VSCODE_APPDATA;if(I)return e.join(I,k);const i=P["user-data-dir"];if(i)return i;switch(process.platform){case"win32":if(I=process.env.APPDATA,!I){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");I=e.join(C,"AppData","Roaming")}break;case"darwin":I=e.join(R.homedir(),"Library","Application Support");break;case"linux":I=process.env.XDG_CONFIG_HOME||e.join(R.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(I,k)}return{getUserDataPath:T}}if(typeof define=="function")define(te[143],ne([0,144,32,15,16,31]),function(e,R,k,D,T,L){const P=T.dirname(D.FileAccess.asFileUri("",e)),y=e.__$__nodeRequire(T.joinPath(P,"package.json").fsPath);return J(R,k,y.name,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),R=require("path"),k=require("os");module.exports=J(R,k,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[145],ne([0,1,32,75,143]),function(J,e,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class T extends k.AbstractNativeEnvironmentService{constructor(P,y){super(P,{homeDir:(0,R.homedir)(),tmpDir:(0,R.tmpdir)(),userDataDir:(0,D.getUserDataPath)(P)},y)}}e.NativeEnvironmentService=T}),define(te[146],ne([0,1,7]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const k=/^([^@:]+@)?([^:]+):/,D=/^([^@:]+@)?([^:]+):(.+)$/,T=/^([^@]+@)?([^:]+)(:\d+)?$/,L=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,y=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function I(f){const b=f.match(L);return b?b[1]:null}function i(f){if(f.indexOf("://")===-1){const b=f.match(k);return b?I(b[2]):null}try{const b=R.URI.parse(f);if(b.authority)return I(b.authority)}catch(b){}return null}function C(f,b){const v=new Set;let S;for(;S=P.exec(f);){const a=i(S[1]);a&&v.add(a)}const c=new Set(b);return Array.from(v).map(a=>c.has(a)?a:a.replace(y,"a"))}e.getDomainsOfRemotes=C;function g(f){const b=f.match(T);return b?b[2]:null}function E(f,b,v){return f&&b?(v&&b.endsWith(".git")&&(b=b.substr(0,b.length-4)),b.indexOf("/")===0?`${f}${b}`:`${f}/${b}`):null}function u(f,b){if(f.indexOf("://")===-1){const v=f.match(D);if(v)return E(v[2],v[3],b)}try{const v=R.URI.parse(f);if(v.authority)return E(g(v.authority),v.path,b)}catch(v){}return null}function p(f,b=!1){const v=[];let S;for(;S=P.exec(f);){const c=u(S[1],b);c&&v.push(c)}return v}e.getRemotes=p}),define(te[147],ne([0,1,26]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const k=/^%([\w\d.-]+)%$/i;function D(T,L){const P=y=>{if(typeof y!="string")return;const I=k.exec(y);if(!I)return;const i=L[I[1]]??y;return typeof i=="string"?i:typeof i.message=="string"?i.message:y};return(0,R.cloneAndChange)(T,P)}e.localizeManifest=D}),define(te[148],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class R{constructor(T){this.channel=T}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(T,L,P,y){return this.channel.call("promptImportantExtensionsInstallNotification",[T,L,P,y])}promptWorkspaceRecommendations(T){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=R;class k{constructor(T){this.service=T}listen(T,L){throw new Error(`Event not found: ${L}`)}call(T,L,P){switch(L){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${L}`)}}e.ExtensionRecommendationNotificationServiceChannel=k}),define(te[76],ne([0,1,128]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function T(g){return g=g.trim(),g==="*"||k.test(g)}e.isValidVersionStr=T;function L(g){if(!T(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=g.match(k);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}e.parseVersion=L;function P(g){if(!g)return null;let E=g.majorBase,u=g.majorMustEqual,p=g.minorBase,f=g.minorMustEqual,b=g.patchBase,v=g.patchMustEqual;g.hasCaret&&(E===0||(f=!1),v=!1);let S=0;if(g.preRelease){const c=D.exec(g.preRelease);if(c){const[,a,t,s]=c;S=Date.UTC(Number(a),Number(t)-1,Number(s))}}return{majorBase:E,majorMustEqual:u,minorBase:p,minorMustEqual:f,patchBase:b,patchMustEqual:v,isMinimum:g.hasGreaterEquals,notBefore:S}}e.normalizeVersion=P;function y(g,E,u){let p;typeof g=="string"?p=P(L(g)):p=g;let f;E instanceof Date?f=E.getTime():typeof E=="string"&&(f=new Date(E).getTime());let b;if(typeof u=="string"?b=P(L(u)):b=u,!p||!b)return!1;let v=p.majorBase,S=p.minorBase,c=p.patchBase,a=b.majorBase,t=b.minorBase,s=b.patchBase,n=b.notBefore,r=b.majorMustEqual,o=b.minorMustEqual,l=b.patchMustEqual;return b.isMinimum?v>a?!0:v<a?!1:S>t?!0:S<t||f&&f<n?!1:c>=s:(v===1&&a===0&&(!r||!o||!l)&&(a=1,t=0,s=0,r=!0,o=!1,l=!1),v<a?!1:v>a?!r:S<t?!1:S>t?!o:c<s?!1:c>s?!l:!(f&&f<n))}e.isValidVersion=y;function I(g,E,u,p){return u.isBuiltin||typeof u.main=="undefined"?!0:C(g,E,u.engines.vscode,p)}e.isValidExtensionVersion=I;function i(g,E,u){return g==="*"||C(E,u,g)}e.isEngineValid=i;function C(g,E,u,p=[]){let f=P(L(u));if(!f)return p.push(R.localize(0,null,u)),!1;if(f.majorBase===0){if(!f.majorMustEqual||!f.minorMustEqual)return p.push(R.localize(1,null,u)),!1}else if(!f.majorMustEqual)return p.push(R.localize(2,null,u)),!1;return y(g,E,f)?!0:(p.push(R.localize(3,null,g,u)),!1)}}),define(te[149],ne([0,1,2,15,33,52]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class L extends R.Disposable{constructor(y,I,i,C){super();this.requests=y,this.onDidFilesChange=I,this.onLogMessage=i,this.verboseLogging=C,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const y=this._register(new T.Client(k.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(y.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=L.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=D.ProxyChannel.toService((0,D.getNextTickChannel)(y.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(I=>!this.isDisposed&&this.onDidFilesChange(I))),this._register(this.service.onDidLogMessage(I=>this.onLogMessage(I))),this.watch(this.requests)}setVerboseLogging(y){this.verboseLogging=y,this.isDisposed||this.service?.setVerboseLogging(y)}error(y){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${y}`})}watch(y){this.requests=y,this.service?.watch(y)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=L,L.MAX_RESTARTS=5}),define(te[150],ne([0,1,2,15,33,52]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class L extends R.Disposable{constructor(y,I,i,C,g={}){super();this.folders=y,this.onDidFilesChange=I,this.onLogMessage=i,this.verboseLogging=C,this.watcherOptions=g,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const y=this._register(new T.Client(k.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(y.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=L.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=D.ProxyChannel.toService((0,D.getNextTickChannel)(y.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(I=>!this.isDisposed&&this.onDidFilesChange(I))),this._register(this.service.onDidLogMessage(I=>this.onLogMessage(I))),this.service.watch(this.folders)}error(y){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${y}`})}setVerboseLogging(y){this.verboseLogging=y,this.service&&this.service.setVerboseLogging(y)}watch(y){this.folders=y,this.service&&this.service.watch(y)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=L,L.MAX_RESTARTS=5}),define(te[151],ne([0,1,37,69,15,70]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class L{constructor(y,I,i,C,g){this.watchedFolder=y,this.eventCallback=i,this.logCallback=C,this.verboseLogging=g,this.restartCounter=0,Array.isArray(I)?this.ignored=I.map(E=>(0,k.parse)(E)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${y}, excludes: ${I.join(",")}`),this.startWatcher()}startWatcher(){const y=[this.watchedFolder];this.verboseLogging&&y.push("-verbose"),this.handle=(0,R.spawn)(D.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",J).fsPath,y);const I=new T.LineDecoder;this.handle.stdout.on("data",i=>{const C=[];for(const g of I.write(i)){const E=g.split("|");if(E.length===2){const u=Number(E[0]),p=E[1];if(u>=0&&u<3){if(this.ignored&&this.ignored.some(f=>f(p))){this.verboseLogging&&this.log(p);continue}C.push({type:L.changeTypeMap[u],path:p})}else this.log(E[1])}}C.length>0&&this.eventCallback(C)}),this.handle.on("error",i=>this.onError(i)),this.handle.stderr.on("data",i=>this.onError(i)),this.handle.on("exit",(i,C)=>this.onExit(i,C))}onError(y){this.error("process error: "+y.toString())}onExit(y,I){this.handle&&(this.error(`terminated unexpectedly (code: ${y}, signal: ${I})`),this.restartCounter<=L.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(y){this.logCallback({type:"error",message:`[File Watcher (C#)] ${y}`})}log(y){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${y}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=L,L.MAX_RESTARTS=5,L.changeTypeMap=[0,1,2]}),define(te[152],ne([0,1,9,25,151]),function(J,e,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class T{constructor(P,y,I,i){this.onDidFilesChange=y,this.onLogMessage=I,this.verboseLogging=i,this.service=void 0,this.folder=P[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(R.posix.sep)&&(this.folder.path=(0,k.rtrim)(this.folder.path,R.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new D.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,P=>this.onFileEvents(P),P=>this.onLogMessage(P),this.verboseLogging)}setVerboseLogging(P){this.verboseLogging=P,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(P){this.isDisposed||P.length>0&&this.onDidFilesChange(P)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=T}),define(te[53],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class R{constructor(D,T=[],L=!1){this.ctor=D,this.staticArguments=T,this.supportsDelayedInstantiation=L}}e.SyncDescriptor=R}),define(te[153],ne([0,1,53]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const k=[];function D(L,P,y){P instanceof R.SyncDescriptor||(P=new R.SyncDescriptor(P,[],y)),k.push([L,P])}e.registerSingleton=D;function T(){return k}e.getSingletonServiceDescriptors=T}),define(te[154],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class R{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=R;class k{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let L of this._nodes.values())L.outgoing.size===0&&T.push(L);return T}insertEdge(T,L){const P=this.lookupOrInsertNode(T),y=this.lookupOrInsertNode(L);P.outgoing.set(this._hashFn(L),y),y.incoming.set(this._hashFn(T),P)}removeNode(T){const L=this._hashFn(T);this._nodes.delete(L);for(let P of this._nodes.values())P.outgoing.delete(L),P.incoming.delete(L)}lookupOrInsertNode(T){const L=this._hashFn(T);let P=this._nodes.get(L);return P||(P=new R(T),this._nodes.set(L,P)),P}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[L,P]of this._nodes)T.push(`${L}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,L]of this._nodes){const P=new Set([T]),y=this._findCycle(L,P);if(y)return y}}_findCycle(T,L){for(let[P,y]of T.outgoing){if(L.has(P))return[...L,P].join(" -> ");L.add(P);const I=this._findCycle(y,L);if(I)return I;L.delete(P)}}}e.Graph=k}),define(te[5],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var R;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function y(I){return I[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=y})(R=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function k(P,y,I,i){y[R.DI_TARGET]===y?y[R.DI_DEPENDENCIES].push({id:P,index:I,optional:i}):(y[R.DI_DEPENDENCIES]=[{id:P,index:I,optional:i}],y[R.DI_TARGET]=y)}function D(P){if(R.serviceIds.has(P))return R.serviceIds.get(P);const y=function(I,i,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(y,I,C,!1)};return y.toString=()=>P,R.serviceIds.set(P,y),y}e.createDecorator=D;function T(P){return P}e.refineServiceDecorator=T;function L(P){return function(y,I,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");k(P,y,i,!0)}}e.optional=L}),define(te[155],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,R.createDecorator)("checksumService")}),define(te[156],ne([0,1,4,25,5]),function(J,e,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=R.userAgent||"";const L=new Map;L.set("false",!1),L.set("true",!0),L.set("isMac",R.isMacintosh),L.set("isLinux",R.isLinux),L.set("isWindows",R.isWindows),L.set("isWeb",R.isWeb),L.set("isMacNative",R.isMacintosh&&!R.isWeb),L.set("isEdge",T.indexOf("Edg/")>=0),L.set("isFirefox",T.indexOf("Firefox")>=0),L.set("isChrome",T.indexOf("Chrome")>=0),L.set("isSafari",T.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var y;(function(_){_[_.False=0]="False",_[_.True=1]="True",_[_.Defined=2]="Defined",_[_.Not=3]="Not",_[_.Equals=4]="Equals",_[_.NotEquals=5]="NotEquals",_[_.And=6]="And",_[_.Regex=7]="Regex",_[_.NotRegex=8]="NotRegex",_[_.Or=9]="Or",_[_.In=10]="In",_[_.NotIn=11]="NotIn",_[_.Greater=12]="Greater",_[_.GreaterEquals=13]="GreaterEquals",_[_.Smaller=14]="Smaller",_[_.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return C.INSTANCE}static true(){return g.INSTANCE}static has(w){return E.create(w)}static equals(w,O){return u.create(w,O)}static notEquals(w,O){return b.create(w,O)}static regex(w,O){return s.create(w,O)}static in(w,O){return p.create(w,O)}static not(w){return v.create(w)}static and(...w){return r.create(w,null)}static or(...w){return o.create(w,null,!0)}static greater(w,O){return S.create(w,O)}static less(w,O){return a.create(w,O)}static deserialize(w,O=!1){if(!!w)return this._deserializeOrExpression(w,O)}static _deserializeOrExpression(w,O){let U=w.split("||");return o.create(U.map($=>this._deserializeAndExpression($,O)),null,!0)}static _deserializeAndExpression(w,O){let U=w.split("&&");return r.create(U.map($=>this._deserializeOne($,O)),null)}static _deserializeOne(w,O){if(w=w.trim(),w.indexOf("!=")>=0){let U=w.split("!=");return b.create(U[0].trim(),this._deserializeValue(U[1],O))}if(w.indexOf("==")>=0){let U=w.split("==");return u.create(U[0].trim(),this._deserializeValue(U[1],O))}if(w.indexOf("=~")>=0){let U=w.split("=~");return s.create(U[0].trim(),this._deserializeRegexValue(U[1],O))}if(w.indexOf(" in ")>=0){let U=w.split(" in ");return p.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(w)){const U=w.split(">=");return c.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(w)){const U=w.split(">");return S.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(w)){const U=w.split("<=");return t.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(w)){const U=w.split("<");return a.create(U[0].trim(),U[1].trim())}return/^\!\s*/.test(w)?v.create(w.substr(1).trim()):E.create(w)}static _deserializeValue(w,O){if(w=w.trim(),w==="true")return!0;if(w==="false")return!1;let U=/^'([^']*)'$/.exec(w);return U?U[1].trim():w}static _deserializeRegexValue(w,O){if((0,k.isFalsyOrWhitespace)(w)){if(O)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let U=w.indexOf("/"),$=w.lastIndexOf("/");if(U===$||U<0){if(O)throw new Error(`bad regexp-value '${w}', missing /-enclosure`);return console.warn(`bad regexp-value '${w}', missing /-enclosure`),null}let Y=w.slice(U+1,$),M=w[$+1]==="i"?"i":"";try{return new RegExp(Y,M)}catch(V){if(O)throw new Error(`bad regexp-value '${w}', parse error: ${V}`);return console.warn(`bad regexp-value '${w}', parse error: ${V}`),null}}}e.ContextKeyExpr=I;function i(_,w){return _.cmp(w)}class C{constructor(){this.type=0}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}evaluate(w){return!1}serialize(){return"false"}keys(){return[]}map(w){return this}negate(){return g.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class g{constructor(){this.type=1}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}evaluate(w){return!0}serialize(){return"true"}keys(){return[]}map(w){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=g,g.INSTANCE=new g;class E{constructor(w,O){this.key=w,this.negated=O,this.type=2}static create(w,O=null){const U=L.get(w);return typeof U=="boolean"?U?g.INSTANCE:C.INSTANCE:new E(w,O)}cmp(w){return w.type!==this.type?this.type-w.type:h(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}evaluate(w){return!!w.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(w){return w.mapDefined(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=E;class u{constructor(w,O,U){this.key=w,this.value=O,this.negated=U,this.type=4}static create(w,O,U=null){if(typeof O=="boolean")return O?E.create(w,U):v.create(w,U);const $=L.get(w);return typeof $=="boolean"?O===($?"true":"false")?g.INSTANCE:C.INSTANCE:new u(w,O,U)}cmp(w){return w.type!==this.type?this.type-w.type:d(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return w.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(w){return w.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=u;class p{constructor(w,O){this.key=w,this.valueKey=O,this.type=10,this.negated=null}static create(w,O){return new p(w,O)}cmp(w){return w.type!==this.type?this.type-w.type:d(this.key,this.valueKey,w.key,w.valueKey)}equals(w){return w.type===this.type?this.key===w.key&&this.valueKey===w.valueKey:!1}evaluate(w){const O=w.getValue(this.valueKey),U=w.getValue(this.key);return Array.isArray(O)?O.indexOf(U)>=0:typeof U=="string"&&typeof O=="object"&&O!==null?P.call(O,U):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(w){return w.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=f.create(this)),this.negated}}e.ContextKeyInExpr=p;class f{constructor(w){this._actual=w,this.type=11}static create(w){return new f(w)}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}evaluate(w){return!this._actual.evaluate(w)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(w){return new f(this._actual.map(w))}negate(){return this._actual}}e.ContextKeyNotInExpr=f;class b{constructor(w,O,U){this.key=w,this.value=O,this.negated=U,this.type=5}static create(w,O,U=null){if(typeof O=="boolean")return O?v.create(w,U):E.create(w,U);const $=L.get(w);return typeof $=="boolean"?O===($?"true":"false")?C.INSTANCE:g.INSTANCE:new b(w,O,U)}cmp(w){return w.type!==this.type?this.type-w.type:d(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return w.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(w){return w.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=b;class v{constructor(w,O){this.key=w,this.negated=O,this.type=3}static create(w,O=null){const U=L.get(w);return typeof U=="boolean"?U?C.INSTANCE:g.INSTANCE:new v(w,O)}cmp(w){return w.type!==this.type?this.type-w.type:h(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}evaluate(w){return!w.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(w){return w.mapNot(this.key)}negate(){return this.negated||(this.negated=E.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=v;class S{constructor(w,O,U){this.key=w,this.value=O,this.negated=U,this.type=12}static create(w,O,U=null){return new S(w,O,U)}cmp(w){return w.type!==this.type?this.type-w.type:d(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=S;class c{constructor(w,O,U){this.key=w,this.value=O,this.negated=U,this.type=13}static create(w,O,U=null){return new c(w,O,U)}cmp(w){return w.type!==this.type?this.type-w.type:d(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=c;class a{constructor(w,O,U){this.key=w,this.value=O,this.negated=U,this.type=14}static create(w,O,U=null){return new a(w,O,U)}cmp(w){return w.type!==this.type?this.type-w.type:d(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=a;class t{constructor(w,O,U){this.key=w,this.value=O,this.negated=U,this.type=15}static create(w,O,U=null){return new t(w,O,U)}cmp(w){return w.type!==this.type?this.type-w.type:d(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=t;class s{constructor(w,O){this.key=w,this.regexp=O,this.type=7,this.negated=null}static create(w,O){return new s(w,O)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.key<w.key)return-1;if(this.key>w.key)return 1;const O=this.regexp?this.regexp.source:"",U=w.regexp?w.regexp.source:"";return O<U?-1:O>U?1:0}equals(w){if(w.type===this.type){const O=this.regexp?this.regexp.source:"",U=w.regexp?w.regexp.source:"";return this.key===w.key&&O===U}return!1}evaluate(w){let O=w.getValue(this.key);return this.regexp?this.regexp.test(O):!1}serialize(){const w=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${w}`}keys(){return[this.key]}map(w){return w.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=s;class n{constructor(w){this._actual=w,this.type=8}static create(w){return new n(w)}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}evaluate(w){return!this._actual.evaluate(w)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(w){return new n(this._actual.map(w))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;class r{constructor(w,O){this.expr=w,this.negated=O,this.type=6}static create(w,O){return r._normalizeArr(w,O)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let O=0,U=this.expr.length;O<U;O++){const $=i(this.expr[O],w.expr[O]);if($!==0)return $}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let O=0,U=this.expr.length;O<U;O++)if(!this.expr[O].equals(w.expr[O]))return!1;return!0}return!1}evaluate(w){for(let O=0,U=this.expr.length;O<U;O++)if(!this.expr[O].evaluate(w))return!1;return!0}static _normalizeArr(w,O){const U=[];let $=!1;for(const Y of w)if(!!Y){if(Y.type===1){$=!0;continue}if(Y.type===0)return C.INSTANCE;if(Y.type===6){U.push(...Y.expr);continue}U.push(Y)}if(U.length===0&&$)return g.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(i);for(let Y=1;Y<U.length;Y++)U[Y-1].equals(U[Y])&&(U.splice(Y,1),Y--);if(U.length===1)return U[0];for(;U.length>1;){const Y=U[U.length-1];if(Y.type!==9)break;U.pop();const M=U.pop(),V=U.length===0,j=o.create(Y.expr.map(z=>r.create([z,M],null)),null,V);j&&(U.push(j),U.sort(i))}return U.length===1?U[0]:new r(U,O)}}serialize(){return this.expr.map(w=>w.serialize()).join(" && ")}keys(){const w=[];for(let O of this.expr)w.push(...O.keys());return w}map(w){return new r(this.expr.map(O=>O.map(w)),null)}negate(){if(!this.negated){const w=[];for(let O of this.expr)w.push(O.negate());this.negated=o.create(w,this,!0)}return this.negated}}class o{constructor(w,O){this.expr=w,this.negated=O,this.type=9}static create(w,O,U){return o._normalizeArr(w,O,U)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let O=0,U=this.expr.length;O<U;O++){const $=i(this.expr[O],w.expr[O]);if($!==0)return $}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let O=0,U=this.expr.length;O<U;O++)if(!this.expr[O].equals(w.expr[O]))return!1;return!0}return!1}evaluate(w){for(let O=0,U=this.expr.length;O<U;O++)if(this.expr[O].evaluate(w))return!0;return!1}static _normalizeArr(w,O,U){let $=[],Y=!1;if(w){for(let M=0,V=w.length;M<V;M++){const j=w[M];if(!!j){if(j.type===0){Y=!0;continue}if(j.type===1)return g.INSTANCE;if(j.type===9){$=$.concat(j.expr);continue}$.push(j)}}if($.length===0&&Y)return C.INSTANCE;$.sort(i)}if($.length!==0){if($.length===1)return $[0];for(let M=1;M<$.length;M++)$[M-1].equals($[M])&&($.splice(M,1),M--);if($.length===1)return $[0];if(U){for(let M=0;M<$.length;M++)for(let V=M+1;V<$.length;V++)m($[M],$[V])&&($.splice(V,1),V--);if($.length===1)return $[0]}return new o($,O)}}serialize(){return this.expr.map(w=>w.serialize()).join(" || ")}keys(){const w=[];for(let O of this.expr)w.push(...O.keys());return w}map(w){return new o(this.expr.map(O=>O.map(w)),null)}negate(){if(!this.negated){let w=[];for(let O of this.expr)w.push(O.negate());for(;w.length>1;){const O=w.shift(),U=w.shift(),$=[];for(const M of A(O))for(const V of A(U))$.push(r.create([M,V],null));const Y=w.length===0;w.unshift(o.create($,null,Y))}this.negated=w[0]}return this.negated}}class l extends E{constructor(w,O,U){super(w,null);this._defaultValue=O,typeof U=="object"?l._info.push({...U,key:w}):U!==!0&&l._info.push({key:w,description:U,type:O!=null?typeof O:void 0})}static all(){return l._info.values()}bindTo(w){return w.createKey(this.key,this._defaultValue)}getValue(w){return w.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(w){return u.create(this.key,w)}notEqualsTo(w){return b.create(this.key,w)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function h(_,w){return _<w?-1:_>w?1:0}function d(_,w,O,U){return _<O?-1:_>O?1:w<U?-1:w>U?1:0}function m(_,w){if(w.type===6&&_.type!==9&&_.type!==6){for(const $ of w.expr)if(_.equals($))return!0}const O=_.negate(),U=A(O).concat(A(w));U.sort(i);for(let $=0;$<U.length;$++){const M=U[$].negate();for(let V=$+1;V<U.length;V++){const j=U[V];if(M.equals(j))return!0}}return!1}e.implies=m;function A(_){return _.type===9?_.expr:[_]}}),define(te[77],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,R.createDecorator)(e.ID);function k(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=k}),define(te[78],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,R.createDecorator)("downloadService")}),define(te[13],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,R.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,R.refineServiceDecorator)(e.IEnvironmentService)}),define(te[28],ne([0,1,15,123,5]),function(J,e,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var T;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(T=e.TargetPlatform||(e.TargetPlatform={}));function L(v){switch(v){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=L;function P(v){switch(v){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function y(v,S){switch(v){case 3:return S==="x64"?"win32-x64":S==="ia32"?"win32-ia32":S==="arm64"?"win32-arm64":"unknown";case 2:return S==="x64"?"linux-x64":S==="arm64"?"linux-arm64":S==="arm"?"linux-armhf":"unknown";case"alpine":return S==="x64"?"alpine-x64":S==="arm64"?"alpine-arm64":"unknown";case 1:return S==="x64"?"darwin-x64":S==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=y;function I(v,S){return S==="web"&&!v.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function i(v,S,c){return I(S,c)?!1:v==="undefined"||v==="universal"?!0:v==="unknown"?!1:v===c?!0:C(c).includes(v)}e.isTargetPlatformCompatible=i;function C(v){switch(v){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=C;function g(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}e.isIExtensionIdentifier=g;var E;(function(v){v[v.NoneOrRelevance=0]="NoneOrRelevance",v[v.LastUpdatedDate=1]="LastUpdatedDate",v[v.Title=2]="Title",v[v.PublisherName=3]="PublisherName",v[v.InstallCount=4]="InstallCount",v[v.PublishedDate=10]="PublishedDate",v[v.AverageRating=6]="AverageRating",v[v.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var u;(function(v){v[v.Default=0]="Default",v[v.Ascending=1]="Ascending",v[v.Descending=2]="Descending"})(u=e.SortOrder||(e.SortOrder={}));var p;(function(v){v.Install="install",v.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var f;(function(v){v[v.None=0]="None",v[v.Install=1]="Install",v[v.Update=2]="Update"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class b extends Error{constructor(S,c){super(S);this.code=c,this.name=c}}e.ExtensionManagementError=b,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=R.FileAccess.asBrowserUri("./media/defaultIcon.png",J).toString(!0),e.ExtensionsLabel=(0,k.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,k.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")});var Q=this&&this.__param||function(J,e){return function(R,k){e(R,k,J)}};define(te[157],ne([0,1,2,28]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let D=class extends R.Disposable{constructor(L){super();this.extensionManagementService=L,this._register(L),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};D=he([Q(0,k.IExtensionManagementService)],D),e.DeprecatedExtensionsCleaner=D}),define(te[158],ne([0,1,3,2,26,7,102,28]),function(J,e,R,k,D,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function y(p,f){return T.URI.revive(f?f.transformIncoming(p):p)}function I(p,f){return f?f.transformOutgoingURI(p):p}function i(p,f){f=f||L.DefaultURITransformer;const b=p.manifest;return{...(0,L.transformAndReviveIncomingURIs)({...p,manifest:void 0},f),manifest:b}}function C(p,f){return f?(0,D.cloneAndChange)(p,b=>b instanceof T.URI?f.transformOutgoingURI(b):void 0):p}class g{constructor(f,b){this.service=f,this.getUriTransformer=b,this.onInstallExtension=R.Event.buffer(f.onInstallExtension,!0),this.onDidInstallExtensions=R.Event.buffer(f.onDidInstallExtensions,!0),this.onUninstallExtension=R.Event.buffer(f.onUninstallExtension,!0),this.onDidUninstallExtension=R.Event.buffer(f.onDidUninstallExtension,!0)}listen(f,b){const v=this.getUriTransformer(f);switch(b){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return R.Event.map(this.onDidInstallExtensions,S=>S.map(c=>({...c,local:c.local?C(c.local,v):c.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(f,b,v){const S=this.getUriTransformer(f);switch(b){case"zip":return this.service.zip(i(v[0],S)).then(c=>I(c,S));case"unzip":return this.service.unzip(y(v[0],S));case"install":return this.service.install(y(v[0],S),v[1]);case"getManifest":return this.service.getManifest(y(v[0],S));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(v[0]);case"installFromGallery":return this.service.installFromGallery(v[0],v[1]);case"uninstall":return this.service.uninstall(i(v[0],S),v[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(i(v[0],S));case"getInstalled":return this.service.getInstalled(v[0]).then(c=>c.map(a=>C(a,S)));case"updateMetadata":return this.service.updateMetadata(i(v[0],S),v[1]).then(c=>C(c,S));case"updateExtensionScope":return this.service.updateExtensionScope(i(v[0],S),v[1]).then(c=>C(c,S));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=g;class E extends k.Disposable{constructor(f){super();this.channel=f,this._onInstallExtension=this._register(new R.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new R.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new R.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new R.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(b=>this._onInstallExtension.fire({identifier:b.identifier,source:this.isUriComponents(b.source)?T.URI.revive(b.source):b.source}))),this._register(this.channel.listen("onDidInstallExtensions")(b=>this._onDidInstallExtensions.fire(b.map(v=>({...v,local:v.local?i(v.local,null):v.local,source:this.isUriComponents(v.source)?T.URI.revive(v.source):v.source}))))),this._register(this.channel.listen("onUninstallExtension")(b=>this._onUninstallExtension.fire(b))),this._register(this.channel.listen("onDidUninstallExtension")(b=>this._onDidUninstallExtension.fire(b)))}isUriComponents(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(f){const b=await this.getTargetPlatform();return f.allTargetPlatforms.some(v=>(0,P.isTargetPlatformCompatible)(v,f.allTargetPlatforms,b))}zip(f){return Promise.resolve(this.channel.call("zip",[f]).then(b=>T.URI.revive(b)))}unzip(f){return Promise.resolve(this.channel.call("unzip",[f]))}install(f,b){return Promise.resolve(this.channel.call("install",[f,b])).then(v=>i(v,null))}getManifest(f){return Promise.resolve(this.channel.call("getManifest",[f]))}installFromGallery(f,b){return Promise.resolve(this.channel.call("installFromGallery",[f,b])).then(v=>i(v,null))}uninstall(f,b){return Promise.resolve(this.channel.call("uninstall",[f,b]))}reinstallFromGallery(f){return Promise.resolve(this.channel.call("reinstallFromGallery",[f]))}getInstalled(f=null){return Promise.resolve(this.channel.call("getInstalled",[f])).then(b=>b.map(v=>i(v,null)))}updateMetadata(f,b){return Promise.resolve(this.channel.call("updateMetadata",[f,b])).then(v=>i(v,null))}updateExtensionScope(f,b){return Promise.resolve(this.channel.call("updateExtensionScope",[f,b])).then(v=>i(v,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=E;class u{constructor(f){this.service=f}listen(f,b){throw new Error("Invalid listen")}call(f,b,v){switch(b){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(v[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=u}),define(te[79],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var k;(function(L){L[L.FILE=1]="FILE",L[L.WORKSPACE=2]="WORKSPACE",L[L.EXE=3]="EXE"})(k=e.RecommendationSource||(e.RecommendationSource={}));function D(L){switch(L){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=D;var T;(function(L){L.Ignored="ignored",L.Cancelled="cancelled",L.TooMany="toomany",L.IncompatibleWindow="incompatibleWindow",L.Accepted="reacted"})(T=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,R.createDecorator)("IExtensionRecommendationNotificationService")}),define(te[159],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,R.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(te[80],ne([0,1,25,5]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function D(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkspaceSupportTypeMessage=D;function T(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(L=e.ExtensionType||(e.ExtensionType={}));class P{constructor(C){this.value=C,this._lower=C.toLowerCase()}static equals(C,g){if(typeof C=="undefined"||C===null)return typeof g=="undefined"||g===null;if(typeof g=="undefined"||g===null)return!1;if(typeof C=="string"||typeof g=="string"){let E=typeof C=="string"?C:C.value,u=typeof g=="string"?g:g.value;return R.equalsIgnoreCase(E,u)}return C._lower===g._lower}static toKey(C){return typeof C=="string"?C.toLowerCase():C._lower}}e.ExtensionIdentifier=P;function y(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function I(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=I,e.IBuiltinExtensionsScannerService=(0,k.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[34],ne([0,1,25,80]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(u,p){return u.uuid&&p.uuid?u.uuid===p.uuid:u.id===p.id?!0:(0,R.compareIgnoreCase)(u.id,p.id)===0}e.areSameExtensions=D;class T{constructor(p,f){this.version=f,this.id=p.id,this.uuid=p.uuid}key(){return`${this.id}-${this.version}`}equals(p){return p instanceof T?D(this,p)&&this.version===p.version:!1}}e.ExtensionIdentifierWithVersion=T;function L(u,p){return`${u}.${p}`}e.getExtensionId=L;function P(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function y(u,p){return P(L(u,p))}e.getGalleryExtensionId=y;function I(u,p){const f=[],b=v=>{for(const S of f)if(S.some(c=>D(p(c),p(v))))return S;return null};for(const v of u){const S=b(v);S?S.push(v):f.push([v])}return f}e.groupByExtension=I;function i(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function C(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function g(u){const p=new Set;for(const f of u)f.malicious&&p.add(f.id.id);return p}e.getMaliciousExtensionsSet=g;function E(u,p){const f=[],b=p.manifest.extensionDependencies?.slice(0)??[];for(;b.length;){const v=b.shift();if(v&&f.every(S=>!D(S.identifier,{id:v}))){const S=u.filter(c=>D(c.identifier,{id:v}));S.length===1&&(f.push(S[0]),b.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return f}e.getExtensionDependencies=E}),define(te[160],ne([0,1,2,9,19,80]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class L extends R.Disposable{constructor(y,I){super();this.environmentService=y,this.extensionsManifestCache=(0,k.join)(this.environmentService.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this._register(I.onDidInstallExtensions(i=>this.onDidInstallExtensions(i))),this._register(I.onDidUninstallExtension(i=>this.onDidUnInstallExtension(i)))}onDidInstallExtensions(y){y.some(I=>!!I.local)&&this.invalidate()}onDidUnInstallExtension(y){y.error||this.invalidate()}invalidate(){D.Promises.rm(this.extensionsManifestCache,D.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=L}),define(te[14],ne([0,1,41,9,25,18,7,130,5]),function(J,e,R,k,D,T,L,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function I(M){return M.create===!0}e.isFileOpenForWriteOptions=I;var i;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var C;(function(M){M[M.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var g;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock"})(g=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=E;function u(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=u;function p(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function f(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=f;var b;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class v extends Error{constructor(V,j){super(V);this.code=j}}e.FileSystemProviderError=v;function S(M,V){const j=new v(M.toString(),V);return a(j,V),j}e.createFileSystemProviderError=S;function c(M){return M||S((0,P.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=c;function a(M,V){return M.name=V?`${V} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=a;function t(M){if(!M)return b.Unknown;if(M instanceof v)return M.code;const V=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!V)return b.Unknown;switch(V[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=t;function s(M){if(M instanceof d)return M.fileOperationResult;switch(t(M)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var n;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class r{constructor(V,j,z){this.resource=V,this.operation=j,this.target=z}isOperation(V){return this.operation===V}}e.FileOperationEvent=r;var o;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class l{constructor(V,j){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const z of V)switch(z.type){case 1:this.added||(this.added=R.TernarySearchTree.forUris(()=>j)),this.added.set(z.resource,z);break;case 0:this.updated||(this.updated=R.TernarySearchTree.forUris(()=>j)),this.updated.set(z.resource,z);break;case 2:this.deleted||(this.deleted=R.TernarySearchTree.forUris(()=>j)),this.deleted.set(z.resource,z);break}}contains(V,...j){return this.doContains(V,{includeChildren:!1},...j)}affects(V,...j){return this.doContains(V,{includeChildren:!0},...j)}doContains(V,j,...z){if(!V)return!1;const q=z.length>0;return!!((!q||z.includes(1))&&(this.added?.get(V)||j.includeChildren&&this.added?.findSuperstr(V))||(!q||z.includes(0))&&(this.updated?.get(V)||j.includeChildren&&this.updated?.findSuperstr(V))||(!q||z.includes(2))&&(this.deleted?.findSubstr(V)||j.includeChildren&&this.deleted?.findSuperstr(V)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=l;function h(M,V,j){return!M||!V||M===V||V.length>M.length?!1:(V.charAt(V.length-1)!==k.sep&&(V+=k.sep),j?(0,D.startsWithIgnoreCase)(M,V):M.indexOf(V)===0)}e.isParent=h;class d extends Error{constructor(V,j,z){super(V);this.fileOperationResult=j,this.options=z}}e.FileOperationError=d;class m extends d{constructor(V,j,z){super(V,2,z);this.stat=j}}e.NotModifiedSinceFileOperationError=m;var A;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var _;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(_=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function w(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=w;async function O(M,V){if(!V.canHandleResource(L.URI.from({scheme:M.scheme})))return new Promise(j=>{const z=V.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===M.scheme&&q.added&&(z.dispose(),j())})})}e.whenProviderRegistered=O,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class U{static formatSize(V){return(0,T.isNumber)(V)||(V=0),V<U.KB?(0,P.localize)(1,null,V.toFixed(0)):V<U.MB?(0,P.localize)(2,null,(V/U.KB).toFixed(2)):V<U.GB?(0,P.localize)(3,null,(V/U.MB).toFixed(2)):V<U.TB?(0,P.localize)(4,null,(V/U.GB).toFixed(2)):(0,P.localize)(5,null,(V/U.TB).toFixed(2))}}e.ByteSize=U,U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB;var $;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})($=e.Arch||(e.Arch={}));function Y(M){return{maxFileSize:M===0?300*U.MB:16*U.GB,maxHeapSize:M===0?700*U.MB:2*700*U.MB}}e.getPlatformLimits=Y}),define(te[161],ne([0,1,81,50,14]),function(J,e,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let T=class{constructor(P){this.fileService=P}checksum(P){return new Promise(async(y,I)=>{const i=(0,R.createHash)("md5"),C=(await this.fileService.readFileStream(P)).value;(0,k.listenStream)(C,{onData:g=>i.update(g.buffer),onError:g=>I(g),onEnd:()=>y(i.digest("base64").replace(/=+$/,""))})})}};T=he([Q(0,D.IFileService)],T),e.ChecksumService=T}),define(te[162],ne([0,1,236,121,142,14]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function L(g,E){const u={onUnknownOption:f=>{console.warn((0,k.localize)(0,null,f))},onMultipleValues:(f,b)=>{console.warn((0,k.localize)(1,null,f,b))}},p=(0,D.parseArgs)(g,D.OPTIONS,E?u:void 0);return p.goto&&p._.forEach(f=>R(/^(\w:)?[^:]+(:\d*){0,2}$/.test(f),(0,k.localize)(2,null))),p["max-memory"]&&R(parseInt(p["max-memory"])>=T.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${T.MIN_MAX_MEMORY_SIZE_MB} MB.`),p}function P(g){const E=g.findIndex(u=>!/^-/.test(u));if(E>-1)return[...g.slice(0,E),...g.slice(E+1)]}function y(g){let[,...E]=g;process.env.VSCODE_DEV&&(E=P(E)||[]);const u=!C(process.env);return L(E,u)}e.parseMainProcessArgv=y;function I(g){const[,,...E]=g;return L(E,!0)}e.parseCLIProcessArgv=I;function i(g,...E){const u=g.indexOf("--");return u===-1?g.push(...E):g.splice(u,0,...E),g}e.addArg=i;function C(g){return g.VSCODE_CLI==="1"}e.isLaunchedFromCli=C}),define(te[163],ne([0,1,37,144,27,38,8,4,30,117,162]),function(J,e,R,k,D,T,L,P,y,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function C(u,p,f){return p["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):P.isWindows?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,i.isLaunchedFromCli)(f)&&!p["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,i.isLaunchedFromCli)(f)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),g||(g=new Promise(async b=>{const v=new D.CancellationTokenSource,S=setTimeout(()=>{u.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),v.dispose(!0),b({})},1e4);try{const c=await E(u,v.token);b(c)}catch(c){(0,L.isPromiseCanceledError)(c)||u.error(`[resolve shell env] Unable to resolve shell environment (${c}). Proceeding without shell environment...`),b({})}finally{clearTimeout(S),v.dispose()}})),g)}e.resolveShellEnv=C;let g;async function E(u,p){const f=new Promise(async(b,v)=>{const S=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",S);const c=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",c);const a=(0,y.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"(.*)"+a),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};u.trace("getUnixShellEnvironment#env",s);const n=await(0,I.getSystemShell)(P.OS,s);if(u.trace("getUnixShellEnvironment#shell",n),p.isCancellationRequested)return v(L.canceled);const r=k.basename(n);let o,l;/^pwsh(-preview)?$/.test(r)?(o=`& '${process.execPath}' -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,l=["-Login","-Command"]):(o=`'${process.execPath}' -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,l=["-ilc"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(l),o);const h=(0,R.spawn)(n,[...l,o],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});p.onCancellationRequested(()=>(h.kill(),v(L.canceled))),h.on("error",A=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(A)),b({})});const d=[];h.stdout.on("data",A=>d.push(A));const m=[];h.stderr.on("data",A=>m.push(A)),h.on("close",(A,_)=>{const w=Buffer.concat(d).toString("utf8");u.trace("getUnixShellEnvironment#raw",w);const O=Buffer.concat(m).toString("utf8");if(O.trim()&&u.trace("getUnixShellEnvironment#stderr",O),A||_)return v(new Error(`Failed to get environment (code ${A}, signal ${_})`));const U=t.exec(w),$=U?U[1]:"{}";try{const Y=JSON.parse($);S?Y.ELECTRON_RUN_AS_NODE=S:delete Y.ELECTRON_RUN_AS_NODE,c?Y.ELECTRON_NO_ATTACH_CONSOLE=c:delete Y.ELECTRON_NO_ATTACH_CONSOLE,delete Y.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",Y),b(Y)}catch(Y){u.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(Y)),v(Y)}})});try{return await f}catch(b){return u.error("getUnixShellEnvironment#error",(0,T.toErrorMessage)(b)),{}}}}),define(te[82],ne([0,1,4,7,14]),function(J,e,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function T(y){return y.map(I=>({type:I.type,resource:k.URI.file(I.path)}))}e.toFileChanges=T;function L(y){const I=new P;for(const i of y)I.processEvent(i);return I.normalize()}e.normalizeFileChanges=L;class P{constructor(){this.normalized=new Set,this.mapPathToChange=new Map}toKey(I){return R.isLinux?I.path:I.path.toLowerCase()}processEvent(I){const i=this.mapPathToChange.get(this.toKey(I));let C=!1;if(i){const g=i.type,E=I.type;i.path!==I.path&&(E===1||E===0)?(i.type=2,C=!0):g===1&&E===2?(this.mapPathToChange.delete(this.toKey(I)),this.normalized.delete(i)):g===2&&E===1?i.type=0:g===1&&E===0||(i.type=E)}else C=!0;C&&(this.normalized.add(I),this.mapPathToChange.set(this.toKey(I),I))}normalize(){const I=[],i=[];return Array.from(this.normalized).filter(C=>C.type!==2?(I.push(C),!1):!0).sort((C,g)=>C.path.length-g.path.length).filter(C=>i.some(g=>(0,D.isParent)(C.path,g,!R.isLinux))?!1:(i.push(C.path),!0)).concat(I)}}}),define(te[164],ne([0,1,6,2,9,106,19,109,82]),function(J,e,R,k,D,T,L,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class I extends k.Disposable{constructor(C,g,E,u){super();this.path=C,this.onDidFilesChange=g,this.onLogMessage=E,this.verboseLogging=u,this.fileChangesDelayer=this._register(new R.ThrottledDelayer(P.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(C){this.verboseLogging=C}async startWatching(){try{const{stat:C,symbolicLink:g}=await L.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let E=this.path;if(g)try{E=await(0,T.realpath)(E)}catch(u){if(this.onError(u),g.dangling)return}C.isDirectory()?this._register((0,P.watchFolder)(E,(u,p)=>{this.onFileChange({type:u==="changed"?0:u==="added"?1:2,path:(0,D.join)(this.path,(0,D.basename)(p))})},u=>this.onError(u))):this._register((0,P.watchFile)(E,u=>{this.onFileChange({type:u==="changed"?0:2,path:this.path})},u=>this.onError(u)))}catch(C){C.code!=="ENOENT"&&this.onError(C)}}onFileChange(C){this.fileChangesBuffer.push(C),this.verboseLogging&&this.onVerbose(`${C.type===1?"[ADDED]":C.type===2?"[DELETED]":"[CHANGED]"} ${C.path}`),this.fileChangesDelayer.trigger(async()=>{const g=this.fileChangesBuffer;this.fileChangesBuffer=[];const E=(0,y.normalizeFileChanges)(g);if(this.verboseLogging)for(const u of E)this.onVerbose(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);E.length>0&&this.onDidFilesChange(E)})}onError(C){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${C}`})}onVerbose(C){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${C}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=I}),define(te[83],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class R{constructor(...D){this._entries=new Map;for(let[T,L]of D)this.set(T,L)}set(D,T){const L=this._entries.get(D);return this._entries.set(D,T),L}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=R}),define(te[165],ne([0,1,6,8,53,154,5,83]),function(J,e,R,k,D,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class I extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class i{constructor(u=new P.ServiceCollection,p=!1,f){this._activeInstantiations=new Set,this._services=u,this._strict=p,this._parent=f,this._services.set(L.IInstantiationService,this)}createChild(u){return new i(u,this._strict,this)}invokeFunction(u,...p){let f=g.traceInvocation(u),b=!1;try{return u({get:(S,c)=>{if(b)throw(0,k.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(S,f);if(!a&&c!==L.optional)throw new Error(`[invokeFunction] unknown service '${S}'`);return a}},...p)}finally{b=!0,f.stop()}}createInstance(u,...p){let f,b;return u instanceof D.SyncDescriptor?(f=g.traceCreation(u.ctor),b=this._createInstance(u.ctor,u.staticArguments.concat(p),f)):(f=g.traceCreation(u),b=this._createInstance(u,p,f)),f.stop(),b}_createInstance(u,p=[],f){let b=L._util.getServiceDependencies(u).sort((c,a)=>c.index-a.index),v=[];for(const c of b){let a=this._getOrCreateServiceInstance(c.id,f);if(!a&&this._strict&&!c.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${c.id}.`);v.push(a)}let S=b.length>0?b[0].index:p.length;if(p.length!==S){console.warn(`[createInstance] First service dependency of ${u.name} at position ${S+1} conflicts with ${p.length} static arguments`);let c=S-p.length;c>0?p=p.concat(new Array(c)):p=p.slice(0,S)}return new u(...[...p,...v])}_setServiceInstance(u,p){if(this._services.get(u)instanceof D.SyncDescriptor)this._services.set(u,p);else if(this._parent)this._parent._setServiceInstance(u,p);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let p=this._services.get(u);return!p&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):p}_getOrCreateServiceInstance(u,p){let f=this._getServiceInstanceOrDescriptor(u);return f instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,f,p.branch(u,!0)):(p.branch(u,!1),f)}_safeCreateAndCacheServiceInstance(u,p,f){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,p,f)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,p,f){const b=new T.Graph(c=>c.id.toString());let v=0;const S=[{id:u,desc:p,_trace:f}];for(;S.length;){const c=S.pop();if(b.lookupOrInsertNode(c),v++>1e3)throw new I(b);for(let a of L._util.getServiceDependencies(c.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(a.id);if(!t&&!a.optional&&console.warn(`[createInstance] ${u} depends on ${a.id} which is NOT registered.`),t instanceof D.SyncDescriptor){const s={id:a.id,desc:t,_trace:c._trace.branch(a.id,!0)};b.insertEdge(c,s),S.push(s)}}}for(;;){const c=b.roots();if(c.length===0){if(!b.isEmpty())throw new I(b);break}for(const{data:a}of c){if(this._getServiceInstanceOrDescriptor(a.id)instanceof D.SyncDescriptor){const s=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,s)}b.removeNode(a)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,p,f=[],b,v){if(this._services.get(u)instanceof D.SyncDescriptor)return this._createServiceInstance(p,f,b,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,p,f,b,v);throw new Error(`illegalState - creating UNKNOWN service instance ${p.name}`)}_createServiceInstance(u,p=[],f,b){if(f){const v=new R.IdleValue(()=>this._createInstance(u,p,b));return new Proxy(Object.create(null),{get(S,c){if(c in S)return S[c];let a=v.value,t=a[c];return typeof t!="function"||(t=t.bind(a),S[c]=t),t},set(S,c,a){return v.value[c]=a,!0}})}else return this._createInstance(u,p,b)}}e.InstantiationService=i;var C;(function(E){E[E.Creation=0]="Creation",E[E.Invocation=1]="Invocation",E[E.Branch=2]="Branch"})(C||(C={}));class g{constructor(u,p){this.type=u,this.name=p,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return y?new g(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):g._None}static traceCreation(u){return y?new g(0,u.name):g._None}branch(u,p){let f=new g(2,u.toString());return this._dep.push([u,p,f]),f}stop(){let u=Date.now()-this._start;g._totals+=u;let p=!1;function f(v,S){let c=[],a=new Array(v+1).join("	");for(const[t,s,n]of S._dep)if(s&&n){p=!0,c.push(`${a}CREATES -> ${t}`);let r=f(v+1,n);r&&c.push(r)}else c.push(`${a}uses -> ${t}`);return c.join(`
`)}let b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(u>2||p)&&console.log(b.join(`
`))}}g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0}),define(te[166],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class R{constructor(D,T){this.server=D,this.router=T}getChannel(D){return this.server.getChannel(D,this.router)}registerChannel(D,T){this.server.registerChannel(D,T)}}e.MessagePortMainProcessService=R}),define(te[167],ne([0,1,33,53,153,5]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class L{constructor(E,u,p){const f=p.getChannel(E);return P(u)?new u.channelClientCtor(f):R.ProxyChannel.toService(f,u?.proxyOptions)}}function P(g){return!!g?.channelClientCtor}e.IMainProcessService=(0,T.createDecorator)("mainProcessService");let y=class extends L{constructor(E,u,p){super(E,u,p)}};y=he([Q(2,e.IMainProcessService)],y);function I(g,E,u){(0,D.registerSingleton)(g,new k.SyncDescriptor(y,[E,u],u?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=I,e.ISharedProcessService=(0,T.createDecorator)("sharedProcessService");let i=class extends L{constructor(E,u,p){super(E,u,p)}};i=he([Q(2,e.ISharedProcessService)],i);function C(g,E,u){(0,D.registerSingleton)(g,new k.SyncDescriptor(i,[E,u],u?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=C}),define(te[58],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,R.createDecorator)("localizationsService");function k(D){if(typeof D.languageId!="string"||!Array.isArray(D.translations)||D.translations.length===0)return!1;for(const T of D.translations)if(typeof T.id!="string"||typeof T.path!="string")return!1;return!(D.languageName&&typeof D.languageName!="string"||D.localizedLanguageName&&typeof D.localizedLanguageName!="string")}e.isValidLocalization=k}),define(te[168],ne([0,1,2,58]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let D=class extends R.Disposable{constructor(L){super();this.localizationsService=L,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};D=he([Q(0,k.ILocalizationsService)],D),e.LocalizationsUpdater=D}),define(te[10],ne([0,1,38,3,2,4,5]),function(J,e,R,k,D,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,L.createDecorator)("logService"),e.ILoggerService=(0,L.createDecorator)("loggerService");function P(){return new Date().toISOString()}var y;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class I extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new k.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=I;class i extends I{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...s){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([t,...s]))}debug(t,...s){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([t,...s]))}info(t,...s){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([t,...s]))}warn(t,...s){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([t,...s]))}error(t,...s){if(this.checkLogLevel(y.Error))if(t instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=t.stack,this.log(y.Error,this.format(n))}else this.log(y.Error,this.format([t,...s]))}critical(t,...s){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([t,...s]))}flush(){}format(t){let s="";for(let n=0;n<t.length;n++){let r=t[n];if(typeof r=="object")try{r=JSON.stringify(r)}catch(o){}s+=(n>0?" ":"")+r}return s}}e.AbstractMessageLogger=i;class C extends I{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!T.isWindows}trace(t,...s){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...s):console.log(`[main ${P()}]`,t,...s))}debug(t,...s){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...s):console.log(`[main ${P()}]`,t,...s))}info(t,...s){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...s):console.log(`[main ${P()}]`,t,...s))}warn(t,...s){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,t,...s):console.warn(`[main ${P()}]`,t,...s))}error(t,...s){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,t,...s):console.error(`[main ${P()}]`,t,...s))}critical(t,...s){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,t,...s):console.error(`[main ${P()}]`,t,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=C;class g extends I{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...s){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",t,...s)}debug(t,...s){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...s)}info(t,...s){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",t,...s)}warn(t,...s){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",t,...s)}error(t,...s){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",t,...s)}critical(t,...s){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...s)}dispose(){}flush(){}}e.ConsoleLogger=g;class E extends I{constructor(t,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(s)}trace(t,...s){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(t),...s])}debug(t,...s){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(t),...s])}info(t,...s){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(t),...s])}warn(t,...s){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(t),...s])}error(t,...s){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(t),...s])}critical(t,...s){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(t),...s])}extractMessage(t){return typeof t=="string"?t:(0,R.toErrorMessage)(t,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=E;class u extends I{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const s of this.logServices)s.setLevel(t);super.setLevel(t)}trace(t,...s){for(const n of this.logServices)n.trace(t,...s)}debug(t,...s){for(const n of this.logServices)n.debug(t,...s)}info(t,...s){for(const n of this.logServices)n.info(t,...s)}warn(t,...s){for(const n of this.logServices)n.warn(t,...s)}error(t,...s){for(const n of this.logServices)n.error(t,...s)}critical(t,...s){for(const n of this.logServices)n.critical(t,...s)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=u;class p extends D.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...s){this.logger.trace(t,...s)}debug(t,...s){this.logger.debug(t,...s)}info(t,...s){this.logger.info(t,...s)}warn(t,...s){this.logger.warn(t,...s)}error(t,...s){this.logger.error(t,...s)}critical(t,...s){this.logger.critical(t,...s)}flush(){this.logger.flush()}}e.LogService=p;class f extends D.Disposable{constructor(t,s){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(n))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,s){let n=this.loggers.get(t.toString());return n||(n=this.doCreateLogger(t,s?.always?y.Trace:this.logLevel,s),this.loggers.set(t.toString(),n),s?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=f;class b{constructor(){this.onDidChangeLogLevel=new k.Emitter().event}setLevel(t){}getLevel(){return y.Info}trace(t,...s){}debug(t,...s){}info(t,...s){}warn(t,...s){}error(t,...s){}critical(t,...s){}dispose(){}flush(){}}e.NullLogService=b;function v(a){if(a.verbose)return y.Trace;if(typeof a.logLevel=="string"){const t=S(a.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=v;function S(a){switch(a){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=S;function c(a){switch(a){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=c}),define(te[169],ne([0,1,6,8,2,9,19,13,10]),function(J,e,R,k,D,T,L,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let I=class extends D.Disposable{constructor(C,g){super();this.environmentService=C,this.logService=g,this._register(new R.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.info("[logs cleanup]: Starting to clean up old logs.");try{const C=(0,T.basename)(this.environmentService.logsPath),g=(0,T.dirname)(this.environmentService.logsPath),p=(await L.Promises.readdir(g)).filter(b=>/^\d{8}T\d{6}$/.test(b)).sort().filter(b=>b!==C),f=p.slice(0,Math.max(0,p.length-9));f.length>0&&(this.logService.info(`[logs cleanup]: Removing log folders '${f.join(", ")}'`),await Promise.all(f.map(b=>L.Promises.rm((0,T.join)(g,b)))))}catch(C){(0,k.onUnexpectedError)(C)}}};I=he([Q(0,P.IEnvironmentService),Q(1,y.ILogService)],I),e.LogsDataCleaner=I}),define(te[170],ne([0,1,6,8,2,9,19,13,10]),function(J,e,R,k,D,T,L,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let I=class vt extends D.Disposable{constructor(C,g,E){super();this.backupWorkspacesPath=C,this.environmentService=g,this.logService=E,this._register(new R.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.info("[storage cleanup]: Starting to clean up storage folders.");try{const C=await L.Promises.readFile(this.backupWorkspacesPath,"utf8"),E=JSON.parse(C).emptyWorkspaceInfos.map(p=>p.backupFolder),u=await L.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(u.map(async p=>{p.length!==vt.NON_EMPTY_WORKSPACE_ID_LENGTH&&E.indexOf(p)===-1&&(this.logService.info(`[storage cleanup]: Deleting storage folder ${p}.`),await L.Promises.rm((0,T.join)(this.environmentService.workspaceStorageHome.fsPath,p)))}))}catch(C){(0,k.onUnexpectedError)(C)}}};I.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,I=he([Q(1,P.INativeEnvironmentService),Q(2,y.ILogService)],I),e.StorageDataCleaner=I}),define(te[171],ne([0,1,6,8,2,4,16,59,7,30,19,13,28,34,14,10]),function(J,e,R,k,D,T,L,P,y,I,i,C,g,E,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const f=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let b=class extends D.Disposable{constructor(S,c,a,t){super();this.fileService=c,this.extensionGalleryService=a,this.logService=t,this.extensionsDownloadDir=y.URI.file(S.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(S,c){await this.cleanUpPromise;const a=this.getName(S),t=(0,L.joinPath)(this.extensionsDownloadDir,a);if(!await this.fileService.exists(t)){const s=(0,L.joinPath)(this.extensionsDownloadDir,`.${(0,I.generateUuid)()}`);await this.fileService.exists(s)||await this.extensionGalleryService.download(S,s,c);try{await this.rename(s,t,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(s)}catch(r){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",S.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,k.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,s.path),n}}return t}async delete(S){await this.cleanUpPromise,await this.fileService.del(S)}async rename(S,c,a){try{await i.Promises.rename(S.fsPath,c.fsPath)}catch(t){if(T.isWindows&&t&&t.code==="EPERM"&&Date.now()<a)return this.logService.info(`Failed renaming ${S} to ${c} with 'EPERM' error. Trying again...`),this.rename(S,c,a);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const S=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(S.children){const c=[],a=[];for(const n of S.children){const r=this.parse(n.name);r&&a.push([r,n])}const t=(0,E.groupByExtension)(a,([n])=>n),s=[];for(const n of t)n.sort((r,o)=>P.rcompare(r[0].version,o[0].version)),c.push(...n.slice(1).map(r=>r[1].resource)),s.push(n[0][1]);s.sort((n,r)=>n.mtime-r.mtime),c.push(...s.slice(0,Math.max(0,s.length-this.cache)).map(n=>n.resource)),await R.Promises.settled(c.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(S){this.logService.error(S)}}getName(S){return this.cache?`${new E.ExtensionIdentifierWithVersion(S.identifier,S.version).key().toLowerCase()}${S.properties.targetPlatform!=="undefined"?`-${S.properties.targetPlatform}`:""}`:(0,I.generateUuid)()}parse(S){const c=f.exec(S);return c&&c[1]&&c[2]?new E.ExtensionIdentifierWithVersion({id:c[1]},c[2]):null}};b=he([Q(0,C.INativeEnvironmentService),Q(1,u.IFileService),Q(2,g.IExtensionGalleryService),Q(3,p.ILogService)],b),e.ExtensionsDownloader=b}),define(te[172],ne([0,1,37,6,38,3,2,15,9,19,13,10]),function(J,e,R,k,D,T,L,P,y,I,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let g=class extends L.Disposable{constructor(u,p){super();this.environmentService=u,this.logService=p,this.processesLimiter=new k.Limiter(5)}async postUninstall(u){const p=this.parseScript(u,"uninstall");return p&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(p.script,"uninstall",p.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),f=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${f}`)))),I.Promises.rm(this.getExtensionStoragePath(u)).then(void 0,f=>this.logService.error("Error while removing extension storage path",f))}parseScript(u,p){const f=`vscode:${p}`;if(u.location.scheme===P.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[f]=="string"){const b=u.manifest.scripts[f].split(" ");return b.length<2||b[0]!=="node"||!b[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${f} should be a node script`),null):{script:(0,y.join)(u.location.fsPath,b[1]),args:b.slice(2)||[]}}return null}runLifecycleHook(u,p,f,b,v){return new Promise((S,c)=>{const a=this.start(u,p,f,v);let t;const s=n=>{t&&(clearTimeout(t),t=null),n?c(n):S(void 0)};a.on("error",n=>{s((0,D.toErrorMessage)(n)||"Unknown")}),a.on("exit",(n,r)=>{s(n?`post-${p} process exited with code ${n}`:void 0)}),b&&(t=setTimeout(()=>{t=null,a.kill(),c("timed out")},5e3))})}start(u,p,f,b){const v={silent:!0,execArgv:void 0},S=(0,R.fork)(u,[`--type=extension-post-${p}`,...f],v);S.stdout.setEncoding("utf8"),S.stderr.setEncoding("utf8");const c=T.Event.fromNodeEventEmitter(S.stdout,"data"),a=T.Event.fromNodeEventEmitter(S.stderr,"data");c(n=>this.logService.info(b.identifier.id,b.manifest.version,`post-${p}`,n)),a(n=>this.logService.error(b.identifier.id,b.manifest.version,`post-${p}`,n));const t=T.Event.any(T.Event.map(c,n=>({data:`%c${n}`,format:[""]})),T.Event.map(a,n=>({data:`%c${n}`,format:["color: red"]})));return T.Event.debounce(t,(n,r)=>n?{data:n.data+r.data,format:[...n.format,...r.format]}:{data:r.data,format:r.format},100)(n=>{console.group(b.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),S}getExtensionStoragePath(u){return(0,y.join)(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};g=he([Q(0,i.IEnvironmentService),Q(1,C.ILogService)],g),e.ExtensionsLifecycle=g}),define(te[173],ne([0,1,3,2,16,7,13,34,14,10]),function(J,e,R,k,D,T,L,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let i=class extends k.Disposable{constructor(g,E,u,p){super();this.extensionsManagementService=g,this.logService=p,this._onDidChangeExtensionsByAnotherSource=this._register(new R.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(v=>{this.installedExtensions=v.map(S=>S.identifier),this.startTimestamp=Date.now()}),this._register(g.onInstallExtension(v=>this.onInstallExtension(v))),this._register(g.onDidInstallExtensions(v=>this.onDidInstallExtensions(v))),this._register(g.onDidUninstallExtension(v=>this.onDidUninstallExtension(v)));const f=T.URI.file(u.extensionsPath),b=new D.ExtUri(v=>!E.hasCapability(v,1024));this._register(E.watch(f)),this._register(R.Event.filter(E.onDidChangeFilesRaw,v=>v.changes.some(S=>this.doesChangeAffects(S,f,b)))(()=>this.onDidChange()))}doesChangeAffects(g,E,u){return u.isEqual(u.dirname(g.resource),E)?u.isEqual(g.resource,u.joinPath(E,".obsolete"))?!0:!(g.type!==1&&g.type!==2||u.basename(g.resource).startsWith(".")):!1}onInstallExtension(g){this.addInstallingExtension(g.identifier)}onDidInstallExtensions(g){for(const E of g)this.removeInstallingExtension(E.identifier),E.local&&this.addInstalledExtension(E.identifier)}onDidUninstallExtension(g){g.error||this.removeInstalledExtension(g.identifier)}addInstallingExtension(g){this.removeInstallingExtension(g),this.installingExtensions.push(g)}removeInstallingExtension(g){this.installingExtensions=this.installingExtensions.filter(E=>!(0,P.areSameExtensions)(E,g))}addInstalledExtension(g){this.installedExtensions&&(this.removeInstalledExtension(g),this.installedExtensions.push(g))}removeInstalledExtension(g){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(E=>!(0,P.areSameExtensions)(E,g)))}async onDidChange(){if(this.installedExtensions){const g=await this.extensionsManagementService.getInstalled(1),E=g.filter(p=>[...this.installingExtensions,...this.installedExtensions].some(f=>(0,P.areSameExtensions)(f,p.identifier))?!1:p.installedTimestamp&&p.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",p.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",p.identifier.id),!1)),u=this.installedExtensions.filter(p=>this.installingExtensions.some(f=>(0,P.areSameExtensions)(f,p))?!1:g.every(f=>!(0,P.areSameExtensions)(f.identifier,p))?(this.logService.info("Detected extension removed from another source",p.id),!0):!1);this.installedExtensions=g.map(p=>p.identifier),(E.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:E,removed:u})}}};i=he([Q(1,y.IFileService),Q(2,L.INativeEnvironmentService),Q(3,I.ILogService)],i),e.ExtensionsWatcher=i}),define(te[174],ne([0,1,8,2,3,37,15,103,4,10]),function(J,e,R,k,D,T,L,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let i=class extends k.Disposable{constructor(E,u){super();this.id=E,this._logService=u,this._onStdout=this._register(new D.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new D.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new D.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._onExit=this._register(new D.Emitter),this.onExit=this._onExit.event,this._process=null}register(E){this._register(E)}start(E){this._process=(0,T.fork)(L.FileAccess.asFileUri("bootstrap-fork",J).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],E),this._logService.info(`Starting extension host with pid ${this._process.pid}.`);const u=new P.StringDecoder("utf-8");this._process.stdout?.on("data",f=>{const b=typeof f=="string"?f:u.write(f);this._onStdout.fire(b)});const p=new P.StringDecoder("utf-8");return this._process.stderr?.on("data",f=>{const b=typeof f=="string"?f:p.write(f);this._onStderr.fire(b)}),this._process.on("message",f=>{this._onMessage.fire(f)}),this._process.on("error",f=>{this._onError.fire({error:(0,R.transformErrorForSerialization)(f)})}),this._process.on("exit",(f,b)=>{this._onExit.fire({code:f,signal:b})}),{pid:this._process.pid}}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):y.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}};i=he([Q(1,I.ILogService)],i);let C=class pt{constructor(E){this._logService=E,this._extHosts=new Map}dispose(){}_getExtHost(E){const u=this._extHosts.get(E);if(!u)throw new Error("Unknown extension host!");return u}onDynamicStdout(E){return this._getExtHost(E).onStdout}onDynamicStderr(E){return this._getExtHost(E).onStderr}onDynamicMessage(E){return this._getExtHost(E).onMessage}onDynamicError(E){return this._getExtHost(E).onError}onDynamicExit(E){return this._getExtHost(E).onExit}async createExtensionHost(){const E=String(++pt._lastId),u=new i(E,this._logService);return this._extHosts.set(E,u),u.onExit(()=>{setTimeout(()=>{u.dispose(),this._extHosts.delete(E)})}),{id:E}}async start(E,u){return this._getExtHost(E).start(u)}async enableInspectPort(E){return this._getExtHost(E).enableInspectPort()}async kill(E){this._getExtHost(E).kill()}};C._lastId=0,C=he([Q(0,I.ILogService)],C),e.ExtensionHostStarter=C}),define(te[175],ne([0,1,81,17,6,2,15,9,19,13,28,34,58,10]),function(J,e,R,k,D,T,L,P,y,I,i,C,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let u=class extends T.Disposable{constructor(b,v,S){super();this.extensionManagementService=b,this.logService=S,this.cache=this._register(new p(v,S)),this.extensionManagementService.registerParticipant({postInstall:async c=>this.postInstallExtension(c),postUninstall:async c=>this.postUninstallExtension(c)})}async getLanguageIds(){const b=await this.cache.getLanguagePacks(),v=["en",...Object.keys(b)];return(0,k.distinct)(v)}async postInstallExtension(b){b&&b.manifest&&b.manifest.contributes&&b.manifest.contributes.localizations&&b.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",b.identifier.id),await this.update())}async postUninstallExtension(b){const v=await this.cache.getLanguagePacks();Object.keys(v).some(S=>v[S]&&v[S].extensions.some(c=>(0,C.areSameExtensions)(c.extensionIdentifier,b.identifier)))&&(this.logService.info("Removing language packs from the extension",b.identifier.id),await this.update())}async update(){const[b,v]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),S=await this.cache.update(v);return!(0,k.equals)(Object.keys(b),Object.keys(S))}};u=he([Q(0,i.IExtensionManagementService),Q(1,I.INativeEnvironmentService),Q(2,E.ILogService)],u),e.LocalizationsService=u;let p=class extends T.Disposable{constructor(b,v){super();this.logService=v,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(b.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new D.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(b){return this.withLanguagePacks(v=>{Object.keys(v).forEach(S=>delete v[S]),this.createLanguagePacksFromExtensions(v,...b)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(b,...v){for(const S of v)S&&S.manifest&&S.manifest.contributes&&S.manifest.contributes.localizations&&S.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(b,S);Object.keys(b).forEach(S=>this.updateHash(b[S]))}createLanguagePacksFromExtension(b,v){const S=v.identifier,c=v.manifest.contributes&&v.manifest.contributes.localizations?v.manifest.contributes.localizations:[];for(const a of c)if(v.location.scheme===L.Schemas.file&&(0,g.isValidLocalization)(a)){let t=b[a.languageId];t||(t={hash:"",extensions:[],translations:{}},b[a.languageId]=t);let s=t.extensions.filter(n=>(0,C.areSameExtensions)(n.extensionIdentifier,S))[0];s?s.version=v.manifest.version:t.extensions.push({extensionIdentifier:S,version:v.manifest.version});for(const n of a.translations)t.translations[n.id]=(0,P.join)(v.location.fsPath,n.path)}}updateHash(b){if(b){const v=(0,R.createHash)("md5");for(const S of b.extensions)v.update(S.extensionIdentifier.uuid||S.extensionIdentifier.id).update(S.version);b.hash=v.digest("hex")}}withLanguagePacks(b=()=>null){return this.languagePacksFileLimiter.queue(()=>{let v=null;return y.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,S=>S.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(S)).then(S=>{try{return JSON.parse(S)}catch(c){return{}}}).then(S=>(v=b(S),S)).then(S=>{for(const a of Object.keys(S))S[a]||delete S[a];this.languagePacks=S,this.initializedCache=!0;const c=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",c),y.Promises.writeFile(this.languagePacksFilePath,c)}).then(()=>v,S=>this.logService.error(S))})}};p=he([Q(0,I.INativeEnvironmentService),Q(1,E.ILogService)],p)}),define(te[84],ne([0,1,3,7,10]),function(J,e,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class T{constructor(g){this.service=g,this.onDidChangeLogLevel=R.Event.buffer(g.onDidChangeLogLevel,!0)}listen(g,E){switch(E){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${E}`)}async call(g,E,u){switch(E){case"setLevel":return this.service.setLevel(u)}throw new Error(`Call not found: ${E}`)}}e.LogLevelChannel=T;class L{constructor(g){this.channel=g}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(g){L.setLevel(this.channel,g)}static setLevel(g,E){return g.call("setLevel",E)}}e.LogLevelChannelClient=L;class P{constructor(g){this.loggerService=g,this.loggers=new Map}listen(g,E){throw new Error(`Event not found: ${E}`)}async call(g,E,u){switch(E){case"createLogger":this.createLogger(k.URI.revive(u[0]),u[1]);return;case"log":return this.log(k.URI.revive(u[0]),u[1]);case"consoleLog":return this.consoleLog(u[0],u[1])}throw new Error(`Call not found: ${E}`)}createLogger(g,E){this.loggers.set(g.toString(),this.loggerService.createLogger(g,E))}consoleLog(g,E){let u=console.log;switch(g){case D.LogLevel.Error:u=console.error;break;case D.LogLevel.Warning:u=console.warn;break;case D.LogLevel.Info:u=console.info;break}u.call(console,...E)}log(g,E){const u=this.loggers.get(g.toString());if(!u)throw new Error("Create the logger before logging");for(const[p,f]of E)switch(p){case D.LogLevel.Trace:u.trace(f);break;case D.LogLevel.Debug:u.debug(f);break;case D.LogLevel.Info:u.info(f);break;case D.LogLevel.Warning:u.warn(f);break;case D.LogLevel.Error:u.error(f);break;case D.LogLevel.Critical:u.critical(f);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=P;class y extends D.AbstractLoggerService{constructor(g,E,u){super(g,E);this.channel=u}createConsoleMainLogger(){return new D.AdapterLogger({log:(g,E)=>{this.channel.call("consoleLog",[g,E])}})}doCreateLogger(g,E,u){return new I(this.channel,g,E,u)}}e.LoggerChannelClient=y;class I extends D.AbstractMessageLogger{constructor(g,E,u,p){super(p?.always);this.channel=g,this.file=E,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(u),this.channel.call("createLogger",[E,p]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(g,E){const u=[[g,E]];this.isLoggerCreated?this.doLog(u):this.buffer.push(...u)}doLog(g){this.channel.call("log",[this.file,g])}}class i extends D.LogService{constructor(g,E){super(E);this.parent=g,this._register(g.onDidChangeLogLevel(u=>E.setLevel(u)))}setLevel(g){super.setLevel(g),this.parent.setLevel(g)}}e.FollowerLogService=i}),define(te[60],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,R.createDecorator)("nativeHostService")}),define(te[42],ne([0,1,15,4,31,16]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let L;if(typeof k.globals.vscode!="undefined"&&typeof k.globals.vscode.context!="undefined"){const P=k.globals.vscode.context.configuration();if(P)L=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const P=(0,T.dirname)(R.FileAccess.asFileUri("",J));L=J.__$__nodeRequire((0,T.joinPath)(P,"product.json").fsPath);const y=J.__$__nodeRequire((0,T.joinPath)(P,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(L,{nameShort:`${L.nameShort} Dev`,nameLong:`${L.nameLong} Dev`,dataFolderName:`${L.dataFolderName}-dev`}),Object.assign(L,{version:y.version})}else L={},Object.keys(L).length===0&&Object.assign(L,{version:"1.61.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=L}),define(te[85],ne([0,1,21,8,131,14,42]),function(J,e,R,k,D,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function P(C,g,E,u,p,f){let b;try{await y(C,g,E,u,p,f)}catch(v){b=v}finally{b&&p.errorTransformer&&(b=p.errorTransformer(b)),typeof b!="undefined"&&E.error(b),E.end()}}e.readFileIntoStream=P;async function y(C,g,E,u,p,f){I(f);const b=await C.open(g,{create:!1});try{I(f);let v=0,S=0,c=p&&typeof p.length=="number"?p.length:void 0,a=R.VSBuffer.alloc(Math.min(p.bufferSize,typeof c=="number"?c:p.bufferSize)),t=p&&typeof p.position=="number"?p.position:0,s=0;do S=await C.read(b,t,a.buffer,s,a.byteLength-s),t+=S,s+=S,v+=S,typeof c=="number"&&(c-=S),s===a.byteLength&&(await E.write(u(a)),a=R.VSBuffer.alloc(Math.min(p.bufferSize,typeof c=="number"?c:p.bufferSize)),s=0);while(S>0&&(typeof c!="number"||c>0)&&I(f)&&i(v,p));if(s>0){let n=s;typeof c=="number"&&(n=Math.min(s,c)),E.write(u(a.slice(0,n)))}}catch(v){throw(0,T.ensureFileSystemProviderError)(v)}finally{await C.close(b)}}function I(C){if(C.isCancellationRequested)throw(0,k.canceled)();return!0}function i(C,g){if(g?.limits){if(typeof g.limits.memory=="number"&&C>g.limits.memory)throw(0,T.createFileSystemProviderError)((0,D.localize)(0,null,L.default.nameShort),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof g.limits.size=="number"&&C>g.limits.size)throw(0,T.createFileSystemProviderError)((0,D.localize)(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[176],ne([0,1,17,6,21,27,3,55,2,41,15,177,16,50,129,14,85,10]),function(J,e,R,k,D,T,L,P,y,I,i,C,g,E,u,p,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let v=class Ve extends y.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new L.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new L.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new L.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new L.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new L.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new L.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new L.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new k.ThrottledWorker(Ve.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ve.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ve.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new p.FileChangesEvent(a,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new k.ThrottledWorker(Ve.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ve.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ve.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new p.FileChangesEvent(a,!0)))),this.watchedResources=I.TernarySearchTree.forUris(a=>{const t=this.getProvider(a.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new k.ResourceQueue)}registerProvider(c,a){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,C.mark)(`code/registerFilesystem/${c}`),this.provider.set(c,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:a});const t=new y.DisposableStore;return t.add(a.onDidChangeFile(s=>this.onDidChangeFile(s,this.isPathCaseSensitive(a)))),t.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:c}))),typeof a.onDidErrorOccur=="function"&&t.add(a.onDidErrorOccur(s=>this._onError.fire(new Error(s)))),(0,y.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:a}),this.provider.delete(c),(0,y.dispose)(t)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(t){a.push(t)}}),!this.provider.has(c)&&await k.Promises.settled(a)}canHandleResource(c){return this.provider.has(c.scheme)}hasCapability(c,a){const t=this.provider.get(c.scheme);return!!(t&&t.capabilities&a)}listCapabilities(){return P.Iterable.map(this.provider,([c,a])=>({scheme:c,capabilities:a.capabilities}))}async withProvider(c){if(!(0,g.isAbsolutePath)(c))throw new p.FileOperationError((0,u.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const a=this.provider.get(c.scheme);if(!a){const t=new Error;throw t.name="ENOPRO",t.message=(0,u.localize)(1,null,c.toString()),t}return a}async withReadProvider(c){const a=await this.withProvider(c);if((0,p.hasOpenReadWriteCloseCapability)(a)||(0,p.hasReadWriteCapability)(a)||(0,p.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const a=await this.withProvider(c);if((0,p.hasOpenReadWriteCloseCapability)(a)||(0,p.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,a){try{return await this.doResolveFile(c,a)}catch(t){throw(0,p.toFileSystemProviderErrorCode)(t)===p.FileSystemProviderErrorCode.FileNotFound?new p.FileOperationError((0,u.localize)(2,null,this.resourceForError(c)),1):(0,p.ensureFileSystemProviderError)(t)}}async doResolveFile(c,a){const t=await this.withProvider(c),s=this.isPathCaseSensitive(t),n=a?.resolveTo,r=a?.resolveSingleChildDescendants,o=a?.resolveMetadata,l=await t.stat(c);let h;return this.toFileStat(t,c,l,void 0,!!o,(d,m)=>{if(!h&&(h=I.TernarySearchTree.forUris(()=>!s),h.set(c,!0),n))for(const A of n)h.set(A,!0);return h.get(d.resource)||h.findSuperstr(d.resource.with({query:null,fragment:null}))?!0:d.isDirectory&&r?m===1:!1})}async toFileStat(c,a,t,s,n,r){const{providerExtUri:o}=this.getExtUri(c),l={resource:a,name:o.basename(a),isFile:(t.type&p.FileType.File)!=0,isDirectory:(t.type&p.FileType.Directory)!=0,isSymbolicLink:(t.type&p.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&p.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,p.etag)({mtime:t.mtime,size:t.size})};if(l.isDirectory&&r(l,s)){try{const h=await c.readdir(a),d=await k.Promises.settled(h.map(async([m,A])=>{try{const _=o.joinPath(a,m),w=n?await c.stat(_):{type:A};return await this.toFileStat(c,_,w,h.length,n,r)}catch(_){return this.logService.trace(_),null}}));l.children=(0,R.coalesce)(d)}catch(h){this.logService.trace(h),l.children=[]}return l}return l}async resolveAll(c){return k.Promises.settled(c.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(c){const a=await this.withProvider(c);try{return!!await a.stat(c)}catch(t){return!1}}async canCreateFile(c,a){try{await this.doValidateCreateFile(c,a)}catch(t){return t}return!0}async doValidateCreateFile(c,a){if(!a?.overwrite&&await this.exists(c))throw new p.FileOperationError((0,u.localize)(3,null,this.resourceForError(c)),3,a)}async createFile(c,a=D.VSBuffer.fromString(""),t){await this.doValidateCreateFile(c,t);const s=await this.writeFile(c,a);return this._onDidRunOperation.fire(new p.FileOperationEvent(c,0,s)),s}async writeFile(c,a,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:n}=this.getExtUri(s);try{await this.validateWriteFile(s,c,t)||await this.mkdirp(s,n.dirname(c));let o;if((0,p.hasReadWriteCapability)(s)&&!(a instanceof D.VSBuffer))if((0,E.isReadableStream)(a)){const l=await(0,E.peekStream)(a,3);l.ended?o=D.VSBuffer.concat(l.buffer):o=l}else o=(0,E.peekReadable)(a,l=>D.VSBuffer.concat(l),3);else o=a;!(0,p.hasOpenReadWriteCloseCapability)(s)||(0,p.hasReadWriteCapability)(s)&&o instanceof D.VSBuffer?await this.doWriteUnbuffered(s,c,t,o):await this.doWriteBuffered(s,c,t,o instanceof D.VSBuffer?(0,D.bufferToReadable)(o):o)}catch(r){throw new p.FileOperationError((0,u.localize)(4,null,this.resourceForError(c),(0,p.ensureFileSystemProviderError)(r).toString()),(0,p.toFileOperationResult)(r),t)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,a,t){if(!!t?.unlock&&!(c.capabilities&8192))throw new Error((0,u.localize)(5,null,this.resourceForError(a)));let n;try{n=await c.stat(a)}catch(r){return}if((n.type&p.FileType.Directory)!=0)throw new p.FileOperationError((0,u.localize)(6,null,this.resourceForError(a)),0,t);if(this.throwIfFileIsReadonly(a,n),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==p.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&t.mtime<n.mtime&&t.etag!==(0,p.etag)({mtime:t.mtime,size:n.size}))throw new p.FileOperationError((0,u.localize)(7,null),3,t);return n}async readFile(c,a){const t=await this.withReadProvider(c);return a?.atomic?this.doReadFileAtomic(t,c,a):this.doReadFile(t,c,a)}async doReadFileAtomic(c,a,t){return new Promise((s,n)=>{this.writeQueue.queueFor(a,this.getExtUri(c).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(c,a,t);s(r)}catch(r){n(r)}})})}async doReadFile(c,a,t){const s=await this.doReadFileStream(c,a,{...t,preferUnbuffered:!0});return{...s,value:await(0,D.streamToBuffer)(s.value)}}async readFileStream(c,a){const t=await this.withReadProvider(c);return this.doReadFileStream(t,c,a)}async doReadFileStream(c,a,t){const s=new T.CancellationTokenSource,n=this.validateReadFile(a,t).then(o=>o,o=>{throw s.cancel(),o});let r;try{return typeof t?.etag=="string"&&t.etag!==p.ETAG_DISABLED&&await n,!((0,p.hasOpenReadWriteCloseCapability)(c)||(0,p.hasFileReadStreamCapability)(c))||(0,p.hasReadWriteCapability)(c)&&t?.preferUnbuffered?r=this.readFileUnbuffered(c,a,t):(0,p.hasFileReadStreamCapability)(c)?r=this.readFileStreamed(c,a,s.token,t):r=this.readFileBuffered(c,a,s.token,t),{...await n,value:r}}catch(o){r&&await(0,E.consumeStream)(r);const l=(0,u.localize)(8,null,this.resourceForError(a),(0,p.ensureFileSystemProviderError)(o).toString());throw o instanceof p.NotModifiedSinceFileOperationError?new p.NotModifiedSinceFileOperationError(l,o.stat,t):new p.FileOperationError(l,(0,p.toFileOperationResult)(o),t)}}readFileStreamed(c,a,t,s=Object.create(null)){const n=c.readFileStream(a,s,t);return(0,E.transform)(n,{data:r=>r instanceof D.VSBuffer?r:D.VSBuffer.wrap(r),error:r=>new p.FileOperationError((0,u.localize)(9,null,this.resourceForError(a),(0,p.ensureFileSystemProviderError)(r).toString()),(0,p.toFileOperationResult)(r),s)},r=>D.VSBuffer.concat(r))}readFileBuffered(c,a,t,s=Object.create(null)){const n=(0,D.newWriteableBufferStream)();return(0,f.readFileIntoStream)(c,a,n,r=>r,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new p.FileOperationError((0,u.localize)(10,null,this.resourceForError(a),(0,p.ensureFileSystemProviderError)(r).toString()),(0,p.toFileOperationResult)(r),s)},t),n}readFileUnbuffered(c,a,t){const s=(0,E.newWriteableStream)(n=>D.VSBuffer.concat(n));return(async()=>{try{let n=await c.readFile(a);typeof t?.position=="number"&&(n=n.slice(t.position)),typeof t?.length=="number"&&(n=n.slice(0,t.length)),this.validateReadFileLimits(a,n.byteLength,t),s.end(D.VSBuffer.wrap(n))}catch(n){s.error(n),s.end()}})(),s}async validateReadFile(c,a){const t=await this.resolve(c,{resolveMetadata:!0});if(t.isDirectory)throw new p.FileOperationError((0,u.localize)(11,null,this.resourceForError(c)),0,a);if(typeof a?.etag=="string"&&a.etag!==p.ETAG_DISABLED&&a.etag===t.etag)throw new p.NotModifiedSinceFileOperationError((0,u.localize)(12,null),t,a);return this.validateReadFileLimits(c,t.size,a),t}validateReadFileLimits(c,a,t){if(t?.limits){let s;if(typeof t.limits.memory=="number"&&a>t.limits.memory&&(s=9),typeof t.limits.size=="number"&&a>t.limits.size&&(s=7),typeof s=="number")throw new p.FileOperationError((0,u.localize)(13,null,this.resourceForError(c)),s)}}async canMove(c,a,t){return this.doCanMoveCopy(c,a,"move",t)}async canCopy(c,a,t){return this.doCanMoveCopy(c,a,"copy",t)}async doCanMoveCopy(c,a,t,s){if(c.toString()!==a.toString())try{const n=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(n,c,r,a,t,s)}catch(n){return n}return!0}async move(c,a,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),r=await this.doMoveCopy(s,c,n,a,"move",!!t),o=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(c,r==="move"?2:3,o)),o}async copy(c,a,t){const s=await this.withReadProvider(c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),r=await this.doMoveCopy(s,c,n,a,"copy",!!t),o=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(c,r==="copy"?3:2,o)),o}async doMoveCopy(c,a,t,s,n,r){if(a.toString()===s.toString())return n;const{exists:o,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(c,a,t,s,n,r);if(o&&!l&&r&&await this.del(s,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(s)),n==="copy"){if(c===t&&(0,p.hasFileFolderCopyCapability)(c))await c.copy(a,s,{overwrite:r});else{const h=await this.resolve(a);h.isDirectory?await this.doCopyFolder(c,h,t,s):await this.doCopyFile(c,a,t,s)}return n}else return c===t?(await c.rename(a,s,{overwrite:r}),n):(await this.doMoveCopy(c,a,t,s,"copy",r),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(c,a,t,s){if((0,p.hasOpenReadWriteCloseCapability)(c)&&(0,p.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(c,a,t,s);if((0,p.hasOpenReadWriteCloseCapability)(c)&&(0,p.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(c,a,t,s);if((0,p.hasReadWriteCapability)(c)&&(0,p.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(c,a,t,s);if((0,p.hasReadWriteCapability)(c)&&(0,p.hasReadWriteCapability)(t))return this.doPipeUnbuffered(c,a,t,s)}async doCopyFolder(c,a,t,s){await t.mkdir(s),Array.isArray(a.children)&&await k.Promises.settled(a.children.map(async n=>{const r=this.getExtUri(t).providerExtUri.joinPath(s,n.name);return n.isDirectory?this.doCopyFolder(c,await this.resolve(n.resource),t,r):this.doCopyFile(c,n.resource,t,r)}))}async doValidateMoveCopy(c,a,t,s,n,r){let o=!1;if(c===t){const{providerExtUri:h,isPathCaseSensitive:d}=this.getExtUri(c);if(d||(o=h.isEqual(a,s)),o&&n==="copy")throw new Error((0,u.localize)(14,null,this.resourceForError(a),this.resourceForError(s)));if(!o&&h.isEqualOrParent(s,a))throw new Error((0,u.localize)(15,null,this.resourceForError(a),this.resourceForError(s)))}const l=await this.exists(s);if(l&&!o){if(!r)throw new p.FileOperationError((0,u.localize)(16,null,this.resourceForError(a),this.resourceForError(s)),4);if(c===t){const{providerExtUri:h}=this.getExtUri(c);if(h.isEqualOrParent(a,s))throw new Error((0,u.localize)(17,null,this.resourceForError(a),this.resourceForError(s)))}}return{exists:l,isSameResourceWithDifferentPathCase:o}}getExtUri(c){const a=this.isPathCaseSensitive(c);return{providerExtUri:a?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(a,c);const t=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(c,0,t)),t}async mkdirp(c,a){const t=[],{providerExtUri:s}=this.getExtUri(c);for(;!s.isEqual(a,s.dirname(a));)try{if(((await c.stat(a)).type&p.FileType.Directory)==0)throw new Error((0,u.localize)(18,null,this.resourceForError(a)));break}catch(n){if((0,p.toFileSystemProviderErrorCode)(n)!==p.FileSystemProviderErrorCode.FileNotFound)throw n;t.push(s.basename(a)),a=s.dirname(a)}for(let n=t.length-1;n>=0;n--){a=s.joinPath(a,t[n]);try{await c.mkdir(a)}catch(r){if((0,p.toFileSystemProviderErrorCode)(r)!==p.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(c,a){try{await this.doValidateDelete(c,a)}catch(t){return t}return!0}async doValidateDelete(c,a){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!a?.useTrash&&!(t.capabilities&4096))throw new Error((0,u.localize)(19,null,this.resourceForError(c)));let n;try{n=await t.stat(c)}catch(o){}if(n)this.throwIfFileIsReadonly(c,n);else throw new p.FileOperationError((0,u.localize)(20,null,this.resourceForError(c)),1);if(!!!a?.recursive){const o=await this.resolve(c);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,u.localize)(21,null,this.resourceForError(c)))}return t}async del(c,a){const t=await this.doValidateDelete(c,a),s=!!a?.useTrash,n=!!a?.recursive;await t.delete(c,{recursive:n,useTrash:s}),this._onDidRunOperation.fire(new p.FileOperationEvent(c,1))}onDidChangeFile(c,a){this._onDidChangeFilesRaw.fire({changes:c});let t,s;{for(const n of c)this.watchedResources.has(n.resource)?(t||(t=[]),t.push(n)):(s||(s=[]),s.push(n));t&&this._onDidFilesChange.fire(new p.FileChangesEvent(t,!a))}if(s){const n=a?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(s)&&Ve.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(c,a={recursive:!1,excludes:[]}){const t=new y.DisposableStore;{let s=!1,n=()=>{s=!0};t.add((0,y.toDisposable)(()=>n())),this.doWatch(c,a).then(r=>{s?(0,y.dispose)(r):n=()=>(0,y.dispose)(r)},r=>this.logService.error(r))}return a.recursive||(this.watchedResources.set(c,(this.watchedResources.get(c)??0)+1),t.add((0,y.toDisposable)(()=>{const s=this.watchedResources.get(c);typeof s=="number"&&(s<=1?this.watchedResources.delete(c):this.watchedResources.set(c,s-1))}))),t}async doWatch(c,a){const t=await this.withProvider(c),s=this.toWatchKey(t,c,a),n=this.activeWatchers.get(s)||{count:0,disposable:t.watch(c,a)};return this.activeWatchers.has(s)||this.activeWatchers.set(s,n),n.count+=1,(0,y.toDisposable)(()=>{n.count--,n.count===0&&((0,y.dispose)(n.disposable),this.activeWatchers.delete(s))})}toWatchKey(c,a,t){const{providerExtUri:s}=this.getExtUri(c);return[s.getComparisonKey(a),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,y.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,a,t,s){return this.writeQueue.queueFor(a,this.getExtUri(c).providerExtUri).queue(async()=>{const n=await c.open(a,{create:!0,unlock:t?.unlock??!1});try{(0,E.isReadableStream)(s)||(0,E.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(c,n,s):await this.doWriteReadableBufferedQueued(c,n,s)}catch(r){throw(0,p.ensureFileSystemProviderError)(r)}finally{await c.close(n)}})}async doWriteStreamBufferedQueued(c,a,t){let s=0,n;if((0,E.isReadableBufferedStream)(t)){if(t.buffer.length>0){const r=D.VSBuffer.concat(t.buffer);await this.doWriteBuffer(c,a,r,r.byteLength,s,0),s+=r.byteLength}if(t.ended)return;n=t.stream}else n=t;return new Promise(async(r,o)=>{(0,E.listenStream)(n,{onData:async l=>{n.pause();try{await this.doWriteBuffer(c,a,l,l.byteLength,s,0)}catch(h){return o(h)}s+=l.byteLength,setTimeout(()=>n.resume())},onError:l=>o(l),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(c,a,t){let s=0,n;for(;(n=t.read())!==null;)await this.doWriteBuffer(c,a,n,n.byteLength,s,0),s+=n.byteLength}async doWriteBuffer(c,a,t,s,n,r){let o=0;for(;o<s;)o+=await c.write(a,n+o,t.buffer,r+o,s-o)}async doWriteUnbuffered(c,a,t,s){return this.writeQueue.queueFor(a,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,a,t,s))}async doWriteUnbufferedQueued(c,a,t,s){let n;s instanceof D.VSBuffer?n=s:(0,E.isReadableStream)(s)?n=await(0,D.streamToBuffer)(s):(0,E.isReadableBufferedStream)(s)?n=await(0,D.bufferedStreamToBuffer)(s):n=(0,D.readableToBuffer)(s),await c.writeFile(a,n.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(c,a,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,a,t,s))}async doPipeBufferedQueued(c,a,t,s){let n,r;try{n=await c.open(a,{create:!1}),r=await t.open(s,{create:!0,unlock:!1});const o=D.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,h=0,d=0;do d=await c.read(n,l,o.buffer,h,o.byteLength-h),await this.doWriteBuffer(t,r,o,d,l,h),l+=d,h+=d,h===o.byteLength&&(h=0);while(d>0)}catch(o){throw(0,p.ensureFileSystemProviderError)(o)}finally{await k.Promises.settled([typeof n=="number"?c.close(n):Promise.resolve(),typeof r=="number"?t.close(r):Promise.resolve()])}}async doPipeUnbuffered(c,a,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,a,t,s))}async doPipeUnbufferedQueued(c,a,t,s){return t.writeFile(s,await c.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,a,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,a,t,s))}async doPipeUnbufferedToBufferedQueued(c,a,t,s){const n=await t.open(s,{create:!0,unlock:!1});try{const r=await c.readFile(a);await this.doWriteBuffer(t,n,D.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,p.ensureFileSystemProviderError)(r)}finally{await t.close(n)}}async doPipeBufferedToUnbuffered(c,a,t,s){const n=await(0,D.streamToBuffer)(this.readFileBuffered(c,a,T.CancellationToken.None));await this.doWriteUnbuffered(t,s,void 0,n)}throwIfFileSystemIsReadonly(c,a){if(c.capabilities&2048)throw new p.FileOperationError((0,u.localize)(22,null,this.resourceForError(a)),6);return c}throwIfFileIsReadonly(c,a){if((a.permissions??0)&p.FilePermission.Readonly)throw new p.FileOperationError((0,u.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===i.Schemas.file?c.fsPath:c.toString(!0)}};v.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},v=he([Q(0,b.ILogService)],v),e.FileService=v}),define(te[178],ne([0,1,17,6,21,3,40,2,9,4,16,50,19,132,14,85,164,149,150,82,152,10,42]),function(J,e,R,k,D,T,L,P,y,I,i,C,g,E,u,p,f,b,v,S,c,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class s extends P.Disposable{constructor(r,o){super();this.logService=r,this.options=o,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=T.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new T.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new k.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,I.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:o,symbolicLink:l}=await g.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(o,l),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.toFileSystemProviderError(o)}}async readdir(r){try{const o=await g.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),l=[];return await Promise.all(o.map(async h=>{try{let d;h.isSymbolicLink()?d=(await this.stat((0,i.joinPath)(r,h.name))).type:d=this.toType(h),l.push([h.name,d])}catch(d){this.logService.trace(d)}})),l}catch(o){throw this.toFileSystemProviderError(o)}}toType(r,o){let l;return o?.dangling?l=u.FileType.Unknown:r.isFile()?l=u.FileType.File:r.isDirectory()?l=u.FileType.Directory:l=u.FileType.Unknown,o&&(l|=u.FileType.SymbolicLink),l}async readFile(r){try{const o=this.toFilePath(r);return await g.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}}readFileStream(r,o,l){const h=(0,C.newWriteableStream)(d=>D.VSBuffer.concat(d.map(m=>D.VSBuffer.wrap(m))).buffer);return(0,p.readFileIntoStream)(this,r,h,d=>d.buffer,{...o,bufferSize:this.BUFFER_SIZE},l),h}async writeFile(r,o,l){let h;try{const d=this.toFilePath(r);if(!l.create||!l.overwrite){if(await g.Promises.exists(d)){if(!l.overwrite)throw(0,u.createFileSystemProviderError)((0,E.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,u.createFileSystemProviderError)((0,E.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}h=await this.open(r,{create:!0,unlock:l.unlock}),await this.write(h,0,o,0,o.byteLength)}catch(d){throw await this.toFileSystemProviderWriteError(r,d)}finally{typeof h=="number"&&await this.close(h)}}async open(r,o){try{const l=this.toFilePath(r);if((0,u.isFileOpenForWriteOptions)(o)&&o.unlock)try{const{stat:m}=await g.SymlinkSupport.stat(l);m.mode&128||await g.Promises.chmod(l,m.mode|128)}catch(m){this.logService.trace(m)}let h;if((0,u.isFileOpenForWriteOptions)(o)){if(I.isWindows)try{await g.Promises.truncate(l,0),h="r+"}catch(m){m.code!=="ENOENT"&&this.logService.trace(m)}h||(h="w")}else h="r";const d=await g.Promises.open(l,h);return this.mapHandleToPos.set(d,0),(0,u.isFileOpenForWriteOptions)(o)&&this.writeHandles.set(d,r),d}catch(l){throw(0,u.isFileOpenForWriteOptions)(o)?await this.toFileSystemProviderWriteError(r,l):this.toFileSystemProviderError(l)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await g.Promises.fdatasync(r)}catch(o){this.canFlush=!1,this.logService.error(o)}return await g.Promises.close(r)}catch(o){throw this.toFileSystemProviderError(o)}}async read(r,o,l,h,d){const m=this.normalizePos(r,o);let A=null;try{const _=await g.Promises.read(r,l,h,d,m);return typeof _=="number"?A=_:A=_.bytesRead,A}catch(_){throw this.toFileSystemProviderError(_)}finally{this.updatePos(r,m,A)}}normalizePos(r,o){return o===this.mapHandleToPos.get(r)?null:o}updatePos(r,o,l){const h=this.mapHandleToPos.get(r);typeof h=="number"&&(typeof o=="number"||(typeof l=="number"?this.mapHandleToPos.set(r,h+l):this.mapHandleToPos.delete(r)))}async write(r,o,l,h,d){return(0,k.retry)(()=>this.doWrite(r,o,l,h,d),100,3)}async doWrite(r,o,l,h,d){const m=this.normalizePos(r,o);let A=null;try{const _=await g.Promises.write(r,l,h,d,m);return typeof _=="number"?A=_:A=_.bytesWritten,A}catch(_){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),_)}finally{this.updatePos(r,m,A)}}async mkdir(r){try{await g.Promises.mkdir(this.toFilePath(r))}catch(o){throw this.toFileSystemProviderError(o)}}async delete(r,o){try{const l=this.toFilePath(r);await this.doDelete(l,o)}catch(l){throw this.toFileSystemProviderError(l)}}async doDelete(r,o){o.recursive?await g.Promises.rm(r,g.RimRafMode.MOVE):await g.Promises.unlink(r)}async rename(r,o,l){const h=this.toFilePath(r),d=this.toFilePath(o);if(h!==d)try{await this.validateTargetDeleted(r,o,"move",l.overwrite),await g.Promises.move(h,d)}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,E.localize)(2,null,(0,y.basename)(h),(0,y.basename)((0,y.dirname)(d)),m.toString()))),this.toFileSystemProviderError(m)}}async copy(r,o,l){const h=this.toFilePath(r),d=this.toFilePath(o);if(h!==d)try{await this.validateTargetDeleted(r,o,"copy",l.overwrite),await g.Promises.copy(h,d,{preserveSymlinks:!0})}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,E.localize)(3,null,(0,y.basename)(h),(0,y.basename)((0,y.dirname)(d)),m.toString()))),this.toFileSystemProviderError(m)}}async validateTargetDeleted(r,o,l,h){const d=this.toFilePath(r),m=this.toFilePath(o);let A=!1;if(!!(this.capabilities&1024)||(A=(0,L.isEqual)(d,m,!0)),A&&l==="copy")throw(0,u.createFileSystemProviderError)((0,E.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(!A&&await g.Promises.exists(m)){if(!h)throw(0,u.createFileSystemProviderError)((0,E.localize)(5,null),u.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}watch(r,o){return o.recursive?this.watchRecursive(r,o):this.watchNonRecursive(r)}watchRecursive(r,o){const l={path:this.toFilePath(r),excludes:o.excludes},h=(0,R.insert)(this.recursiveFoldersToWatch,l);return this.refreshRecursiveWatchers(),(0,P.toDisposable)(()=>{h(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof b.FileWatcher)this.recursiveWatcher.watch(this.recursiveFoldersToWatch);else if((0,P.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let r,o;if(this.options?.watcher?.usePolling)r=v.FileWatcher,o=this.options?.watcher;else{let l;this.options?.enableLegacyRecursiveWatcher?l=!0:l=t.default.quality==="stable"&&I.isLinux,l&&this.recursiveFoldersToWatch.length===1?I.isWindows?r=c.FileWatcher:r=v.FileWatcher:r=b.FileWatcher}this.recursiveWatcher=new r(this.recursiveFoldersToWatch,l=>this._onDidChangeFile.fire((0,S.toFileChanges)(l)),l=>{l.type==="error"&&this._onDidWatchErrorOccur.fire(l.message),this.logService[l.type](l.message)},this.logService.getLevel()===a.LogLevel.Trace,o),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===a.LogLevel.Trace)}))}}watchNonRecursive(r){const o=new f.FileWatcher(this.toFilePath(r),h=>this._onDidChangeFile.fire((0,S.toFileChanges)(h)),h=>{h.type==="error"&&this._onDidWatchErrorOccur.fire(h.message),this.logService[h.type](h.message)},this.logService.getLevel()===a.LogLevel.Trace),l=this.logService.onDidChangeLogLevel(()=>{o.setVerboseLogging(this.logService.getLevel()===a.LogLevel.Trace)});return(0,P.combinedDisposable)(o,l)}toFilePath(r){return(0,y.normalize)(r.fsPath)}toFileSystemProviderError(r){if(r instanceof u.FileSystemProviderError)return r;let o;switch(r.code){case"ENOENT":o=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=u.FileSystemProviderErrorCode.NoPermissions;break;default:o=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(r,o)}async toFileSystemProviderWriteError(r,o){let l=this.toFileSystemProviderError(o);if(r&&l.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await g.SymlinkSupport.stat(this.toFilePath(r));h.mode&128||(l=(0,u.createFileSystemProviderError)(o,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.logService.trace(h)}return l}dispose(){super.dispose(),(0,P.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,P.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=s}),define(te[29],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,R.createDecorator)("productService")}),define(te[179],ne([0,1,6,8,2,9,19,10,29]),function(J,e,R,k,D,T,L,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let I=class extends D.Disposable{constructor(C,g,E){super();this.productService=g,this.logService=E,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,C&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpCodeCaches(C)},30*1e3)).schedule()}async cleanUpCodeCaches(C){this.logService.info("[code cache cleanup]: Starting to clean up old code cache folders.");try{const g=Date.now(),E=(0,T.dirname)(C),u=(0,T.basename)(C),p=await L.Promises.readdir(E);await Promise.all(p.map(async f=>{if(f===u)return;const b=(0,T.join)(E,f),v=await L.Promises.stat(b);if(v.isDirectory()&&g-v.mtime.getTime()>this._DataMaxAge)return this.logService.info(`[code cache cleanup]: Removing code cache folder ${f}.`),L.Promises.rm(b)}))}catch(g){(0,k.onUnexpectedError)(g)}}};I=he([Q(1,y.IProductService),Q(2,P.ILogService)],I),e.CodeCacheCleaner=I}),define(te[180],ne([0,1,6,8,2,9,19,13,10,29]),function(J,e,R,k,D,T,L,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let i=class extends D.Disposable{constructor(g,E,u){super();this.environmentService=g,this.logService=E,this.productService=u,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.info("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const g=Object.create(null),E=JSON.parse(await L.Promises.readFile((0,T.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let v of Object.keys(E)){const S=E[v];g[`${S.hash}.${v}`]=!0}const u=(0,T.join)(this.environmentService.userDataPath,"clp");if(!await L.Promises.exists(u))return;const f=await L.Promises.readdir(u);for(const v of f){if(g[v]){this.logService.info(`[language pack cache cleanup]: Skipping folder ${v}. Language pack still in use.`);continue}this.logService.info(`[language pack cache cleanup]: Removing unused language pack: ${v}`),await L.Promises.rm((0,T.join)(u,v))}const b=Date.now();for(const v of Object.keys(g)){const S=(0,T.join)(u,v),c=await L.Promises.readdir(S);for(const a of c){if(a==="tcf.json")continue;const t=(0,T.join)(S,a),s=await L.Promises.stat(t);s.isDirectory()&&b-s.mtime.getTime()>this._DataMaxAge&&(this.logService.info(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.join)(v,a)}`),await L.Promises.rm(t))}}}catch(g){(0,k.onUnexpectedError)(g)}}};i=he([Q(0,P.INativeEnvironmentService),Q(1,y.ILogService),Q(2,I.IProductService)],i),e.LanguagePackCachedDataCleaner=i}),define(te[35],ne([0,1,96,18]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(L,P){R.ok(k.isString(L)),R.ok(k.isObject(P)),R.ok(!this.data.has(L),"There is already an extension with this id"),this.data.set(L,P)}knows(L){return this.data.has(L)}as(L){return this.data.get(L)||null}}e.Registry=new D}),define(te[86],ne([0,1,3,35]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class T{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,I){this.schemasById[D(y)]=I,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const L=new T;k.Registry.add(e.Extensions.JSONContribution,L)}),define(te[39],ne([0,1,17,3,18,119,86,35]),function(J,e,R,k,D,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var y;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(y=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const i=P.Registry.as(L.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new k.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new k.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(S,c=!0){this.registerConfigurations([S],c)}registerConfigurations(S,c=!0){const a=this.doRegisterConfigurations(S,c);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterConfigurations(S){const c=this.doDeregisterConfigurations(S);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}updateConfigurations({add:S,remove:c}){const a=[];a.push(...this.doDeregisterConfigurations(c)),a.push(...this.doRegisterConfigurations(S,!1)),i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,R.distinct)(a))}registerDefaultConfigurations(S){const c=[],a=[];for(const t of S)for(const s in t)if(c.push(s),e.OVERRIDE_PROPERTY_PATTERN.test(s)){this.defaultValues[s]={...this.defaultValues[s]||{},...t[s]};const n={type:"object",default:this.defaultValues[s],description:T.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId};a.push(E(s)),this.configurationProperties[s]=n,this.defaultLanguageConfigurationOverridesNode.properties[s]=n}else{this.defaultValues[s]=t[s];const n=this.configurationProperties[s];n&&(this.updatePropertyDefaultValue(s,n),this.updateSchema(s,n))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterDefaultConfigurations(S){const c=[];for(const a of S)for(const t in a)if(c.push(t),delete this.defaultValues[t],e.OVERRIDE_PROPERTY_PATTERN.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const s=this.configurationProperties[t];s&&(this.updatePropertyDefaultValue(t,s),this.updateSchema(t,s))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}notifyConfigurationSchemaUpdated(...S){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(S){for(const c of S)this.overrideIdentifiers.add(c);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(S,c){const a=[];return S.forEach(t=>{a.push(...this.validateAndRegisterProperties(t,c,t.extensionInfo)),this.configurationContributors.push(t),this.registerJSONConfiguration(t)}),a}doDeregisterConfigurations(S){const c=[],a=t=>{if(t.properties)for(const s in t.properties)c.push(s),delete this.configurationProperties[s],this.removeFromSchema(s,t.properties[s]);t.allOf&&t.allOf.forEach(s=>a(s))};for(const t of S){a(t);const s=this.configurationContributors.indexOf(t);s!==-1&&this.configurationContributors.splice(s,1)}return c}validateAndRegisterProperties(S,c=!0,a,t=3){t=D.isUndefinedOrNull(S.scope)?t:S.scope;let s=[],n=S.properties;if(n)for(let o in n){if(c&&f(o)){delete n[o];continue}const l=n[o];if(this.updatePropertyDefaultValue(o,l),e.OVERRIDE_PROPERTY_PATTERN.test(o)?l.scope=void 0:(l.scope=D.isUndefinedOrNull(l.scope)?t:l.scope,l.restricted=D.isUndefinedOrNull(l.restricted)?!!a?.restrictedConfigurations?.includes(o):l.restricted),n[o].hasOwnProperty("included")&&!n[o].included){this.excludedConfigurationProperties[o]=n[o],delete n[o];continue}else this.configurationProperties[o]=n[o];!n[o].deprecationMessage&&n[o].markdownDeprecationMessage&&(n[o].deprecationMessage=n[o].markdownDeprecationMessage),s.push(o)}let r=S.allOf;if(r)for(let o of r)s.push(...this.validateAndRegisterProperties(o,c,a,t));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(S){const c=a=>{let t=a.properties;if(t)for(const n in t)this.updateSchema(n,t[n]);let s=a.allOf;s&&s.forEach(c)};c(S)}updateSchema(S,c){switch(e.allSettings.properties[S]=c,c.scope){case 1:e.applicationSettings.properties[S]=c;break;case 2:e.machineSettings.properties[S]=c;break;case 6:e.machineOverridableSettings.properties[S]=c;break;case 3:e.windowSettings.properties[S]=c;break;case 4:e.resourceSettings.properties[S]=c;break;case 5:e.resourceSettings.properties[S]=c,this.resourceLanguageSettingsSchema.properties[S]=c;break}}removeFromSchema(S,c){switch(delete e.allSettings.properties[S],c.scope){case 1:delete e.applicationSettings.properties[S];break;case 2:delete e.machineSettings.properties[S];break;case 6:delete e.machineOverridableSettings.properties[S];break;case 3:delete e.windowSettings.properties[S];break;case 4:case 5:delete e.resourceSettings.properties[S];break}}updateOverridePropertyPatternKey(){for(const S of this.overrideIdentifiers.values()){const c=`[${S}]`,a={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(c,a),e.allSettings.properties[c]=a,e.applicationSettings.properties[c]=a,e.machineSettings.properties[c]=a,e.machineOverridableSettings.properties[c]=a,e.windowSettings.properties[c]=a,e.resourceSettings.properties[c]=a}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(S,c){let a=this.defaultValues[S];D.isUndefined(a)&&(a=c.default),D.isUndefined(a)&&(a=u(c.type)),c.default=a}}const g="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(g);function E(v){return v.substring(1,v.length-1)}e.overrideIdentifierFromKey=E;function u(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const p=new C;P.Registry.add(e.Extensions.Configuration,p);function f(v){return v.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(v)?T.localize(5,null,v):p.getConfigurationProperties()[v]!==void 0?T.localize(6,null,v):null:T.localize(4,null)}e.validateProperty=f;function b(){const v=[],S=p.getConfigurationProperties();for(const c of Object.keys(S))v.push([c,S[c].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.getScopes=b}),define(te[22],ne([0,1,26,18,7,39,5,35]),function(J,e,R,k,D,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,L.createDecorator)("configurationService");function y(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof D.URI)}e.isConfigurationOverrides=y;var I;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function C(s,n){const r=n?s?n.keys.filter(_=>s.keys.indexOf(_)===-1):[...n.keys]:[],o=s?n?s.keys.filter(_=>n.keys.indexOf(_)===-1):[...s.keys]:[],l=[];if(n&&s){for(const _ of s.keys)if(n.keys.indexOf(_)!==-1){const w=b(s.contents,_),O=b(n.contents,_);R.equals(w,O)||l.push(_)}}const h=[],d=_=>{const w={};for(const O of _)for(const U of O.identifiers)w[a(U)]=O;return w},m=n?d(n.overrides):{},A=s?d(s.overrides):{};if(Object.keys(m).length)for(const _ of r){const w=m[_];w&&h.push([(0,T.overrideIdentifierFromKey)(_),w.keys])}if(Object.keys(A).length)for(const _ of o){const w=A[_];w&&h.push([(0,T.overrideIdentifierFromKey)(_),w.keys])}if(Object.keys(m).length&&Object.keys(A).length)for(const _ of l){const w=A[_],O=m[_];if(w&&O){const U=C({contents:w.contents,keys:w.keys,overrides:[]},{contents:O.contents,keys:O.keys,overrides:[]});h.push([(0,T.overrideIdentifierFromKey)(_),[...U.added,...U.removed,...U.updated]])}}return{added:r,removed:o,updated:l,overrides:h}}e.compare=C;function g(s,n){const r=[];for(const o of Object.keys(s))if(T.OVERRIDE_PROPERTY_PATTERN.test(o)){const l={};for(const h in s[o])l[h]=s[o][h];r.push({identifiers:[(0,T.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(l),contents:E(l,n)})}return r}e.toOverrides=g;function E(s,n){const r=Object.create(null);for(let o in s)u(r,o,s[o],n);return r}e.toValuesTree=E;function u(s,n,r,o){const l=n.split("."),h=l.pop();let d=s;for(let m=0;m<l.length;m++){let A=l[m],_=d[A];switch(typeof _){case"undefined":_=d[A]=Object.create(null);break;case"object":break;default:o(`Ignoring ${n} as ${l.slice(0,m+1).join(".")} is ${JSON.stringify(_)}`);return}d=_}if(typeof d=="object"&&d!==null)try{d[h]=r}catch(m){o(`Ignoring ${n} as ${l.join(".")} is ${JSON.stringify(d)}`)}else o(`Ignoring ${n} as ${l.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=u;function p(s,n){const r=n.split(".");f(s,r)}e.removeFromValueTree=p;function f(s,n){const r=n.shift();if(n.length===0){delete s[r];return}if(Object.keys(s).indexOf(r)!==-1){const o=s[r];typeof o=="object"&&!Array.isArray(o)&&(f(o,n),Object.keys(o).length===0&&delete s[r])}}function b(s,n,r){function o(d,m){let A=d;for(const _ of m){if(typeof A!="object"||A===null)return;A=A[_]}return A}const l=n.split("."),h=o(s,l);return typeof h=="undefined"?r:h}e.getConfigurationValue=b;function v(s,n,r){Object.keys(n).forEach(o=>{o!=="__proto__"&&(o in s?k.isObject(s[o])&&k.isObject(n[o])?v(s[o],n[o],r):r&&(s[o]=n[o]):s[o]=n[o])})}e.merge=v;function S(){const s=P.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=S;function c(){const s=Object.create(null),n=P.Registry.as(T.Extensions.Configuration).getConfigurationProperties();for(let r in n){let o=n[r].default;u(s,r,o,l=>console.error(`Conflict in default settings: ${l}`))}return s}e.getDefaultValues=c;function a(s){return`[${s}]`}e.keyFromOverrideIdentifier=a;function t(s,n,r){const o=s.inspect(n),l=s.inspect(r);return typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:o.defaultValue}e.getMigratedSettingValue=t}),define(te[181],ne([0,1,17,3,36,2,41,26,18,7,22,39,35]),function(J,e,R,k,D,T,L,P,y,I,i,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class E{constructor(t={},s=[],n=[]){this._contents=t,this._keys=s,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,i.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,s){const n=this.getContentsForOverrideIdentifer(s);return n?t?(0,i.getConfigurationValue)(n,t):n:void 0}getKeysForOverrideIdentifier(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.keys;return[]}override(t){const s=this.getContentsForOverrideIdentifer(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let n={};for(const r of R.distinct([...Object.keys(this.contents),...Object.keys(s)])){let o=this.contents[r],l=s[r];l&&(typeof o=="object"&&typeof l=="object"?(o=P.deepClone(o),this.mergeContents(o,l)):o=l),n[r]=o}return new E(n,this.keys,this.overrides)}merge(...t){const s=P.deepClone(this.contents),n=P.deepClone(this.overrides),r=[...this.keys];for(const o of t){this.mergeContents(s,o.contents);for(const l of o.overrides){const[h]=n.filter(d=>R.equals(d.identifiers,l.identifiers));h?this.mergeContents(h.contents,l.contents):n.push(P.deepClone(l))}for(const l of o.keys)r.indexOf(l)===-1&&r.push(l)}return new E(s,r,n)}freeze(){return this.isFrozen=!0,this}mergeContents(t,s){for(const n of Object.keys(s)){if(n in t&&y.isObject(t[n])&&y.isObject(s[n])){this.mergeContents(t[n],s[n]);continue}t[n]=P.deepClone(s[n])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?P.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,s){this.addKey(t),(0,i.addToValueTree)(this.contents,t,s,n=>{throw new Error(n)})}removeValue(t){this.removeKey(t)&&(0,i.removeFromValueTree)(this.contents,t)}addKey(t){let s=this.keys.length;for(let n=0;n<s;n++)t.indexOf(this.keys[n])===0&&(s=n);this.keys.splice(s,1,t)}removeKey(t){let s=this.keys.indexOf(t);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=E;class u extends E{constructor(){const t=(0,i.getDefaultValues)(),s=(0,i.getConfigurationKeys)(),n=[];for(const r of Object.keys(t))C.OVERRIDE_PROPERTY_PATTERN.test(r)&&n.push({identifiers:[(0,C.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(t[r]),contents:(0,i.toValuesTree)(t[r],o=>console.error(`Conflict in default settings file: ${o}`))});super(t,s,n)}}e.DefaultConfigurationModel=u;class p{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,s){if(!y.isUndefinedOrNull(t)){const n=this.doParseContent(t);this.parseRaw(n,s)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,s){this._raw=t;const{contents:n,keys:r,overrides:o,restricted:l}=this.doParseRaw(t,s);this._configurationModel=new E(n,r,o),this._restrictedConfigurations=l||[]}doParseContent(t){let s={},n=null,r=[],o=[],l=[];function h(m){Array.isArray(r)?r.push(m):n!==null&&(r[n]=m)}let d={onObjectBegin:()=>{let m={};h(m),o.push(r),r=m,n=null},onObjectProperty:m=>{n=m},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{let m=[];h(m),o.push(r),r=m,n=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:h,onError:(m,A,_)=>{l.push({error:m,offset:A,length:_})}};if(t)try{D.visit(t,d),s=r[0]||{}}catch(m){console.error(`Error while parsing settings file ${this._name}: ${m}`),this._parseErrors=[m]}return s}doParseRaw(t,s){const n=g.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),r=this.filter(t,n,!0,s);t=r.raw;const o=(0,i.toValuesTree)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`)),l=Object.keys(t),h=(0,i.toOverrides)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`));return{contents:o,keys:l,overrides:h,restricted:r.restricted}}filter(t,s,n,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:t,restricted:[]};const o={},l=[];for(let h in t)if(C.OVERRIDE_PROPERTY_PATTERN.test(h)&&n){const d=this.filter(t[h],s,!1,r);o[h]=d.raw,l.push(...d.restricted)}else{const d=s[h],m=d?typeof d.scope!="undefined"?d.scope:3:void 0;d?.restricted&&l.push(h),(m===void 0||r.scopes===void 0||r.scopes.includes(m))&&(r.skipRestricted&&d?.restricted||(o[h]=t[h]))}return{raw:o,restricted:l}}}e.ConfigurationModelParser=p;class f extends T.Disposable{constructor(t,s,n,r){super();this.userSettingsResource=t,this.scopes=s,this.fileService=r,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new p(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(k.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new E}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=f;class b{constructor(t,s,n=new E,r=new E,o=new L.ResourceMap,l=new E,h=new L.ResourceMap,d=!0){this._defaultConfiguration=t,this._localUserConfiguration=s,this._remoteUserConfiguration=n,this._workspaceConfiguration=r,this._folderConfigurations=o,this._memoryConfiguration=l,this._memoryConfigurationByResource=h,this._freeze=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(t,s,n){return this.getConsolidateConfigurationModel(s,n).getValue(t)}updateValue(t,s,n={}){let r;n.resource?(r=this._memoryConfigurationByResource.get(n.resource),r||(r=new E,this._memoryConfigurationByResource.set(n.resource,r))):r=this._memoryConfiguration,s===void 0?r.removeValue(t):r.setValue(t,s),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,s,n){const r=this.getConsolidateConfigurationModel(s,n),o=this.getFolderConfigurationModelForResource(s.resource,n),l=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,h=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),d=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),m=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),A=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),_=n?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,w=o?s.overrideIdentifier?o.freeze().override(s.overrideIdentifier).getValue(t):o.freeze().getValue(t):void 0,O=s.overrideIdentifier?l.override(s.overrideIdentifier).getValue(t):l.getValue(t),U=r.getValue(t),$=R.distinct(R.flatten(r.overrides.map(Y=>Y.identifiers))).filter(Y=>r.getOverrideValue(t,Y)!==void 0);return{defaultValue:h,userValue:d,userLocalValue:m,userRemoteValue:A,workspaceValue:_,workspaceFolderValue:w,memoryValue:O,value:U,default:h!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,user:d!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userLocal:m!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspace:_!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspaceFolder:w!==void 0?{value:o?.freeze().getValue(t),override:s.overrideIdentifier?o?.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,memory:O!==void 0?{value:l.getValue(t),override:s.overrideIdentifier?l.getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:$.length?$:void 0}}keys(t){const s=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,s){this._folderConfigurations.set(t,s),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const n=s.filter(r=>C.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const o=(0,C.overrideIdentifierFromKey)(r),l=this._defaultConfiguration.getKeysForOverrideIdentifier(o),h=t.getKeysForOverrideIdentifier(o),d=[...h.filter(m=>l.indexOf(m)===-1),...l.filter(m=>h.indexOf(m)===-1),...l.filter(m=>!P.equals(this._defaultConfiguration.override(o).getValue(m),t.override(o).getValue(m)))];return[o,d]});return this.updateDefaultConfiguration(t),{keys:s,overrides:n}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:n,removed:r,overrides:o}=(0,i.compare)(this.localUserConfiguration,t),l=[...s,...n,...r];return l.length&&this.updateLocalUserConfiguration(t),{keys:l,overrides:o}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:n,removed:r,overrides:o}=(0,i.compare)(this.remoteUserConfiguration,t);let l=[...s,...n,...r];return l.length&&this.updateRemoteUserConfiguration(t),{keys:l,overrides:o}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:n,removed:r,overrides:o}=(0,i.compare)(this.workspaceConfiguration,t);let l=[...s,...n,...r];return l.length&&this.updateWorkspaceConfiguration(t),{keys:l,overrides:o}}compareAndUpdateFolderConfiguration(t,s){const n=this.folderConfigurations.get(t),{added:r,updated:o,removed:l,overrides:h}=(0,i.compare)(n,s);let d=[...r,...o,...l];return(d.length||!n)&&this.updateFolderConfiguration(t,s),{keys:d,overrides:h}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:n,updated:r,removed:o,overrides:l}=(0,i.compare)(s,void 0);return{keys:[...n,...r,...o],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,s){let n=this.getConsolidatedConfigurationModelForResource(t,s);return t.overrideIdentifier?n.override(t.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:t},s){let n=this.getWorkspaceConsolidatedConfiguration();if(s&&t){const r=s.getFolder(t);r&&(n=this.getFolderConsolidatedConfiguration(r.uri)||n);const o=this._memoryConfigurationByResource.get(t);o&&(n=n.merge(o))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let s=this._foldersConsolidatedConfigurations.get(t);if(!s){const n=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(t);r?(s=n.merge(r),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(t,s)):s=n}return s}getFolderConfigurationModelForResource(t,s){if(s&&t){const n=s.getFolder(t);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,s)=>{const{contents:n,overrides:r,keys:o}=this._folderConfigurations.get(s);return t.push([s,{contents:n,overrides:r,keys:o}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>t.add(s)),this.userConfiguration.freeze().keys.forEach(s=>t.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(n=>t.add(n))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>s.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>s.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>s.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r))),[...s.values()]}static parse(t){const s=this.parseConfigurationModel(t.defaults),n=this.parseConfigurationModel(t.user),r=this.parseConfigurationModel(t.workspace),o=t.folders.reduce((l,h)=>(l.set(I.URI.revive(h[0]),this.parseConfigurationModel(h[1])),l),new L.ResourceMap);return new b(s,n,new E,r,o,new E,new L.ResourceMap,!1)}static parseConfigurationModel(t){return new E(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=b;function v(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const t=new Set,s=new Map;for(const r of a)r.keys.forEach(o=>t.add(o)),r.overrides.forEach(([o,l])=>{const h=(0,L.getOrSet)(s,o,new Set);l.forEach(d=>h.add(d))});const n=[];return s.forEach((r,o)=>n.push([o,[...r.values()]])),{keys:[...t.values()],overrides:n}}e.mergeChanges=v;class S{constructor(t,s,n,r){this.change=t,this.previous=s,this.currentConfiguraiton=n,this.currentWorkspace=r,this._previousConfiguration=void 0;const o=new Set;t.keys.forEach(h=>o.add(h)),t.overrides.forEach(([,h])=>h.forEach(d=>o.add(d))),this.affectedKeys=[...o.values()];const l=new E;this.affectedKeys.forEach(h=>l.setValue(h,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(s){const n=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(t,s,this.currentWorkspace);return!P.equals(n,r)}return!0}return!1}doesAffectedKeysTreeContains(t,s){let n=(0,i.toValuesTree)({[s]:!0},()=>{}),r;for(;typeof n=="object"&&(r=Object.keys(n)[0]);){if(t=t[r],!t)return!1;n=n[r]}return!0}}e.ConfigurationChangeEvent=S;class c extends S{constructor(t,s,n,r){super({keys:t.allKeys(),overrides:[]},void 0,t,s);this.source=n,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=c}),define(te[182],ne([0,1,6,3,2,16,22,181,39,35]),function(J,e,R,k,D,T,L,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class i extends D.Disposable{constructor(g,E){super();this.settingsResource=g,this._onDidChangeConfiguration=this._register(new k.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,T.extUriBiasedIgnorePathCase,E)),this.configuration=new P.Configuration(new P.DefaultConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new R.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(I.Registry.as(y.Extensions.Configuration).onDidUpdateConfiguration(u=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const g=await this.userConfiguration.loadConfiguration();this.configuration=new P.Configuration(new P.DefaultConfigurationModel,g)}getConfigurationData(){return this.configuration.toData()}getValue(g,E){const u=typeof g=="string"?g:void 0,p=(0,L.isConfigurationOverrides)(g)?g:(0,L.isConfigurationOverrides)(E)?E:{};return this.configuration.getValue(u,p,void 0)}updateValue(g,E,u,p){return Promise.reject(new Error("not supported"))}inspect(g){return this.configuration.inspect(g,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const g=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(g)}onDidChangeUserConfiguration(g){const E=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(g);this.trigger(u,E,1)}onDidDefaultConfigurationChange(g){const E=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new P.DefaultConfigurationModel,g);this.trigger(u,E,6)}trigger(g,E,u){const p=new P.ConfigurationChangeEvent(g,{data:E},this.configuration);p.source=u,p.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(p)}getTargetConfiguration(g){switch(g){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=i}),define(te[183],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,R.createDecorator)("remoteAuthorityResolverService");var k;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(L,P=k.Unknown,y){super(L);this._message=L,this._code=P,this._detail=y,this.isHandled=P===k.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(L){return L instanceof D&&L._code===k.TemporarilyNotAvailable}static isNoResolverFound(L){return L instanceof D&&L._code===k.NoResolverFound}static isHandled(L){return L instanceof D&&L.isHandled}}e.RemoteAuthorityResolverError=D}),define(te[184],ne([0,1,6,21,27,8,3,2,30,72,183]),function(J,e,R,k,D,T,L,P,y,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const C=30*1e3;var g;(function(x){x[x.Management=1]="Management",x[x.ExtensionHost=2]="ExtensionHost",x[x.Tunnel=3]="Tunnel"})(g=e.ConnectionType||(e.ConnectionType={}));function E(x){switch(x){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(x){const N=new D.CancellationTokenSource;return setTimeout(()=>N.cancel(),x),N.token}function p(x,N){if(x.isCancellationRequested||N.isCancellationRequested)return D.CancellationToken.Cancelled;const W=new D.CancellationTokenSource;return x.onCancellationRequested(()=>W.cancel()),N.onCancellationRequested(()=>W.cancel()),W.token}class f{constructor(N){this._state="pending",this._disposables=new P.DisposableStore,this.promise=new Promise((W,X)=>{this._resolvePromise=W,this._rejectPromise=X}),N.isCancellationRequested?this._timeout():this._disposables.add(N.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(N){this._state==="pending"?this._disposables.add(N):N.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const N=new Error("Time limit reached");return N.code="ETIMEDOUT",N.syscall="connect",N}resolve(N){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(N))}reject(N){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(N))}}function b(x,N){const W=new f(N);return W.registerDisposable(x.onControlMessage(X=>{const Z=JSON.parse(X.toString()),B=j(Z);B?W.reject(B):W.resolve(Z)})),W.promise}function v(x,N,W,X,Z,B){const H=new f(B);return N.connect(W,X,Z,(ie,re)=>{H.didTimeout?(ie&&x.error(ie),re?.dispose()):ie||!re?H.reject(ie):H.resolve(re)}),H.promise}function S(x,N){const W=new f(N);return x.then(X=>{W.didTimeout||W.resolve(X)},X=>{W.didTimeout||W.reject(X)}),W.promise}async function c(x,N,W,X){const Z=F(x,N);x.logService.trace(`${Z} 1/6. invoking socketFactory.connect().`);let B;try{B=await v(x.logService,x.socketFactory,x.host,x.port,`reconnectionToken=${x.reconnectionToken}&reconnection=${x.reconnectionProtocol?"true":"false"}`,X)}catch(ae){throw x.logService.error(`${Z} socketFactory.connect() failed or timed out. Error:`),x.logService.error(ae),ae}x.logService.trace(`${Z} 2/6. socketFactory.connect() was successful.`);let H,ie;x.reconnectionProtocol?(x.reconnectionProtocol.beginAcceptReconnection(B,null),H=x.reconnectionProtocol,ie=!1):(H=new I.PersistentProtocol(B,null),ie=!0),x.logService.trace(`${Z} 3/6. sending AuthRequest control message.`);const re={type:"auth",auth:x.connectionToken||"00000000000000000000"};H.sendControl(k.VSBuffer.fromString(JSON.stringify(re)));try{const ae=await b(H,p(X,u(1e4)));if(ae.type!=="sign"||typeof ae.data!="string"){const ge=new Error("Unexpected handshake message");throw ge.code="VSCODE_CONNECTION_ERROR",ge}x.logService.trace(`${Z} 4/6. received SignRequest control message.`);const ue=await S(x.signService.sign(ae.data),X),fe={type:"connectionType",commit:x.commit,signedData:ue,desiredConnectionType:N};return W&&(fe.args=W),x.logService.trace(`${Z} 5/6. sending ConnectionTypeRequest control message.`),H.sendControl(k.VSBuffer.fromString(JSON.stringify(fe))),{protocol:H,ownsProtocol:ie}}catch(ae){throw ae&&ae.code==="ETIMEDOUT"&&(x.logService.error(`${Z} the handshake timed out. Error:`),x.logService.error(ae)),ae&&ae.code==="VSCODE_CONNECTION_ERROR"&&(x.logService.error(`${Z} received error control message when negotiating connection. Error:`),x.logService.error(ae)),ie&&V(H),ae}}async function a(x,N,W,X){const Z=Date.now(),B=F(x,N),{protocol:H,ownsProtocol:ie}=await c(x,N,W,X),re=new f(X);return re.registerDisposable(H.onControlMessage(ae=>{const ue=JSON.parse(ae.toString()),fe=j(ue);fe?(x.logService.error(`${B} received error control message when negotiating connection. Error:`),x.logService.error(fe),ie&&V(H),re.reject(fe)):(x.reconnectionProtocol&&x.reconnectionProtocol.endAcceptReconnection(),x.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${G(Z)}!`),re.resolve({protocol:H,firstMessage:ue}))})),re.promise}async function t(x,N){const{protocol:W}=await a(x,1,void 0,N);return{protocol:W}}async function s(x,N,W){const{protocol:X,firstMessage:Z}=await a(x,2,N,W),B=Z&&Z.debugPort;return{protocol:X,debugPort:B}}async function n(x,N,W){const X=Date.now(),Z=F(x,3),{protocol:B}=await c(x,3,N,W);return x.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${G(X)}!`),B}async function r(x,N,W){const{host:X,port:Z,connectionToken:B}=await x.addressProvider.getAddress();return{commit:x.commit,host:X,port:Z,connectionToken:B,reconnectionToken:N,reconnectionProtocol:W,socketFactory:x.socketFactory,signService:x.signService,logService:x.logService}}async function o(x,N,W){try{const X=(0,y.generateUuid)(),Z=await r(x,X,null),{protocol:B}=await t(Z,D.CancellationToken.None);return new Y(x,N,W,X,B)}catch(X){throw x.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),x.logService.error(X),$.triggerPermanentFailure(0,0,i.RemoteAuthorityResolverError.isHandled(X)),X}}e.connectRemoteAgentManagement=o;async function l(x,N){try{const W=(0,y.generateUuid)(),X=await r(x,W,null),{protocol:Z,debugPort:B}=await s(X,N,D.CancellationToken.None);return new M(x,N,W,Z,B)}catch(W){throw x.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),x.logService.error(W),$.triggerPermanentFailure(0,0,i.RemoteAuthorityResolverError.isHandled(W)),W}}e.connectRemoteAgentExtensionHost=l;async function h(x,N,W){const X=await r(x,(0,y.generateUuid)(),null);return await n(X,{host:N,port:W},D.CancellationToken.None)}e.connectRemoteAgentTunnel=h;function d(x){return(0,R.createCancelablePromise)(N=>new Promise((W,X)=>{const Z=setTimeout(W,x*1e3);N.onCancellationRequested(()=>{clearTimeout(Z),W()})}))}var m;(function(x){x[x.ConnectionLost=0]="ConnectionLost",x[x.ReconnectionWait=1]="ReconnectionWait",x[x.ReconnectionRunning=2]="ReconnectionRunning",x[x.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",x[x.ConnectionGain=4]="ConnectionGain"})(m=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class A{constructor(N,W){this.reconnectionToken=N,this.millisSinceLastIncomingData=W,this.type=0}}e.ConnectionLostEvent=A;class _{constructor(N,W,X,Z){this.reconnectionToken=N,this.millisSinceLastIncomingData=W,this.durationSeconds=X,this.cancellableTimer=Z,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=_;class w{constructor(N,W,X){this.reconnectionToken=N,this.millisSinceLastIncomingData=W,this.attempt=X,this.type=2}}e.ReconnectionRunningEvent=w;class O{constructor(N,W,X){this.reconnectionToken=N,this.millisSinceLastIncomingData=W,this.attempt=X,this.type=4}}e.ConnectionGainEvent=O;class U{constructor(N,W,X,Z){this.reconnectionToken=N,this.millisSinceLastIncomingData=W,this.attempt=X,this.handled=Z,this.type=3}}e.ReconnectionPermanentFailureEvent=U;class $ extends P.Disposable{constructor(N,W,X,Z){super();this._connectionType=N,this._onDidStateChange=this._register(new L.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=W,this.reconnectionToken=X,this.protocol=Z,this._isReconnecting=!1,this._onDidStateChange.fire(new O(this.reconnectionToken,0,0)),this._register(Z.onSocketClose(B=>{const H=q(this._connectionType,this.reconnectionToken,!0);B?B.type===0?(this._options.logService.info(`${H} received socket close event (hadError: ${B.hadError}).`),B.error&&this._options.logService.error(B.error)):(this._options.logService.info(`${H} received socket close event (wasClean: ${B.wasClean}, code: ${B.code}, reason: ${B.reason}).`),B.event&&this._options.logService.error(B.event)):this._options.logService.info(`${H} received socket close event.`),this._beginReconnecting()})),this._register(Z.onSocketTimeout(()=>{const B=q(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${B} received socket timeout event.`),this._beginReconnecting()})),$._instances.push(this),$._permanentFailure&&this._gotoPermanentFailure($._permanentFailureMillisSinceLastIncomingData,$._permanentFailureAttempt,$._permanentFailureHandled)}static triggerPermanentFailure(N,W,X){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=N,this._permanentFailureAttempt=W,this._permanentFailureHandled=X,this._instances.forEach(Z=>Z._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if($._permanentFailure)return;const N=q(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${N} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new A(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const W=[0,5,5,10,10,10,10,10,30];let X=-1;do{X++;const Z=X<W.length?W[X]:W[W.length-1];try{if(Z>0){const H=d(Z);this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Z,H)),this._options.logService.info(`${N} waiting for ${Z} seconds before reconnecting...`);try{await H}catch{}}if($._permanentFailure){this._options.logService.error(`${N} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new w(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),X+1)),this._options.logService.info(`${N} resolving connection...`);const B=await r(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${N} connecting to ${B.host}:${B.port}...`),await this._reconnect(B,u(C)),this._options.logService.info(`${N} reconnected!`),this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),X+1));break}catch(B){if(B.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${N} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(B),$.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),X+1,!1);break}if(X>360){this._options.logService.error(`${N} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(B),$.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),X+1,!1);break}if(i.RemoteAuthorityResolverError.isTemporarilyNotAvailable(B)){this._options.logService.info(`${N} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(B);continue}if((B.code==="ETIMEDOUT"||B.code==="ENETUNREACH"||B.code==="ECONNREFUSED"||B.code==="ECONNRESET")&&B.syscall==="connect"){this._options.logService.info(`${N} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(B);continue}if((0,T.isPromiseCanceledError)(B)){this._options.logService.info(`${N} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(B);continue}if(B instanceof i.RemoteAuthorityResolverError){this._options.logService.error(`${N} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(B),$.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),X+1,i.RemoteAuthorityResolverError.isHandled(B));break}this._options.logService.error(`${N} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(B),$.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),X+1,!1);break}}while(!$._permanentFailure)}_gotoPermanentFailure(N,W,X){this._onDidStateChange.fire(new U(this.reconnectionToken,N,W,X)),V(this.protocol)}}$._permanentFailure=!1,$._permanentFailureMillisSinceLastIncomingData=0,$._permanentFailureAttempt=0,$._permanentFailureHandled=!1,$._instances=[];class Y extends ${constructor(N,W,X,Z,B){super(1,N,Z,B);this.client=this._register(new I.Client(B,{remoteAuthority:W,clientId:X},N.ipcLogger))}async _reconnect(N,W){await t(N,W)}}e.ManagementPersistentConnection=Y;class M extends ${constructor(N,W,X,Z,B){super(2,N,X,Z);this._startArguments=W,this.debugPort=B}async _reconnect(N,W){await s(N,this._startArguments,W)}}e.ExtensionHostPersistentConnection=M;function V(x){try{x.acceptDisconnect();const N=x.getSocket();x.dispose(),N.dispose()}catch(N){(0,T.onUnexpectedError)(N)}}function j(x){if(x&&x.type==="error"){const N=new Error(`Connection error: ${x.reason}`);return N.code="VSCODE_CONNECTION_ERROR",N}return null}function z(x,N){for(;x.length<N;)x+=" ";return x}function q(x,N,W){return`[remote-connection][${z(E(x),13)}][${N.substr(0,5)}\u2026][${W?"reconnect":"initial"}]`}function F(x,N){return`${q(N,x.reconnectionToken,!!x.reconnectionProtocol)}[${x.host}:${x.port}]`}function G(x){return`${Date.now()-x} ms`}}),define(te[185],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,R.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(te[61],ne([0,1,3,4,5,10]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService");var L;(function(u){u.Http="http",u.Https="https"})(L=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(u){u.ConstantPrivate="constantPrivate",u.Private="private",u.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(u){u[u.Notify=1]="Notify",u[u.OpenBrowser=2]="OpenBrowser",u[u.OpenPreview=3]="OpenPreview",u[u.Silent=4]="Silent",u[u.Ignore=5]="Ignore",u[u.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function I(u){if(u.scheme!=="http"&&u.scheme!=="https")return;const p=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(u.authority);if(!!p)return{address:p[1],port:+p[2]}}e.extractLocalHostUriMetaDataForPortMapping=I,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function i(u){return e.LOCALHOST_ADDRESSES.indexOf(u)>=0}e.isLocalhost=i,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function C(u){return e.ALL_INTERFACES_ADDRESSES.indexOf(u)>=0}e.isAllInterfaces=C;function g(u,p){return p?p!==1&&u<1024:!k.isWindows&&u<1024}e.isPortPrivileged=g;let E=class{constructor(p){this.logService=p,this._onTunnelOpened=new R.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new R.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new R.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(p,f){return this._tunnelProvider=p,p?(this._canElevate=f.elevation,this._privacyOptions=f.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return new Promise(async p=>{const f=[],b=Array.from(this._tunnels.values());for(let v of b){const S=Array.from(v.values());for(let c of S){const a=await c.value;a&&f.push(a)}}p(f)})}async dispose(){for(const p of this._tunnels.values()){for(const{value:f}of p.values())await f.then(b=>b?.dispose());p.clear()}this._tunnels.clear()}openTunnel(p,f,b,v,S=!1,c=P.Private,a){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${b} on local port ${v}.`),!p)return;f||(f="localhost");const t=this.retainOrCreateTunnel(p,f,b,v,S,c,a);return t?t.then(s=>{if(!s){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(f,b);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(s);return(s.tunnelRemoteHost!==f||s.tunnelRemotePort!==b)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}makeTunnel(p){return{tunnelRemotePort:p.tunnelRemotePort,tunnelRemoteHost:p.tunnelRemoteHost,tunnelLocalPort:p.tunnelLocalPort,localAddress:p.localAddress,privacy:p.privacy,protocol:p.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${p.tunnelRemoteHost}:${p.tunnelRemotePort} `);const f=this._tunnels.get(p.tunnelRemoteHost);if(f){const b=f.get(p.tunnelRemotePort);b&&(b.refcount--,await this.tryDisposeTunnel(p.tunnelRemoteHost,p.tunnelRemotePort,b))}}}}async tryDisposeTunnel(p,f,b){if(b.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${p}:${f}.`);const v=b.value.then(async S=>{S&&(await S.dispose(!0),this._onTunnelClosed.fire({host:S.tunnelRemoteHost,port:S.tunnelRemotePort}))});return this._tunnels.has(p)&&this._tunnels.get(p).delete(f),v}}async closeTunnel(p,f){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${p}:${f} `);const b=this._tunnels.get(p);if(b&&b.has(f)){const v=b.get(f);v.refcount=0,await this.tryDisposeTunnel(p,f,v)}}addTunnelToMap(p,f,b){this._tunnels.has(p)||this._tunnels.set(p,new Map),this._tunnels.get(p).set(f,{refcount:1,value:b})}async removeEmptyTunnelFromMap(p,f){const b=this._tunnels.get(p);b&&(await b.get(f)||b.delete(f),b.size===0&&this._tunnels.delete(p))}getTunnelFromMap(p,f){let b=[p];i(p)?(b.push(...e.LOCALHOST_ADDRESSES),b.push(...e.ALL_INTERFACES_ADDRESSES)):C(p)&&b.push(...e.ALL_INTERFACES_ADDRESSES);const v=b.map(S=>this._tunnels.get(S));for(const S of v){const c=S?.get(f);if(c)return c}}canTunnel(p){return!!I(p)}createWithProvider(p,f,b,v,S,c,a){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${b} on local port ${v}.`);const s={elevationRequired:S?g(v===void 0?b:v):!1},n={remoteAddress:{host:f,port:b},localAddressPort:v,privacy:c,public:c!==P.Private,protocol:a},r=p.forwardPort(n,s);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(f,b,r),r}};E=he([Q(0,T.ILogService)],E),e.AbstractTunnelService=E}),define(te[186],ne([0,1,10,61,2,8]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;let L=class yt extends D.Disposable{constructor(y,I){super();this._tunnelService=y,this._logService=I,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(y=>y.dispose())}async createTunnel(){return{id:String(++yt._lastId)}}async startTunnel(y,I,i,C,g,E){const u=new class{async getAddress(){return I}},p=await Promise.resolve(this._tunnelService.openTunnel(u,i,C,g,E));if(!p)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${i}:${C} (remote).`),new Error("Could not create tunnel");if(this._disposedTunnels.has(y))throw this._disposedTunnels.delete(y),await p.dispose(),(0,T.canceled)();return this._tunnels.set(y,p),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${y}: ${p.localAddress} (local) to ${i}:${C} (remote).`),{tunnelLocalPort:p.tunnelLocalPort,localAddress:p.localAddress}}async destroyTunnel(y){const I=this._tunnels.get(y);if(I){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${y}.`),this._tunnels.delete(y),await I.dispose();return}this._disposedTunnels.add(y)}};L._lastId=0,L=he([Q(0,k.ITunnelService),Q(1,R.ILogService)],L),e.SharedProcessTunnelService=L}),define(te[187],ne([0,1,113,22,10]),function(J,e,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let T=class{constructor(P,y){this.configurationService=P,this.logService=y}request(P,y){return this.logService.trace("RequestService#request",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,R.request)(P,y)}async resolveProxy(P){}};T=he([Q(0,k.IConfigurationService),Q(1,D.ILogService)],T),e.RequestService=T}),define(te[43],ne([0,1,21,133,39,5,35]),function(J,e,R,k,D,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,T.createDecorator)("requestService");function P(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}e.isSuccess=P;function y(u){return u.res.statusCode===204}async function I(u){if(!P(u))throw new Error("Server returned "+u.res.statusCode);return y(u)?null:(await(0,R.streamToBuffer)(u.stream)).toString()}e.asText=I;async function i(u){if(!P(u))throw new Error("Server returned "+u.res.statusCode);if(y(u))return null;const f=(await(0,R.streamToBuffer)(u.stream)).toString();try{return JSON.parse(f)}catch(b){throw b.message+=`:
`+f,b}}e.asJson=i;function C(u){E(u)}e.updateProxyConfigurationsScope=C;let g;function E(u){const p=L.Registry.as(D.Extensions.Configuration),f=g;g={id:"http",order:15,title:(0,k.localize)(0,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,k.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,k.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,k.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,k.localize)(4,null),(0,k.localize)(5,null),(0,k.localize)(6,null),(0,k.localize)(7,null)],default:"override",description:(0,k.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,k.localize)(9,null),restricted:!0}}},p.updateConfigurations({add:[g],remove:f?[f]:[]})}E(2)}),define(te[188],ne([0,1,27,15,14,43]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let L=class{constructor(y,I){this.requestService=y,this.fileService=I}async download(y,I,i=R.CancellationToken.None){if(y.scheme===k.Schemas.file||y.scheme===k.Schemas.vscodeRemote){await this.fileService.copy(y,I);return}const C={type:"GET",url:y.toString()},g=await this.requestService.request(C,i);if(g.res.statusCode===200)await this.fileService.writeFile(I,g.stream);else{const E=await(0,T.asText)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${E}`)}}};L=he([Q(0,T.IRequestService),Q(1,D.IFileService)],L),e.DownloadService=L}),define(te[189],ne([0,1,17,27,65,2,16,146,14,10,29,43]),function(J,e,R,k,D,T,L,P,y,I,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let g=class extends T.Disposable{constructor(u,p,f,b){super();this.fileService=u,this.productService=p,this.requestService=f,this.logService=b,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,D.forEach)(this.productService.configBasedExtensionTips,({value:v})=>this.allConfigBasedTips.set(v.configPath,v))}getConfigBasedTips(u){return this.getValidConfigBasedTips(u)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(u){const p=[];for(const[f,b]of this.allConfigBasedTips)if(!(b.configScheme&&b.configScheme!==u.scheme))try{const v=await this.fileService.readFile((0,L.joinPath)(u,f)),S=new Map;(0,D.forEach)(b.recommendations,({key:a,value:t})=>{if((0,R.isNonEmptyArray)(t.remotes))for(const s of t.remotes)S.set(s,{extensionId:a,extensionName:t.name,configName:b.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else p.push({extensionId:a,extensionName:t.name,configName:b.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const c=(0,P.getDomainsOfRemotes)(v.value.toString(),[...S.keys()]);for(const a of c){const t=S.get(a);t&&p.push(t)}}catch(v){}return p}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const u=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},k.CancellationToken.None);if(u.res.statusCode!==200)return[];const p=await(0,C.asJson)(u);return p?p.workspaceRecommendations||[]:[]}catch(u){return this.logService.error(u),[]}}};g=he([Q(0,y.IFileService),Q(1,i.IProductService),Q(2,C.IRequestService),Q(3,I.ILogService)],g),e.ExtensionTipsService=g}),define(te[45],ne([0,1,21,30]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(T,L,P){let y=P&&P.get("storage.serviceMachineId",0)||null;if(y)return y;try{const i=(await L.readFile(T.serviceMachineIdResource)).value.toString();y=(0,k.isUUID)(i)?i:null}catch(I){y=null}if(!y){y=(0,k.generateUuid)();try{await L.writeFile(T.serviceMachineIdResource,R.VSBuffer.fromString(y))}catch(I){}}return P&&P.store("storage.serviceMachineId",y,0,1),y}e.getServiceMachineId=D}),define(te[87],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,R.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[190],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class R{vsda(){return new Promise((D,T)=>J(["vsda"],D,T))}async sign(D){try{const T=await this.vsda(),L=new T.signer;if(L)return L.sign(D)}catch(T){}return D}}e.SignService=R}),define(te[23],ne([0,1,6,3,2,18,73,5]),function(J,e,R,k,D,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const y="__$__targetStorageMarker";e.IStorageService=(0,P.createDecorator)("storageService");var I;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(I=e.WillSaveStateReason||(e.WillSaveStateReason={}));var i;(function(p){p[p.GLOBAL=0]="GLOBAL",p[p.WORKSPACE=1]="WORKSPACE"})(i=e.StorageScope||(e.StorageScope={}));var C;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(C=e.StorageTarget||(e.StorageTarget={}));class g extends D.Disposable{constructor(f={flushInterval:g.DEFAULT_FLUSH_INTERVAL}){super();this.options=f,this._onDidChangeValue=this._register(new k.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new k.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new k.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new R.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,R.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(f,b){b===y?(f===0?this._globalKeyTargets=void 0:f===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:f})):this._onDidChangeValue.fire({scope:f,key:b,target:this.getKeyTargets(f)[b]})}emitWillSaveState(f){this._onWillSaveState.fire({reason:f})}get(f,b,v){return this.getStorage(b)?.get(f,v)}getBoolean(f,b,v){return this.getStorage(b)?.getBoolean(f,v)}getNumber(f,b,v){return this.getStorage(b)?.getNumber(f,v)}store(f,b,v,S){if((0,T.isUndefinedOrNull)(b)){this.remove(f,v);return}this.withPausedEmitters(()=>{this.updateKeyTarget(f,v,S),this.getStorage(v)?.set(f,b)})}remove(f,b){this.withPausedEmitters(()=>{this.updateKeyTarget(f,b,void 0),this.getStorage(b)?.delete(f)})}withPausedEmitters(f){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{f()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(f,b){const v=[],S=this.getKeyTargets(f);for(const c of Object.keys(S))S[c]===b&&v.push(c);return v}updateKeyTarget(f,b,v){const S=this.getKeyTargets(b);typeof v=="number"?S[f]!==v&&(S[f]=v,this.getStorage(b)?.set(y,JSON.stringify(S))):typeof S[f]=="number"&&(delete S[f],this.getStorage(b)?.set(y,JSON.stringify(S)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(f){return f===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(f){const b=this.get(y,f);if(b)try{return JSON.parse(b)}catch(v){}return Object.create(null)}isNew(f){return this.getBoolean(e.IS_NEW_KEY,f)===!0}async flush(f=I.NONE){this._onWillSaveState.fire({reason:f}),await R.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const f=this.getStorage(0)?.items??new Map,b=this.getStorage(1)?.items??new Map;return u(f,b,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=g,g.DEFAULT_FLUSH_INTERVAL=60*1e3;class E extends g{constructor(){super();this.globalStorage=this._register(new L.Storage(new L.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new L.Storage(new L.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(f=>this.emitDidChangeValue(1,f))),this._register(this.globalStorage.onDidChangeStorage(f=>this.emitDidChangeValue(0,f)))}getStorage(f){return f===0?this.globalStorage:this.workspaceStorage}getLogDetails(f){return f===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(f){}}e.InMemoryStorageService=E;async function u(p,f,b,v){const S=o=>{try{return JSON.parse(o)}catch(l){return o}},c=new Map,a=new Map;p.forEach((o,l)=>{c.set(l,o),a.set(l,S(o))});const t=new Map,s=new Map;f.forEach((o,l)=>{t.set(l,o),s.set(l,S(o))}),console.group(`Storage: Global (path: ${b})`);let n=[];c.forEach((o,l)=>{n.push({key:l,value:o})}),console.table(n),console.groupEnd(),console.log(a),console.group(`Storage: Workspace (path: ${v})`);let r=[];t.forEach((o,l)=>{r.push({key:l,value:o})}),console.table(r),console.groupEnd(),console.log(s)}e.logStorage=u}),define(te[191],ne([0,1,3,2,18,28,34,23]),function(J,e,R,k,D,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let y=class extends k.Disposable{constructor(C){super();this._onDidChangeEnablement=new R.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new I(C)),this._register(this.storageManger.onDidChange(g=>this._onDidChangeEnablement.fire({extensions:g,source:"storage"})))}async enableExtension(C,g){return this._removeFromDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:g}),!0):!1}async disableExtension(C,g){return this._addToDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:g}),!0):!1}getDisabledExtensions(){return this._getExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(C){let g=this.getDisabledExtensions();return g.every(E=>!(0,L.areSameExtensions)(E,C))?(g.push(C),this._setDisabledExtensions(g),!0):!1}_removeFromDisabledExtensions(C){let g=this.getDisabledExtensions();for(let E=0;E<g.length;E++){const u=g[E];if((0,L.areSameExtensions)(u,C))return g.splice(E,1),this._setDisabledExtensions(g),!0}return!1}_setDisabledExtensions(C){this._setExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH,C)}_getExtensions(C){return this.storageManger.get(C,0)}_setExtensions(C,g){this.storageManger.set(C,g,0)}};y=he([Q(0,P.IStorageService)],y),e.GlobalExtensionEnablementService=y;class I extends k.Disposable{constructor(C){super();this.storageService=C,this.storage=Object.create(null),this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this._register(C.onDidChangeValue(g=>this.onDidStorageChange(g)))}get(C,g){let E;return g===0?((0,D.isUndefinedOrNull)(this.storage[C])&&(this.storage[C]=this._get(C,g)),E=this.storage[C]):E=this._get(C,g),JSON.parse(E)}set(C,g,E){let u=JSON.stringify(g.map(({id:f,uuid:b})=>({id:f,uuid:b})));this._get(C,E)!==u&&(E===0&&(g.length?this.storage[C]=u:delete this.storage[C]),this._set(C,g.length?u:void 0,E))}onDidStorageChange(C){if(C.scope===0&&!(0,D.isUndefinedOrNull)(this.storage[C.key])&&this._get(C.key,C.scope)!==this.storage[C.key]){const E=this.get(C.key,C.scope);delete this.storage[C.key];const u=this.get(C.key,C.scope),p=E.filter(b=>!u.some(v=>(0,L.areSameExtensions)(b,v))),f=u.filter(b=>!E.some(v=>(0,L.areSameExtensions)(v,b)));(p.length||f.length)&&this._onDidChange.fire([...p,...f])}}_get(C,g){return this.storageService.get(C,g,"[]")}_set(C,g,E){g?this.storageService.store(C,g,E,1):this.storageService.remove(C,E)}}e.StorageManager=I}),define(te[192],ne([0,1,3,2]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class D extends k.Disposable{constructor(I,i){super();this.channel=I,this.workspace=i}async getItems(){const I={workspace:this.workspace},i=await this.channel.call("getItems",I);return new Map(i)}updateItems(I){const i={workspace:this.workspace};return I.insert&&(i.insert=Array.from(I.insert.entries())),I.delete&&(i.delete=Array.from(I.delete.values())),this.channel.call("updateItems",i)}}class T extends D{constructor(I){super(I,void 0);this._onDidChangeItemsExternal=this._register(new R.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(I=>this.onDidChangeGlobalStorage(I)))}onDidChangeGlobalStorage(I){(Array.isArray(I.changed)||Array.isArray(I.deleted))&&this._onDidChangeItemsExternal.fire({changed:I.changed?new Map(I.changed):void 0,deleted:I.deleted?new Set(I.deleted):void 0})}async close(){this.dispose()}}class L extends D{constructor(I,i){super(I,i);this.onDidChangeItemsExternal=R.Event.None}async close(){const I={workspace:this.workspace};return this.channel.call("close",I)}}class P extends k.Disposable{constructor(I,i){super();this.channel=I,this.workspace=i,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new T(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new L(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=P}),define(te[193],ne([0,1,6,2,177,16,73,23,192]),function(J,e,R,k,D,T,L,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class I extends P.AbstractStorageService{constructor(C,g,E){super();this.mainProcessService=g,this.environmentService=E,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new k.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(C)}createGlobalStorage(){const C=new y.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),g=new L.Storage(C.globalStorage);return this._register(g.onDidChangeStorage(E=>this.emitDidChangeValue(0,E))),g}createWorkspaceStorage(C){const g=new y.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),C);if(g.workspaceStorage){const E=new L.Storage(g.workspaceStorage);return this.workspaceStorageDisposable.value=E.onDidChangeStorage(u=>this.emitDidChangeValue(1,u)),this.workspaceStorageId=C?.id,E}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){(0,D.mark)("code/willInitStorage");try{await R.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}finally{(0,D.mark)("code/didInitStorage")}}getStorage(C){return C===0?this.globalStorage:this.workspaceStorage}getLogDetails(C){return C===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,T.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(P.WillSaveStateReason.SHUTDOWN),await R.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(C){const g=this.workspaceStorage,E=g?.items??new Map;g&&(await g.close(),g.dispose()),this.workspaceStorage=this.createWorkspaceStorage(C),await this.workspaceStorage.init();for(const[u,p]of E)this.workspaceStorage.set(u,p)}}e.NativeStorageService=I}),define(te[194],ne([0,1,4,31,7,30]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function L(I){if(R.platform===2&&/^penguin(\.|$)/i.test(I))return"chromebook"}async function P(I,i,C,g,E,u,p,f,b,v){const S=Object.create(null);S["common.machineId"]=p,S.sessionID=(0,T.generateUuid)()+Date.now(),S.commitHash=E,S.version=u,S["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),S["common.platform"]=(0,R.PlatformToString)(R.platform),S["common.nodePlatform"]=k.platform,S["common.nodeArch"]=g,S["common.product"]=v||"desktop";const c=y(f||[]);c&&(S["common.msftInternal"]=c);let a=0;const t=Date.now();Object.defineProperties(S,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),R.isLinuxSnap&&(S["common.snap"]="true");const s=L(C);s&&(S["common.platformDetail"]=s);try{const n=await I.readFile(D.URI.file(b));S["common.source"]=n.value.toString().slice(0,30)}catch(n){}return S}e.resolveCommonProperties=P;function y(I){const i=k.env.USERDNSDOMAIN;if(!i)return!1;const C=i.toLowerCase();return I.some(g=>C===g)}e.verifyMicrosoftInternalDomain=y}),define(te[20],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,R.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,R.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var k;(function(T){T[T.NONE=0]="NONE",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(k=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(T){T.OFF="off",T.ERROR="error",T.ON="on"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(te[195],ne([0,1,32,55,36,15,9,4,7,105,19,108,77,14,29,20]),function(J,e,R,k,D,T,L,P,y,I,i,C,g,E,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function f(a,t){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],n=new Map,r=new Map,o=2e4;function l(m,A,_,w){const O=A.substring(m.length+1);return new Promise(async U=>{let $;try{$=await i.Promises.readdir(A,{withFileTypes:!0})}catch(V){U();return}if(w.count>=o){w.count+=$.length,w.maxReached=!0,U();return}let Y=$.length;if(Y===0){U();return}let M=$;w.count+$.length>o&&(w.maxReached=!0,Y=o-w.count,M=$.slice(0,Y)),w.count+=$.length;for(const V of M)if(V.isDirectory()){if(_.includes(V.name)||await l(m,(0,L.join)(A,V.name),_,w),--Y==0){U();return}}else{const j=V.name.lastIndexOf(".");if(j>=0){const z=V.name.substring(j+1);z&&n.set(z,(n.get(z)??0)+1)}for(const z of s)z.relativePathPattern?.test(O)!==!1&&z.filePattern.test(V.name)&&r.set(z.tag,(r.get(z.tag)??0)+1);if(--Y==0){U();return}}})}const h={count:0,maxReached:!1};await l(a,a,t,h);const d=await S(a);return{configFiles:b(r),fileTypes:b(n),fileCount:h.count,maxFilesReached:h.maxReached,launchConfigFiles:d}}e.collectWorkspaceStats=f;function b(a){return[...k.Iterable.map(a.entries(),([t,s])=>({name:t,count:s}))].sort((t,s)=>s.count-t.count)}function v(){const a={os:`${R.type()} ${R.arch()} ${R.release()}`,memory:`${(R.totalmem()/E.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/E.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(I.virtualMachineHint.value()*100)}%`},t=R.cpus();return t&&t.length>0&&(a.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),a}e.getMachineInfo=v;async function S(a){try{const t=new Map,s=(0,L.join)(a,".vscode","launch.json"),n=await i.Promises.readFile(s),r=[],o=(0,D.parse)(n.toString(),r);if(r.length)return console.log(`Unable to parse ${s}`),[];if((0,D.getNodeType)(o)==="object"&&o.configurations)for(const l of o.configurations){const h=l.type;h&&(t.has(h)?t.set(h,t.get(h)+1):t.set(h,1))}return b(t)}catch(t){return[]}}e.collectLaunchConfigs=S;let c=class{constructor(t,s){this.telemetryService=t,this.productService=s}formatMachineInfo(t){const s=[];return s.push(`OS Version:       ${t.os}`),s.push(`CPUs:             ${t.cpus}`),s.push(`Memory (System):  ${t.memory}`),s.push(`VM:               ${t.vmHint}`),s.join(`
`)}formatEnvironment(t){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${R.type()} ${R.arch()} ${R.release()}`);const n=R.cpus();return n&&n.length>0&&s.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),s.push(`Memory (System):  ${(R.totalmem()/E.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/E.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||s.push(`Load (avg):       ${R.loadavg().map(r=>Math.round(r)).join(", ")}`),s.push(`VM:               ${Math.round(I.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${t.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(t,s){return Promise.all([(0,C.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async n=>{let[r,o]=n,l=this.formatProcessList(t,r);return s.forEach(h=>{if((0,g.isRemoteDiagnosticError)(h))l+=`
${h.errorMessage}`,o+=`
${h.errorMessage}`;else if(l+=`

Remote: ${h.hostName}`,h.processes&&(l+=`
${this.formatProcessList(t,h.processes)}`),h.workspaceMetadata){o+=`
|  Remote: ${h.hostName}`;for(const d of Object.keys(h.workspaceMetadata)){const m=h.workspaceMetadata[d];let A=`${m.fileCount} files`;m.maxFilesReached&&(A=`more than ${A}`),o+=`|    Folder (${d}): ${A}`,o+=this.formatWorkspaceStats(m)}}}),{processInfo:l,workspaceInfo:o}})}async getSystemInfo(t,s){const{memory:n,vmHint:r,os:o,cpus:l}=v(),h={os:o,memory:n,cpus:l,vmHint:r,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:s};return P.isWindows||(h.load=`${R.loadavg().map(d=>Math.round(d)).join(", ")}`),P.isLinux&&(h.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(h)}async getDiagnostics(t,s){const n=[];return(0,C.listProcesses)(t.mainPID).then(async r=>(n.push(""),n.push(this.formatEnvironment(t)),n.push(""),n.push(this.formatProcessList(t,r)),t.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.formatWorkspaceMetadata(t))),s.forEach(o=>{if((0,g.isRemoteDiagnosticError)(o))n.push(`
${o.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${o.hostName}`),n.push(this.formatMachineInfo(o.machineInfo)),o.processes&&n.push(this.formatProcessList(t,o.processes)),o.workspaceMetadata)for(const l of Object.keys(o.workspaceMetadata)){const h=o.workspaceMetadata[l];let d=`${h.fileCount} files`;h.maxFilesReached&&(d=`more than ${d}`),n.push(`Folder (${l}): ${d}`),n.push(this.formatWorkspaceStats(h))}}),n.push(""),n.push(""),n.join(`
`)))}formatWorkspaceStats(t){const s=[],n=60;let r=0;const o=(m,A)=>{const _=` ${m}(${A})`;r+_.length>n?(s.push(l),l="|                 ",r=l.length):r+=_.length,l+=_};let l="|      File types:";const h=10;let d=t.fileTypes.length>h?h:t.fileTypes.length;for(let m=0;m<d;m++){const A=t.fileTypes[m];o(A.name,A.count)}if(s.push(l),t.configFiles.length>=0&&(l="|      Conf files:",r=0,t.configFiles.forEach(m=>{o(m.name,m.count)}),s.push(l)),t.launchConfigFiles.length>0){let m="|      Launch Configs:";t.launchConfigFiles.forEach(A=>{m+=A.count>1?` ${A.name}(${A.count})`:` ${A.name}`}),s.push(m)}return s.join(`
`)}expandGPUFeatures(t){const s=Math.max(...Object.keys(t).map(n=>n.length));return Object.keys(t).map(n=>`${n}:  ${" ".repeat(s-n.length)}  ${t[n]}`).join(`
                  `)}formatWorkspaceMetadata(t){const s=[],n=[];return t.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(s.push(`|  Window (${r.title})`),r.folderURIs.forEach(o=>{const l=y.URI.revive(o);if(l.scheme===T.Schemas.file){const h=l.fsPath;n.push(f(h,["node_modules",".git"]).then(d=>{let m=`${d.fileCount} files`;d.maxFilesReached&&(m=`more than ${m}`),s.push(`|    Folder (${(0,L.basename)(h)}): ${m}`),s.push(this.formatWorkspaceStats(d))}).catch(d=>{s.push(`|      Error: Unable to collect workspace stats for folder ${h} (${d.toString()})`)}))}else s.push(`|    Folder (${l.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(r=>s.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}formatProcessList(t,s){const n=new Map;t.windows.forEach(o=>n.set(o.pid,o.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(t.mainPID,n,r,s,0),r.join(`
`)}formatProcessItem(t,s,n,r,o){const l=o===0;let h;l?h=r.pid===t?`${this.productService.applicationName} main`:"remote agent":(h=`${"  ".repeat(o)} ${r.name}`,r.name==="window"&&(h=`${h} (${s.get(r.pid)})`));const d=process.platform==="win32"?r.mem:R.totalmem()*(r.mem/100);n.push(`${r.load.toFixed(0).padStart(5," ")}	${(d/E.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${h}`),Array.isArray(r.children)&&r.children.forEach(m=>this.formatProcessItem(t,s,n,m,o+1))}async reportWorkspaceStats(t){for(const{uri:s}of t.folders){const n=y.URI.revive(s);if(n.scheme!==T.Schemas.file)continue;const r=n.fsPath;try{const o=await f(r,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),o.fileTypes.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:l.name,count:l.count})}),o.launchConfigFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:l.name,count:l.count})}),o.configFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:l.name,count:l.count})})}catch{}}}};c=he([Q(0,p.ITelemetryService),Q(1,u.IProductService)],c),e.DiagnosticsService=c}),define(te[196],ne([0,1,17,6,27,8,3,2,4,7,122,28,34,10,42,20]),function(J,e,R,k,D,T,L,P,y,I,i,C,g,E,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.INSTALL_ERROR_LOCAL=e.ERROR_UNKNOWN=e.INSTALL_ERROR_VALIDATING=void 0,e.INSTALL_ERROR_VALIDATING="validating",e.ERROR_UNKNOWN="unknown",e.INSTALL_ERROR_LOCAL="local";let f=class extends P.Disposable{constructor(a,t,s){super();this.galleryService=a,this.telemetryService=t,this.logService=s,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new L.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new L.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new L.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new L.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(n=>n.cancel()),this.uninstallingExtensions.forEach(n=>n.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(a){const t=await this.getTargetPlatform();return a.allTargetPlatforms.some(s=>(0,C.isTargetPlatformCompatible)(s,a.allTargetPlatforms,t))}async installFromGallery(a,t={}){if(!this.galleryService.isEnabled())throw new Error(i.localize(0,null));if(!await this.canInstall(a)){const n=await this.getTargetPlatform(),r=new C.ExtensionManagementError(i.localize(1,null,a.identifier.id,u.default.nameLong,(0,C.TargetPlatformToString)(n)),e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Cannot install extension.",a.identifier.id,r.message),v(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(a),void 0,r),r}try{a=await this.checkAndGetCompatibleVersion(a,!t.installGivenVersion)}catch(n){throw this.logService.error((0,T.getErrorMessage)(n)),v(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(a),void 0,n),n}const s=await this.galleryService.getManifest(a,D.CancellationToken.None);if(s===null){const n=new C.ExtensionManagementError(`Missing manifest for extension ${a.identifier.id}`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",a.identifier.id,n.message),v(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(a),void 0,n),n}if(s.version!==a.version){const n=new C.ExtensionManagementError(`Cannot install '${a.identifier.id}' extension because of version mismatch in Marketplace`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error(n.message),v(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(a),void 0,n),n}return this.installExtension(s,a,t)}async uninstall(a,t={}){return this.logService.trace("ExtensionManagementService#uninstall",a.identifier.id),this.unininstallExtension(a,t)}async reinstallFromGallery(a){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",a.identifier.id),!this.galleryService.isEnabled())throw new Error(i.localize(2,null));const t=await this.findGalleryExtension(a);if(!t)throw new Error(i.localize(3,null));await this.createUninstallExtensionTask(a,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(t)}getExtensionsReport(){const a=new Date().getTime();return(!this.reportedExtensions||a-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=a),this.reportedExtensions}registerParticipant(a){this.participants.push(a)}async installExtension(a,t,s){if(!I.URI.isUri(t)){let h=this.installingExtensions.get(new g.ExtensionIdentifierWithVersion(t.identifier,t.version).key());if(h)return this.logService.info("Extensions is already requested to install",t.identifier.id),h.waitUntilTaskIsFinished();s={...s,installOnlyNewlyAddedFromExtensionPack:!0}}const n=[],r=[],o=this.createInstallExtensionTask(a,t,s);I.URI.isUri(t)||this.installingExtensions.set(new g.ExtensionIdentifierWithVersion(o.identifier,a.version).key(),o),this._onInstallExtension.fire({identifier:o.identifier,source:t}),this.logService.info("Installing extension:",o.identifier.id),n.push({task:o,manifest:a});let l=!1;try{if(s.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",o.identifier.id);else try{const d=await this.getAllDepsAndPackExtensionsToInstall(o.identifier,a,!!s.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:m,manifest:A}of d)if(l=l||!!A.extensionDependencies?.some(_=>(0,g.areSameExtensions)({id:_},o.identifier)),this.installingExtensions.has(new g.ExtensionIdentifierWithVersion(m.identifier,m.version).key()))this.logService.info("Extension is already requested to install",m.identifier.id);else{const _=this.createInstallExtensionTask(A,m,{...s,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new g.ExtensionIdentifierWithVersion(_.identifier,A.version).key(),_),this._onInstallExtension.fire({identifier:_.identifier,source:m}),this.logService.info("Installing extension:",_.identifier.id),n.push({task:_,manifest:A})}}catch(d){if(I.URI.isUri(o.source))(0,R.isNonEmptyArray)(a.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",o.identifier.id,d.message),(0,R.isNonEmptyArray)(a.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",o.identifier.id,d.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",o.identifier.id),this.logService.error(d),d}const h=n.reduce((d,{task:m,manifest:A})=>(d.set(m.identifier.id.toLowerCase(),{task:m,manifest:A}),d),new Map);for(;h.size;){let d;const m=[...h.values()].filter(({manifest:A})=>!A.extensionDependencies?.some(_=>h.has(_.toLowerCase())));m.length?d=h.size===1?m:m.filter(({task:A})=>!(A===o&&!l)):(this.logService.info("Found extensions with circular dependencies",m.map(({task:A})=>A.identifier.id)),d=[...h.values()]),await this.joinAllSettled(d.map(async({task:A})=>{const _=new Date().getTime();try{const w=await A.run();if(await this.joinAllSettled(this.participants.map(O=>O.postInstall(w,A.source,s,D.CancellationToken.None))),!I.URI.isUri(A.source)&&(v(this.telemetryService,A.operation===2?"extensionGallery:update":"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(A.source),new Date().getTime()-_,void 0),y.isWeb&&A.operation===1))try{await this.galleryService.reportStatistic(w.manifest.publisher,w.manifest.name,w.manifest.version,"install")}catch(O){}r.push({local:w,identifier:A.identifier,operation:A.operation,source:A.source})}catch(w){throw I.URI.isUri(A.source)||v(this.telemetryService,A.operation===2?"extensionGallery:update":"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(A.source),new Date().getTime()-_,w),this.logService.error("Error while installing the extension:",A.identifier.id),this.logService.error(w),w}finally{h.delete(A.identifier.id.toLowerCase())}}))}return r.forEach(({identifier:d})=>this.logService.info("Extension installed successfully:",d.id)),this._onDidInstallExtensions.fire(r),r.filter(({identifier:d})=>(0,g.areSameExtensions)(d,o.identifier))[0].local}catch(h){if(n.forEach(({task:d})=>d.cancel()),r.length)try{const d=await Promise.allSettled(r.map(({local:m})=>this.createUninstallExtensionTask(m,{versionOnly:!0}).run()));for(let m=0;m<d.length;m++){const A=d[m],{identifier:_}=r[m];A.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",_.id):this.logService.warn("Rollback: Error while uninstalling extension",_.id,(0,T.getErrorMessage)(A.reason))}}catch(d){this.logService.warn("Error while rolling back extensions",(0,T.getErrorMessage)(d),r.map(({identifier:m})=>m.id))}throw this.logService.error("Failed to install extension:",o.identifier.id,(0,T.getErrorMessage)(h)),this._onDidInstallExtensions.fire(n.map(({task:d})=>({identifier:d.identifier,operation:1,source:d.source}))),h instanceof Error&&(h.name=h&&h.code?h.code:e.ERROR_UNKNOWN),h}finally{for(const{task:h,manifest:d}of n)if(!I.URI.isUri(h.source)){const m=new g.ExtensionIdentifierWithVersion(h.identifier,d.version).key();this.installingExtensions.delete(m)||this.logService.warn("Installation task is not found in the cache",m)}}}async joinAllSettled(a){const t=[],s=[],n=await Promise.allSettled(a);for(const r of n)r.status==="fulfilled"?t.push(r.value):s.push(r.reason);if(s.length)throw b(s);return t}async getAllDepsAndPackExtensionsToInstall(a,t,s){if(!this.galleryService.isEnabled())return[];let n=await this.getInstalled();const r=[a,...n.map(h=>h.identifier)],o=[],l=async(h,d)=>{const m=d.extensionDependencies||[],A=[...m];if(d.extensionPack){const _=s?n.find(w=>(0,g.areSameExtensions)(w.identifier,h)):void 0;for(const w of d.extensionPack)_&&_.manifest.extensionPack&&_.manifest.extensionPack.some(O=>(0,g.areSameExtensions)({id:O},{id:w}))||A.every(O=>!(0,g.areSameExtensions)({id:O},{id:w}))&&A.push(w)}if(A.length){const _=[...r,...o.map(O=>O.gallery.identifier)],w=A.filter(O=>_.every(U=>!(0,g.areSameExtensions)(U,{id:O})));if(w.length){const O=await this.galleryService.query({names:w,pageSize:A.length},D.CancellationToken.None);for(const U of O.firstPage){if(_.find(V=>(0,g.areSameExtensions)(V,U.identifier)))continue;if(!m.some(V=>(0,g.areSameExtensions)({id:V},U.identifier))&&!await this.canInstall(U)){this.logService.info("Skipping the packed extension as it cannot be installed",U.identifier.id);continue}const Y=await this.checkAndGetCompatibleVersion(U,!0),M=await this.galleryService.getManifest(Y,D.CancellationToken.None);if(M===null)throw new C.ExtensionManagementError(`Missing manifest for extension ${Y.identifier.id}`,e.INSTALL_ERROR_VALIDATING);o.push({gallery:Y,manifest:M}),await l(Y.identifier,M)}}}};return await l(a,t),n=await this.getInstalled(),o.filter(h=>!n.some(d=>(0,g.areSameExtensions)(d.identifier,h.gallery.identifier)))}async checkAndGetCompatibleVersion(a,t){if(await this.isMalicious(a))throw new C.ExtensionManagementError(i.localize(4,null,a.identifier.id),C.INSTALL_ERROR_MALICIOUS);const s=await this.getCompatibleVersion(a,t);if(!s)throw new C.ExtensionManagementError(i.localize(5,null,a.identifier.id,u.default.version),C.INSTALL_ERROR_INCOMPATIBLE);return s}async getCompatibleVersion(a,t){const s=await this.getTargetPlatform();let n=null;return await this.galleryService.isExtensionCompatible(a,s)&&(n=a),!n&&t&&(n=await this.galleryService.getCompatibleExtension(a,s)),n}async isMalicious(a){const t=await this.getExtensionsReport();return(0,g.getMaliciousExtensionsSet)(t).has(a.identifier.id)}async unininstallExtension(a,t){const s=this.uninstallingExtensions.get(a.identifier.id.toLowerCase());if(s)return this.logService.info("Extensions is already requested to uninstall",a.identifier.id),s.waitUntilTaskIsFinished();const n=(h,d)=>{const m=this.createUninstallExtensionTask(h,d);return this.uninstallingExtensions.set(m.extension.identifier.id.toLowerCase(),m),this.logService.info("Uninstalling extension:",h.identifier.id),this._onUninstallExtension.fire(h.identifier),m},r=(h,d)=>{d?this.logService.error("Failed to uninstall extension:",h.identifier.id,d.message):this.logService.info("Successfully uninstalled extension:",h.identifier.id),v(this.telemetryService,"extensionGallery:uninstall",(0,g.getLocalExtensionTelemetryData)(h),void 0,d),this._onDidUninstallExtension.fire({identifier:h.identifier,error:d?.code})},o=[],l=[];try{o.push(n(a,{}));const h=await this.getInstalled(1);if(t.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",a.identifier.id);else{const d=this.getAllPackExtensionsToUninstall(a,h);for(const m of d)this.uninstallingExtensions.has(m.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",m.identifier.id):o.push(n(m,{}))}t.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",a.identifier.id):this.checkForDependents(o.map(d=>d.extension),h,a),await this.joinAllSettled(o.map(async d=>{try{if(await d.run(),await this.joinAllSettled(this.participants.map(m=>m.postUninstall(d.extension,t,D.CancellationToken.None))),d.extension.identifier.uuid)try{await this.galleryService.reportStatistic(d.extension.manifest.publisher,d.extension.manifest.name,d.extension.manifest.version,"uninstall")}catch(m){}r(d.extension)}catch(m){const A=m instanceof C.ExtensionManagementError?m:new C.ExtensionManagementError((0,T.getErrorMessage)(m),e.ERROR_UNKNOWN);throw r(d.extension,A),A}finally{l.push(d)}}))}catch(h){const d=h instanceof C.ExtensionManagementError?h:new C.ExtensionManagementError((0,T.getErrorMessage)(h),e.ERROR_UNKNOWN);for(const m of o){try{m.cancel()}catch(A){}l.includes(m)||r(m.extension,d)}throw d}finally{for(const h of o)this.uninstallingExtensions.delete(h.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",h.extension.identifier.id)}}checkForDependents(a,t,s){for(const n of a){const r=this.getDependents(n,t);if(r.length){const o=r.filter(l=>!a.some(h=>(0,g.areSameExtensions)(h.identifier,l.identifier)));if(o.length)throw new Error(this.getDependentsErrorMessage(n,o,s))}}}getDependentsErrorMessage(a,t,s){return s===a?t.length===1?i.localize(6,null,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name):t.length===2?i.localize(7,null,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):i.localize(8,null,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):t.length===1?i.localize(9,null,s.manifest.displayName||s.manifest.name,a.manifest.displayName||a.manifest.name,t[0].manifest.displayName||t[0].manifest.name):t.length===2?i.localize(10,null,s.manifest.displayName||s.manifest.name,a.manifest.displayName||a.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):i.localize(11,null,s.manifest.displayName||s.manifest.name,a.manifest.displayName||a.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name)}getAllPackExtensionsToUninstall(a,t,s=[]){if(s.indexOf(a)!==-1)return[];s.push(a);const n=a.manifest.extensionPack?a.manifest.extensionPack:[];if(n.length){const r=t.filter(l=>!l.isBuiltin&&n.some(h=>(0,g.areSameExtensions)({id:h},l.identifier))),o=[];for(const l of r)o.push(...this.getAllPackExtensionsToUninstall(l,t,s));return[...r,...o]}return[]}getDependents(a,t){return t.filter(s=>s.manifest.extensionDependencies&&s.manifest.extensionDependencies.some(n=>(0,g.areSameExtensions)({id:n},a.identifier)))}async findGalleryExtension(a){if(a.identifier.uuid){const t=await this.findGalleryExtensionById(a.identifier.uuid);return t||this.findGalleryExtensionByName(a.identifier.id)}return this.findGalleryExtensionByName(a.identifier.id)}async findGalleryExtensionById(a){return(await this.galleryService.query({ids:[a],pageSize:1},D.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(a){return(await this.galleryService.query({names:[a],pageSize:1},D.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const a=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${a.length} reported extensions from service`),a}catch(a){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};f=he([Q(0,C.IExtensionGalleryService),Q(1,p.ITelemetryService),Q(2,E.ILogService)],f),e.AbstractExtensionManagementService=f;function b(c){const a=Array.isArray(c)?c:[c];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((t,s)=>new Error(`${t.message}${t.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}e.joinErrors=b;function v(c,a,t,s,n){const r=n?n instanceof C.ExtensionManagementError?n.code:e.ERROR_UNKNOWN:void 0;c.publicLogError(a,{...t,success:!n,duration:s,errorcode:r})}e.reportTelemetry=v;class S{constructor(){this.barrier=new k.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,k.createCancelablePromise)(a=>this.doRun(a))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,k.createCancelablePromise)(a=>new Promise((t,s)=>{const n=a.onCancellationRequested(()=>{n.dispose(),s((0,T.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=S}),define(te[197],ne([0,1,17,6,65,3,9,4,31,7,124,13,28,189,79,14,10,60,29,43,23,20]),function(J,e,R,k,D,T,L,P,y,I,i,C,g,E,u,p,f,b,v,S,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",s="extensionTips/lastPromptedMediumImpExeTime";let n=class extends E.ExtensionTipsService{constructor(o,l,h,d,m,A,_,w,O,U){super(_,w,O,U);this.environmentService=o,this.telemetryService=l,this.extensionManagementService=h,this.storageService=d,this.nativeHostService=m,this.extensionRecommendationNotificationService=A,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,w.exeBasedExtensionTips&&(0,D.forEach)(w.exeBasedExtensionTips,({key:$,value:Y})=>{const M=[],V=[],j=[];(0,D.forEach)(Y.recommendations,({key:z,value:q})=>{q.important?Y.important?M.push({extensionId:z,extensionName:q.name,isExtensionPack:!!q.isExtensionPack}):V.push({extensionId:z,extensionName:q.name,isExtensionPack:!!q.isExtensionPack}):j.push({extensionId:z,extensionName:q.name,isExtensionPack:!!q.isExtensionPack})}),M.length&&this.highImportanceExecutableTips.set($,{exeFriendlyName:Y.friendlyName,windowsPath:Y.windowsPath,recommendations:M}),V.length&&this.mediumImportanceExecutableTips.set($,{exeFriendlyName:Y.friendlyName,windowsPath:Y.windowsPath,recommendations:V}),j.length&&this.allOtherExecutableTips.set($,{exeFriendlyName:Y.friendlyName,windowsPath:Y.windowsPath,recommendations:j})}),(0,k.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...o,...l]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),h=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(o,h),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(l,h)}groupImportantTipsByExe(o,l){const h=new Map;o.forEach(w=>h.set(w.extensionId.toLowerCase(),w));const{installed:d,uninstalled:m}=this.groupByInstalled([...h.keys()],l);for(const w of d){const O=h.get(w);O&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:w,exeName:O.exeName})}for(const w of m){const O=h.get(w);O&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:w,exeName:O.exeName})}const A=this.getPromptedExecutableTips(),_=new Map;for(const w of m){const O=h.get(w);if(O&&(!A[O.exeName]||!A[O.exeName].includes(O.extensionId))){let U=_.get(O.exeName);U||(U=[],_.set(O.exeName,U)),U.push(O)}}return _}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[o,l]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(l).then(h=>{switch(h){case"reacted":this.addToRecommendedExecutables(l[0].exeName,l);break;case"ignored":this.highImportanceTipsByExe.delete(o);break;case"incompatibleWindow":const d=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(d(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const m=this._register((0,k.disposableTimeout)(()=>{m.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const o=this.getLastPromptedMediumExeTime(),l=Date.now()-o,h=7*24*60*60*1e3;if(l<h){const A=this._register((0,k.disposableTimeout)(()=>{A.dispose(),this.promptMediumImportanceExeBasedTip()},h-l));return}const[d,m]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(m).then(A=>{switch(A){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(d),this.addToRecommendedExecutables(m[0].exeName,m);const _=this._register((0,k.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},h));break;case"ignored":this.mediumImportanceTipsByExe.delete(d),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const w=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(w(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const O=this._register((0,k.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(o){const l=o.map(({extensionId:d})=>d.toLowerCase()),h=(0,i.localize)(0,null,o[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(l,h,`@exe:"${o[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let o=this.storageService.getNumber(s,0);return o||(o=Date.now(),this.updateLastPromptedMediumExeTime(o)),o}updateLastPromptedMediumExeTime(o){this.storageService.store(s,o,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(o,l){const h=this.getPromptedExecutableTips();h[o]=l.map(({extensionId:d})=>d.toLowerCase()),this.storageService.store(t,JSON.stringify(h),0,0)}groupByInstalled(o,l){const h=[],d=[],m=l.reduce((A,_)=>(A.add(_.identifier.id.toLowerCase()),A),new Set);return o.forEach(A=>{m.has(A.toLowerCase())?h.push(A):d.push(A)}),{installed:h,uninstalled:d}}async getValidExecutableBasedExtensionTips(o){const l=[],h=new Map;for(const d of o.keys()){const m=o.get(d);if(!m||!(0,R.isNonEmptyArray)(m.recommendations))continue;const A=[];P.isWindows?m.windowsPath&&A.push(m.windowsPath.replace("%USERPROFILE%",y.env.USERPROFILE).replace("%ProgramFiles(x86)%",y.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",y.env.ProgramFiles).replace("%APPDATA%",y.env.APPDATA).replace("%WINDIR%",y.env.WINDIR)):(A.push((0,L.join)("/usr/local/bin",d)),A.push((0,L.join)("/usr/bin",d)),A.push((0,L.join)(this.environmentService.userHome.fsPath,d)));for(const _ of A){let w=h.get(_);if(w===void 0&&(w=await this.fileService.exists(I.URI.file(_)),h.set(_,w)),w)for(const{extensionId:O,extensionName:U,isExtensionPack:$}of m.recommendations)l.push({extensionId:O,extensionName:U,isExtensionPack:$,exeName:d,exeFriendlyName:m.exeFriendlyName,windowsPath:m.windowsPath})}}return l}};n=he([Q(0,C.INativeEnvironmentService),Q(1,a.ITelemetryService),Q(2,g.IExtensionManagementService),Q(3,c.IStorageService),Q(4,b.INativeHostService),Q(5,u.IExtensionRecommendationNotificationService),Q(6,p.IFileService),Q(7,v.IProductService),Q(8,S.IRequestService),Q(9,f.ILogService)],n),e.ExtensionTipsService=n}),define(te[88],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class R{constructor(T){this.appender=T}listen(T,L){throw new Error(`Event not found: ${L}`)}call(T,L,{eventName:P,data:y}){return this.appender.log(P,y),Promise.resolve(null)}}e.TelemetryAppenderChannel=R;class k{constructor(T){this.channel=T}log(T,L){return this.channel.call("log",{eventName:T,data:L}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=k}),define(te[46],ne([0,1,26,18,22,20]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(p,f){return Promise.resolve(void 0)}publicLog2(p,f){return this.publicLog(p,f)}publicLogError(p,f){return Promise.resolve(void 0)}publicLogError2(p,f){return this.publicLogError(p,f)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class L{async publicLog(f,b,v){}async publicLogError(f,b,v){}}e.NullEndpointTelemetryService=L,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function P(p,f){return f.onDidChangeConfiguration(b=>{b.source!==6&&p.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(b.source),configurationKeys:E(b.sourceConfig)})})}e.configurationTelemetry=P;function y(p,f){return!(f.disableTelemetry||!p.enableTelemetry)}e.supportsTelemetry=y;function I(p){const f=p.getValue(T.TELEMETRY_SETTING_ID),b=p.getValue(T.TELEMETRY_OLD_SETTING_ID);if(b!==void 0&&b===!1)return 0;switch(f??"on"){case"on":return 3;case"error":return 2;case"off":return 0}}e.getTelemetryLevel=I;function i(p){const f=Object.create(null),b=Object.create(null),v=Object.create(null);g(p,v);for(let S in v){S=S.length>150?S.substr(S.length-149):S;const c=v[S];typeof c=="number"?b[S]=c:typeof c=="boolean"?b[S]=c?1:0:typeof c=="string"?f[S]=c.substring(0,1023):typeof c!="undefined"&&c!==null&&(f[S]=c)}return{properties:f,measurements:b}}e.validateTelemetryData=i;function C(p){if(!p)return"none";let f="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(v=>{p.indexOf(`${v}+`)===0&&(f=v)}),f}e.cleanRemoteAuthority=C;function g(p,f,b=0,v){if(!!p)for(let S of Object.getOwnPropertyNames(p)){const c=p[S],a=v?v+S:S;Array.isArray(c)?f[a]=(0,R.safeStringify)(c):c instanceof Date?f[a]=c.toISOString():(0,k.isObject)(c)?b<2?g(c,f,b+1,a+"."):f[a]=(0,R.safeStringify)(c):f[a]=c}}function E(p){if(!p)return[];const f=[];return u(f,"",p),f}function u(p,f,b){b&&typeof b=="object"&&!Array.isArray(b)?Object.keys(b).forEach(v=>u(p,f?`${f}.${v}`:v,b[v])):p.push(f)}}),define(te[198],ne([0,1,17,27,8,26,4,31,7,22,13,28,34,76,14,10,29,43,45,23,20,46]),function(J,e,R,k,D,T,L,P,y,I,i,C,g,E,u,p,f,b,v,S,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const t=L.isWeb?"web":(0,C.getTargetPlatform)(L.platform,P.arch);var s;(function(B){B[B.None=0]="None",B[B.IncludeVersions=1]="IncludeVersions",B[B.IncludeFiles=2]="IncludeFiles",B[B.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",B[B.IncludeSharedAccounts=8]="IncludeSharedAccounts",B[B.IncludeVersionProperties=16]="IncludeVersionProperties",B[B.ExcludeNonValidated=32]="ExcludeNonValidated",B[B.IncludeInstallationTargets=64]="IncludeInstallationTargets",B[B.IncludeAssetUri=128]="IncludeAssetUri",B[B.IncludeStatistics=256]="IncludeStatistics",B[B.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",B[B.Unpublished=4096]="Unpublished"})(s||(s={}));function n(...B){return String(B.reduce((H,ie)=>H|ie,0))}var r;(function(B){B[B.Tag=1]="Tag",B[B.ExtensionId=4]="ExtensionId",B[B.Category=5]="Category",B[B.ExtensionName=7]="ExtensionName",B[B.Target=8]="Target",B[B.Featured=9]="Featured",B[B.SearchText=10]="SearchText",B[B.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},d={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class m{constructor(H=d){this.state=H}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(H,ie=this.state.pageSize){return new m({...this.state,pageNumber:H,pageSize:ie})}withFilter(H,...ie){const re=[...this.state.criteria,...ie.length?ie.map(ae=>({filterType:H,value:ae})):[{filterType:H}]];return new m({...this.state,criteria:re})}withSortBy(H){return new m({...this.state,sortBy:H})}withSortOrder(H){return new m({...this.state,sortOrder:H})}withFlags(...H){return new m({...this.state,flags:H.reduce((ie,re)=>ie|re,0)})}withAssetTypes(...H){return new m({...this.state,assetTypes:H})}get raw(){const{criteria:H,pageNumber:ie,pageSize:re,sortBy:ae,sortOrder:ue,flags:fe,assetTypes:ge}=this.state;return{filters:[{criteria:H,pageNumber:ie,pageSize:re,sortBy:ae,sortOrder:ue}],assetTypes:ge,flags:fe}}get searchText(){const H=this.state.criteria.filter(ie=>ie.filterType===r.SearchText)[0];return H&&H.value?H.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(H=>String(H.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function A(B,H){const ie=(B||[]).filter(re=>re.statisticName===H)[0];return ie?ie.value:0}function _(B){const H="Microsoft.VisualStudio.Code.Translation.";return B.files.filter(re=>re.assetType.indexOf(H)===0).reduce((re,ae)=>{const ue=$(B,ae.assetType);return ue&&re.push([ae.assetType.substring(H.length),ue]),re},[])}function w(B){if(B.properties){const H=B.properties.filter(ae=>ae.key===o.Repository),ie=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),re=H.filter(ae=>ie.test(ae.value))[0];return re?{uri:re.value,fallbackUri:re.value}:null}return $(B,o.Repository)}function O(B){return{uri:`${B.fallbackAssetUri}/${o.VSIX}?redirect=true${B.targetPlatform?`&targetPlatform=${B.targetPlatform}`:""}`,fallbackUri:`${B.fallbackAssetUri}/${o.VSIX}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`}}function U(B){const H=$(B,o.Icon);if(H)return H;const ie=C.DefaultIconPath;return{uri:ie,fallbackUri:ie}}function $(B,H){return B.files.filter(re=>re.assetType===H)[0]?{uri:`${B.assetUri}/${H}`,fallbackUri:`${B.fallbackAssetUri}/${H}`}:null}function Y(B,H){const ie=B.properties?B.properties.filter(ae=>ae.key===H):[],re=ie.length>0&&ie[0].value;return re?re.split(",").map(ae=>(0,g.adoptToGalleryExtensionId)(ae)):[]}function M(B){const H=B.properties?B.properties.filter(ie=>ie.key===l.Engine):[];return H.length>0&&H[0].value||""}function V(B){const H=B.properties?B.properties.filter(re=>re.key===l.LocalizedLanguages):[],ie=H.length>0&&H[0].value||"";return ie?ie.split(","):[]}function j(B){return B.indexOf("preview")!==-1}function z(B){return B.targetPlatform?(0,C.toTargetPlatform)(B.targetPlatform):"undefined"}function q(B){const H=(0,R.distinct)(B.versions.map(z)),ie=!!B.tags?.includes(C.WEB_EXTENSION_TAG),re=H.indexOf("web");return ie?re===-1&&H.push("web"):re!==-1&&H.splice(re,1),H}function F(B,H){const ie=(0,C.getFallbackTargetPlarforms)(H);for(let re=0;re<B.length;re++){const ae=B[re];if(ae.version===B[re-1]?.version){let ue=re;const fe=z(ae);if(fe===H)for(;ue>0&&B[ue-1].version===ae.version;)ue--;else if(ie.includes(fe))for(;ue>0&&B[ue-1].version===ae.version&&z(B[ue-1])!==H;)ue--;ue!==re&&(B.splice(re,1),B.splice(ue,0,ae))}}return B}e.sortExtensionVersions=F;function G(B,H,ie,re,ae){const ue=q(B);let fe=B.versions[0];return fe=B.versions.find(ge=>ge.version===fe.version&&(0,C.isTargetPlatformCompatible)(z(ge),ue,ae))||fe,x(B,fe,ue,H,ie,re)}function x(B,H,ie,re,ae,ue){const fe={manifest:$(H,o.Manifest),readme:$(H,o.Details),changelog:$(H,o.Changelog),license:$(H,o.License),repository:w(H),download:O(H),icon:U(H),coreTranslations:_(H)};return{identifier:{id:(0,g.getGalleryExtensionId)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},name:B.extensionName,version:H.version,displayName:B.displayName,publisherId:B.publisher.publisherId,publisher:B.publisher.publisherName,publisherDisplayName:B.publisher.displayName,description:B.shortDescription||"",installCount:A(B.statistics,"install"),rating:A(B.statistics,"averagerating"),ratingCount:A(B.statistics,"ratingcount"),categories:B.categories||[],tags:B.tags||[],releaseDate:Date.parse(B.releaseDate),lastUpdated:Date.parse(B.lastUpdated),allTargetPlatforms:ie,assets:fe,properties:{dependencies:Y(H,l.Dependency),extensionPack:Y(H,l.ExtensionPack),engine:M(H),localizedLanguages:V(H),targetPlatform:z(H)},preview:j(B.flags),telemetryData:{index:(ae.pageNumber-1)*ae.pageSize+re,querySource:ue}}}let N=class{constructor(H,ie,re,ae,ue,fe,ge,Ie){this.requestService=ie,this.logService=re,this.environmentService=ae,this.telemetryService=ue,this.fileService=fe,this.productService=ge,this.configurationService=Ie;const Pe=ge.extensionsGallery;this.extensionsGalleryUrl=Pe&&Pe.serviceUrl,this.extensionsControlUrl=Pe&&Pe.controlUrl,this.commonHeadersPromise=Z(ge.version,ge,this.environmentService,this.configurationService,this.fileService,H)}api(H=""){return`${this.extensionsGalleryUrl}${H}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(H,ie){const re=[];let ae=new m().withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,H.length).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExtensionName,...H.map(({id:fe})=>fe.toLowerCase()));H.every(fe=>!fe.version)&&(ae=ae.withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties,s.IncludeLatestVersionOnly));const{galleryExtensions:ue}=await this.queryGallery(ae,t,k.CancellationToken.None);for(let fe=0;fe<ue.length;fe++){const ge=ue[fe];if(!ge.versions.length)continue;const Ie=(0,g.getGalleryExtensionId)(ge.publisher.publisherName,ge.extensionName),Pe=H.find(Ee=>(0,g.areSameExtensions)(Ee,{id:Ie}))?.version;if(Pe){const Ee=ge.versions.find(_e=>_e.version===Pe);Ee&&re.push(x(ge,Ee,q(ge),fe,ae))}else re.push(G(ge,fe,ae,void 0,t))}return re}async getCompatibleExtension(H,ie){const re=(0,C.isIExtensionIdentifier)(H)?null:H;if(re){if((0,C.isNotWebExtensionInWebTargetPlatform)(re.allTargetPlatforms,ie))return null;if(await this.isExtensionCompatible(re,ie))return re}const{id:ae,uuid:ue}=re?re.identifier:H;let fe=new m().withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");ue?fe=fe.withFilter(r.ExtensionId,ue):fe=fe.withFilter(r.ExtensionName,ae);const{galleryExtensions:ge}=await this.queryGallery(fe,ie,k.CancellationToken.None),[Ie]=ge;if(!Ie||!Ie.versions.length)return null;const Pe=q(Ie);if((0,C.isNotWebExtensionInWebTargetPlatform)(Pe,ie))return null;for(let Ee of Ie.versions){if(!M(Ee)){const _e=await this.getEngine(Ee);Ee={...Ee,properties:[...Ee.properties||[],{key:l.Engine,value:_e}]}}if(await this.isRawExtensionVersionCompatible(Ee,Pe,ie))return x(Ie,Ee,Pe,0,fe)}return null}async isExtensionCompatible(H,ie){if(!(0,C.isTargetPlatformCompatible)(H.properties.targetPlatform,H.allTargetPlatforms,ie))return!1;let re=H.properties.engine;if(!re){const ae=await this.getManifest(H,k.CancellationToken.None);if(!ae)throw new Error("Manifest was not found");re=ae.engines.vscode}return(0,E.isEngineValid)(re,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(H,ie,re){if(!(0,C.isTargetPlatformCompatible)(z(H),ie,re))return!1;const ae=await this.getEngine(H);return(0,E.isEngineValid)(ae,this.productService.version,this.productService.date)}async query(H,ie){const re=k.CancellationToken.isCancellationToken(H)?{}:H,ae=k.CancellationToken.isCancellationToken(H)?H:ie;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let ue=re.text||"";const fe=(0,T.getOrDefault)(re,De=>De.pageSize,50);let ge=new m().withFlags(s.IncludeLatestVersionOnly,s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,fe).withFilter(r.Target,"Microsoft.VisualStudio.Code");ue?(ue=ue.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(De,Te,Fe)=>(ge=ge.withFilter(r.Category,Fe||Te),"")),ue=ue.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(De,Te,Fe)=>(ge=ge.withFilter(r.Tag,Fe||Te),"")),ue=ue.replace(/\bfeatured(\s+|\b|$)/g,()=>(ge=ge.withFilter(r.Featured),"")),ue=ue.trim(),ue&&(ue=ue.length<200?ue:ue.substring(0,200),ge=ge.withFilter(r.SearchText,ue)),ge=ge.withSortBy(0)):re.ids?ge=ge.withFilter(r.ExtensionId,...re.ids):re.names?ge=ge.withFilter(r.ExtensionName,...re.names):ge=ge.withSortBy(4),typeof re.sortBy=="number"&&(ge=ge.withSortBy(re.sortBy)),typeof re.sortOrder=="number"&&(ge=ge.withSortOrder(re.sortOrder));const{galleryExtensions:Ie,total:Pe}=await this.queryGallery(ge,t,ae),Ee=Ie.map((De,Te)=>G(De,Te,ge,re.source,t)),_e=async(De,Te)=>{if(Te.isCancellationRequested)throw(0,D.canceled)();const Fe=ge.withPage(De+1),{galleryExtensions:Ne}=await this.queryGallery(Fe,t,Te);return Ne.map((ze,xe)=>G(ze,xe,Fe,re.source,t))};return{firstPage:Ee,total:Pe,pageSize:ge.pageSize,getPage:_e}}async queryGallery(H,ie,re){if(!this.isEnabled())throw new Error("No extension gallery service configured.");H=H.withFlags(H.flags,s.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,n(s.Unpublished));const ae=await this.commonHeadersPromise,ue=JSON.stringify(H.raw),fe={...ae,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ue.length)},ge=new Date().getTime();let Ie,Pe,Ee=0;try{if(Ie=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:ue,headers:fe},re),Ie.res.statusCode&&Ie.res.statusCode>=400&&Ie.res.statusCode<500)return{galleryExtensions:[],total:Ee};const _e=await(0,b.asJson)(Ie);if(_e){const De=_e.results[0],Te=De.extensions;Te.forEach(Ne=>F(Ne.versions,ie));const Fe=De.resultMetadata&&De.resultMetadata.filter(Ne=>Ne.metadataType==="ResultCount")[0];return Ee=Fe&&Fe.metadataItems.filter(Ne=>Ne.name==="TotalCount")[0].count||0,{galleryExtensions:Te,total:Ee}}return{galleryExtensions:[],total:Ee}}catch(_e){throw Pe=_e,_e}finally{this.telemetryService.publicLog2("galleryService:query",{...H.telemetryData,requestBodySize:String(ue.length),duration:new Date().getTime()-ge,success:!!Ie&&(0,b.isSuccess)(Ie),responseBodySize:Ie?.res.headers["Content-Length"],statusCode:Ie?String(Ie.res.statusCode):void 0,errorCode:Pe?(0,D.isPromiseCanceledError)(Pe)?"canceled":(0,D.getErrorMessage)(Pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Ee)})}}async reportStatistic(H,ie,re,ae){if(!this.isEnabled())return;const ue=L.isWeb?this.api(`/itemName/${H}.${ie}/version/${re}/statType/${ae==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${H}/extensions/${ie}/${re}/stats?statType=${ae}`),fe=L.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Ie={...await this.commonHeadersPromise,Accept:fe};try{await this.requestService.request({type:"POST",url:ue,headers:Ie},k.CancellationToken.None)}catch(Pe){}}async download(H,ie,re){this.logService.trace("ExtensionGalleryService#download",H.identifier.id);const ae=(0,g.getGalleryExtensionTelemetryData)(H),ue=new Date().getTime(),fe=Ee=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ae,duration:Ee}),ge=re===1?"install":re===2?"update":"",Ie=ge?{uri:`${H.assets.download.uri}${y.URI.parse(H.assets.download.uri).query?"&":"?"}${ge}=true`,fallbackUri:`${H.assets.download.fallbackUri}${y.URI.parse(H.assets.download.fallbackUri).query?"&":"?"}${ge}=true`}:H.assets.download,Pe=await this.getAsset(Ie);await this.fileService.writeFile(ie,Pe.stream),fe(new Date().getTime()-ue)}async getReadme(H,ie){if(H.assets.readme){const re=await this.getAsset(H.assets.readme,{},ie);return await(0,b.asText)(re)||""}return""}async getManifest(H,ie){if(H.assets.manifest){const re=await this.getAsset(H.assets.manifest,{},ie),ae=await(0,b.asText)(re);return ae?JSON.parse(ae):null}return null}async getManifestFromRawExtensionVersion(H,ie){const re=$(H,o.Manifest);if(!re)throw new Error("Manifest was not found");const ae={"Accept-Encoding":"gzip"},ue=await this.getAsset(re,{headers:ae});return await(0,b.asJson)(ue)}async getCoreTranslation(H,ie){const re=H.assets.coreTranslations.filter(ae=>ae[0]===ie.toUpperCase())[0];if(re){const ae=await this.getAsset(re[1]),ue=await(0,b.asText)(ae);return ue?JSON.parse(ue):null}return null}async getChangelog(H,ie){if(H.assets.changelog){const re=await this.getAsset(H.assets.changelog,{},ie);return await(0,b.asText)(re)||""}return""}async getAllCompatibleVersions(H,ie){let re=new m().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");H.identifier.uuid?re=re.withFilter(r.ExtensionId,H.identifier.uuid):re=re.withFilter(r.ExtensionName,H.identifier.id);const{galleryExtensions:ae}=await this.queryGallery(re,ie,k.CancellationToken.None);if(!ae.length)return[];const ue=q(ae[0]);if((0,C.isNotWebExtensionInWebTargetPlatform)(ue,ie))return[];const fe=[];for(const ge of ae[0].versions)try{fe[fe.length-1]?.version!==ge.version&&await this.isRawExtensionVersionCompatible(ge,ue,ie)&&fe.push({version:ge.version,date:ge.lastUpdated})}catch(Ie){}return fe}async getAsset(H,ie={},re=k.CancellationToken.None){const ae=await this.commonHeadersPromise,ue={type:"GET"},fe={...ae,...ie.headers||{}};ie={...ie,...ue,headers:fe};const ge=H.uri,Ie=H.fallbackUri,Pe={...ie,url:ge};try{const Ee=await this.requestService.request(Pe,re);if(Ee.res.statusCode===200)return Ee;const _e=await(0,b.asText)(Ee);throw new Error(`Expected 200, got back ${Ee.res.statusCode} instead.

${_e}`)}catch(Ee){if((0,D.isPromiseCanceledError)(Ee))throw Ee;const _e=(0,D.getErrorMessage)(Ee);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ge,message:_e});const De={...ie,url:Ie};return this.requestService.request(De,re)}}async getEngine(H){let ie=M(H);if(!ie){const re=await this.getManifestFromRawExtensionVersion(H,k.CancellationToken.None);if(!re)throw new Error("Manifest was not found");ie=re.engines.vscode}return ie}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const H=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},k.CancellationToken.None);if(H.res.statusCode!==200)throw new Error("Could not get extensions report.");const ie=await(0,b.asJson)(H),re=new Map;if(ie)for(const ae of ie.malicious){const ue=re.get(ae)||{id:{id:ae},malicious:!0,slow:!1};ue.malicious=!0,re.set(ae,ue)}return[...re.values()]}};N=he([Q(1,b.IRequestService),Q(2,p.ILogService),Q(3,i.IEnvironmentService),Q(4,c.ITelemetryService),Q(5,u.IFileService),Q(6,f.IProductService),Q(7,I.IConfigurationService)],N);let W=class extends N{constructor(H,ie,re,ae,ue,fe,ge,Ie){super(H,ie,re,ae,ue,fe,ge,Ie)}};W=he([Q(0,S.IStorageService),Q(1,b.IRequestService),Q(2,p.ILogService),Q(3,i.IEnvironmentService),Q(4,c.ITelemetryService),Q(5,u.IFileService),Q(6,f.IProductService),Q(7,I.IConfigurationService)],W),e.ExtensionGalleryService=W;let X=class extends N{constructor(H,ie,re,ae,ue,fe,ge){super(void 0,H,ie,re,ae,ue,fe,ge)}};X=he([Q(0,b.IRequestService),Q(1,p.ILogService),Q(2,i.IEnvironmentService),Q(3,c.ITelemetryService),Q(4,u.IFileService),Q(5,f.IProductService),Q(6,I.IConfigurationService)],X),e.ExtensionGalleryServiceWithNoStorageService=X;async function Z(B,H,ie,re,ae,ue){const fe={"X-Market-Client-Id":`VSCode ${B}`,"User-Agent":`VSCode ${B}`},ge=await(0,v.getServiceMachineId)(ie,ae,ue);return(0,a.supportsTelemetry)(H,ie)&&(0,a.getTelemetryLevel)(re)===3&&(fe["X-Market-User-Id"]=ge),fe}e.resolveMarketplaceHeaders=Z}),define(te[89],ne([0,1,2,13,10,46]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let L=class extends R.Disposable{constructor(y,I,i=""){super();this.prefix=i;const C=y.getLogger(I.telemetryLogResource);C?this.logger=this._register(C):(this.logger=this._register(y.createLogger(I.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(y,I){this.logger.trace(`${this.prefix}telemetry/${y}`,(0,T.validateTelemetryData)(I))}};L=he([Q(0,D.ILoggerService),Q(1,k.IEnvironmentService)],L),e.TelemetryLogAppender=L}),define(te[90],ne([0,1,2,26,4,25,134,22,39,42,35,20,46]),function(J,e,R,k,D,T,L,P,y,I,i,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let E=class{constructor(f,b){this._configurationService=b,this._experimentProperties={},this._disposables=new R.DisposableStore,this._cleanupPatterns=[],this._appenders=f.appenders,this._commonProperties=f.commonProperties||Promise.resolve({}),this._piiPaths=f.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!f.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let v of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(v),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(v=>{const S=/^[a-f0-9]+$/i.test(v["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!S})})}setExperimentProperty(f,b){this._experimentProperties[f]=b}_updateTelemetryLevel(){this._telemetryLevel=(0,g.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const f=await this._commonProperties;let b=f.sessionID,v=f["common.instanceId"],S=f["common.machineId"],c=f["common.firstSessionDate"],a=f["common.msftInternal"];return{sessionId:b,instanceId:v,machineId:S,firstSessionDate:c,msftInternal:a}}dispose(){this._disposables.dispose()}_log(f,b,v,S){return this.telemetryLevel<b?Promise.resolve(void 0):this._commonProperties.then(c=>{v=(0,k.mixin)(v,c),v=(0,k.mixin)(v,this._experimentProperties),v=(0,k.cloneAndChange)(v,a=>{if(typeof a=="string")return this._cleanupInfo(a,S)}),this._appenders.forEach(a=>a.log(f,v))},c=>{console.error(c)})}publicLog(f,b,v){return this._log(f,3,b,v)}publicLog2(f,b,v){return this.publicLog(f,b,v)}publicLogError(f,b){return this.sendErrorTelemetry?this._log(f,2,b,!0):Promise.resolve(void 0)}publicLogError2(f,b){return this.publicLogError(f,b)}_anonymizeFilePaths(f){let b=f;const v=[];for(let t of this._cleanupPatterns)for(;;){const s=t.exec(f);if(!s)break;v.push([s.index,t.lastIndex])}const S=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(b="";;){const t=c.exec(f);if(!t)break;!S.test(t[0])&&v.every(([s,n])=>t.index<s||t.index>=n)&&(b+=f.substring(a,t.index)+"<REDACTED: user-file-path>",a=c.lastIndex)}return a<f.length&&(b+=f.substr(a)),b}_removePropertiesWithPossibleUserInfo(f){if(!f)return f;const b=f.toLowerCase(),v=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(b)?"<REDACTED: secret>":v.test(b)?"<REDACTED: email>":f}_cleanupInfo(f,b){let v=f;b&&(v=this._anonymizeFilePaths(v));for(let S of this._cleanupPatterns)v=v.replace(S,"");return v=this._removePropertiesWithPossibleUserInfo(v),v}};E.IDLE_START_EVENT_NAME="UserIdleStart",E.IDLE_STOP_EVENT_NAME="UserIdleStop",E=he([Q(1,P.IConfigurationService)],E),e.TelemetryService=E;const u=D.isWeb?"":" "+(0,L.localize)(0,null);i.Registry.as(y.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(1,null),properties:{[C.TELEMETRY_SETTING_ID]:{type:"string",enum:["on","error","off"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null)],markdownDescription:I.default.privacyStatementUrl?(0,L.localize)(6,null,I.default.nameLong,I.default.privacyStatementUrl)+u:(0,L.localize)(5,null,I.default.nameLong)+u,default:"on",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),i.Registry.as(y.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(7,null),properties:{[C.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:I.default.privacyStatementUrl?(0,L.localize)(9,null,I.default.nameLong,I.default.privacyStatementUrl):(0,L.localize)(8,null,I.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(10,null,`\`#${C.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[199],ne([0,1,8,26,46]),function(J,e,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function T(P){const y=await new Promise((i,C)=>{J(["applicationinsights"],i,C)});let I;return y.defaultClient?(I=new y.TelemetryClient(P),I.channel.setUseDiskRetryCaching(!0)):(y.setup(P).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),I=y.defaultClient),P.indexOf("AIF-")===0&&(I.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),I}class L{constructor(y,I,i){this._eventPrefix=y,this._defaultData=I,this._defaultData||(this._defaultData=Object.create(null)),typeof i=="function"?this._aiClient=i():this._aiClient=i,this._asyncAIClient=null}_withAIClient(y){if(!!this._aiClient){if(typeof this._aiClient!="string"){y(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=T(this._aiClient)),this._asyncAIClient.then(I=>{y(I)},I=>{(0,R.onUnexpectedError)(I),console.error(I)})}}log(y,I){!this._aiClient||(I=(0,k.mixin)(I,this._defaultData),I=(0,D.validateTelemetryData)(I),this._withAIClient(i=>i.trackEvent({name:this._eventPrefix+"/"+y,properties:I.properties,measurements:I.measurements})))}flush(){return this._aiClient?new Promise(y=>{this._withAIClient(I=>{I.flush({callback:()=>{this._aiClient=void 0,y(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=L}),define(te[200],ne([0,1,15,52,22,13,10,20,88,89,90]),function(J,e,R,k,D,T,L,P,y,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let C=class{constructor(E,u,p,f){this.configurationService=E,this.telemetryService=u,this.loggerService=p,this.environmentService=f,this.customTelemetryServices=new Map}async getCustomTelemetryService(E){if(!this.customTelemetryServices.has(E.id)){const{machineId:u,sessionId:p}=await this.telemetryService.getTelemetryInfo(),f=Object.create(null);f["common.vscodemachineid"]=u,f["common.vscodesessionid"]=p;const b=[E.id,JSON.stringify(f),E.aiKey],S=new k.Client(R.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:b,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),c=[new y.TelemetryAppenderClient(S),new I.TelemetryLogAppender(this.loggerService,this.environmentService,`[${E.id}] `)];this.customTelemetryServices.set(E.id,new i.TelemetryService({appenders:c,sendErrorTelemetry:E.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(E.id)}async publicLog(E,u,p){await(await this.getCustomTelemetryService(E)).publicLog(u,p)}async publicLogError(E,u,p){await(await this.getCustomTelemetryService(E)).publicLogError(u,p)}};C=he([Q(0,D.IConfigurationService),Q(1,P.ITelemetryService),Q(2,L.ILoggerService),Q(3,T.IEnvironmentService)],C),e.CustomEndpointTelemetryService=C}),define(te[201],ne([0,1,6,27,3,2,10]),function(J,e,R,k,D,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends T.Disposable{constructor(I,i){super();this._logService=i,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new D.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=I===void 0?15e3:I}createRequest(I){return new Promise((i,C)=>{const g=++this._lastRequestId;this._pendingRequests.set(g,i),this._onCreateRequest.fire({requestId:g,...I});const E=new k.CancellationTokenSource;(0,R.timeout)(this._timeout,E.token).then(()=>C(`Request ${g} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(g,[(0,T.toDisposable)(()=>E.cancel())])})}acceptReply(I,i){const C=this._pendingRequests.get(I);C?(this._pendingRequests.delete(I),(0,T.dispose)(this._pendingRequestDisposables.get(I)||[]),this._pendingRequestDisposables.delete(I),C(i)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${I}`)}};P=he([Q(1,L.ILogService)],P),e.RequestStore=P}),define(te[91],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.ProcessCapability=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var k;(function(f){f.Shell="terminal.integrated.shell.",f.ShellArgs="terminal.integrated.shellArgs.",f.DefaultProfile="terminal.integrated.defaultProfile.",f.Profiles="terminal.integrated.profiles."})(k=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var D;(function(f){f.ShellLinux="terminal.integrated.shell.linux",f.ShellMacOs="terminal.integrated.shell.osx",f.ShellWindows="terminal.integrated.shell.windows",f.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",f.AutomationShellLinux="terminal.integrated.automationShell.linux",f.AutomationShellMacOs="terminal.integrated.automationShell.osx",f.AutomationShellWindows="terminal.integrated.automationShell.windows",f.ShellArgsLinux="terminal.integrated.shellArgs.linux",f.ShellArgsMacOs="terminal.integrated.shellArgs.osx",f.ShellArgsWindows="terminal.integrated.shellArgs.windows",f.ProfilesWindows="terminal.integrated.profiles.windows",f.ProfilesMacOs="terminal.integrated.profiles.osx",f.ProfilesLinux="terminal.integrated.profiles.linux",f.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",f.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",f.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",f.UseWslProfiles="terminal.integrated.useWslProfiles",f.TabsEnabled="terminal.integrated.tabs.enabled",f.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",f.TabsHideCondition="terminal.integrated.tabs.hideCondition",f.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",f.TabsShowActions="terminal.integrated.tabs.showActions",f.TabsLocation="terminal.integrated.tabs.location",f.TabsFocusMode="terminal.integrated.tabs.focusMode",f.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",f.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",f.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",f.CopyOnSelection="terminal.integrated.copyOnSelection",f.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",f.FontFamily="terminal.integrated.fontFamily",f.FontSize="terminal.integrated.fontSize",f.LetterSpacing="terminal.integrated.letterSpacing",f.LineHeight="terminal.integrated.lineHeight",f.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",f.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",f.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",f.BellDuration="terminal.integrated.bellDuration",f.FontWeight="terminal.integrated.fontWeight",f.FontWeightBold="terminal.integrated.fontWeightBold",f.CursorBlinking="terminal.integrated.cursorBlinking",f.CursorStyle="terminal.integrated.cursorStyle",f.CursorWidth="terminal.integrated.cursorWidth",f.Scrollback="terminal.integrated.scrollback",f.DetectLocale="terminal.integrated.detectLocale",f.DefaultLocation="terminal.integrated.defaultLocation",f.GpuAcceleration="terminal.integrated.gpuAcceleration",f.TerminalTitleSeparator="terminal.integrated.tabs.separator",f.TerminalTitle="terminal.integrated.tabs.title",f.TerminalDescription="terminal.integrated.tabs.description",f.RightClickBehavior="terminal.integrated.rightClickBehavior",f.Cwd="terminal.integrated.cwd",f.ConfirmOnExit="terminal.integrated.confirmOnExit",f.ConfirmOnKill="terminal.integrated.confirmOnKill",f.EnableBell="terminal.integrated.enableBell",f.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",f.AllowChords="terminal.integrated.allowChords",f.AllowMnemonics="terminal.integrated.allowMnemonics",f.EnvMacOs="terminal.integrated.env.osx",f.EnvLinux="terminal.integrated.env.linux",f.EnvWindows="terminal.integrated.env.windows",f.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",f.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",f.ShowExitAlert="terminal.integrated.showExitAlert",f.SplitCwd="terminal.integrated.splitCwd",f.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",f.WordSeparators="terminal.integrated.wordSeparators",f.EnableFileLinks="terminal.integrated.enableFileLinks",f.UnicodeVersion="terminal.integrated.unicodeVersion",f.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",f.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",f.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",f.LocalEchoStyle="terminal.integrated.localEchoStyle",f.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",f.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",f.CustomGlyphs="terminal.integrated.customGlyphs",f.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",f.InheritEnv="terminal.integrated.inheritEnv",f.ShowLinkHover="terminal.integrated.showLinkHover"})(D=e.TerminalSettingId||(e.TerminalSettingId={}));var T;(function(f){f.CommandPrompt="cmd",f.PowerShell="pwsh",f.Wsl="wsl",f.GitBash="gitbash"})(T=e.WindowsShellType||(e.WindowsShellType={}));var L;(function(f){f[f.Api=0]="Api",f[f.Process=1]="Process",f[f.Sequence=2]="Sequence",f[f.Config=3]="Config"})(L=e.TitleEventSource||(e.TitleEventSource={}));var P;(function(f){f.LocalPty="localPty",f.PtyHost="ptyHost",f.Log="log",f.Heartbeat="heartbeat"})(P=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,R.createDecorator)("ptyService");var y;(function(f){f.Cwd="cwd",f.InitialCwd="initialCwd",f.FixedDimensions="fixedDimensions"})(y=e.ProcessPropertyType||(e.ProcessPropertyType={}));var I;(function(f){f[f.BeatInterval=5e3]="BeatInterval",f[f.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",f[f.SecondWaitMultiplier=1]="SecondWaitMultiplier",f[f.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(I=e.HeartbeatConstants||(e.HeartbeatConstants={}));var i;(function(f){f[f.Panel=1]="Panel",f[f.Editor=2]="Editor"})(i=e.TerminalLocation||(e.TerminalLocation={}));var C;(function(f){f.TerminalView="view",f.Editor="editor"})(C=e.TerminalLocationString||(e.TerminalLocationString={}));var g;(function(f){f.CwdDetection="cwdDetection"})(g=e.ProcessCapability||(e.ProcessCapability={}));var E;(function(f){f[f.GraceTime=6e4]="GraceTime",f[f.ShortGraceTime=6e3]="ShortGraceTime"})(E=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var u;(function(f){f[f.HighWatermarkChars=1e5]="HighWatermarkChars",f[f.LowWatermarkChars=5e3]="LowWatermarkChars",f[f.CharCountAckSize=5e3]="CharCountAckSize"})(u=e.FlowControlConstants||(e.FlowControlConstants={}));var p;(function(f){f.GitBash="Git Bash",f.Pwsh="PowerShell"})(p=e.ProfileSource||(e.ProfileSource={}))}),define(te[202],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,R.createDecorator)("localPtyService")}),define(te[203],ne([0,1,32,26,9,4,31,18,19]),function(J,e,R,k,D,T,L,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function I(){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(R.release());let g=0;return C&&C.length===4&&(g=parseInt(C[3])),g}e.getWindowsBuildNumber=I;async function i(C,g,E,u=L.env,p=y.Promises.exists){if(D.isAbsolute(C))return await p(C)?C:void 0;if(g===void 0&&(g=L.cwd()),D.dirname(C)!=="."){const S=D.join(g,C);return await p(S)?S:void 0}const b=(0,k.getCaseInsensitive)(u,"PATH");if(E===void 0&&(0,P.isString)(b)&&(E=b.split(D.delimiter)),E===void 0||E.length===0){const S=D.join(g,C);return await p(S)?S:void 0}for(let S of E){let c;if(D.isAbsolute(S)?c=D.join(S,C):c=D.join(g,S,C),await p(c))return c;if(T.isWindows){let a=c+".com";if(await p(a)||(a=c+".exe",await p(a)))return a}}const v=D.join(g,C);return await p(v)?v:void 0}e.findExecutable=i}),define(te[204],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var R;(function(k){k.DARK="dark",k.LIGHT="light",k.HIGH_CONTRAST="hc"})(R=e.ColorScheme||(e.ColorScheme={}))}),define(te[92],ne([0,1,49,3,2,5,35,204]),function(J,e,R,k,D,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var y;(function(f){function b(v){return v&&typeof v=="object"&&typeof v.id=="string"}f.isThemeColor=b})(y=e.ThemeColor||(e.ThemeColor={}));function I(f){return{id:f}}e.themeColorFromId=I;var i;(function(f){function b(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||y.isThemeColor(s.color))}f.isThemeIcon=b;const v=new RegExp(`^\\$\\((${R.CSSIcon.iconNameExpression}(?:${R.CSSIcon.iconModifierExpression})?)\\)$`);function S(s){const n=v.exec(s);if(!n)return;let[,r]=n;return{id:r}}f.fromString=S;function c(s,n){let r=s.id;const o=r.lastIndexOf("~");return o!==-1&&(r=r.substring(0,o)),n&&(r=`${r}~${n}`),{id:r}}f.modify=c;function a(s,n){return s.id===n.id&&s.color?.id===n.color?.id}f.isEqual=a;function t(s,n){return{id:s.id,color:n?I(n):void 0}}f.asThemeIcon=t,f.asClassNameArray=R.CSSIcon.asClassNameArray,f.asClassName=R.CSSIcon.asClassName,f.asCSSSelector=R.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=R.Codicon.file,e.FolderThemeIcon=R.Codicon.folder;function C(f){switch(f){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class g{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new k.Emitter}onColorThemeChange(b){return this.themingParticipants.push(b),this.onThemingParticipantAddedEmitter.fire(b),(0,D.toDisposable)(()=>{const v=this.themingParticipants.indexOf(b);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let E=new g;L.Registry.add(e.Extensions.ThemingContribution,E);function u(f){return E.onColorThemeChange(f)}e.registerThemingParticipant=u;class p extends D.Disposable{constructor(b){super();this.themeService=b,this.theme=b.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(b){this.theme=b,this.updateStyles()}updateStyles(){}getColor(b,v){let S=this.theme.getColor(b);return S&&v&&(S=v(S,this.theme)),S?S.toString():null}}e.Themable=p}),define(te[205],ne([0,1,49,92]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProfileSchemaEnums=void 0;function D(P,y){const I=P.map(i=>({name:i.profileName,description:T(i)}));return y&&I.push(...y.map(i=>({name:i.title,description:L(i)}))),{values:I.map(i=>i.name),markdownDescriptions:I.map(i=>i.description)}}e.createProfileSchemaEnums=D;function T(P){let y=`$(${k.ThemeIcon.isThemeIcon(P.icon)?P.icon.id:P.icon?P.icon:R.Codicon.terminal.id}) ${P.profileName}
- path: ${P.path}`;return P.args&&(typeof P.args=="string"?y+=`
- args: "${P.args}"`:y+=`
- args: [${P.args.length===0?"":`'${P.args.join("','")}'`}]`),P.overrideName!==void 0&&(y+=`
- overrideName: ${P.overrideName}`),P.color&&(y+=`
- color: ${P.color}`),P.env&&(y+=`
- env: ${JSON.stringify(P.env)}`),y}function L(P){return`$(${k.ThemeIcon.isThemeIcon(P.icon)?P.icon.id:P.icon?P.icon:R.Codicon.terminal.id}) ${P.title}
- extensionIdenfifier: ${P.extensionIdentifier}`}}),define(te[206],ne([0,1,49,135,39,35,205]),function(J,e,R,k,D,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const P={args:{description:(0,k.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,k.localize)(1,null),type:"boolean"},icon:{description:(0,k.localize)(2,null),type:"string",enum:Array.from(R.iconRegistry.all,f=>f.id),markdownEnumDescriptions:Array.from(R.iconRegistry.all,f=>`$(${f.id})`)},color:{description:(0,k.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,k.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},y={type:"object",required:["path"],properties:{path:{description:(0,k.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},I=(0,k.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),i=(0,k.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),C=(0,k.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),g={id:"terminal",order:100,title:(0,k.localize)(9,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,k.localize)(10,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,k.localize)(11,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,k.localize)(12,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,k.localize)(13,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,k.localize)(14,null),type:["string","null"],default:null,markdownDeprecationMessage:i},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,k.localize)(15,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,k.localize)(16,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:I},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,k.localize)(17,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:i},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,k.localize)(18,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,k.localize)(19,null)}},{type:"string",markdownDescription:(0,k.localize)(20,null)}],default:[],markdownDeprecationMessage:C},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,k.localize)(21,null,"`source`","`path`","`args`."),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,k.localize)(22,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,k.localize)(23,null),type:"string"},id:{description:(0,k.localize)(24,null),type:"string"},title:{description:(0,k.localize)(25,null),type:"string"},...P}},{type:"null"},y]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,k.localize)(26,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,k.localize)(27,null),type:"string"},id:{description:(0,k.localize)(28,null),type:"string"},title:{description:(0,k.localize)(29,null),type:"string"},...P}},{type:"null"},y]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,k.localize)(30,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,k.localize)(31,null),type:"string"},id:{description:(0,k.localize)(32,null),type:"string"},title:{description:(0,k.localize)(33,null),type:"string"},...P}},{type:"null"},y]}},["terminal.integrated.useWslProfiles"]:{description:(0,k.localize)(34,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,k.localize)(35,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,k.localize)(36,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,k.localize)(37,null),type:"boolean",default:!0}}};function E(){T.Registry.as(D.Extensions.Configuration).registerConfiguration(g),p()}e.registerTerminalPlatformConfiguration=E;let u;function p(f,b){const v=T.Registry.as(D.Extensions.Configuration);let S;f&&(S=(0,L.createProfileSchemaEnums)(f?.profiles,b));const c=u;u={id:"terminal",order:100,title:(0,k.localize)(38,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,k.localize)(39,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:f?.os===3?S?.values:void 0,markdownEnumDescriptions:f?.os===3?S?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,k.localize)(40,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:f?.os===2?S?.values:void 0,markdownEnumDescriptions:f?.os===2?S?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,k.localize)(41,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:f?.os===1?S?.values:void 0,markdownEnumDescriptions:f?.os===1?S?.markdownDescriptions:void 0}}},v.updateConfigurations({add:[u],remove:c?[c]:[]})}e.registerTerminalDefaultProfileConfiguration=p}),define(te[207],ne([0,1,37,49,9,4,19,71,203,92]),function(J,e,R,k,D,T,L,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let i;function C(t,s,n,r,o=process.env,l,h,d,m){return l=l||{existsFile:L.SymlinkSupport.existsFile,readFile:L.Promises.readFile},T.isWindows?g(n,l,o,h,r.getValue("terminal.integrated.useWslProfiles")!==!1,t&&typeof t=="object"?{...t}:r.getValue("terminal.integrated.profiles.windows"),typeof s=="string"?s:r.getValue("terminal.integrated.defaultProfile.windows"),m,d):S(l,h,n,t&&typeof t=="object"?{...t}:r.getValue(T.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof s=="string"?s:r.getValue(T.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),m,d,o)}e.detectAvailableProfiles=C;async function g(t,s,n,r,o,l,h,d,m){const A=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),_=`${process.env.windir}\\${A?"Sysnative":"System32"}`;let w=!1;(0,y.getWindowsBuildNumber)()>=16299&&(w=!0),await p(d);const O=new Map;t&&(O.set("PowerShell",{source:"PowerShell",icon:k.Codicon.terminalPowershell,isAutoDetected:!0}),O.set("Windows PowerShell",{path:`${_}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:k.Codicon.terminalPowershell,isAutoDetected:!0}),O.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),O.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),O.set("Command Prompt",{path:`${_}\\cmd.exe`,icon:k.Codicon.terminalCmd,isAutoDetected:!0})),c(l,O);const U=await E(O.entries(),h,s,n,r,m);if(t||!t&&o)try{const $=await b(`${_}\\${w?"wsl":"bash"}.exe`,h);for(const Y of $)(!l||!(Y.profileName in l))&&U.push(Y)}catch($){r?.info("WSL is not installed, so could not detect WSL profiles")}return U}async function E(t,s,n,r=process.env,o,l){const h=[];for(const[d,m]of t){if(m===null)continue;let A,_,w;if("source"in m){const $=i?.get(m.source);if(!$)continue;A=$.paths,_=m.args||$.args,m.icon?w=u(m.icon):$.icon&&(w=$.icon)}else A=Array.isArray(m.path)?m.path:[m.path],_=T.isWindows||Array.isArray(m.args)?m.args:void 0,w=u(m.icon)||void 0;const O=await l?.(A)||A.slice(),U=await a(d,s,O,n,r,_,m.env,m.overrideName,m.isAutoDetected,o);U?(U.isAutoDetected=m.isAutoDetected,U.icon=w,U.color=m.color,h.push(U)):o?.trace("profile not validated",d,A)}return h}function u(t){return typeof t=="string"?{id:t}:t}async function p(t){i&&!t||(i=new Map,i.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),i.set("PowerShell",{profileName:"PowerShell",paths:t||await f(),icon:I.ThemeIcon.asThemeIcon(k.Codicon.terminalPowershell)}))}async function f(){const t=[];for await(const s of(0,P.enumeratePowerShellInstallations)())t.push(s.exePath);return t}async function b(t,s){const n=[],r=await new Promise((h,d)=>{R.exec("wsl.exe -l -q",{encoding:"utf16le"},(m,A)=>{if(m)return d("Problem occurred when getting wsl distros");h(A)})});if(!r)return[];const o=new RegExp(/[\r?\n]/),l=r.split(o).filter(h=>h.trim().length>0&&h!=="");for(const h of l){if(h===""||h.startsWith("docker-desktop"))continue;const d=`${h} (WSL)`,m={profileName:d,path:t,args:["-d",`${h}`],isDefault:d===s,icon:v(h)};n.push(m)}return n}function v(t){return t.includes("Ubuntu")?I.ThemeIcon.asThemeIcon(k.Codicon.terminalUbuntu):t.includes("Debian")?I.ThemeIcon.asThemeIcon(k.Codicon.terminalDebian):I.ThemeIcon.asThemeIcon(k.Codicon.terminalLinux)}async function S(t,s,n,r,o,l,h,d){const m=new Map;if(n){const A=(await t.readFile("/etc/shells")).toString(),_=l||A.split(`
`).filter(O=>O.trim().indexOf("#")!==0&&O.trim().length>0),w=new Map;for(const O of _){let U=(0,D.basename)(O),$=w.get(U)||0;$++,$>1&&(U=`${U} (${$})`),w.set(U,$),m.set(U,{path:O,isAutoDetected:!0})}}return c(r,m),await E(m.entries(),o,t,d,s,h)}function c(t,s){if(!!t)for(const[n,r]of Object.entries(t))r===null||!("path"in r)&&!("source"in r)?s.delete(n):s.set(n,r)}async function a(t,s,n,r,o,l,h,d,m,A){if(n.length===0)return Promise.resolve(void 0);const _=n.shift();if(_==="")return a(t,s,n,r,o,l,h,d,m);const w={profileName:t,path:_,args:l,env:h,overrideName:d,isAutoDetected:m,isDefault:t===s};if((0,D.basename)(_)===_){const U=o.PATH?o.PATH.split(D.delimiter):void 0;return await(0,y.findExecutable)(_,void 0,U,void 0,r.existsFile)?w:a(t,s,n,r,o,l)}return await r.existsFile((0,D.normalize)(_))?w:a(t,s,n,r,o,l,h,d,m)}}),define(te[208],ne([0,1,3,2,15,4,33,52,22,13,75,163,10,84,20,201,91,206,207]),function(J,e,R,k,D,T,L,P,y,I,i,C,g,E,u,p,f,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var S;(function(t){t[t.MaxRestarts=5]="MaxRestarts"})(S||(S={}));let c=0,a=class extends k.Disposable{constructor(s,n,r,o,l){super();this._reconnectConstants=s,this._configurationService=n,this._environmentService=r,this._logService=o,this._telemetryService=l,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new R.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new R.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new R.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new R.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new R.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new R.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new R.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new R.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new R.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new R.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new R.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new R.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new R.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new R.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new R.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onProcessDidChangeHasChildProcesses=this._register(new R.Emitter),this.onProcessDidChangeHasChildProcesses=this._onProcessDidChangeHasChildProcesses.event,this._onDidChangeProperty=this._register(new R.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,(0,b.registerTerminalPlatformConfiguration)(),this._shellEnv=T.isWindows?Promise.resolve(process.env):(0,C.resolveShellEnv)(this._logService,{_:[]},process.env),this._register((0,k.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new p.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const s={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:c,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},n=(0,i.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);n&&(n.break&&n.port?s.debugBrk=n.port:!n.break&&n.port&&(s.debug=n.port));const r=new P.Client(D.FileAccess.asFileUri("bootstrap-fork",J).fsPath,s);this._onPtyHostStart.fire(),L.ProxyChannel.toService(r.getChannel(f.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(r.onDidProcessExit(d=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(d.code),this._isDisposed||(this._restartCount<=S.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${d.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${d.code}, giving up`))}));const l=r.getChannel(f.TerminalIpcChannels.Log);E.LogLevelChannelClient.setLevel(l,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{E.LogLevelChannelClient.setLevel(l,this._logService.getLevel())}));const h=L.ProxyChannel.toService(r.getChannel(f.TerminalIpcChannels.PtyHost));return this._register(h.onProcessData(d=>this._onProcessData.fire(d))),this._register(h.onProcessExit(d=>this._onProcessExit.fire(d))),this._register(h.onProcessReady(d=>this._onProcessReady.fire(d))),this._register(h.onProcessTitleChanged(d=>this._onProcessTitleChanged.fire(d))),this._register(h.onProcessShellTypeChanged(d=>this._onProcessShellTypeChanged.fire(d))),this._register(h.onProcessOverrideDimensions(d=>this._onProcessOverrideDimensions.fire(d))),this._register(h.onProcessResolvedShellLaunchConfig(d=>this._onProcessResolvedShellLaunchConfig.fire(d))),this._register(h.onProcessDidChangeHasChildProcesses(d=>this._onProcessDidChangeHasChildProcesses.fire(d))),this._register(h.onDidChangeProperty(d=>this._onDidChangeProperty.fire(d))),this._register(h.onProcessReplay(d=>this._onProcessReplay.fire(d))),this._register(h.onProcessOrphanQuestion(d=>this._onProcessOrphanQuestion.fire(d))),this._register(h.onDidRequestDetach(d=>this._onDidRequestDetach.fire(d))),[r,h]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(s,n,r,o,l,h,d,m,A,_,w){const O=setTimeout(()=>this._handleUnresponsiveCreateProcess(),f.HeartbeatConstants.CreateProcessTimeout),U=await this._proxy.createProcess(s,n,r,o,l,h,d,m,A,_,w);return clearTimeout(O),c=Math.max(c,U),U}updateTitle(s,n,r){return this._proxy.updateTitle(s,n,r)}updateIcon(s,n,r){return this._proxy.updateIcon(s,n,r)}attachToProcess(s){return this._proxy.attachToProcess(s)}detachFromProcess(s){return this._proxy.detachFromProcess(s)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(s){return this._proxy.start(s)}shutdown(s,n){return this._proxy.shutdown(s,n)}input(s,n){return this._proxy.input(s,n)}processBinary(s,n){return this._proxy.processBinary(s,n)}resize(s,n,r){return this._proxy.resize(s,n,r)}acknowledgeDataEvent(s,n){return this._proxy.acknowledgeDataEvent(s,n)}setUnicodeVersion(s,n){return this._proxy.setUnicodeVersion(s,n)}getInitialCwd(s){return this._proxy.getInitialCwd(s)}getCwd(s){return this._proxy.getCwd(s)}getLatency(s){return this._proxy.getLatency(s)}orphanQuestionReply(s){return this._proxy.orphanQuestionReply(s)}getDefaultSystemShell(s){return this._proxy.getDefaultSystemShell(s)}async getProfiles(s,n,r,o=!1){const l=await this._shellEnv;return(0,v.detectAvailableProfiles)(n,r,o,this._configurationService,l,void 0,this._logService,this._resolveVariables.bind(this,s))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(s){return this._proxy.getWslPath(s)}setTerminalLayoutInfo(s){return this._proxy.setTerminalLayoutInfo(s)}async getTerminalLayoutInfo(s){return await this._proxy.getTerminalLayoutInfo(s)}async requestDetachInstance(s,n){return this._proxy.requestDetachInstance(s,n)}async acceptDetachInstanceReply(s,n){return this._proxy.acceptDetachInstanceReply(s,n)}async serializeTerminalState(s){return this._proxy.serializeTerminalState(s)}async reviveTerminalProcesses(s){return this._proxy.reviveTerminalProcesses(s)}async refreshProperty(s,n){return this._proxy.refreshProperty(s,n)}async updateProperty(s,n,r){return this._proxy.updateProperty(s,n,r)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier+f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${f.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(s,n){return this._resolveVariablesRequestStore.createRequest({workspaceId:s,originalText:n})}async acceptPtyHostResolvedVariables(s,n){this._resolveVariablesRequestStore.acceptReply(s,n)}};a=he([Q(1,y.IConfigurationService),Q(2,I.IEnvironmentService),Q(3,g.ILogService),Q(4,u.ITelemetryService)],a),e.PtyHostService=a}),define(te[54],ne([0,1,44]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function k(L,P,y,I){const i=(0,R.setProperty)(L,P,y,I)[0];return i&&(L=L.substring(0,i.offset)+i.content+L.substring(i.offset+i.length)),L}e.edit=k;function D(L,P,y){let I=y;for(;I>=0;){if(L.charAt(I)===P.charAt(P.length-1)&&P.length===1)return I+1;if(I--,P.length===2&&I>=0&&L.charAt(I)===P.charAt(0))return I+2}return 0}e.getLineStartOffset=D;function T(L,P,y){let I=y;for(;I>=0;)if(L.charAt(I)===P.charAt(P.length-1)&&P.length===1||(I++,P.length===2&&I>=0&&L.charAt(I)===P.charAt(1)))return I;return L.length-1}e.getLineEndOffset=T}),define(te[209],ne([0,1,26,59]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(C,g,E,u,p){const f=[],b=[],v=[];if(!g){const _=C.filter(({identifier:w})=>p.every(O=>O.toLowerCase()!==w.id.toLowerCase()));return{local:{added:f,removed:b,updated:v},remote:_.length>0?{added:_,updated:[],removed:[],all:_}:null}}C=C.map(I),g=g.map(I),E=E?E.map(I):null;const S=new Map,c=_=>{_.uuid&&S.set(_.id.toLowerCase(),_.uuid)};C.forEach(({identifier:_})=>c(_)),g.forEach(({identifier:_})=>c(_)),E&&E.forEach(({identifier:_})=>c(_));const a=_=>{const w=_.identifier.uuid||S.get(_.identifier.id.toLowerCase());return w?`uuid:${w}`:`id:${_.identifier.id.toLowerCase()}`},t=(_,w)=>(_.set(a(w),w),_),s=C.reduce(t,new Map),n=g.reduce(t,new Map),r=g.reduce((_,w)=>{const O=a(w);w=(0,R.deepClone)(w);const U=s.get(O);return U&&(U.installed&&(w.installed=!0),w.version||(w.version=U.version)),t(_,w)},new Map),o=E?E.reduce(t,new Map):null,l=u.reduce(t,new Map),h=p.reduce((_,w)=>{const O=S.get(w.toLowerCase());return _.add(O?`uuid:${O}`:`id:${w.toLowerCase()}`)},new Set),d=T(s,n,h);if(d.added.size>0||d.removed.size>0||d.updated.size>0){const _=T(o,s,h),w=T(o,n,h),O=(U,$)=>{const Y=s.get(U);if(Y){const M=n.get(U);return{...$?M:Y,version:(M.version&&k.gt(M.version,Y.version),Y.version),state:L(Y,M,o?.get(U))}}};for(const U of w.removed.values()){const $=s.get(U);$&&b.push($.identifier)}for(const U of w.added.values())if(_.added.has(U)){if(d.updated.has(U)){const $=O(U,!0);$&&(v.push(i($,U)),r.set(U,$))}}else{const $=n.get(U);$.installed&&f.push(i($,U))}for(const U of w.updated.values()){const $=O(U,!0);$&&(v.push(i($,U)),r.set(U,$))}for(const U of _.added.values())w.added.has(U)||r.set(U,s.get(U));for(const U of _.updated.values())if(!w.removed.has(U)&&!w.updated.has(U)){const $=O(U,!1);$&&(r.get(U)?.installed&&($.installed=!0),r.set(U,$))}for(const U of _.removed.values())!l.has(U)&&!w.updated.has(U)&&o?.get(U)?.installed&&r.delete(U)}const m=[],A=T(n,r,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(A.added.size>0||A.updated.size>0||A.removed.size>0)&&r.forEach((_,w)=>m.push(i(_,w))),{local:{added:f,removed:b,updated:v},remote:m.length?{added:[...A.added].map(_=>r.get(_)),updated:[...A.updated].map(_=>r.get(_)),removed:[...A.removed].map(_=>n.get(_)),all:m}:null}}e.merge=D;function T(C,g,E,{checkInstalledProperty:u,checkVersionProperty:p}={checkInstalledProperty:!1,checkVersionProperty:!1}){const f=C?[...C.keys()].filter(a=>!E.has(a)):[],b=[...g.keys()].filter(a=>!E.has(a)),v=b.filter(a=>f.indexOf(a)===-1).reduce((a,t)=>(a.add(t),a),new Set),S=f.filter(a=>b.indexOf(a)===-1).reduce((a,t)=>(a.add(t),a),new Set),c=new Set;for(const a of f){if(S.has(a))continue;const t=C.get(a),s=g.get(a);(!s||t.disabled!==s.disabled||!y(t.state,s.state)||p&&t.version!==s.version||u&&t.installed!==s.installed)&&c.add(a)}return{added:v,removed:S,updated:c}}function L(C,g,E){const u=C.state,p=g.state,f=E?.state;if(!g.version||u&&k.gt(C.version,g.version))return u;if(p&&k.gt(g.version,C.version)||!u)return p;if(!p)return u;const b=(0,R.deepClone)(u),v=f?P(f,p):{added:Object.keys(p).reduce((c,a)=>(c.add(a),c),new Set),removed:new Set,updated:new Set},S=f?P(f,u):{added:Object.keys(u).reduce((c,a)=>(c.add(a),c),new Set),removed:new Set,updated:new Set};for(const c of[...v.added.values(),...v.updated.values()])b[c]=p[c];for(const c of v.removed.values())S.updated.has(c)||delete b[c];return b}function P(C,g){const E=Object.keys(C),u=Object.keys(g),p=u.filter(v=>E.indexOf(v)===-1).reduce((v,S)=>(v.add(S),v),new Set),f=E.filter(v=>u.indexOf(v)===-1).reduce((v,S)=>(v.add(S),v),new Set),b=new Set;for(const v of E){if(f.has(v))continue;const S=C[v],c=g[v];(0,R.equals)(S,c)||b.add(v)}return{added:p,removed:f,updated:b}}function y(C={},g={}){const{added:E,removed:u,updated:p}=P(C,g);return E.size===0&&u.size===0&&p.size===0}function I(C){return{...C,disabled:!!C.disabled,installed:!!C.installed}}function i(C,g){const E={identifier:{id:C.identifier.id,uuid:g.startsWith("uuid:")?g.substring("uuid:".length):void 0}};return C.version&&(E.version=C.version),C.disabled&&(E.disabled=!0),C.installed&&(E.installed=!0),C.state&&(E.state=C.state),E}}),define(te[93],ne([0,1,17,3,2,34,5,29,23]),function(J,e,R,k,D,T,L,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,L.createDecorator)("IExtensionsStorageSyncService");const I=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let i=class tt extends D.Disposable{constructor(g,E){super();this.storageService=g,this.productService=E,this._onDidChangeExtensionsStorage=this._register(new k.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(u=>this.onDidChangeStorageValue(u)))}static toKey(g){return`extensionKeys/${(0,T.adoptToGalleryExtensionId)(g.id)}@${g.version}`}static fromKey(g){const E=I.exec(g);if(E&&E[1])return{id:E[1],version:E[2]}}initialize(){const g=this.storageService.keys(0,1);for(const E of g){const u=tt.fromKey(E);u&&this.extensionsWithKeysForSync.add(u.id.toLowerCase())}}onDidChangeStorageValue(g){if(g.scope!==0)return;if(this.extensionsWithKeysForSync.has(g.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const E=tt.fromKey(g.key);if(E){this.extensionsWithKeysForSync.add(E.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(g,E){this.storageService.store(tt.toKey(g),JSON.stringify(E),0,1)}getKeysForSync(g){const E=this.productService.extensionSyncedKeys?.[g.id.toLowerCase()],u=this.storageService.get(tt.toKey(g),0),p=u?JSON.parse(u):void 0;return p&&E?(0,R.distinct)([...p,...E]):p||E}};i=he([Q(0,y.IStorageService),Q(1,P.IProductService)],i),e.ExtensionsStorageSyncService=i}),define(te[94],ne([0,1,17,22,5]),function(J,e,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,D.createDecorator)("IIgnoredExtensionsManagementService");let T=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,y){let I=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(i=>i.toLowerCase());return I=I.filter(i=>i!==P&&i!==`-${P}`),y&&I.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",I.length?I:void 0,1)}updateSynchronizedExtensions(P,y){let I=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(i=>i.toLowerCase());return I=I.filter(i=>i!==P&&i!==`-${P}`),y&&I.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",I.length?I:void 0,1)}getIgnoredExtensions(P){const y=P.filter(g=>g.isMachineScoped).map(g=>g.identifier.id.toLowerCase()),I=this.getConfiguredIgnoredExtensions().map(g=>g.toLowerCase()),i=[],C=[];if(Array.isArray(I))for(const g of I)g.startsWith("-")?C.push(g.substring(1)):i.push(g);return(0,R.distinct)([...y,...i].filter(g=>C.indexOf(g)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(y=>y.toLowerCase())}};T=he([Q(0,k.IConfigurationService)],T),e.IgnoredExtensionsManagementService=T}),define(te[210],ne([0,1,17,36,26,156,54]),function(J,e,R,k,D,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(c){return(0,k.parse)(c)||[]}e.parseKeybindings=P;async function y(c,a,t,s,n){const r=P(c),o=P(a),l=t?P(t):null,h=[...r,...o,...l||[]].map(V=>V.key),d=await n.resolveUserBindings(h);let m=i(r,o,l,d);if(!m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:c,hasChanges:!1,hasConflicts:!1};if(!m.hasLocalForwarded&&m.hasRemoteForwarded)return{mergeContent:a,hasChanges:!0,hasConflicts:!1};if(m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};const A=g(r),_=g(o),w=l?g(l):null,O=u(A,_,d),U=w?u(w,A,d):{added:[...A.keys()].reduce((V,j)=>(V.add(j),V),new Set),removed:new Set,updated:new Set},$=w?u(w,_,d):{added:[..._.keys()].reduce((V,j)=>(V.add(j),V),new Set),removed:new Set,updated:new Set},Y=I(O,U,$);let M=c;for(const V of Y.removed.values())Y.conflicts.has(V)||(M=v(M,V,s));for(const V of Y.added.values()){if(Y.conflicts.has(V))continue;const j=_.get(V);if(j.some(z=>z.command!==`-${V}`&&m.conflicts.has(d[z.key]))){Y.conflicts.add(V);continue}M=b(M,j,s)}for(const V of Y.updated.values()){if(Y.conflicts.has(V))continue;const j=_.get(V);if(j.some(z=>z.command!==`-${V}`&&m.conflicts.has(d[z.key]))){Y.conflicts.add(V);continue}M=S(M,V,j,s)}return{mergeContent:M,hasChanges:!0,hasConflicts:Y.conflicts.size>0}}e.merge=y;function I(c,a,t){const s=new Set,n=new Set,r=new Set,o=new Set;for(const l of a.removed.values())t.updated.has(l)&&o.add(l);for(const l of t.removed.values())o.has(l)||(a.updated.has(l)?o.add(l):n.add(l));for(const l of a.added.values())o.has(l)||t.added.has(l)&&c.updated.has(l)&&o.add(l);for(const l of t.added.values())o.has(l)||(a.added.has(l)?c.updated.has(l)&&o.add(l):s.add(l));for(const l of a.updated.values())o.has(l)||t.updated.has(l)&&c.updated.has(l)&&o.add(l);for(const l of t.updated.values())o.has(l)||(a.updated.has(l)?c.updated.has(l)&&o.add(l):r.add(l));return{added:s,removed:n,updated:r,conflicts:o}}function i(c,a,t,s){const n=new Set,r=C(c,s),o=C(a,s),l=t?C(t,s):null,h=E(r,o);if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const d=l?E(l,r):{added:[...r.keys()].reduce((U,$)=>(U.add($),U),new Set),removed:new Set,updated:new Set};if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const m=l?E(l,o):{added:[...o.keys()].reduce((U,$)=>(U.add($),U),new Set),removed:new Set,updated:new Set};if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:A,removed:_,updated:w,conflicts:O}=I(h,d,m);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:A,removed:_,updated:w,conflicts:O}}function C(c,a){const t=new Map;for(const s of c){const n=a[s.key];let r=t.get(n);r||(r=[],t.set(n,r)),r.push(s)}return t}function g(c){const a=new Map;for(const t of c){const s=t.command[0]==="-"?t.command.substring(1):t.command;let n=a.get(s);n||(n=[],a.set(s,n)),n.push(t)}return a}function E(c,a){const t=[...c.keys()],s=[...a.keys()],n=s.filter(l=>t.indexOf(l)===-1).reduce((l,h)=>(l.add(h),l),new Set),r=t.filter(l=>s.indexOf(l)===-1).reduce((l,h)=>(l.add(h),l),new Set),o=new Set;for(const l of t){if(r.has(l))continue;const h=c.get(l).map(m=>({...m,key:l})),d=a.get(l).map(m=>({...m,key:l}));(0,R.equals)(h,d,(m,A)=>f(m,A))||o.add(l)}return{added:n,removed:r,updated:o}}function u(c,a,t){const s=[...c.keys()],n=[...a.keys()],r=n.filter(h=>s.indexOf(h)===-1).reduce((h,d)=>(h.add(d),h),new Set),o=s.filter(h=>n.indexOf(h)===-1).reduce((h,d)=>(h.add(d),h),new Set),l=new Set;for(const h of s){if(o.has(h))continue;const d=c.get(h).map(A=>({...A,key:t[A.key]})),m=a.get(h).map(A=>({...A,key:t[A.key]}));p(d,m)||l.add(h)}return{added:r,removed:o,updated:l}}function p(c,a){return!(!(0,R.equals)(c.filter(({command:t})=>t[0]!=="-"),a.filter(({command:t})=>t[0]!=="-"),(t,s)=>f(t,s))||!(0,R.equals)(c.filter(({command:t})=>t[0]==="-"),a.filter(({command:t})=>t[0]==="-"),(t,s)=>f(t,s)))}function f(c,a){if(c.command!==a.command||c.key!==a.key)return!1;const t=T.ContextKeyExpr.deserialize(c.when),s=T.ContextKeyExpr.deserialize(a.when);return!(t&&!s||!t&&s||t&&s&&!t.equals(s)||!D.equals(c.args,a.args))}function b(c,a,t){for(const s of a)c=L.edit(c,[-1],s,t);return c}function v(c,a,t){const s=P(c);for(let n=s.length-1;n>=0;n--)(s[n].command===a||s[n].command===`-${a}`)&&(c=L.edit(c,[n],void 0,t));return c}function S(c,a,t,s){const n=P(c),r=n.findIndex(o=>o.command===a||o.command===`-${a}`);for(let o=n.length-1;o>=0;o--)(n[o].command===a||n[o].command===`-${a}`)&&(c=L.edit(c,[o],void 0,s));for(let o=t.length-1;o>=0;o--)c=L.edit(c,[r],t[o],s);return c}}),define(te[211],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function R(T,L,P){const y={},I={},i=new Set;if(!L)return{local:{added:y,updated:I,removed:[...i.values()]},remote:{added:T,updated:{},removed:[]},conflicts:[]};const C=k(T,L);if(C.added.size===0&&C.removed.size===0&&C.updated.size===0)return{local:{added:y,updated:I,removed:[...i.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const g=k(P,T),E=k(P,L),u={},p={},f=new Set,b=new Set;for(const v of g.removed.values())E.updated.has(v)?y[v]=L[v]:f.add(v);for(const v of E.removed.values())b.has(v)||(g.updated.has(v)?b.add(v):i.add(v));for(const v of g.updated.values())b.has(v)||(E.updated.has(v)?C.updated.has(v)&&b.add(v):p[v]=T[v]);for(const v of E.updated.values())b.has(v)||(g.updated.has(v)?C.updated.has(v)&&b.add(v):T[v]!==void 0&&(I[v]=L[v]));for(const v of g.added.values())b.has(v)||(E.added.has(v)?C.updated.has(v)&&b.add(v):u[v]=T[v]);for(const v of E.added.values())b.has(v)||(g.added.has(v)?C.updated.has(v)&&b.add(v):y[v]=L[v]);return{local:{added:y,removed:[...i.values()],updated:I},remote:{added:u,removed:[...f.values()],updated:p},conflicts:[...b.values()]}}e.merge=R;function k(T,L){const P=T?Object.keys(T):[],y=L?Object.keys(L):[],I=y.filter(g=>P.indexOf(g)===-1).reduce((g,E)=>(g.add(E),g),new Set),i=P.filter(g=>y.indexOf(g)===-1).reduce((g,E)=>(g.add(E),g),new Set),C=new Set;for(const g of P){if(i.has(g))continue;const E=T[g],u=L[g];E!==u&&C.add(g)}return{added:I,removed:i,updated:C}}function D(T,L){const{added:P,removed:y,updated:I}=k(T,L);return P.size===0&&y.size===0&&I.size===0}e.areSame=D}),define(te[24],ne([0,1,17,16,18,140,39,28,5,86,35]),function(J,e,R,k,D,T,L,P,y,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function C(){const l=i.Registry.as(L.Extensions.Configuration).getConfigurationProperties();return Object.keys(l).filter(h=>!!l[h].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=C;function g(){const l=i.Registry.as(L.Extensions.Configuration).getConfigurationProperties(),h=Object.keys(l).filter(A=>!!l[A].ignoreSync),d=Object.keys(l).filter(A=>l[A].scope===2||l[A].scope===6),m=C();return(0,R.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...h,...d,...m])}e.getDefaultIgnoredSettings=g;function E(){const l="vscode://schemas/ignoredSettings",h=i.Registry.as(L.Extensions.Configuration);h.registerConfiguration({id:"settingsSync",order:30,title:(0,T.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,T.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,T.localize)(2,null),items:[{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,T.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,T.localize)(4,null),default:[],scope:1,$ref:l,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const d=i.Registry.as(I.Extensions.JSONContribution),m=()=>{const A=C(),_=g().filter($=>$!==e.CONFIGURATION_SYNC_STORE_KEY),w=Object.keys(L.allSettings.properties).filter($=>_.indexOf($)===-1),O=_.filter($=>A.indexOf($)===-1),U={items:{type:"string",enum:[...w,...O.map($=>`-${$}`)]}};d.registerSchema(l,U)};return h.onDidUpdateConfiguration(()=>m())}e.registerConfiguration=E;function u(l){return l&&(0,D.isObject)(l)&&(0,D.isString)(l.id)&&(0,D.isArray)(l.scopes)}e.isAuthenticationProvider=u;var p;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Extensions="extensions",l.GlobalState="globalState"})(p=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function f(l,h,d){return d.joinPath(h.userDataSyncHome,l,`lastSync${l}.json`)}e.getLastSyncResourceUri=f,e.IUserDataSyncStoreManagementService=(0,y.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,y.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,y.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function b(l){const h={};return h[e.HEADER_EXECUTION_ID]=l,h}e.createSyncHeaders=b;var v;(function(l){l.Unauthorized="Unauthorized",l.Conflict="Conflict",l.Gone="Gone",l.PreconditionFailed="PreconditionFailed",l.TooLarge="TooLarge",l.UpgradeRequired="UpgradeRequired",l.PreconditionRequired="PreconditionRequired",l.TooManyRequests="RemoteTooManyRequests",l.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",l.RequestFailed="RequestFailed",l.RequestCanceled="RequestCanceled",l.RequestTimeout="RequestTimeout",l.RequestProtocolNotSupported="RequestProtocolNotSupported",l.RequestPathNotEscaped="RequestPathNotEscaped",l.RequestHeadersNotObject="RequestHeadersNotObject",l.NoRef="NoRef",l.EmptyResponse="EmptyResponse",l.TurnedOff="TurnedOff",l.SessionExpired="SessionExpired",l.ServiceChanged="ServiceChanged",l.DefaultServiceChanged="DefaultServiceChanged",l.LocalTooManyRequests="LocalTooManyRequests",l.LocalPreconditionFailed="LocalPreconditionFailed",l.LocalInvalidContent="LocalInvalidContent",l.LocalError="LocalError",l.IncompatibleLocalContent="IncompatibleLocalContent",l.IncompatibleRemoteContent="IncompatibleRemoteContent",l.UnresolvedConflicts="UnresolvedConflicts",l.Unknown="Unknown"})(v=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class S extends Error{constructor(h,d,m,A){super(h);this.code=d,this.resource=m,this.operationId=A,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=S;class c extends S{constructor(h,d,m,A,_){super(h,m,void 0,_);this.url=d,this.serverCode=A}}e.UserDataSyncStoreError=c;class a extends S{constructor(h,d){super(h,d)}}e.UserDataAutoSyncError=a,function(l){function h(d){if(d instanceof l)return d;const m=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(d.name);if(m&&m[1]){const A=m[2]==="unknown"?void 0:m[2],_=m[3]==="unknown"?void 0:m[3];return new l(d.message,m[1],A,_)}return new l(d.message,"Unknown")}l.toUserDataSyncError=h}(S=e.UserDataSyncError||(e.UserDataSyncError={}));var t;(function(l){l.Uninitialized="uninitialized",l.Idle="idle",l.Syncing="syncing",l.HasConflicts="hasConflicts"})(t=e.SyncStatus||(e.SyncStatus={}));var s;(function(l){l[l.None=0]="None",l[l.Added=1]="Added",l[l.Modified=2]="Modified",l[l.Deleted=3]="Deleted"})(s=e.Change||(e.Change={}));var n;(function(l){l.Preview="preview",l.Conflict="conflict",l.Accepted="accepted"})(n=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function r(l){return`sync.enable.${l}`}e.getEnablementKey=r,e.IUserDataSyncResourceEnablementService=(0,y.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,y.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,y.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,y.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,y.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,y.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function o(l,h){if(l.scheme!==e.USER_DATA_SYNC_SCHEME)return l=l.with({scheme:h.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(d=>(0,k.isEqualOrParent)(l,(0,k.joinPath)(h.userDataSyncHome,d,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=o}),define(te[47],ne([0,1,17,6,21,27,3,36,2,16,25,18,7,136,22,13,14,45,23,20,24]),function(J,e,R,k,D,T,L,P,y,I,i,C,g,E,u,p,f,b,v,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function a(o){return!!(o&&o.version!==void 0&&typeof o.version=="number"&&o.content!==void 0&&typeof o.content=="string"&&(Object.keys(o).length===2||Object.keys(o).length===3&&o.machineId!==void 0&&typeof o.machineId=="string"))}e.isSyncData=a;let t=class extends y.Disposable{constructor(l,h,d,m,A,_,w,O,U,$){super();this.resource=l,this.fileService=h,this.environmentService=d,this.userDataSyncStoreService=A,this.userDataSyncBackupStoreService=_,this.userDataSyncResourceEnablementService=w,this.telemetryService=O,this.logService=U,this.configurationService=$,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new k.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new L.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,i.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(d.userDataSyncHome,1024)?I.extUri:I.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(d.userDataSyncHome,l),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,c.PREVIEW_DIR_NAME),this.lastSyncResource=(0,c.getLastSyncResourceUri)(l,d,this.extUri),this.currentMachineIdPromise=(0,b.getServiceMachineId)(d,h,m)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const l=await this.syncPreviewPromise;this.syncPreviewPromise=null;const h=await this.performSync(l.remoteUserData,l.lastSyncUserData,!0);this.setStatus(h)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const l=await this.getLastSyncUserData();(l?(await this.doGenerateSyncResourcePreview(l,l,!0,T.CancellationToken.None)).resourcePreviews.some(({remoteChange:d})=>d!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(l){if(this._status!==l){const h=this._status;l==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),h==="hasConflicts"&&l==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=l,this._onDidChangStatus.fire(l)}}async sync(l,h={}){await this._sync(l,!0,h)}async preview(l,h={}){return this._sync(l,!1,h)}async apply(l,h={}){try{this.syncHeaders={...h};const d=await this.doApply(l);return this.setStatus(d),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(l,h,d){try{if(this.syncHeaders={...d},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let m="idle";try{const A=await this.getLastSyncUserData(),_=await this.getLatestRemoteUserData(l,A);return m=await this.performSync(_,A,h),m==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):m==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(m)}}finally{this.syncHeaders={}}}async replace(l){const h=await this.resolveContent(l);if(!h)return!1;const d=this.parseSyncData(h);if(!d)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const m=await this.getLastSyncUserData(),A=await this.getLatestRemoteUserData(null,m),_=await this.isRemoteDataFromCurrentMachine(A),w=await this.generateSyncPreview({ref:A.ref,syncData:d},m,_,T.CancellationToken.None),O=[];for(const U of w){const $=await this.getAcceptResult(U,U.remoteResource,void 0,T.CancellationToken.None),{remoteChange:Y}=await this.getAcceptResult(U,U.previewResource,U.remoteContent,T.CancellationToken.None);O.push([U,{...$,remoteChange:Y!==0?Y:2}])}await this.applyResult(A,m,O,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(l){const h=await this.currentMachineIdPromise;return!!l.syncData?.machineId&&l.syncData.machineId===h}async getLatestRemoteUserData(l,h){if(h){const d=l&&l.latest?l.latest[this.resource]:void 0;if(h.ref===d||d===void 0&&h.syncData===null)return h}return this.getRemoteUserData(h)}async performSync(l,h,d){if(l.syncData&&l.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new c.UserDataSyncError((0,E.localize)(0,null,this.resource,this.version,l.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(l,h,d)}catch(m){if(m instanceof c.UserDataSyncError)switch(m.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(l,h,d);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),l=await this.getRemoteUserData(null),h=await this.getLastSyncUserData(),this.performSync(l,h,d)}throw m}}async doSync(l,h,d){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,k.createCancelablePromise)(A=>this.doGenerateSyncResourcePreview(l,h,d,A)));const m=await this.syncPreviewPromise;return this.updateConflicts(m.resourcePreviews),m.resourcePreviews.some(({mergeState:A})=>A==="conflict")?"hasConflicts":d?await this.doApply(!1):"syncing"}catch(m){throw this.syncPreviewPromise=null,m}}async merge(l){return await this.updateSyncResourcePreview(l,async h=>{const d=await this.getMergeResult(h,T.CancellationToken.None);await this.fileService.writeFile(h.previewResource,D.VSBuffer.fromString(d?.content||""));const m=d&&!d.hasConflicts?await this.getAcceptResult(h,h.previewResource,void 0,T.CancellationToken.None):void 0;return h.acceptResult=m,h.mergeState=d.hasConflicts?"conflict":m?"accepted":"preview",h.localChange=m?m.localChange:d.localChange,h.remoteChange=m?m.remoteChange:d.remoteChange,h}),this.syncPreviewPromise}async accept(l,h){return await this.updateSyncResourcePreview(l,async d=>{const m=await this.getAcceptResult(d,l,h,T.CancellationToken.None);return d.acceptResult=m,d.mergeState="accepted",d.localChange=m.localChange,d.remoteChange=m.remoteChange,d}),this.syncPreviewPromise}async discard(l){return await this.updateSyncResourcePreview(l,async h=>{const d=await this.getMergeResult(h,T.CancellationToken.None);return await this.fileService.writeFile(h.previewResource,D.VSBuffer.fromString(d.content||"")),h.acceptResult=void 0,h.mergeState="preview",h.localChange=d.localChange,h.remoteChange=d.remoteChange,h}),this.syncPreviewPromise}async updateSyncResourcePreview(l,h){if(!this.syncPreviewPromise)return;let d=await this.syncPreviewPromise;const m=d.resourcePreviews.findIndex(({localResource:A,remoteResource:_,previewResource:w})=>this.extUri.isEqual(A,l)||this.extUri.isEqual(_,l)||this.extUri.isEqual(w,l));m!==-1&&(this.syncPreviewPromise=(0,k.createCancelablePromise)(async A=>{const _=[...d.resourcePreviews];return _[m]=await h(_[m]),{...d,resourcePreviews:_}}),d=await this.syncPreviewPromise,this.updateConflicts(d.resourcePreviews),d.resourcePreviews.some(({mergeState:A})=>A==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(l){if(!this.syncPreviewPromise)return"idle";const h=await this.syncPreviewPromise;return h.resourcePreviews.some(({mergeState:d})=>d==="conflict")?"hasConflicts":h.resourcePreviews.some(({mergeState:d})=>d!=="accepted")?"syncing":(await this.applyResult(h.remoteUserData,h.lastSyncUserData,h.resourcePreviews.map(d=>[d,d.acceptResult]),l),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(l){}}updateConflicts(l){const h=l.filter(({mergeState:d})=>d==="conflict");(0,R.equals)(this._conflicts,h,(d,m)=>this.extUri.isEqual(d.previewResource,m.previewResource))||(this._conflicts=h,this._onDidChangeConflicts.fire(h))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:h,ref:d})=>({created:h,uri:this.toRemoteBackupResource(d)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:h,ref:d})=>({created:h,uri:this.toLocalBackupResource(d)}))}toRemoteBackupResource(l){return g.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${l}`})}toLocalBackupResource(l){return g.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${l}`})}async getMachineId({uri:l}){const h=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(h))){const{content:d}=await this.getUserData(h);if(d)return this.parseSyncData(d)?.machineId}}async resolveContent(l){const h=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(h))){const{content:d}=await this.getUserData(h);return d}return this.extUri.isEqual(l,this.toLocalBackupResource(h))?this.userDataSyncBackupStoreService.resolveContent(this.resource,h):null}async resolvePreviewContent(l){const h=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(h)for(const d of h.resourcePreviews){if(this.extUri.isEqual(d.acceptedResource,l))return d.acceptResult?d.acceptResult.content:null;if(this.extUri.isEqual(d.remoteResource,l))return d.remoteContent;if(this.extUri.isEqual(d.localResource,l))return d.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(l){}}async doGenerateSyncResourcePreview(l,h,d,m){const A=await this.isRemoteDataFromCurrentMachine(l),_=await this.generateSyncPreview(l,h,A,m),w=[];for(const O of _){const U=O.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(O.localChange===0&&O.remoteChange===0)w.push({...O,acceptedResource:U,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const $=d?await this.getMergeResult(O,m):void 0;if(m.isCancellationRequested)break;await this.fileService.writeFile(O.previewResource,D.VSBuffer.fromString($?.content||""));const Y=$&&!$.hasConflicts?await this.getAcceptResult(O,O.previewResource,void 0,m):void 0;w.push({...O,acceptResult:Y,mergeState:$?.hasConflicts?"conflict":Y?"accepted":"preview",localChange:Y?Y.localChange:$?$.localChange:O.localChange,remoteChange:Y?Y.remoteChange:$?$.remoteChange:O.remoteChange})}}return{remoteUserData:l,lastSyncUserData:h,resourcePreviews:w,isLastSyncFromCurrentMachine:A}}async getLastSyncUserData(){try{const l=await this.fileService.readFile(this.lastSyncResource),h=JSON.parse(l.value.toString()),d=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=h.version&&d&&h.version!==d,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${h.version} is not compatible with current sync state version ${d}.`),await this.resetLocal(),null;const m=h;if(m.content===null)return{ref:h.ref,syncData:null};const A=JSON.parse(m.content);if(a(A))return{...h,syncData:A,content:void 0}}catch(l){l instanceof f.FileOperationError&&l.fileOperationResult===1||this.logService.error(l)}return null}async updateLastSyncUserData(l,h={}){if(h.ref||h.content||h.version)throw new Error("Cannot have core properties as additional");const d=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),m={ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,version:d,...h};await this.fileService.writeFile(this.lastSyncResource,D.VSBuffer.fromString(JSON.stringify(m)))}async getRemoteUserData(l){const{ref:h,content:d}=await this.getUserData(l);let m=null;return d!==null&&(m=this.parseSyncData(d)),{ref:h,syncData:m}}parseSyncData(l){try{const h=JSON.parse(l);if(a(h))return h}catch(h){this.logService.error(h)}throw new c.UserDataSyncError((0,E.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(l){if((0,C.isString)(l)){const h=await this.userDataSyncStoreService.resolveContent(this.resource,l);return{ref:l,content:h}}else{const h=l?{ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,h,this.syncHeaders)}}async updateRemoteUserData(l,h){const d=await this.currentMachineIdPromise,m={version:this.version,machineId:d,content:l};return h=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(m),h,this.syncHeaders),{ref:h,syncData:m}}async backupLocal(l){const h={version:this.version,content:l};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(h))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};t=he([Q(1,f.IFileService),Q(2,p.IEnvironmentService),Q(3,v.IStorageService),Q(4,c.IUserDataSyncStoreService),Q(5,c.IUserDataSyncBackupStoreService),Q(6,c.IUserDataSyncResourceEnablementService),Q(7,S.ITelemetryService),Q(8,c.IUserDataSyncLogService),Q(9,u.IConfigurationService)],t),e.AbstractSynchroniser=t;let s=class extends t{constructor(l,h,d,m,A,_,w,O,U,$,Y){super(h,d,m,A,_,w,O,U,$,Y);this.file=l,this._register(this.fileService.watch(this.extUri.dirname(l))),this._register(this.fileService.onDidFilesChange(M=>this.onFileChanges(M)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(l){return null}}async updateLocalFileContent(l,h,d){try{h?await this.fileService.writeFile(this.file,D.VSBuffer.fromString(l),d?void 0:h):await this.fileService.createFile(this.file,D.VSBuffer.fromString(l),{overwrite:d})}catch(m){throw m instanceof f.FileOperationError&&m.fileOperationResult===1||m instanceof f.FileOperationError&&m.fileOperationResult===3?new c.UserDataSyncError(m.message,"LocalPreconditionFailed"):m}}onFileChanges(l){!l.contains(this.file)||this.triggerLocalChange()}};s=he([Q(2,f.IFileService),Q(3,p.IEnvironmentService),Q(4,v.IStorageService),Q(5,c.IUserDataSyncStoreService),Q(6,c.IUserDataSyncBackupStoreService),Q(7,c.IUserDataSyncResourceEnablementService),Q(8,S.ITelemetryService),Q(9,c.IUserDataSyncLogService),Q(10,u.IConfigurationService)],s),e.AbstractFileSynchroniser=s;let n=class extends s{constructor(l,h,d,m,A,_,w,O,U,$,Y,M){super(l,h,d,m,A,_,w,O,U,$,M);this.userDataSyncUtilService=Y,this._formattingOptions=void 0}hasErrors(l){const h=[];return(0,P.parse)(l,h,{allowEmptyContent:!0,allowTrailingComma:!0}),h.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};n=he([Q(2,f.IFileService),Q(3,p.IEnvironmentService),Q(4,v.IStorageService),Q(5,c.IUserDataSyncStoreService),Q(6,c.IUserDataSyncBackupStoreService),Q(7,c.IUserDataSyncResourceEnablementService),Q(8,S.ITelemetryService),Q(9,c.IUserDataSyncLogService),Q(10,c.IUserDataSyncUtilService),Q(11,u.IConfigurationService)],n),e.AbstractJsonFileSynchroniser=n;let r=class{constructor(l,h,d,m){this.resource=l,this.environmentService=h,this.logService=d,this.fileService=m,this.extUri=this.fileService.hasCapability(h.userDataSyncHome,1024)?I.extUri:I.extUriIgnorePathCase,this.lastSyncResource=(0,c.getLastSyncResourceUri)(this.resource,h,I.extUri)}async initialize({ref:l,content:h}){if(!h){this.logService.info("Remote content does not exist.",this.resource);return}const d=this.parseSyncData(h);if(!d)return;if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:l,syncData:d})}catch(A){this.logService.error(A)}}parseSyncData(l){try{const h=JSON.parse(l);if(a(h))return h}catch(h){this.logService.error(h)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(l,h={}){const d={ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,...h};await this.fileService.writeFile(this.lastSyncResource,D.VSBuffer.fromString(JSON.stringify(d)))}};r=he([Q(1,p.IEnvironmentService),Q(2,c.IUserDataSyncLogService),Q(3,f.IFileService)],r),e.AbstractInitializer=r}),define(te[212],ne([0,1,6,27,8,3,44,48,25,7,22,13,28,34,14,23,20,47,209,93,94,24]),function(J,e,R,k,D,T,L,P,y,I,i,C,g,E,u,p,f,b,v,S,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function t(l,h){const d=JSON.parse(l.content);if(l.version===1||l.version===2){const m=(await h.getInstalled(0)).filter(A=>A.isBuiltin);for(const A of d)l.version===1&&(A.enabled===!1&&(A.disabled=!0),delete A.enabled),l.version===2&&m.every(_=>!(0,E.areSameExtensions)(_.identifier,A.identifier))&&(A.installed=!0)}return d}function s(l,h,d){const m=d.get((0,E.getExtensionId)(l,h),0)||"{}";return JSON.parse(m)}e.getExtensionStorageState=s;function n(l,h,d,m){m.store((0,E.getExtensionId)(l,h),JSON.stringify(d),0,1)}e.storeExtensionStorageState=n;let r=class ft extends b.AbstractSynchroniser{constructor(h,d,m,A,_,w,O,U,$,Y,M,V,j,z){super("extensions",d,h,m,A,_,V,j,$,M);this.storageService=m,this.extensionManagementService=w,this.extensionEnablementService=O,this.ignoredExtensionsManagementService=U,this.extensionGalleryService=Y,this.extensionsStorageSyncService=z,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(T.Event.debounce(T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtensions,q=>q.some(({local:F})=>!!F)),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,q=>!q.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(h,d){const m=h.syncData?await t(h.syncData,this.extensionManagementService):null,A=d?.skippedExtensions||[],_=d?.syncData?await t(d.syncData,this.extensionManagementService):null,w=await this.extensionManagementService.getInstalled(),O=this.getLocalExtensions(w),U=this.ignoredExtensionsManagementService.getIgnoredExtensions(w);m?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:$,remote:Y}=(0,v.merge)(O,m,_,A,U),M={local:$,remote:Y,content:this.getPreviewContent(O,$.added,$.updated,$.removed),localChange:$.added.length>0||$.removed.length>0||$.updated.length>0?2:0,remoteChange:Y!==null?2:0};return[{skippedExtensions:A,localResource:this.localResource,localContent:this.format(O),localExtensions:O,remoteResource:this.remoteResource,remoteContent:m?this.format(m):null,previewResource:this.previewResource,previewResult:M,localChange:M.localChange,remoteChange:M.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(h,d,m,A){const _=[...d,...m],w=new Set,O=U=>{w.add(U.id.toLowerCase()),U.uuid&&w.add(U.uuid)};_.forEach(({identifier:U})=>O(U)),A.forEach(O);for(const U of h)w.has(U.identifier.id.toLowerCase())||U.identifier.uuid&&w.has(U.identifier.uuid)||_.push(U);return this.format(_)}async getMergeResult(h,d){return{...h.previewResult,hasConflicts:!1}}async getAcceptResult(h,d,m,A){if(this.extUri.isEqual(d,this.localResource))return this.acceptLocal(h);if(this.extUri.isEqual(d,this.remoteResource))return this.acceptRemote(h);if(this.extUri.isEqual(d,this.previewResource))return h.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async acceptLocal(h){const d=await this.extensionManagementService.getInstalled(),m=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),A=(0,v.merge)(h.localExtensions,null,null,h.skippedExtensions,m),{local:_,remote:w}=A;return{content:h.localContent,local:_,remote:w,localChange:_.added.length>0||_.removed.length>0||_.updated.length>0?2:0,remoteChange:w!==null?2:0}}async acceptRemote(h){const d=await this.extensionManagementService.getInstalled(),m=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),A=h.remoteContent?JSON.parse(h.remoteContent):null;if(A!==null){const _=(0,v.merge)(h.localExtensions,A,h.localExtensions,[],m),{local:w,remote:O}=_;return{content:h.remoteContent,local:w,remote:O,localChange:w.added.length>0||w.removed.length>0||w.updated.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:h.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(h,d,m,A){let{skippedExtensions:_,localExtensions:w}=m[0][0],{local:O,remote:U,localChange:$,remoteChange:Y}=m[0][1];if($===0&&Y===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),$!==0&&(await this.backupLocal(JSON.stringify(w)),_=await this.updateLocalExtensions(O.added,O.removed,O.updated,_)),U){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const M=JSON.stringify(U.all);h=await this.updateRemoteUserData(M,A?null:h.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${U.added.length?` Added: ${JSON.stringify(U.added.map(V=>V.identifier.id))}.`:""}${U.updated.length?` Updated: ${JSON.stringify(U.updated.map(V=>V.identifier.id))}.`:""}${U.removed.length?` Removed: ${JSON.stringify(U.removed.map(V=>V.identifier.id))}.`:""}`)}d?.ref!==h.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(h,{skippedExtensions:_}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${_.length?` Skipped: ${JSON.stringify(_.map(M=>M.identifier.id))}.`:""}`))}async getAssociatedResources({uri:h}){return[{resource:this.extUri.joinPath(h,"extensions.json"),comparableResource:ft.EXTENSIONS_DATA_URI}]}async resolveContent(h){if(this.extUri.isEqual(h,ft.EXTENSIONS_DATA_URI)){const m=await this.extensionManagementService.getInstalled(),A=this.ignoredExtensionsManagementService.getIgnoredExtensions(m),_=this.getLocalExtensions(m).filter(w=>!A.some(O=>(0,E.areSameExtensions)({id:O},w.identifier)));return this.format(_)}if(this.extUri.isEqual(this.remoteResource,h)||this.extUri.isEqual(this.localResource,h)||this.extUri.isEqual(this.acceptedResource,h))return this.resolvePreviewContent(h);let d=await super.resolveContent(h);if(d)return d;if(d=await super.resolveContent(this.extUri.dirname(h)),d){const m=this.parseSyncData(d);if(m)switch(this.extUri.basename(h)){case"extensions.json":return this.format(this.parseExtensions(m))}}return null}format(h){h.sort((A,_)=>!A.identifier.uuid&&_.identifier.uuid?-1:A.identifier.uuid&&!_.identifier.uuid?1:(0,y.compare)(A.identifier.id,_.identifier.id));const d=JSON.stringify(h),m=(0,P.format)(d,void 0,{});return(0,L.applyEdits)(d,m)}async hasLocalData(){try{const h=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(h).some(m=>m.installed||m.disabled))return!0}catch(h){}return!1}async updateLocalExtensions(h,d,m,A){const _=[],w=[],O=await this.extensionManagementService.getInstalled();if(d.length){const $=O.filter(({identifier:Y,isBuiltin:M})=>!M&&d.some(V=>(0,E.areSameExtensions)(Y,V)));await R.Promises.settled($.map(async Y=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,Y.identifier.id),await this.extensionManagementService.uninstall(Y,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,Y.identifier.id),_.push(Y.identifier)}))}(h.length||m.length)&&await R.Promises.settled([...h,...m].map(async $=>{const Y=O.find(V=>(0,E.areSameExtensions)(V.identifier,$.identifier));if(Y&&Y.isBuiltin){$.state&&Y.manifest.version===$.version&&this.updateExtensionState($.state,Y.manifest.publisher,Y.manifest.name,Y.manifest.version),$.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,$.identifier.id),await this.extensionEnablementService.disableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,$.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,$.identifier.id),await this.extensionEnablementService.enableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,$.identifier.id)),_.push($.identifier);return}const M=(await this.extensionGalleryService.getExtensions([$.identifier],k.CancellationToken.None))[0];if($.state&&(Y?Y.manifest.version===$.version:!!M)){const V=Y?Y.manifest.publisher:M.publisher,j=Y?Y.manifest.name:M.name;this.updateExtensionState($.state,V,j,Y?.manifest.version)}if(M)try{$.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,$.identifier.id,M.version),await this.extensionEnablementService.disableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,$.identifier.id,M.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,$.identifier.id,M.version),await this.extensionEnablementService.enableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,$.identifier.id,M.version)),Y||(await this.extensionManagementService.canInstall(M)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,$.identifier.id,M.version),await this.extensionManagementService.installFromGallery(M,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,$.identifier.id,M.version),_.push(M.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,M.displayName||M.identifier.id),w.push($)))}catch(V){w.push($),V instanceof g.ExtensionManagementError&&V.code===g.INSTALL_ERROR_INCOMPATIBLE?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,M.displayName||M.identifier.id):(this.logService.error(V),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,M.displayName||M.identifier.id))}else w.push($),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,$.identifier.id)}));const U=[];for(const $ of A)_.some(Y=>(0,E.areSameExtensions)(Y,$.identifier))||U.push($);for(const $ of w)U.some(Y=>(0,E.areSameExtensions)(Y.identifier,$.identifier))||U.push($);return U}updateExtensionState(h,d,m,A){const _=s(d,m,this.storageService),w=A?this.extensionsStorageSyncService.getKeysForSync({id:(0,E.getGalleryExtensionId)(d,m),version:A}):void 0;w?w.forEach(O=>{_[O]=h[O]}):Object.keys(h).forEach(O=>_[O]=h[O]),n(d,m,_,this.storageService)}parseExtensions(h){return JSON.parse(h.content)}getLocalExtensions(h){const d=this.extensionEnablementService.getDisabledExtensions();return h.map(({identifier:m,isBuiltin:A,manifest:_})=>{const w={identifier:m,version:_.version};d.some(O=>(0,E.areSameExtensions)(O,m))&&(w.disabled=!0),A||(w.installed=!0);try{const O=this.extensionsStorageSyncService.getKeysForSync({id:m.id,version:_.version});if(O){const U=s(_.publisher,_.name,this.storageService);w.state=Object.keys(U).reduce(($,Y)=>(O.includes(Y)&&($[Y]=U[Y]),$),{})}}catch(O){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,D.getErrorMessage)(O))}return w})}};r.EXTENSIONS_DATA_URI=I.URI.from({scheme:a.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),r=he([Q(0,C.IEnvironmentService),Q(1,u.IFileService),Q(2,p.IStorageService),Q(3,a.IUserDataSyncStoreService),Q(4,a.IUserDataSyncBackupStoreService),Q(5,g.IExtensionManagementService),Q(6,g.IGlobalExtensionEnablementService),Q(7,c.IIgnoredExtensionsManagementService),Q(8,a.IUserDataSyncLogService),Q(9,g.IExtensionGalleryService),Q(10,i.IConfigurationService),Q(11,a.IUserDataSyncResourceEnablementService),Q(12,f.ITelemetryService),Q(13,S.IExtensionsStorageSyncService)],r),e.ExtensionsSynchroniser=r;let o=class extends b.AbstractInitializer{constructor(h,d,m,A,_){super("extensions",A,_,m);this.extensionManagementService=h,this.ignoredExtensionsManagementService=d}async parseExtensions(h){return h.syncData?await t(h.syncData,this.extensionManagementService):null}generatePreview(h,d){const m=[],A=[],_=[];for(const w of h){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(w.identifier.id))continue;const O=d.find(U=>(0,E.areSameExtensions)(U.identifier,w.identifier));O?(m.push(O),w.disabled&&_.push(w.identifier)):w.installed&&(A.push(w.identifier),w.disabled&&_.push(w.identifier))}return{installedExtensions:m,newExtensions:A,disabledExtensions:_,remoteExtensions:h}}};o=he([Q(0,g.IExtensionManagementService),Q(1,c.IIgnoredExtensionsManagementService),Q(2,u.IFileService),Q(3,C.IEnvironmentService),Q(4,a.IUserDataSyncLogService)],o),e.AbstractExtensionsInitializer=o}),define(te[213],ne([0,1,26,24]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(P,y,I,i,C){if(!y)return{remote:Object.keys(P).length>0?P:null,local:{added:{},removed:[],updated:{}}};const g=T(P,y);if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const E=I?T(I,y):{added:Object.keys(y).reduce((v,S)=>(v.add(S),v),new Set),removed:new Set,updated:new Set},u=I?T(I,P):{added:Object.keys(P).reduce((v,S)=>(v.add(S),v),new Set),removed:new Set,updated:new Set},p={added:{},removed:[],updated:{}},f=R.deepClone(y),b=!I;for(const v of u.added.values())v!==k.SYNC_SERVICE_URL_TYPE&&b&&E.added.has(v)||(f[v]=P[v]);for(const v of u.updated.values())f[v]=P[v];for(const v of u.removed.values())i.unregistered.includes(v)||delete f[v];for(const v of E.added.values()){const S=y[v];if(i.machine.includes(v)){C.info(`GlobalState: Skipped adding ${v} in local storage because it is declared as machine scoped.`);continue}if(I&&u.added.has(v))continue;const c=P[v];c&&c.value===S.value||v===k.SYNC_SERVICE_URL_TYPE&&b&&u.added.has(v)||(c?p.updated[v]=S:p.added[v]=S)}for(const v of E.updated.values()){const S=y[v];if(i.machine.includes(v)){C.info(`GlobalState: Skipped updating ${v} in local storage because it is declared as machine scoped.`);continue}if(u.updated.has(v)||u.removed.has(v))continue;const c=P[v];c&&c.value===S.value||(p.updated[v]=S)}for(const v of E.removed.values()){if(i.machine.includes(v)){C.trace(`GlobalState: Skipped removing ${v} in local storage because it is declared as machine scoped.`);continue}u.updated.has(v)||u.removed.has(v)||p.removed.push(v)}return{local:p,remote:L(f,y)?null:f}}e.merge=D;function T(P,y){const I=Object.keys(P),i=Object.keys(y),C=i.filter(u=>I.indexOf(u)===-1).reduce((u,p)=>(u.add(p),u),new Set),g=I.filter(u=>i.indexOf(u)===-1).reduce((u,p)=>(u.add(p),u),new Set),E=new Set;for(const u of I){if(g.has(u))continue;const p=P[u],f=y[u];R.equals(p,f)||E.add(u)}return{added:C,removed:g,updated:E}}function L(P,y){const{added:I,removed:i,updated:C}=T(P,y);return I.size===0&&i.size===0&&C.size===0}}),define(te[214],ne([0,1,21,3,36,44,48,4,7,30,22,13,14,10,45,23,20,47,54,213,24]),function(J,e,R,k,D,T,L,P,y,I,i,C,g,E,u,p,f,b,v,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const a="globalState.argv.",t=["locale"];function s(h){const d=h.storage?Object.keys(h.storage).sort():[],m={};d.forEach(w=>m[w]=h.storage[w]),h.storage=m;const A=JSON.stringify(h),_=(0,L.format)(A,void 0,{});return(0,T.applyEdits)(A,_)}const n=1;let r=class dt extends b.AbstractSynchroniser{constructor(d,m,A,_,w,O,U,$,Y){super("globalState",d,w,Y,m,A,O,U,_,$);this.storageService=Y,this.version=n,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(d.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(k.Event.any(k.Event.filter(d.onDidFilesChange,M=>M.contains(this.environmentService.argvResource)),k.Event.filter(Y.onDidChangeValue,M=>M.scope===0&&M.target!==void 0?M.target===0:Y.keys(0,0).includes(M.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(d,m,A,_){const w=d.syncData?JSON.parse(d.syncData.content):null;m=m===null&&A?d:m;const O=m&&m.syncData?JSON.parse(m.syncData.content):null,U=await this.getLocalGlobalState();w?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const $=this.getStorageKeys(O),{local:Y,remote:M}=(0,S.merge)(U.storage,w?w.storage:null,O?O.storage:null,$,this.logService),V={content:null,local:Y,remote:M,localChange:Object.keys(Y.added).length>0||Object.keys(Y.updated).length>0||Y.removed.length>0?2:0,remoteChange:M!==null?2:0};return[{localResource:this.localResource,localContent:s(U),localUserData:U,remoteResource:this.remoteResource,remoteContent:w?s(w):null,previewResource:this.previewResource,previewResult:V,localChange:V.localChange,remoteChange:V.remoteChange,acceptedResource:this.acceptedResource,storageKeys:$}]}async getMergeResult(d,m){return{...d.previewResult,hasConflicts:!1}}async getAcceptResult(d,m,A,_){if(this.extUri.isEqual(m,this.localResource))return this.acceptLocal(d);if(this.extUri.isEqual(m,this.remoteResource))return this.acceptRemote(d);if(this.extUri.isEqual(m,this.previewResource))return d.previewResult;throw new Error(`Invalid Resource: ${m.toString()}`)}async acceptLocal(d){return{content:d.localContent,local:{added:{},removed:[],updated:{}},remote:d.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(d){if(d.remoteContent!==null){const m=JSON.parse(d.remoteContent),{local:A,remote:_}=(0,S.merge)(d.localUserData.storage,m.storage,null,d.storageKeys,this.logService);return{content:d.remoteContent,local:A,remote:_,localChange:Object.keys(A.added).length>0||Object.keys(A.updated).length>0||A.removed.length>0?2:0,remoteChange:_!==null?2:0}}else return{content:d.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(d,m,A,_){let{localUserData:w}=A[0][0],{local:O,remote:U,localChange:$,remoteChange:Y}=A[0][1];if($===0&&Y===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),$!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(w)),await this.writeLocalGlobalState(O),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),Y!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const M=JSON.stringify({storage:U});d=await this.updateRemoteUserData(M,_?null:d.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}m?.ref!==d.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(d),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:d}){return[{resource:this.extUri.joinPath(d,"globalState.json"),comparableResource:dt.GLOBAL_STATE_DATA_URI}]}async resolveContent(d){if(this.extUri.isEqual(d,dt.GLOBAL_STATE_DATA_URI)){const A=await this.getLocalGlobalState();return s(A)}if(this.extUri.isEqual(this.remoteResource,d)||this.extUri.isEqual(this.localResource,d)||this.extUri.isEqual(this.acceptedResource,d))return this.resolvePreviewContent(d);let m=await super.resolveContent(d);if(m)return m;if(m=await super.resolveContent(this.extUri.dirname(d)),m){const A=this.parseSyncData(m);if(A)switch(this.extUri.basename(d)){case"globalState.json":return s(JSON.parse(A.content))}}return null}async hasLocalData(){try{const{storage:d}=await this.getLocalGlobalState();if(Object.keys(d).length>1||d[`${a}.locale`]?.value!=="en")return!0}catch(d){}return!1}async getLocalGlobalState(){const d={},m=await this.getLocalArgvContent(),A=(0,D.parse)(m);for(const _ of t)A[_]!==void 0&&(d[`${a}${_}`]={version:1,value:A[_]});for(const _ of this.storageService.keys(0,0)){const w=this.storageService.get(_,0);w&&(d[_]={version:1,value:w})}return{storage:d}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(d){}return"{}"}async writeLocalGlobalState({added:d,removed:m,updated:A}){const _={},w={},O=($,Y)=>{for(const M of $){if(M.startsWith(a)){_[M.substring(a.length)]=Y?Y[M].value:void 0;continue}if(Y){const V=Y[M];V.value!==String(this.storageService.get(M,0))&&(w[M]=V.value)}else this.storageService.get(M,0)!==void 0&&(w[M]=void 0)}};if(O(Object.keys(d),d),O(Object.keys(A),A),O(m),Object.keys(_).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(_),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(w).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const $ of Object.keys(w))this.storageService.store($,w[$],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(w))}}async updateArgv(d){const m=await this.getLocalArgvContent();let A=m;for(const _ of Object.keys(d))A=(0,v.edit)(A,[_],d[_],{});m!==A&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(A)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(d){const m=this.storageService.keys(0,0),A=this.storageService.keys(0,1),_=[...m,...A],w=d?.storage?Object.keys(d.storage).filter(O=>!O.startsWith(a)&&!_.includes(O)&&this.storageService.get(O,0)!==void 0):[];if(!P.isWeb){const O=[...c.ALL_SYNC_RESOURCES.map(U=>(0,c.getEnablementKey)(U)),c.SYNC_SERVICE_URL_TYPE];w.push(...O),A.push(...O)}return{user:m,machine:A,unregistered:w}}};r.GLOBAL_STATE_DATA_URI=y.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),r=he([Q(0,g.IFileService),Q(1,c.IUserDataSyncStoreService),Q(2,c.IUserDataSyncBackupStoreService),Q(3,c.IUserDataSyncLogService),Q(4,C.IEnvironmentService),Q(5,c.IUserDataSyncResourceEnablementService),Q(6,f.ITelemetryService),Q(7,i.IConfigurationService),Q(8,p.IStorageService)],r),e.GlobalStateSynchroniser=r;let o=class extends b.AbstractInitializer{constructor(d,m,A,_){super("globalState",A,_,m);this.storageService=d}async doInitialize(d){const m=d.syncData?JSON.parse(d.syncData.content):null;if(!m){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const A={},_={};for(const w of Object.keys(m.storage))w.startsWith(a)?A[w.substring(a.length)]=m.storage[w].value:this.storageService.get(w,0)===void 0&&(_[w]=m.storage[w].value);if(Object.keys(A).length){let w="{}";try{w=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(O){}for(const O of Object.keys(A))w=(0,v.edit)(w,[O],A[O],{});await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(w))}if(Object.keys(_).length)for(const w of Object.keys(_))this.storageService.store(w,_[w],0,0)}};o=he([Q(0,p.IStorageService),Q(1,g.IFileService),Q(2,C.IEnvironmentService),Q(3,c.IUserDataSyncLogService)],o),e.GlobalStateInitializer=o;let l=class{constructor(d,m,A,_,w){this.userDataSyncStoreClient=d,this.storageService=m,this.environmentService=A,this.fileService=_,this.logService=w}getSyncStoreType(d){return this.parseGlobalState(d)?.storage[c.SYNC_SERVICE_URL_TYPE]?.value}async sync(d){const m=(0,c.createSyncHeaders)((0,I.generateUuid)());try{return await this.doSync(d,m)}catch(A){if(A instanceof c.UserDataSyncError)switch(A.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(d,m)}throw A}}async doSync(d,m){const A=await this.userDataSyncStoreClient.read("globalState",null,m),_=this.parseGlobalState(A)||{storage:{}};_.storage[c.SYNC_SERVICE_URL_TYPE]={value:d,version:n};const w=await(0,u.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),O={version:n,machineId:w,content:s(_)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(O),A.ref,m)}parseGlobalState({content:d}){if(!d)return null;const m=JSON.parse(d);if((0,b.isSyncData)(m))return m?JSON.parse(m.content):null;throw new Error("Invalid remote data")}};l=he([Q(1,p.IStorageService),Q(2,C.IEnvironmentService),Q(3,g.IFileService),Q(4,E.ILogService)],l),e.UserDataSyncStoreTypeSynchronizer=l}),define(te[215],ne([0,1,17,21,3,36,4,18,137,22,13,14,23,20,47,210,24]),function(J,e,R,k,D,T,L,P,y,I,i,C,g,E,u,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function b(c,a){const t=JSON.parse(c);if(!a)return(0,P.isUndefined)(t.all)?null:t.all;switch(L.OS){case 2:return(0,P.isUndefined)(t.mac)?null:t.mac;case 3:return(0,P.isUndefined)(t.linux)?null:t.linux;case 1:return(0,P.isUndefined)(t.windows)?null:t.windows}}e.getKeybindingsContentFromSyncContent=b;let v=class extends u.AbstractJsonFileSynchroniser{constructor(a,t,s,n,r,o,l,h,d,m){super(l.keybindingsResource,"keybindings",o,l,h,a,t,r,m,s,d,n);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(D.Event.filter(n.onDidChangeConfiguration,A=>A.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(a,t,s,n){const r=a.syncData?this.getKeybindingsContentFromSyncContent(a.syncData.content):null;t=t===null&&s?a:t;const o=t?this.getKeybindingsContentFromLastSyncUserData(t):null,l=await this.getLocalFileContent(),h=await this.getFormattingOptions();let d=null,m=!1,A=!1,_=!1;if(r){let O=l?l.value.toString():"[]";if(O=O||"[]",this.hasErrors(O))throw new f.UserDataSyncError((0,y.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==O||o!==r){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const U=await(0,p.merge)(O,r,o,h,this.userDataSyncUtilService);U.hasChanges&&(d=U.mergeContent,_=U.hasConflicts,m=_||U.mergeContent!==O,A=_||U.mergeContent!==r)}}else l&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),d=l.value.toString(),A=!0);const w={content:d,localChange:m?l?2:1:0,remoteChange:A?2:0,hasConflicts:_};return[{fileContent:l,localResource:this.localResource,localContent:l?l.value.toString():null,localChange:w.localChange,remoteResource:this.remoteResource,remoteContent:r,remoteChange:w.remoteChange,previewResource:this.previewResource,previewResult:w,acceptedResource:this.acceptedResource}]}async getMergeResult(a,t){return a.previewResult}async getAcceptResult(a,t,s,n){if(this.extUri.isEqual(t,this.localResource))return{content:a.fileContent?a.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:a.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return s===void 0?{content:a.previewResult.content,localChange:a.previewResult.localChange,remoteChange:a.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(a,t,s,n){const{fileContent:r}=s[0][0];let{content:o,localChange:l,remoteChange:h}=s[0][1];if(l===0&&h===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.hasErrors(o)))throw new f.UserDataSyncError((0,y.localize)(1,null),"LocalInvalidContent",this.resource);if(l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),r&&await this.backupLocal(this.toSyncContent(r.value.toString())),await this.updateLocalFileContent(o||"[]",r,n),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),h!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const d=this.toSyncContent(o||"[]",a.syncData?.content);a=await this.updateRemoteUserData(d,n?null:a.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(d){}t?.ref!==a.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(a,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const a=await this.getLocalFileContent();if(a){const t=(0,T.parse)(a.value.toString());if((0,R.isNonEmptyArray)(t))return!0}}catch(a){if(a.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:a}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(a,"keybindings.json"),comparableResource:t}]}async resolveContent(a){if(this.extUri.isEqual(this.remoteResource,a)||this.extUri.isEqual(this.localResource,a)||this.extUri.isEqual(this.acceptedResource,a))return this.resolvePreviewContent(a);let t=await super.resolveContent(a);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(a)),t){const s=this.parseSyncData(t);if(s)switch(this.extUri.basename(a)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(s.content)}}return null}getKeybindingsContentFromLastSyncUserData(a){return!a.syncData||a.platformSpecific!==void 0&&a.platformSpecific!==this.syncKeybindingsPerPlatform()?null:this.getKeybindingsContentFromSyncContent(a.syncData.content)}getKeybindingsContentFromSyncContent(a){try{return b(a,this.syncKeybindingsPerPlatform())}catch(t){return this.logService.error(t),null}}toSyncContent(a,t){let s={};try{s=JSON.parse(t||"{}")}catch(n){this.logService.error(n)}switch(this.syncKeybindingsPerPlatform()?delete s.all:s.all=a,L.OS){case 2:s.mac=a;break;case 3:s.linux=a;break;case 1:s.windows=a;break}return JSON.stringify(s)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};v=he([Q(0,f.IUserDataSyncStoreService),Q(1,f.IUserDataSyncBackupStoreService),Q(2,f.IUserDataSyncLogService),Q(3,I.IConfigurationService),Q(4,f.IUserDataSyncResourceEnablementService),Q(5,C.IFileService),Q(6,i.IEnvironmentService),Q(7,g.IStorageService),Q(8,f.IUserDataSyncUtilService),Q(9,E.ITelemetryService)],v),e.KeybindingsSynchroniser=v;let S=class extends u.AbstractInitializer{constructor(a,t,s){super("keybindings",t,s,a)}async doInitialize(a){const t=a.syncData?this.getKeybindingsContentFromSyncContent(a.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,k.VSBuffer.fromString(t)),await this.updateLastSyncUserData(a)}async isEmpty(){try{const a=await this.fileService.readFile(this.environmentService.settingsResource),t=(0,T.parse)(a.value.toString());return!(0,R.isNonEmptyArray)(t)}catch(a){return a.fileOperationResult===1}}getKeybindingsContentFromSyncContent(a){try{return b(a,!0)}catch(t){return this.logService.error(t),null}}};S=he([Q(0,C.IFileService),Q(1,i.IEnvironmentService),Q(2,f.IUserDataSyncLogService)],S),e.KeybindingsInitializer=S}),define(te[216],ne([0,1,17,36,44,48,26,54,24]),function(J,e,R,k,D,T,L,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function I(l,h,d){let m=[];d?m=C(d):m=i(h);const A=[],_=[...(0,y.getDisallowedIgnoredSettings)()];if(Array.isArray(m))for(const w of m)w.startsWith("-")?_.push(w.substring(1)):A.push(w);return(0,R.distinct)([...l,...A].filter(w=>_.indexOf(w)===-1))}e.getIgnoredSettings=I;function i(l){let h=l.inspect("settingsSync.ignoredSettings").userValue;return h!==void 0||(h=l.inspect("sync.ignoredSettings").userValue,h!==void 0)?h:l.getValue("settingsSync.ignoredSettings")||[]}function C(l){const h=(0,k.parse)(l);return h?h["settingsSync.ignoredSettings"]||h["sync.ignoredSettings"]||[]:[]}function g(l,h,d,m){if(d.length){const A=o(h),_=(0,k.parse)(h),w=(0,k.parse)(l),O=[];for(const U of d){const $=_[U],Y=w[U];$===void 0?l=P.edit(l,[U],void 0,m):Y!==void 0?l=P.edit(l,[U],$,m):O.push(a(U,A))}O.sort((U,$)=>U.startOffset-$.startOffset),O.forEach(U=>l=b(U.setting.key,h,l,m))}return l}e.updateIgnoredSettings=g;function E(l,h,d,m,A,_){const w=g(l,h,m,_),O=d!==w,U=d!==h;if(!O&&!U)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(O&&!U)return{conflictsSettings:[],localContent:null,remoteContent:w,hasConflicts:!1};if(U&&!O)return{conflictsSettings:[],localContent:g(h,l,m,_),remoteContent:null,hasConflicts:!1};if(d===null&&p(l)){const H=u(l,h,m)?null:g(h,l,m,_);return{conflictsSettings:[],localContent:H,remoteContent:null,hasConflicts:!1}}let $=l,Y=h;const M=(0,k.parse)(l),V=(0,k.parse)(h),j=d?(0,k.parse)(d):null,z=m.reduce((H,ie)=>(H.add(ie),H),new Set),q=f(M,V,z),F=f(j,M,z),G=f(j,V,z),x=new Map,N=new Set,W=H=>{N.add(H);const ie=A.filter(({key:re})=>re===H)[0];ie?($=P.edit($,[H],ie.value,_),Y=P.edit(Y,[H],ie.value,_)):x.set(H,{key:H,localValue:M[H],remoteValue:V[H]})};for(const H of F.removed.values())G.updated.has(H)?W(H):Y=P.edit(Y,[H],void 0,_);for(const H of G.removed.values())N.has(H)||(F.updated.has(H)?W(H):$=P.edit($,[H],void 0,_));for(const H of F.updated.values())N.has(H)||(G.updated.has(H)?q.updated.has(H)&&W(H):Y=P.edit(Y,[H],M[H],_));for(const H of G.updated.values())N.has(H)||(F.updated.has(H)?q.updated.has(H)&&W(H):$=P.edit($,[H],V[H],_));for(const H of F.added.values())N.has(H)||(G.added.has(H)?q.updated.has(H)&&W(H):Y=b(H,$,Y,_));for(const H of G.added.values())N.has(H)||(F.added.has(H)?q.updated.has(H)&&W(H):$=b(H,Y,$,_));const X=x.size>0||!u($,Y,m),Z=X||!u($,l,[]),B=X||!u(Y,h,[]);return{localContent:Z?$:null,remoteContent:B?Y:null,conflictsSettings:[...x.values()],hasConflicts:X}}e.merge=E;function u(l,h,d){if(l===h)return!0;const m=(0,k.parse)(l),A=(0,k.parse)(h),_=d.reduce((U,$)=>(U.add($),U),new Set),w=o(l).filter(U=>!(U.setting&&_.has(U.setting.key))),O=o(h).filter(U=>!(U.setting&&_.has(U.setting.key)));if(w.length!==O.length)return!1;for(let U=0;U<w.length;U++){const $=w[U],Y=O[U];if($.setting&&Y.setting){if($.setting.key!==Y.setting.key||!L.equals(m[$.setting.key],A[$.setting.key]))return!1}else if(!$.setting&&!Y.setting){if($.value!==Y.value)return!1}else return!1}return!0}e.areSame=u;function p(l){return l?o(l).length===0:!0}e.isEmpty=p;function f(l,h,d){const m=l?Object.keys(l).filter(U=>!d.has(U)):[],A=Object.keys(h).filter(U=>!d.has(U)),_=A.filter(U=>m.indexOf(U)===-1).reduce((U,$)=>(U.add($),U),new Set),w=m.filter(U=>A.indexOf(U)===-1).reduce((U,$)=>(U.add($),U),new Set),O=new Set;if(l)for(const U of m){if(w.has(U))continue;const $=l[U],Y=h[U];L.equals($,Y)||O.add(U)}return{added:_,removed:w,updated:O}}function b(l,h,d,m){const A=(0,k.parse)(h),_=o(h),w=o(d),O=v(l,_,w);return S(d,l,A[l],O,w,m)}e.addSetting=b;function v(l,h,d){const m=h.findIndex(_=>_.setting?.key===l),A=h[m-1];if(A){if(A.setting){const w=a(A.setting.key,d);if(w)return{index:d.indexOf(w),insertAfter:!0}}else{const w=t(m,h);if(w){const O=a(w.setting.key,d);if(O){const U=s(d.indexOf(O),d),$=n(h,w,h[m]);if(U){const Y=n(d,O,U),M=r($,Y);return M?{index:d.indexOf(M),insertAfter:!0}:{index:d.indexOf(U),insertAfter:!1}}else{const Y=n(d,O,d[d.length-1]),M=r($,Y);return M?{index:d.indexOf(M),insertAfter:!0}:{index:d.length-1,insertAfter:!0}}}}}const _=h[m+1];if(_)if(_.setting){const w=a(_.setting.key,d);if(w)return{index:d.indexOf(w),insertAfter:!1}}else{const w=s(m,h);if(w){const O=a(w.setting.key,d);if(O){const U=t(d.indexOf(O),d),$=n(h,h[m],w);if(U){const Y=n(d,U,O),M=r($.reverse(),Y.reverse());return M?{index:d.indexOf(M),insertAfter:!1}:{index:d.indexOf(U),insertAfter:!0}}else{const Y=n(d,d[0],O),M=r($.reverse(),Y.reverse());return M?{index:d.indexOf(M),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:d.length-1,insertAfter:!0}}function S(l,h,d,m,A,_){let w;return m.index===-1?w=(0,D.setProperty)(l,[h],d,_):w=c(l,h,d,m,A,_).map(O=>(0,D.withFormatting)(l,O,_)[0]),(0,D.applyEdits)(l,w)}function c(l,h,d,m,A,_){const w=`${JSON.stringify(h)}: ${JSON.stringify(d)}`,O=(0,T.getEOL)(_,l),U=A[m.index];if(m.insertAfter){const $=[];if(U.setting)$.push({offset:U.endOffset,length:0,content:","+w});else{const Y=s(m.index,A),M=t(m.index,A),V=M?.setting?.commaOffset;M&&V===void 0&&$.push({offset:M.endOffset,length:0,content:","});const j=V!==void 0&&V>U.endOffset;$.push({offset:j?V+1:U.endOffset,length:0,content:Y?O+w+",":O+w})}return $}else{if(U.setting)return[{offset:U.startOffset,length:0,content:w+","}];const $=(A[m.index-1]&&!A[m.index-1].setting?O:"")+w+(s(m.index,A)?",":"")+O;return[{offset:U.startOffset,length:0,content:$}]}}function a(l,h){return h.filter(d=>d.setting?.key===l)[0]}function t(l,h){for(let d=l-1;d>=0;d--)if(h[d].setting)return h[d]}function s(l,h){for(let d=l+1;d<h.length;d++)if(h[d].setting)return h[d]}function n(l,h,d){const m=l.indexOf(h),A=l.indexOf(d);return l.filter((_,w)=>m<w&&w<A)}function r(l,h){if(l.length&&h.length){let d=0;for(;d<h.length&&d<l.length;d++)if(l[d].value!==h[d].value)return h[d-1];return h[d-1]}}function o(l){const h=[];let d=-1,m,A;const _={onObjectBegin:w=>{d++},onObjectProperty:(w,O,U)=>{d===0&&(m=O,A=w)},onObjectEnd:(w,O)=>{d--,d===0&&h.push({startOffset:m,endOffset:w+O,value:l.substring(m,w+O),setting:{key:A,commaOffset:void 0}})},onArrayBegin:(w,O)=>{d++},onArrayEnd:(w,O)=>{d--,d===0&&h.push({startOffset:m,endOffset:w+O,value:l.substring(m,w+O),setting:{key:A,commaOffset:void 0}})},onLiteralValue:(w,O,U)=>{d===0&&h.push({startOffset:m,endOffset:O+U,value:l.substring(m,O+U),setting:{key:A,commaOffset:void 0}})},onSeparator:(w,O,U)=>{if(d===0&&w===","){let $=h.length-1;for(;$>=0&&!h[$].setting;$--);const Y=h[$];Y&&h.splice($,1,{startOffset:Y.startOffset,endOffset:Y.endOffset,value:Y.value,setting:{key:Y.setting.key,commaOffset:O}})}},onComment:(w,O)=>{d===0&&h.push({startOffset:w,endOffset:w+O,value:l.substring(w,w+O)})}};return(0,k.visit)(l,_),h}}),define(te[217],ne([0,1,21,3,44,138,22,13,28,14,23,20,47,54,216,24]),function(J,e,R,k,D,T,L,P,y,I,i,C,g,E,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function f(a){return a&&a.settings&&typeof a.settings=="string"&&Object.keys(a).length===1}function b(a){const t=JSON.parse(a);return f(t)?t:{settings:a}}e.parseSettingsSyncContent=b;let v=class extends g.AbstractJsonFileSynchroniser{constructor(t,s,n,r,o,l,h,d,m,A,_){super(s.settingsResource,"settings",t,s,n,r,o,m,A,l,h,d);this.extensionManagementService=_,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(t,s,n,r){const o=await this.getLocalFileContent(),l=await this.getFormattingOptions(),h=this.getSettingsSyncContent(t);s=s===null&&n?t:s;const d=s?this.getSettingsSyncContent(s):null,m=await this.getIgnoredSettings();let A=null,_=!1,w=!1,O=!1;if(h){let $=o?o.value.toString().trim():"{}";$=$||"{}",this.validateContent($),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const Y=(0,u.merge)($,h.settings,d?d.settings:null,m,[],l);A=Y.localContent||Y.remoteContent,_=Y.localContent!==null,w=Y.remoteContent!==null,O=Y.hasConflicts}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),A=o.value.toString(),w=!0);const U={content:A,localChange:_?2:0,remoteChange:w?2:0,hasConflicts:O};return[{fileContent:o,localResource:this.localResource,localContent:o?o.value.toString():null,localChange:U.localChange,remoteResource:this.remoteResource,remoteContent:h?h.settings:null,remoteChange:U.remoteChange,previewResource:this.previewResource,previewResult:U,acceptedResource:this.acceptedResource}]}async getMergeResult(t,s){const n=await this.getFormattingOptions(),r=await this.getIgnoredSettings();return{...t.previewResult,content:t.previewResult.content?(0,u.updateIgnoredSettings)(t.previewResult.content,"{}",r,n):null}}async getAcceptResult(t,s,n,r){const o=await this.getFormattingOptions(),l=await this.getIgnoredSettings();if(this.extUri.isEqual(s,this.localResource))return{content:t.fileContent?(0,u.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",l,o):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(s,this.remoteResource))return{content:t.remoteContent!==null?(0,u.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",l,o):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(s,this.previewResource))return n===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:n!==null?(0,u.updateIgnoredSettings)(n,t.fileContent?t.fileContent.value.toString():"{}",l,o):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${s.toString()}`)}async applyResult(t,s,n,r){const{fileContent:o}=n[0][0];let{content:l,localChange:h,remoteChange:d}=n[0][1];if(h===0&&d===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),l=l?l.trim():"{}",l=l||"{}",this.validateContent(l),h!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),o&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(o.value.toString()))),await this.updateLocalFileContent(l,o,r),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),d!==0){const m=await this.getFormattingOptions(),A=this.getSettingsSyncContent(t),_=await this.getIgnoredSettings(l);l=(0,u.updateIgnoredSettings)(l,A?A.settings:"{}",_,m),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(l)),r?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(m){}s?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const s=await this.getFormattingOptions(),n=(0,E.edit)(t.value.toString(),[p.CONFIGURATION_SYNC_STORE_KEY],void 0,s);return!(0,u.isEmpty)(n)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const s=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:s}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let s=await super.resolveContent(t);if(s)return s;if(s=await super.resolveContent(this.extUri.dirname(t)),s){const n=this.parseSyncData(s);if(n){const r=this.parseSettingsSyncContent(n.content);if(r)switch(this.extUri.basename(t)){case"settings.json":return r.settings}}}return null}async resolvePreviewContent(t){let s=await super.resolvePreviewContent(t);if(s){const n=await this.getFormattingOptions(),r=await this.getIgnoredSettings();s=(0,u.updateIgnoredSettings)(s,"{}",r,n)}return s}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return b(t)}catch(s){this.logService.error(s)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const n=k.Event.any(k.Event.filter(this.extensionManagementService.onDidInstallExtensions,r=>r.some(({local:o})=>!!o)),k.Event.filter(this.extensionManagementService.onDidUninstallExtension,r=>!r.error))(()=>{n.dispose(),this._defaultIgnoredSettings=void 0})}const s=await this._defaultIgnoredSettings;return(0,u.getIgnoredSettings)(s,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new p.UserDataSyncError((0,T.localize)(0,null),"LocalInvalidContent",this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const s=JSON.parse(t.value.toString());if(!c(s))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const n=this.parseSettingsSyncContent(s.content);if(!n||!n.settings)return;let r=n.settings;const o=await this.getFormattingOptions();for(const l in s)if(["version","content","machineId"].indexOf(l)===-1&&s[l]!==void 0){const h=(0,D.setProperty)(r,[l],s[l],o);h.length&&(r=(0,D.applyEdits)(r,h))}await this.fileService.writeFile(this.file,R.VSBuffer.fromString(r))}catch(t){}}};v=he([Q(0,I.IFileService),Q(1,P.IEnvironmentService),Q(2,i.IStorageService),Q(3,p.IUserDataSyncStoreService),Q(4,p.IUserDataSyncBackupStoreService),Q(5,p.IUserDataSyncLogService),Q(6,p.IUserDataSyncUtilService),Q(7,L.IConfigurationService),Q(8,p.IUserDataSyncResourceEnablementService),Q(9,C.ITelemetryService),Q(10,y.IExtensionManagementService)],v),e.SettingsSynchroniser=v;let S=class extends g.AbstractInitializer{constructor(t,s,n){super("settings",s,n,t)}async doInitialize(t){const s=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!s){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,R.VSBuffer.fromString(s.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,u.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return b(t)}catch(s){this.logService.error(s)}return null}};S=he([Q(0,I.IFileService),Q(1,P.IEnvironmentService),Q(2,p.IUserDataSyncLogService)],S),e.SettingsInitializer=S;function c(a){return!!(a&&a.version!==void 0&&typeof a.version=="number"&&a.content!==void 0&&typeof a.content=="string"&&a.machineId!==void 0&&typeof a.machineId=="string")}}),define(te[218],ne([0,1,21,3,26,22,13,14,23,20,47,211,24]),function(J,e,R,k,D,T,L,P,y,I,i,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let E=class extends i.AbstractSynchroniser{constructor(f,b,v,S,c,a,t,s,n){super("snippets",b,f,v,S,c,s,n,a,t);this.version=1,this.snippetsFolder=f.snippetsHome,this._register(this.fileService.watch(f.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(k.Event.filter(this.fileService.onDidFilesChange,r=>r.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(f,b,v,S){const c=await this.getSnippetsFileContents(),a=this.toSnippetsContents(c),t=f.syncData?this.parseSnippets(f.syncData):null;b=b===null&&v?f:b;const s=b&&b.syncData?this.parseSnippets(b.syncData):null;t?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,C.merge)(a,t,s);return this.getResourcePreviews(n,c,t||{})}async getMergeResult(f,b){return f.previewResult}async getAcceptResult(f,b,v,S){if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:f.fileContent?f.fileContent.value.toString():null,localChange:0,remoteChange:f.fileContent?f.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:f.remoteContent,localChange:f.remoteContent!==null?f.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder))return v===void 0?{content:f.previewResult.content,localChange:f.previewResult.localChange,remoteChange:f.previewResult.remoteChange}:{content:v,localChange:v===null?f.fileContent!==null?3:0:2,remoteChange:v===null?f.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${b.toString()}`)}async applyResult(f,b,v,S){const c=v.map(([a,t])=>({...a,acceptResult:t}));c.every(({localChange:a,remoteChange:t})=>a===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),c.some(({localChange:a})=>a!==0)&&(await this.updateLocalBackup(c),await this.updateLocalSnippets(c,S)),c.some(({remoteChange:a})=>a!==0)&&(f=await this.updateRemoteSnippets(c,f,S)),b?.ref!==f.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(f),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:a}of c)try{await this.fileService.del(a)}catch(t){}}getResourcePreviews(f,b,v){const S=new Map;for(const c of Object.keys(f.local.added)){const a={content:f.local.added[c],hasConflicts:!1,localChange:1,remoteChange:0};S.set(c,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:v[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(f.local.updated)){const a={content:f.local.updated[c],hasConflicts:!1,localChange:2,remoteChange:0};S.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[c],localContent:b[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:v[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of f.local.removed){const a={content:null,hasConflicts:!1,localChange:3,remoteChange:0};S.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[c],localContent:b[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(f.remote.added)){const a={content:f.remote.added[c],hasConflicts:!1,localChange:0,remoteChange:1};S.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[c],localContent:b[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(f.remote.updated)){const a={content:f.remote.updated[c],hasConflicts:!1,localChange:0,remoteChange:2};S.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[c],localContent:b[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:v[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of f.remote.removed){const a={content:null,hasConflicts:!1,localChange:0,remoteChange:3};S.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:v[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of f.conflicts){const a={content:b[c]?b[c].value.toString():null,hasConflicts:!0,localChange:b[c]?2:1,remoteChange:v[c]?2:1};S.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[c]||null,localContent:b[c]?b[c].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:v[c]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(b))if(!S.has(c)){const a={content:b[c]?b[c].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};S.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[c]||null,localContent:b[c]?b[c].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:v[c]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...S.values()]}async getAssociatedResources({uri:f}){let b=await super.resolveContent(f);if(b){const v=this.parseSyncData(b);if(v){const S=this.parseSnippets(v),c=[];for(const a of Object.keys(S)){const t=this.extUri.joinPath(f,a),s=this.extUri.joinPath(this.snippetsFolder,a),n=await this.fileService.exists(s);c.push({resource:t,comparableResource:n?s:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"})})}return c}}return[]}async resolveContent(f){if(this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(f);let b=await super.resolveContent(f);if(b)return b;if(b=await super.resolveContent(this.extUri.dirname(f)),b){const v=this.parseSyncData(b);if(v)return this.parseSnippets(v)[this.extUri.basename(f)]||null}return null}async hasLocalData(){try{const f=await this.getSnippetsFileContents();if(Object.keys(f).length)return!0}catch(f){}return!1}async updateLocalBackup(f){const b={};for(const v of f)v.fileContent&&(b[this.extUri.basename(v.localResource)]=v.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(b)))}async updateLocalSnippets(f,b){for(const{fileContent:v,acceptResult:S,localResource:c,remoteResource:a,localChange:t}of f)if(t!==0){const s=a?this.extUri.basename(a):this.extUri.basename(c),n=this.extUri.joinPath(this.snippetsFolder,s);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(n)),await this.fileService.del(n),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(n))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(n)),await this.fileService.createFile(n,R.VSBuffer.fromString(S.content),{overwrite:b}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(n))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(n)),await this.fileService.writeFile(n,R.VSBuffer.fromString(S.content),b?void 0:v),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(n)))}}async updateRemoteSnippets(f,b,v){const S=b.syncData?this.parseSnippets(b.syncData):{},c=(0,D.deepClone)(S);for(const{acceptResult:a,localResource:t,remoteResource:s,remoteChange:n}of f)if(n!==0){const r=t?this.extUri.basename(t):this.extUri.basename(s);n===3?delete c[r]:c[r]=a.content}return(0,C.areSame)(S,c)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),b=await this.updateRemoteUserData(JSON.stringify(c),v?null:b.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),b}parseSnippets(f){return JSON.parse(f.content)}toSnippetsContents(f){const b={};for(const v of Object.keys(f))b[v]=f[v].value.toString();return b}async getSnippetsFileContents(){const f={};let b;try{b=await this.fileService.resolve(this.snippetsFolder)}catch(v){if(v instanceof P.FileOperationError&&v.fileOperationResult===1)return f;throw v}for(const v of b.children||[]){const S=v.resource,c=this.extUri.extname(S);if(c===".json"||c===".code-snippets"){const a=this.extUri.relativePath(this.snippetsFolder,S),t=await this.fileService.readFile(S);f[a]=t}}return f}};E=he([Q(0,L.IEnvironmentService),Q(1,P.IFileService),Q(2,y.IStorageService),Q(3,g.IUserDataSyncStoreService),Q(4,g.IUserDataSyncBackupStoreService),Q(5,g.IUserDataSyncLogService),Q(6,T.IConfigurationService),Q(7,g.IUserDataSyncResourceEnablementService),Q(8,I.ITelemetryService)],E),e.SnippetsSynchroniser=E;let u=class extends i.AbstractInitializer{constructor(f,b,v){super("snippets",b,v,f)}async doInitialize(f){const b=f.syncData?JSON.parse(f.syncData.content):null;if(!b){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const S of Object.keys(b)){const c=b[S];if(c){const a=this.extUri.joinPath(this.environmentService.snippetsHome,S);await this.fileService.createFile(a,R.VSBuffer.fromString(c)),this.logService.info("Created snippet",this.extUri.basename(a))}}await this.updateLastSyncUserData(f)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(f){return f.fileOperationResult===1}}};u=he([Q(0,P.IFileService),Q(1,L.IEnvironmentService),Q(2,g.IUserDataSyncLogService)],u),e.SnippetsInitializer=u}),define(te[62],ne([0,1,3,2,5,24]),function(J,e,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,D.createDecorator)("IUserDataSyncAccountService");let L=class extends k.Disposable{constructor(y){super();this.userDataSyncStoreService=y,this._onDidChangeAccount=this._register(new R.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new R.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(y.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(y.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(y){(y&&this._account?y.token!==this._account.token||y.authenticationProviderId!==this._account.authenticationProviderId:y!==this._account)&&(this._account=y,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(y))}};L=he([Q(0,T.IUserDataSyncStoreService)],L),e.UserDataSyncAccountService=L}),define(te[219],ne([0,1,6,21,57,2,16,22,13,14,24]),function(J,e,R,k,D,T,L,P,y,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let C=class extends T.Disposable{constructor(E,u,p,f){super();this.environmentService=E,this.fileService=u,this.configurationService=p,this.logService=f,i.ALL_SYNC_RESOURCES.forEach(b=>this.cleanUpBackup(b))}async getAllRefs(E){const u=(0,L.joinPath)(this.environmentService.userDataSyncHome,E),p=await this.fileService.resolve(u);return p.children?p.children.filter(b=>b.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(b.name)).sort().reverse().map(b=>({ref:b.name,created:this.getCreationTime(b)})):[]}async resolveContent(E,u){if(!u){const p=await this.getAllRefs(E);p.length&&(u=p[p.length-1].ref)}if(u){const p=(0,L.joinPath)(this.environmentService.userDataSyncHome,E,u);return(await this.fileService.readFile(p)).value.toString()}return null}async backup(E,u){const p=(0,L.joinPath)(this.environmentService.userDataSyncHome,E),f=(0,L.joinPath)(p,`${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(f,k.VSBuffer.fromString(u))}catch(b){this.logService.error(b)}try{this.cleanUpBackup(E)}catch(b){}}async cleanUpBackup(E){const u=(0,L.joinPath)(this.environmentService.userDataSyncHome,E);try{try{if(!await this.fileService.exists(u))return}catch(f){return}const p=await this.fileService.resolve(u);if(p.children){const f=p.children.filter(c=>c.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(c.name)).sort(),b=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let v=f.filter(c=>Date.now()-this.getCreationTime(c)>b);const S=f.length-v.length;S<10&&(v=v.slice(10-S)),await R.Promises.settled(v.map(async c=>{this.logService.info("Deleting from backup",c.resource.path),await this.fileService.del(c.resource)}))}}catch(p){this.logService.error(p)}}getCreationTime(E){return E.ctime||new Date(parseInt(E.name.substring(0,4)),parseInt(E.name.substring(4,6))-1,parseInt(E.name.substring(6,8)),parseInt(E.name.substring(9,11)),parseInt(E.name.substring(11,13)),parseInt(E.name.substring(13,15))).getTime()}};C=he([Q(0,y.IEnvironmentService),Q(1,I.IFileService),Q(2,P.IConfigurationService),Q(3,i.IUserDataSyncLogService)],C),e.UserDataSyncBackupStoreService=C}),define(te[220],ne([0,1,2,7]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class D{constructor(g){this.service=g}listen(g,E){switch(E){case"onError":return this.service.onError}throw new Error(`Event not found: ${E}`)}call(g,E,u){switch(E){case"triggerSync":return this.service.triggerSync(u[0],u[1],u[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(u[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=D;class T{constructor(g){this.service=g}listen(g,E){throw new Error(`Event not found: ${E}`)}call(g,E,u){switch(E){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(u[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(k.URI.revive(u[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=T;class L{constructor(g){this.channel=g}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(g){return this.channel.call("resolveUserKeybindings",[g])}async resolveFormattingOptions(g){return this.channel.call("resolveFormattingOptions",[g])}}e.UserDataSyncUtilServiceClient=L;class P{constructor(g){this.service=g}listen(g,E){switch(E){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${E}`)}async call(g,E,u){switch(E){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(u[0],u[1]);case"setEnablement":return this.service.setEnablement(u[0],u[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class y{constructor(g){this.service=g}listen(g,E){switch(E){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${E}`)}call(g,E,u){switch(E){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(u)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=y;class I{constructor(g){this.service=g}listen(g,E){switch(E){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${E}`)}call(g,E,u){switch(E){case"switch":return this.service.switch(u[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=I;class i extends R.Disposable{constructor(g){super();this.channel=g,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(g){return this.channel.call("switch",[g])}async getPreviousUserDataSyncStore(){const g=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(g)}revive(g){return{url:k.URI.revive(g.url),type:g.type,defaultUrl:k.URI.revive(g.defaultUrl),insidersUrl:k.URI.revive(g.insidersUrl),stableUrl:k.URI.revive(g.stableUrl),canSwitch:g.canSwitch,authenticationProviders:g.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=i}),define(te[221],ne([0,1,13,10]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let D=class extends k.AbstractLogger{constructor(L,P){super();this.logger=this._register(L.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(L,...P){this.logger.trace(L,...P)}debug(L,...P){this.logger.debug(L,...P)}info(L,...P){this.logger.info(L,...P)}warn(L,...P){this.logger.warn(L,...P)}error(L,...P){this.logger.error(L,...P)}critical(L,...P){this.logger.critical(L,...P)}flush(){this.logger.flush()}};D=he([Q(0,k.ILoggerService),Q(1,R.IEnvironmentService)],D),e.UserDataSyncLogService=D}),define(te[63],ne([0,1,3,2,4,25,141,13,14,5,29,45,23,24]),function(J,e,R,k,D,T,L,P,y,I,i,C,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,I.createDecorator)("IUserDataSyncMachinesService");const u="sync.currentMachineName";let p=class Ze extends k.Disposable{constructor(b,v,S,c,a,t){super();this.storageService=S,this.userDataSyncStoreService=c,this.logService=a,this.productService=t,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,C.getServiceMachineId)(b,v,S)}async getMachines(b){const v=await this.currentMachineIdPromise;return(await this.readMachinesData(b)).machines.map(c=>({...c,isCurrent:c.id===v}))}async addCurrentMachine(b){const v=await this.currentMachineIdPromise,S=await this.readMachinesData(b);S.machines.some(({id:c})=>c===v)||(S.machines.push({id:v,name:this.computeCurrentMachineName(S.machines)}),await this.writeMachinesData(S))}async removeCurrentMachine(b){const v=await this.currentMachineIdPromise,S=await this.readMachinesData(b),c=S.machines.filter(({id:a})=>a!==v);c.length!==S.machines.length&&(S.machines=c,await this.writeMachinesData(S))}async renameMachine(b,v,S){const c=await this.currentMachineIdPromise,a=await this.readMachinesData(S),t=a.machines.find(({id:s})=>s===b);t&&(t.name=v,await this.writeMachinesData(a),a.machines.some(({id:s})=>s===c)&&this.storageService.store(u,v,0,1))}async setEnablement(b,v){const S=await this.readMachinesData(),c=S.machines.find(({id:a})=>a===b);c&&(c.disabled=v?void 0:!0,await this.writeMachinesData(S))}computeCurrentMachineName(b){const v=this.storageService.get(u,0);if(v)return v;const S=`${this.productService.nameLong} (${(0,D.PlatformToString)(D.isWeb?0:D.platform)})`,c=new RegExp(`${(0,T.escapeRegExpCharacters)(S)}\\s#(\\d+)`);let a=0;for(const t of b){const s=c.exec(t.name),n=s?parseInt(s[1]):0;a=n>a?n:a}return`${S} #${a+1}`}async readMachinesData(b){this.userData=await this.readUserData(b);const v=this.parse(this.userData);if(v.version!==Ze.VERSION)throw new Error((0,L.localize)(0,null,this.productService.nameLong));return v}async writeMachinesData(b){const v=JSON.stringify(b),S=await this.userDataSyncStoreService.write(Ze.RESOURCE,v,this.userData?.ref||null);this.userData={ref:S,content:v},this._onDidChange.fire()}async readUserData(b){if(this.userData){const v=b&&b.latest?b.latest[Ze.RESOURCE]:void 0;if(this.userData.ref===v)return this.userData;if(v===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ze.RESOURCE,this.userData)}parse(b){if(b.content!==null)try{return JSON.parse(b.content)}catch(v){this.logService.error(v)}return{version:Ze.VERSION,machines:[]}}};p.VERSION=1,p.RESOURCE="machines",p=he([Q(0,P.IEnvironmentService),Q(1,y.IFileService),Q(2,g.IStorageService),Q(3,E.IUserDataSyncStoreService),Q(4,E.IUserDataSyncLogService),Q(5,i.IProductService)],p),e.UserDataSyncMachinesService=p}),define(te[95],ne([0,1,6,57,38,8,3,2,4,16,7,139,13,29,23,20,24,62,63]),function(J,e,R,k,D,T,L,P,y,I,i,C,g,E,u,p,f,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const S="sync.enable",c="sync.disableMachineEventually",a="sync.sessionId",t="sync.storeUrl",s="sync.productQuality";let n=class extends P.Disposable{constructor(h,d,m){super();this.storageService=h,this.environmentService=d,this.userDataSyncStoreManagementService=m,this._onDidChangeEnablement=new L.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(h.onDidChangeValue(A=>this.onDidStorageChange(A)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(S,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(h){h&&!this.canToggleEnablement()||this.storageService.store(S,h,0,1)}onDidStorageChange(h){if(h.scope===0&&S===h.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};n=he([Q(0,u.IStorageService),Q(1,g.IEnvironmentService),Q(2,f.IUserDataSyncStoreManagementService)],n),e.UserDataAutoSyncEnablementService=n;let r=class extends P.Disposable{constructor(h,d,m,A,_,w,O,U,$,Y,M){super();this.userDataSyncStoreManagementService=d,this.userDataSyncStoreService=m,this.userDataSyncResourceEnablementService=A,this.userDataSyncService=_,this.logService=w,this.userDataSyncAccountService=O,this.telemetryService=U,this.userDataSyncMachinesService=$,this.storageService=Y,this.autoSync=this._register(new P.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new L.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=M,this.syncTriggerDelayer=this._register(new R.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=d.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=h.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(d.onDidChangeUserDataSyncStore(()=>{(0,I.isEqual)(this.syncUrl,d.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=d.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(O.onDidChangeAccount(()=>this.updateAutoSync())),this._register(m.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(L.Event.debounce(_.onDidChangeLocal,(V,j)=>V?[...V,j]:[j],1e3)(V=>this.triggerSync(V,!1,!1))),this._register(L.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,V])=>V)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const h=this.storageService.get(t,0);return h?i.URI.parse(h):void 0}set syncUrl(h){h?this.storageService.store(t,h.toString(),0,1):this.storageService.remove(t,0)}get productQuality(){return this.storageService.get(s,0)}set productQuality(h){h?this.storageService.store(s,h,0,1):this.storageService.remove(s,0)}updateAutoSync(){const{enabled:h,message:d}=this.isAutoSyncEnabled();h?this.autoSync.value===void 0&&(this.autoSync.value=new o(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(m=>this.onDidFinishSync(m))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(d&&this.logService.info(d),this.autoSync.clear()):d&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(d))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,k.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(h,d,m){try{this.userDataSyncAccountService.account&&!m&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(a,0),h?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(A){if(d)this.logService.error(A),this.updateEnablement(!1);else throw A}}updateEnablement(h){this.userDataAutoSyncEnablementService.isEnabled()!==h&&(this.telemetryService.publicLog2(S,{enabled:h}),this.userDataAutoSyncEnablementService.setEnablement(h),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(h){if(!h){this.successiveFailures=0;return}const d=f.UserDataSyncError.toUserDataSyncError(h);d instanceof f.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:d.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),d.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):d.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):d.code==="LocalTooManyRequests"||d.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):d.code==="UpgradeRequired"||d.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):d.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${d.resource} content with newer version than of client. Requires client upgrade.`)):d.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${d.resource} content with older version than of client. Requires server reset.`)):d.code==="ServiceChanged"||d.code==="DefaultServiceChanged"?y.isWeb&&d.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(d),this.successiveFailures++),this._onError.fire(d)}async disableMachineEventually(){this.storageService.store(c,!0,0,1),await(0,R.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(c,0,!1)}stopDisableMachineEventually(){this.storageService.remove(c,0)}async triggerSync(h,d,m){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(d&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...h),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",m)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};r=he([Q(0,E.IProductService),Q(1,f.IUserDataSyncStoreManagementService),Q(2,f.IUserDataSyncStoreService),Q(3,f.IUserDataSyncResourceEnablementService),Q(4,f.IUserDataSyncService),Q(5,f.IUserDataSyncLogService),Q(6,b.IUserDataSyncAccountService),Q(7,p.ITelemetryService),Q(8,v.IUserDataSyncMachinesService),Q(9,u.IStorageService),Q(10,f.IUserDataAutoSyncEnablementService)],r),e.UserDataAutoSyncService=r;class o extends P.Disposable{constructor(h,d,m,A,_,w,O,U){super();this.lastSyncUrl=h,this.interval=d,this.userDataSyncStoreManagementService=m,this.userDataSyncStoreService=A,this.userDataSyncService=_,this.userDataSyncMachinesService=w,this.logService=O,this.storageService=U,this.intervalHandler=this._register(new P.MutableDisposable),this._onDidStartSync=this._register(new L.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new L.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,P.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(o.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,R.disposableTimeout)(()=>this.sync(o.INTERVAL_SYNCING,!1),this.interval)}sync(h,d){const m=(0,R.createCancelablePromise)(async A=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(_){if((0,T.isPromiseCanceledError)(_))return}return this.doSync(h,d,A)});return this.syncPromise=m,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,I.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const h=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),d=this.userDataSyncStoreManagementService.userDataSyncStore;return!!d&&!!h&&(!(0,I.isEqual)(d.defaultUrl,h.defaultUrl)||!(0,I.isEqual)(d.insidersUrl,h.insidersUrl)||!(0,I.isEqual)(d.stableUrl,h.stableUrl))}async doSync(h,d,m){this.logService.info(`Auto Sync: Triggered by ${h}`),this._onDidStartSync.fire();let A;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,d),m.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new f.UserDataAutoSyncError((0,C.localize)(0,null),"DefaultServiceChanged"):new f.UserDataAutoSyncError((0,C.localize)(1,null),"ServiceChanged"):new f.UserDataAutoSyncError((0,C.localize)(2,null),"TurnedOff");const _=this.storageService.get(a,0);if(_&&this.manifest&&_!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new f.UserDataAutoSyncError((0,C.localize)(3,null),"DefaultServiceChanged"):new f.UserDataAutoSyncError((0,C.localize)(4,null),"ServiceChanged"):new f.UserDataAutoSyncError((0,C.localize)(5,null),"SessionExpired");const w=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(m.isCancellationRequested)return;const O=w.find(U=>U.isCurrent);if(O?.disabled)throw new f.UserDataAutoSyncError((0,C.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(U){throw new f.UserDataAutoSyncError((0,D.toErrorMessage)(U),U instanceof f.UserDataSyncError?U.code:"Unknown")}if(this.manifest&&this.manifest.session!==_&&this.storageService.store(a,this.manifest.session,0,1),m.isCancellationRequested)return;O||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(_){this.logService.error(_),A=_}this._onDidFinishSync.fire(A)}register(h){return super._register(h)}}o.INTERVAL_SYNCING="Interval"}),define(te[222],ne([0,1,3,2,4,23,20,24]),function(J,e,R,k,D,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let y=class extends k.Disposable{constructor(i,C){super();this.storageService=i,this.telemetryService=C,this._onDidChangeResourceEnablement=new R.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(i.onDidChangeValue(g=>this.onDidStorageChange(g)))}isResourceEnabled(i){return this.storageService.getBoolean((0,P.getEnablementKey)(i),0,!0)}setResourceEnablement(i,C){if(this.isResourceEnabled(i)!==C){const g=(0,P.getEnablementKey)(i);this.telemetryService.publicLog2(g,{enabled:C}),this.storeResourceEnablement(g,C)}}getResourceSyncStateVersion(i){}storeResourceEnablement(i,C){this.storageService.store(i,C,0,D.isWeb?0:1)}onDidStorageChange(i){if(i.scope===0){const C=P.ALL_SYNC_RESOURCES.filter(g=>(0,P.getEnablementKey)(g)===i.key)[0];if(C){this._onDidChangeResourceEnablement.fire([C,this.isResourceEnabled(C)]);return}}}};y=he([Q(0,T.IStorageService),Q(1,L.ITelemetryService)],y),e.UserDataSyncResourceEnablementService=y}),define(te[223],ne([0,1,17,6,38,8,3,2,16,30,5,23,20,212,214,215,217,218,24]),function(J,e,R,k,D,T,L,P,y,I,i,C,g,E,u,p,f,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const S="sync.lastSyncTime";let c=class extends P.Disposable{constructor(n,r,o,l,h,d){super();this.userDataSyncStoreService=n,this.userDataSyncStoreManagementService=r,this.instantiationService=o,this.logService=l,this.telemetryService=h,this.storageService=d,this._status="uninitialized",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new L.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new L.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new L.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new L.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(f.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(p.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(b.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(u.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(E.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(L.Event.any(...this.synchronisers.map(m=>L.Event.map(m.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(L.Event.any(...this.synchronisers.map(m=>L.Event.map(m.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(S,0,void 0),this.onDidChangeLocal=L.Event.any(...this.synchronisers.map(m=>L.Event.map(m.onDidChangeLocal,()=>m.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(n,r){await this.checkEnablement();const o=(0,I.generateUuid)();try{const m=(0,v.createSyncHeaders)(o);r&&(m["Cache-Control"]="no-cache"),n=await this.userDataSyncStoreService.manifest(n,m)}catch(m){const A=v.UserDataSyncError.toUserDataSyncError(m);throw this.reportUserDataSyncError(A,o),A}let l=!1;const h=this;let d;return{manifest:n,run(){if(l)throw new Error("Can run a task only once");return d=(0,k.createCancelablePromise)(m=>h.sync(n,o,m)),d.finally(()=>d=void 0)},async stop(){if(d&&d.cancel(),h.status!=="idle")return h.stop()}}}async createManualSyncTask(){await this.checkEnablement();const n=(0,I.generateUuid)(),r=(0,v.createSyncHeaders)(n);let o;try{o=await this.userDataSyncStoreService.manifest(null,r)}catch(l){const h=v.UserDataSyncError.toUserDataSyncError(l);throw this.reportUserDataSyncError(h,n),h}return new a(n,o,r,this.synchronisers,this.logService)}async sync(n,r,o){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),o.isCancellationRequested)return;const l=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const h=(0,v.createSyncHeaders)(r);for(const d of this.synchronisers){if(o.isCancellationRequested)return;try{await d.sync(n,h)}catch(m){let A=!1;if(m instanceof v.UserDataSyncError)switch(m.code){case"TooLarge":m=new v.UserDataSyncError(m.message,m.code,d.resource),A=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":A=!0;break}const _=v.UserDataSyncError.toUserDataSyncError(m);if(this.reportUserDataSyncError(_,r),A)throw _;this.logService.error(m),this.logService.error(`${d.resource}: ${(0,D.toErrorMessage)(m)}`),this._syncErrors.push([d.resource,_])}}this.logService.info(`Sync done. Took ${new Date().getTime()-l}ms`),this.updateLastSyncTime()}catch(h){const d=v.UserDataSyncError.toUserDataSyncError(h);throw this.reportUserDataSyncError(d,r),d}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const n of this.synchronisers)try{n.status!=="idle"&&await n.stop()}catch(r){this.logService.error(r)}}async replace(n){await this.checkEnablement();for(const r of this.synchronisers)if(await r.replace(n))return}async accept(n,r,o,l){await this.checkEnablement();const h=this.getSynchroniser(n);await h.accept(r,o),l&&await h.apply(!1,(0,v.createSyncHeaders)((0,I.generateUuid)()))}async resolveContent(n){for(const r of this.synchronisers){const o=await r.resolveContent(n);if(o)return o}return null}getRemoteSyncResourceHandles(n){return this.getSynchroniser(n).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(n){return this.getSynchroniser(n).getLocalSyncResourceHandles()}getAssociatedResources(n,r){return this.getSynchroniser(n).getAssociatedResources(r)}getMachineId(n,r){return this.getSynchroniser(n).getMachineId(r)}async hasLocalData(){const n=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const r of n)if(await r.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(n){this.logService.error(n)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(S,0);for(const n of this.synchronisers)try{await n.resetLocal()}catch(r){this.logService.error(`${n.resource}: ${(0,D.toErrorMessage)(r)}`),this.logService.error(r)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const n of this.synchronisers)if(await n.hasPreviouslySynced())return!0;return!1}setStatus(n){const r=this._status;this._status!==n&&(this._status=n,this._onDidChangeStatus.fire(n),r==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const n=this.computeStatus();this.setStatus(n)}updateConflicts(){const n=this.computeConflicts();(0,R.equals)(this._conflicts,n,([r,o],[l,h])=>r===r&&(0,R.equals)(o,h,(d,m)=>(0,y.isEqual)(d.previewResource,m.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(n))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(n=>n.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(n=>n.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(S,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(n,r){this.telemetryService.publicLog2("sync/error",{code:n.code,serverCode:n instanceof v.UserDataSyncStoreError?String(n.serverCode):void 0,url:n instanceof v.UserDataSyncStoreError?n.url:void 0,resource:n.resource,executionId:r,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(n=>n.status==="hasConflicts").map(n=>[n.resource,n.conflicts.map(t)])}getSynchroniser(n){return this.synchronisers.find(r=>r.resource===n)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};c=he([Q(0,v.IUserDataSyncStoreService),Q(1,v.IUserDataSyncStoreManagementService),Q(2,i.IInstantiationService),Q(3,v.IUserDataSyncLogService),Q(4,g.ITelemetryService),Q(5,C.IStorageService)],c),e.UserDataSyncService=c;class a extends P.Disposable{constructor(n,r,o,l,h){super();this.id=n,this.manifest=r,this.syncHeaders=o,this.synchronisers=l,this.logService=h,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new L.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(n=>n.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(n=>n.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,k.createCancelablePromise)(n=>this.getPreviews(n))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(n){throw this.logService.error(n),n}}async accept(n,r){try{return await this.performAction(n,o=>o.accept(n,r))}catch(o){throw this.logService.error(o),o}}async merge(n){try{return n?await this.performAction(n,r=>r.merge(n)):await this.mergeAll()}catch(r){throw this.logService.error(r),r}}async discard(n){try{return await this.performAction(n,r=>r.discard(n))}catch(r){throw this.logService.error(r),r}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const n=[];for(const[,r]of this.previews)for(const o of r.resourcePreviews)o.mergeState==="conflict"&&n.push(o.previewResource);for(const r of n)await this.discard(r);return this.previews}catch(n){throw this.logService.error(n),n}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const n=[];for(const[r,o]of this.previews){this.synchronizingResources.push([r,o.resourcePreviews.map(d=>d.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(d=>d.resource===r);for(const d of o.resourcePreviews)(d.localChange!==0||d.remoteChange!==0)&&d.mergeState==="preview"&&await l.merge(d.previewResource);const h=await l.apply(!1,this.syncHeaders);h&&n.push(this.toSyncResourcePreview(l.resource,h)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(d=>d[0]===r),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=n,this.previews}catch(n){throw this.logService.error(n),n}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[n,r]of this.previews){this.synchronizingResources.push([n,r.resourcePreviews.map(l=>l.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const o=this.synchronisers.find(l=>l.resource===n);for(const l of r.resourcePreviews)await o.accept(l.remoteResource);await o.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(l=>l[0]===n),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(n){throw this.logService.error(n),n}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[n,r]of this.previews){this.synchronizingResources.push([n,r.resourcePreviews.map(l=>l.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const o=this.synchronisers.find(l=>l.resource===n);for(const l of r.resourcePreviews)await o.accept(l.localResource);await o.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(l=>l[0]===n),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(n){throw this.logService.error(n),n}}async stop(){for(const n of this.synchronisers)try{await n.stop()}catch(r){(0,T.isPromiseCanceledError)(r)||this.logService.error(r)}this.reset()}async performAction(n,r){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const o=this.previews.findIndex(([,O])=>O.resourcePreviews.some(({localResource:U,previewResource:$,remoteResource:Y})=>(0,y.isEqual)(n,U)||(0,y.isEqual)(n,$)||(0,y.isEqual)(n,Y)));if(o===-1)return this.previews;const[l,h]=this.previews[o],d=h.resourcePreviews.find(({localResource:O,remoteResource:U,previewResource:$})=>(0,y.isEqual)(O,n)||(0,y.isEqual)(U,n)||(0,y.isEqual)($,n));if(!d)return this.previews;let m=this.synchronizingResources.find(O=>O[0]===l);m||(m=[l,[]],this.synchronizingResources.push(m)),m[1].some(O=>(0,y.isEqual)(O,d.localResource))||(m[1].push(d.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const A=this.synchronisers.find(O=>O.resource===this.previews[o][0]),_=await r(A);_?this.previews.splice(o,1,this.toSyncResourcePreview(A.resource,_)):this.previews.splice(o,1);const w=this.synchronizingResources.findIndex(O=>O[0]===l);return this.synchronizingResources[w][1].splice(m[1].findIndex(O=>(0,y.isEqual)(O,d.localResource)),1),m[1].length||(this.synchronizingResources.splice(w,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const n=[];for(const[r,o]of this.previews){this.synchronizingResources.push([r,o.resourcePreviews.map(d=>d.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(d=>d.resource===r);let h=o;for(const d of o.resourcePreviews)(d.localChange!==0||d.remoteChange!==0)&&d.mergeState==="preview"&&(h=await l.merge(d.previewResource));h&&n.push(this.toSyncResourcePreview(l.resource,h)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(d=>d[0]===r),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=n,this.previews}async getPreviews(n){const r=[];for(const o of this.synchronisers){if(n.isCancellationRequested)return[];const l=await o.preview(this.manifest,this.syncHeaders);l&&r.push(this.toSyncResourcePreview(o.resource,l))}return r}toSyncResourcePreview(n,r){return[n,{isLastSyncFromCurrentMachine:r.isLastSyncFromCurrentMachine,resourcePreviews:r.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function t(s){return{localResource:s.localResource,previewResource:s.previewResource,remoteResource:s.remoteResource,acceptedResource:s.acceptedResource,localChange:s.localChange,remoteChange:s.remoteChange,mergeState:s.mergeState}}}),define(te[224],ne([0,1,3,2,18,7,24]),function(J,e,R,k,D,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class P{constructor(C,g){this.service=C,this.logService=g,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new R.Emitter}listen(C,g){switch(g){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${g}`)}async call(C,g,E){try{return await this._call(C,g,E)}catch(u){throw this.logService.error(u),u}}async _call(C,g,E){switch(g){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(T.URI.revive(E[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(E[0],T.URI.revive(E[1]),E[2],E[3]);case"resolveContent":return this.service.resolveContent(T.URI.revive(E[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(E[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(E[0]);case"getAssociatedResources":return this.service.getAssociatedResources(E[0],{created:E[1].created,uri:T.URI.revive(E[1].uri)});case"getMachineId":return this.service.getMachineId(E[0],{created:E[1].created,uri:T.URI.revive(E[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(g.startsWith("manualSync/")){const u=g.substring("manualSync/".length),p=E[0],f=this.getManualSyncTask(p);switch(E=E.slice(1),u){case"preview":return f.preview();case"accept":return f.accept(T.URI.revive(E[0]),E[1]);case"merge":return f.merge(T.URI.revive(E[0]));case"discard":return f.discard(T.URI.revive(E[0]));case"discardConflicts":return f.discardConflicts();case"apply":return f.apply();case"pull":return f.pull();case"push":return f.push();case"stop":return f.stop();case"_getStatus":return f.status;case"dispose":return this.disposeManualSyncTask(f)}}throw new Error("Invalid call")}getManualSyncTask(C){const g=this.manualSyncTasks.get(this.createKey(C));if(!g)throw new Error(`Manual sync taks not found: ${C}`);return g.manualSyncTask}async createManualSyncTask(){const C=new k.DisposableStore,g=C.add(await this.service.createManualSyncTask());return C.add(g.onSynchronizeResources(E=>this.onManualSynchronizeResources.fire({manualSyncTaskId:g.id,data:E}))),this.manualSyncTasks.set(this.createKey(g.id),{manualSyncTask:g,disposables:C}),{id:g.id,manifest:g.manifest,status:g.status}}disposeManualSyncTask(C){C.dispose();const g=this.createKey(C.id);this.manualSyncTasks.get(g)?.disposables.dispose(),this.manualSyncTasks.delete(g)}createKey(C){return`manualSyncTask-${C}`}}e.UserDataSyncChannel=P;class y extends k.Disposable{constructor(C){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new R.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new R.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new R.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new R.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(g,E,u){return C.call(g,E,u).then(null,p=>{throw L.UserDataSyncError.toUserDataSyncError(p)})},listen(g,E){return C.listen(g,E)}},this.channel.call("_getInitialData").then(([g,E,u])=>{this.updateStatus(g),this.updateConflicts(E),u&&this.updateLastSyncTime(u),this._register(this.channel.listen("onDidChangeStatus")(p=>this.updateStatus(p))),this._register(this.channel.listen("onDidChangeLastSyncTime")(p=>this.updateLastSyncTime(p)))}),this._register(this.channel.listen("onDidChangeConflicts")(g=>this.updateConflicts(g))),this._register(this.channel.listen("onSyncErrors")(g=>this._onSyncErrors.fire(g.map(([E,u])=>[E,L.UserDataSyncError.toUserDataSyncError(u)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:C,manifest:g,status:E}=await this.channel.call("createManualSyncTask"),u=this,p=new I(C,g,E,{async call(f,b,v){return u.channel.call(`manualSync/${f}`,[C,...(0,D.isArray)(b)?b:[b]],v)},listen(f,b){return R.Event.map(R.Event.filter(u.channel.listen(`manualSync/${f}`,b),v=>!p.isDiposed()&&v.manualSyncTaskId===C),v=>v.data)}});return p}replace(C){return this.channel.call("replace",[C])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(C,g,E,u){return this.channel.call("accept",[C,g,E,u])}resolveContent(C){return this.channel.call("resolveContent",[C])}async getLocalSyncResourceHandles(C){return(await this.channel.call("getLocalSyncResourceHandles",[C])).map(({created:E,uri:u})=>({created:E,uri:T.URI.revive(u)}))}async getRemoteSyncResourceHandles(C){return(await this.channel.call("getRemoteSyncResourceHandles",[C])).map(({created:E,uri:u})=>({created:E,uri:T.URI.revive(u)}))}async getAssociatedResources(C,g){return(await this.channel.call("getAssociatedResources",[C,g])).map(({resource:u,comparableResource:p})=>({resource:T.URI.revive(u),comparableResource:T.URI.revive(p)}))}async getMachineId(C,g){return this.channel.call("getMachineId",[C,g])}async updateStatus(C){this._status=C,this._onDidChangeStatus.fire(C)}async updateConflicts(C){this._conflicts=C.map(([g,E])=>[g,E.map(u=>({...u,localResource:T.URI.revive(u.localResource),remoteResource:T.URI.revive(u.remoteResource),previewResource:T.URI.revive(u.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(C){this._lastSyncTime!==C&&(this._lastSyncTime=C,this._onDidChangeLastSyncTime.fire(C))}}e.UserDataSyncChannelClient=y;class I extends k.Disposable{constructor(C,g,E,u){super();this.id=C,this.manifest=g,this._disposed=!1,this._status=E;const p=this;this.channel={async call(f,b,v){try{const S=await u.call(f,b,v);return p.isDiposed()||(p._status=await u.call("_getStatus")),S}catch(S){throw L.UserDataSyncError.toUserDataSyncError(S)}},listen(f,b){return u.listen(f,b)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const C=await this.channel.call("preview");return this.deserializePreviews(C)}async accept(C,g){const E=await this.channel.call("accept",[C,g]);return this.deserializePreviews(E)}async merge(C){const g=await this.channel.call("merge",[C]);return this.deserializePreviews(g)}async discard(C){const g=await this.channel.call("discard",[C]);return this.deserializePreviews(g)}async discardConflicts(){const C=await this.channel.call("discardConflicts");return this.deserializePreviews(C)}async apply(){const C=await this.channel.call("apply");return this.deserializePreviews(C)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(C){return C.map(([g,E])=>[g,{isLastSyncFromCurrentMachine:E.isLastSyncFromCurrentMachine,resourcePreviews:E.resourcePreviews.map(u=>({...u,localResource:T.URI.revive(u.localResource),remoteResource:T.URI.revive(u.remoteResource),previewResource:T.URI.revive(u.previewResource),acceptedResource:T.URI.revive(u.acceptedResource)}))}])}}}),define(te[225],ne([0,1,6,27,8,3,2,101,4,16,18,7,30,22,13,14,29,43,45,23,24]),function(J,e,R,k,D,T,L,P,y,I,i,C,g,E,u,p,f,b,v,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const a="sync.previous.store",t="sync.donot-make-requests-until",s="sync.user-session-id",n="sync.machine-session-id",r=100,o=1e3*60*5;let l=class extends L.Disposable{constructor(w,O,U){super();this.productService=w,this.configurationService=O,this.storageService=U,this._onDidChangeUserDataSyncStore=this._register(new T.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(T.Event.filter(U.onDidChangeValue,$=>$.key===c.SYNC_SERVICE_URL_TYPE&&$.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(c.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(w){this.storageService.store(c.SYNC_SERVICE_URL_TYPE,w,0,y.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[c.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(c.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(w,O){w=y.isWeb&&w?.web?{...w,...w.web}:w;const U={...w||{},...O||{}};if(U&&(0,i.isString)(U.url)&&(0,i.isObject)(U.authenticationProviders)&&Object.keys(U.authenticationProviders).every($=>(0,i.isArray)(U.authenticationProviders[$].scopes))){const $=U,Y=!!$.canSwitch&&!O?.url,M=$.url===$.insidersUrl?"insiders":"stable",V=(Y?this.userDataSyncStoreType:void 0)||M,j=O?.url||(V==="insiders"?$.insidersUrl:V==="stable"?$.stableUrl:$.url);return{url:C.URI.parse(j),type:V,defaultType:M,defaultUrl:C.URI.parse($.url),stableUrl:C.URI.parse($.stableUrl),insidersUrl:C.URI.parse($.insidersUrl),canSwitch:Y,authenticationProviders:Object.keys($.authenticationProviders).reduce((z,q)=>(z.push({id:q,scopes:$.authenticationProviders[q].scopes}),z),[])}}}};l=he([Q(0,f.IProductService),Q(1,E.IConfigurationService),Q(2,S.IStorageService)],l),e.AbstractUserDataSyncStoreManagementService=l;let h=class extends l{constructor(w,O,U){super(w,O,U);const $=this.storageService.get(a,0);$&&(this.previousConfigurationSyncStore=JSON.parse($));const Y=this.productService[c.CONFIGURATION_SYNC_STORE_KEY];Y?this.storageService.store(a,JSON.stringify(Y),0,1):this.storageService.remove(a,0)}async switch(w){w!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=w,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};h=he([Q(0,f.IProductService),Q(1,E.IConfigurationService),Q(2,S.IStorageService)],h),e.UserDataSyncStoreManagementService=h;let d=class extends L.Disposable{constructor(w,O,U,$,Y,M,V){super();this.requestService=U,this.logService=$,this.storageService=V,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new T.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new T.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(w),this.commonHeadersPromise=(0,v.getServiceMachineId)(Y,M,V).then(j=>{const z={"X-Client-Name":`${O.applicationName}${y.isWeb?"-web":""}`,"X-Client-Version":O.version};return O.commit&&(z["X-Client-Commit"]=O.commit),z}),this.session=new A(r,o,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,L.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(w,O){this.authToken={token:w,type:O}}updateUserDataSyncStoreUrl(w){this.userDataSyncStoreUrl=w?(0,I.joinPath)(w,"v1"):void 0}initDonotMakeRequestsUntil(){const w=this.storageService.getNumber(t,0);w&&Date.now()<w&&this.setDonotMakeRequestsUntil(new Date(w))}setDonotMakeRequestsUntil(w){this._donotMakeRequestsUntil?.getTime()!==w?.getTime()&&(this._donotMakeRequestsUntil=w,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(t,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,R.createCancelablePromise)(O=>(0,R.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),O).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,O=>null)):this.storageService.remove(t,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(w){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",w),U={},$=await this.request(O.toString(),{type:"GET",headers:U},[],k.CancellationToken.None);return(await(0,b.asJson)($)||[]).map(({url:M,created:V})=>({ref:(0,I.relativePath)(O,O.with({path:M})),created:V*1e3}))}async resolveContent(w,O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",w,O).toString(),$={};$["Cache-Control"]="no-cache";const Y=await this.request(U,{type:"GET",headers:$},[],k.CancellationToken.None);return await(0,b.asText)(Y)}async delete(w){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",w).toString(),U={};await this.request(O,{type:"DELETE",headers:U},[],k.CancellationToken.None)}async read(w,O,U={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",w,"latest").toString();U={...U},U["Cache-Control"]="no-cache",O&&(U["If-None-Match"]=O.ref);const Y=await this.request($,{type:"GET",headers:U},[304],k.CancellationToken.None);let M=null;if(Y.res.statusCode===304&&(M=O),M===null){const V=Y.res.headers.etag;if(!V)throw new c.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",Y.res.statusCode,Y.res.headers[c.HEADER_OPERATION_ID]);const j=await(0,b.asText)(Y);if(!j&&Y.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",$,"EmptyResponse",Y.res.statusCode,Y.res.headers[c.HEADER_OPERATION_ID]);M={ref:V,content:j}}return M}async write(w,O,U,$={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const Y=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",w).toString();$={...$},$["Content-Type"]=P.Mimes.text,U&&($["If-Match"]=U);const M=await this.request(Y,{type:"POST",data:O,headers:$},[],k.CancellationToken.None),V=M.res.headers.etag;if(!V)throw new c.UserDataSyncStoreError("Server did not return the ref",Y,"NoRef",M.res.statusCode,M.res.headers[c.HEADER_OPERATION_ID]);return V}async manifest(w,O={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,I.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();O={...O},O["Content-Type"]="application/json",w&&(O["If-None-Match"]=w.ref);const $=await this.request(U,{type:"GET",headers:O},[304],k.CancellationToken.None);let Y=null;if($.res.statusCode===304&&(Y=w),!Y){const V=$.res.headers.etag;if(!V)throw new c.UserDataSyncStoreError("Server did not return the ref",U,"NoRef",$.res.statusCode,$.res.headers[c.HEADER_OPERATION_ID]);const j=await(0,b.asText)($);if(!j&&$.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",U,"EmptyResponse",$.res.statusCode,$.res.headers[c.HEADER_OPERATION_ID]);j&&(Y={...JSON.parse(j),ref:V})}const M=this.storageService.get(s,0);return M&&Y&&M!==Y.session&&this.clearSession(),Y===null&&M&&this.clearSession(),Y&&this.storageService.store(s,Y.session,0,1),Y}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const w=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),O={"Content-Type":P.Mimes.text};await this.request(w,{type:"DELETE",headers:O},[],k.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(s,0),this.storageService.remove(n,0)}async request(w,O,U,$){if(!this.authToken)throw new c.UserDataSyncStoreError("No Auth Token Available",w,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new c.UserDataSyncStoreError(`${O.type} request '${w}' failed because of too many requests (429).`,w,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const Y=await this.commonHeadersPromise;O.headers={...O.headers||{},...Y,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(O.headers),this.logService.trace("Sending request to server",{url:w,type:O.type,headers:{...O.headers,authorization:void 0}});let M;try{M=await this.session.request(w,O,$)}catch(q){if(!(q instanceof c.UserDataSyncStoreError)){let F="RequestFailed";const G=(0,D.getErrorMessage)(q).toLowerCase();G.includes("xhr timeout")?F="RequestTimeout":G.includes("protocol")&&G.includes("not supported")?F="RequestProtocolNotSupported":G.includes("request path contains unescaped characters")?F="RequestPathNotEscaped":G.includes("headers must be an object")?F="RequestHeadersNotObject":(0,D.isPromiseCanceledError)(q)&&(F="RequestCanceled"),q=new c.UserDataSyncStoreError(`Connection refused for the request '${w}'.`,w,F,void 0,void 0)}throw this.logService.info("Request failed",w),q}const V=M.res.headers[c.HEADER_OPERATION_ID],j={url:w,status:M.res.statusCode,"execution-id":O.headers[c.HEADER_EXECUTION_ID],"operation-id":V},z=(0,b.isSuccess)(M)||M.res.statusCode&&U.indexOf(M.res.statusCode)!==-1;if(z?this.logService.trace("Request succeeded",j):this.logService.info("Request failed",j),M.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new c.UserDataSyncStoreError(`Request '${w}' failed because of Unauthorized (401).`,w,"Unauthorized",M.res.statusCode,V);if(this._onTokenSucceed.fire(),M.res.statusCode===409)throw new c.UserDataSyncStoreError(`${O.type} request '${w}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,w,"Conflict",M.res.statusCode,V);if(M.res.statusCode===410)throw new c.UserDataSyncStoreError(`${O.type} request '${w}' failed because the requested resource is not longer available (410).`,w,"Gone",M.res.statusCode,V);if(M.res.statusCode===412)throw new c.UserDataSyncStoreError(`${O.type} request '${w}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,w,"PreconditionFailed",M.res.statusCode,V);if(M.res.statusCode===413)throw new c.UserDataSyncStoreError(`${O.type} request '${w}' failed because of too large payload (413).`,w,"TooLarge",M.res.statusCode,V);if(M.res.statusCode===426)throw new c.UserDataSyncStoreError(`${O.type} request '${w}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,w,"UpgradeRequired",M.res.statusCode,V);if(M.res.statusCode===429){const q=M.res.headers["retry-after"];throw q?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(q)*1e3)),new c.UserDataSyncStoreError(`${O.type} request '${w}' failed because of too many requests (429).`,w,"TooManyRequestsAndRetryAfter",M.res.statusCode,V)):new c.UserDataSyncStoreError(`${O.type} request '${w}' failed because of too many requests (429).`,w,"RemoteTooManyRequests",M.res.statusCode,V)}if(!z)throw new c.UserDataSyncStoreError("Server returned "+M.res.statusCode,w,"Unknown",M.res.statusCode,V);return M}addSessionHeaders(w){let O=this.storageService.get(n,0);O===void 0&&(O=(0,g.generateUuid)(),this.storageService.store(n,O,0,1)),w["X-Machine-Session-Id"]=O;const U=this.storageService.get(s,0);U!==void 0&&(w["X-User-Session-Id"]=U)}};d=he([Q(1,f.IProductService),Q(2,b.IRequestService),Q(3,c.IUserDataSyncLogService),Q(4,u.IEnvironmentService),Q(5,p.IFileService),Q(6,S.IStorageService)],d),e.UserDataSyncStoreClient=d;let m=class extends d{constructor(w,O,U,$,Y,M,V){super(w.userDataSyncStore?.url,O,U,$,Y,M,V);this._register(w.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(w.userDataSyncStore?.url)))}};m=he([Q(0,c.IUserDataSyncStoreManagementService),Q(1,f.IProductService),Q(2,b.IRequestService),Q(3,c.IUserDataSyncLogService),Q(4,u.IEnvironmentService),Q(5,p.IFileService),Q(6,S.IStorageService)],m),e.UserDataSyncStoreService=m;class A{constructor(w,O,U,$){this.limit=w,this.interval=O,this.requestService=U,this.logService=$,this.requests=[],this.startTime=void 0}request(w,O,U){if(this.isExpired()&&this.reset(),O.url=w,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new c.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,w,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(w),this.requestService.request(O,U)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=A}),define(te[226],ne([0,1,3,60,29,23,20,95,24,62,63]),function(J,e,R,k,D,T,L,P,y,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let C=class extends P.UserDataAutoSyncService{constructor(E,u,p,f,b,v,S,c,a,t,s,n){super(E,u,p,f,b,S,c,a,t,s,n);this._register(R.Event.debounce(R.Event.any(R.Event.map(v.onDidFocusWindow,()=>"windowFocus"),R.Event.map(v.onDidOpenWindow,()=>"windowOpen")),(r,o)=>r?[...r,o]:[o],1e3)(r=>this.triggerSync(r,!0,!1)))}};C=he([Q(0,D.IProductService),Q(1,y.IUserDataSyncStoreManagementService),Q(2,y.IUserDataSyncStoreService),Q(3,y.IUserDataSyncResourceEnablementService),Q(4,y.IUserDataSyncService),Q(5,k.INativeHostService),Q(6,y.IUserDataSyncLogService),Q(7,I.IUserDataSyncAccountService),Q(8,L.ITelemetryService),Q(9,i.IUserDataSyncMachinesService),Q(10,T.IStorageService),Q(11,y.IUserDataAutoSyncEnablementService)],C),e.UserDataAutoSyncService=C}),define(te[227],ne([0,1,6,3,2]),function(J,e,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class T extends D.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:y,getActiveWindowId:I}){super();this.disposables=this._register(new D.DisposableStore),k.Event.latch(k.Event.any(P,y))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,R.createCancelablePromise)(()=>I()),(async()=>{try{const C=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:C}catch(C){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=T}),define(te[64],ne([0,1,51,6,9,18,19,118,237,238]),function(J,e,R,k,D,T,L,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class i extends Error{constructor(t,s){let n=s.message;switch(t){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=t,this.cause=s}}e.ExtractError=i;function C(a){const t=a.externalFileAttributes>>16||33188;return[448,56,7].map(s=>t&s).reduce((s,n)=>s+n,t&61440)}function g(a){if(a instanceof i)return a;let t;return/end of central directory record signature not found/.test(a.message)&&(t="CorruptZip"),new i(t,a)}function E(a,t,s,n,r,o){const l=D.dirname(t),h=D.join(n,l);if(!h.startsWith(n))return Promise.reject(new Error(P.localize(0,null,t)));const d=D.join(n,t);let m;return o.onCancellationRequested(()=>{m&&m.destroy()}),Promise.resolve(L.Promises.mkdir(h,{recursive:!0})).then(()=>new Promise((A,_)=>{if(!o.isCancellationRequested)try{m=(0,R.createWriteStream)(d,{mode:s}),m.once("close",()=>A()),m.once("error",_),a.once("error",_),a.pipe(m)}catch(w){_(w)}}))}function u(a,t,s,n){let r=(0,k.createCancelablePromise)(()=>Promise.resolve()),o=0;return n.onCancellationRequested(()=>{r.cancel(),a.close()}),new Promise((l,h)=>{const d=new k.Sequencer,m=A=>{A.isCancellationRequested||(o++,a.readEntry())};a.once("error",h),a.once("close",()=>r.then(()=>{n.isCancellationRequested||a.entryCount===o?l():h(new i("Incomplete",new Error(P.localize(1,null,o,a.entryCount))))},h)),a.readEntry(),a.on("entry",A=>{if(n.isCancellationRequested)return;if(!s.sourcePathRegex.test(A.fileName)){m(n);return}const _=A.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(_)){const U=D.join(t,_);r=(0,k.createCancelablePromise)($=>L.Promises.mkdir(U,{recursive:!0}).then(()=>m($)).then(void 0,h));return}const w=f(a,A),O=C(A);r=(0,k.createCancelablePromise)(U=>d.queue(()=>w.then($=>E($,_,O,t,s,U).then(()=>m(U)))).then(null,h))})})}function p(a,t=!1){return new Promise((s,n)=>{(0,y.open)(a,t?{lazyEntries:!0}:void 0,(r,o)=>{r?n(g(r)):s((0,T.assertIsDefined)(o))})})}function f(a,t){return new Promise((s,n)=>{a.openReadStream(t,(r,o)=>{r?n(g(r)):s((0,T.assertIsDefined)(o))})})}function b(a,t){return new Promise((s,n)=>{const r=new I.ZipFile;t.forEach(l=>{l.contents?r.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&r.addFile(l.localPath,l.path)}),r.end();const o=(0,R.createWriteStream)(a);r.outputStream.pipe(o),r.outputStream.once("error",n),o.once("error",n),o.once("finish",()=>s(a))})}e.zip=b;function v(a,t,s={},n){const r=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let o=p(a,!0);return s.overwrite&&(o=o.then(l=>L.Promises.rm(t).then(()=>l))),o.then(l=>u(l,t,{sourcePathRegex:r},n))}e.extract=v;function S(a,t){return p(a).then(s=>new Promise((n,r)=>{s.on("entry",o=>{o.fileName===t&&f(s,o).then(l=>n(l),l=>r(l))}),s.once("close",()=>r(new Error(P.localize(2,null,t))))}))}function c(a,t){return S(a,t).then(s=>new Promise((n,r)=>{const o=[];s.once("error",r),s.on("data",l=>o.push(l)),s.on("end",()=>n(Buffer.concat(o)))}))}e.buffer=c}),define(te[228],ne([0,1,64,126]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function D(T){return(0,R.buffer)(T,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch(P){throw new Error((0,k.localize)(0,null))}})}e.getManifest=D}),define(te[229],ne([0,1,17,6,8,2,15,9,4,16,59,7,30,19,64,127,13,28,34,147,14,10,29]),function(J,e,R,k,D,T,L,P,y,I,i,C,g,E,u,p,f,b,v,S,c,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const s="scanningSystem",n="scanningUser",r="extracting",o="deleting",l="renaming";let h=class extends T.Disposable{constructor(m,A,_,w,O){super();this.beforeRemovingExtension=m,this.fileService=A,this.logService=_,this.environmentService=w,this.productService=O,this._devSystemExtensionsPath=null,this.systemExtensionsPath=w.builtinExtensionsPath,this.extensionsPath=w.extensionsPath,this.uninstalledPath=P.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new k.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(m){const A=[];(m===null||m===0)&&A.push(this.scanSystemExtensions().then(null,_=>Promise.reject(new b.ExtensionManagementError(this.joinErrors(_).message,s)))),(m===null||m===1)&&A.push(this.scanUserExtensions(!0).then(null,_=>Promise.reject(new b.ExtensionManagementError(this.joinErrors(_).message,n))));try{const _=await Promise.all(A);return(0,R.flatten)(_)}catch(_){throw this.joinErrors(_)}}async scanUserExtensions(m){this.logService.trace("Started scanning user extensions");let[A,_]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return _=_.filter(w=>!A[new v.ExtensionIdentifierWithVersion(w.identifier,w.manifest.version).key()]),m&&(_=(0,v.groupByExtension)(_,O=>O.identifier).map(O=>O.sort((U,$)=>i.rcompare(U.manifest.version,$.manifest.version))[0])),this.logService.trace("Scanned user extensions:",_.length),_}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(m,A,_,w){const O=m.key(),U=P.join(this.extensionsPath,`.${(0,g.generateUuid)()}`),$=P.join(this.extensionsPath,O);try{await E.Promises.rm($)}catch(M){try{await E.Promises.rm($)}catch(V){}throw new b.ExtensionManagementError((0,p.localize)(0,null,$,m.id),o)}await this.extractAtLocation(m,A,U,w);let Y=await this.scanExtension(C.URI.file(U),1);if(!Y)throw new Error((0,p.localize)(1,null,U));await this.storeMetadata(Y,{..._,installedTimestamp:Date.now()});try{await this.rename(m,U,$,Date.now()+2*60*1e3),this.logService.info("Renamed to",$)}catch(M){try{await E.Promises.rm(U)}catch(V){}if(M.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",m.id);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(M)}. Deleted from extracted location`,U),M}try{Y=await this.scanExtension(C.URI.file($),1)}catch(M){}if(Y)return Y;throw new Error((0,p.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(m,A){return this.setMetadata(m,A),await this.storeMetadata(m,{...A,installedTimestamp:m.installedTimestamp}),m}async storeMetadata(m,A){A.isMachineScoped=A.isMachineScoped||void 0,A.isBuiltin=A.isBuiltin||void 0,A.installedTimestamp=A.installedTimestamp||void 0;const _=P.join(m.location.fsPath,"package.json"),w=await E.Promises.readFile(_,"utf8"),{manifest:O}=await this.parseManifest(w);return O.__metadata=A,await E.Promises.writeFile(_,JSON.stringify(O,null,"	")),m}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...m){const A=m.map(_=>new v.ExtensionIdentifierWithVersion(_.identifier,_.manifest.version));await this.withUninstalledExtensions(_=>{A.forEach(w=>_[w.key()]=!0)})}async setInstalled(m){await this.withUninstalledExtensions(w=>delete w[m.key()]);const _=(await this.scanExtensions(1)).find(w=>new v.ExtensionIdentifierWithVersion(w.identifier,w.manifest.version).equals(m))||null;return _?(await this.storeMetadata(_,{installedTimestamp:Date.now()}),this.scanExtension(_.location,1)):null}async withUninstalledExtensions(m){return this.uninstalledFileLimiter.queue(async()=>{let A;try{A=await E.Promises.readFile(this.uninstalledPath,"utf8")}catch(w){if(w.code!=="ENOENT")throw w}let _={};if(A)try{_=JSON.parse(A)}catch(w){}return m&&(m(_),Object.keys(_).length?await E.Promises.writeFile(this.uninstalledPath,JSON.stringify(_)):await E.Promises.rm(this.uninstalledPath)),_})}async removeExtension(m,A){this.logService.trace(`Deleting ${A} extension from disk`,m.identifier.id,m.location.fsPath),await E.Promises.rm(m.location.fsPath),this.logService.info("Deleted from disk",m.identifier.id,m.location.fsPath)}async removeUninstalledExtension(m){await this.removeExtension(m,"uninstalled"),await this.withUninstalledExtensions(A=>delete A[new v.ExtensionIdentifierWithVersion(m.identifier,m.manifest.version).key()])}async extractAtLocation(m,A,_,w){this.logService.trace(`Started extracting the extension from ${A} to ${_}`);try{await E.Promises.rm(_)}catch(O){throw new b.ExtensionManagementError(this.joinErrors(O).message,o)}try{await(0,u.extract)(A,_,{sourcePath:"extension",overwrite:!0},w),this.logService.info(`Extracted extension to ${_}:`,m.id)}catch(O){try{await E.Promises.rm(_)}catch(U){}throw new b.ExtensionManagementError(O.message,O instanceof u.ExtractError&&O.type?O.type:r)}}async rename(m,A,_,w){try{await E.Promises.rename(A,_)}catch(O){if(y.isWindows&&O&&O.code==="EPERM"&&Date.now()<w)return this.logService.info(`Failed renaming ${A} to ${_} with 'EPERM' error. Trying again...`,m.id),this.rename(m,A,_,w);throw new b.ExtensionManagementError(O.message||(0,p.localize)(3,null,A,_),O.code||l)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const m=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return m;const A=this.scanDevSystemExtensions(),[_,w]=await Promise.all([m,A]);return[..._,...w]}async scanExtensionsInDir(m,A){const _=new k.Limiter(10),w=await this.fileService.resolve(C.URI.file(m));return w.children?(await Promise.all(w.children.filter(U=>U.isDirectory).map(U=>_.queue(async()=>A===1&&(0,I.basename)(U.resource).indexOf(".")===0?null:this.scanExtension(U.resource,A))))).filter(U=>U&&U.identifier):[]}async scanExtension(m,A){try{const _=await this.fileService.resolve(m);if(_.children){const{manifest:w,metadata:O}=await this.readManifest(m.fsPath),U=_.children.find(({name:V})=>/^readme(\.txt|\.md|)$/i.test(V))?.resource,$=_.children.find(({name:V})=>/^changelog(\.txt|\.md|)$/i.test(V))?.resource,Y={id:(0,v.getGalleryExtensionId)(w.publisher,w.name)},M={type:A,identifier:Y,manifest:w,location:m,readmeUrl:U,changelogUrl:$,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:A===0};return O&&(this.setMetadata(M,O),M.installedTimestamp=O.installedTimestamp),M}}catch(_){A!==0&&this.logService.trace(_)}return null}async scanDefaultSystemExtensions(){const m=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",m.length),m}async scanDevSystemExtensions(){const m=this.getDevSystemExtensionsList();if(m.length){const A=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",A.length),A.filter(_=>m.some(w=>(0,v.areSameExtensions)(_.identifier,{id:w})))}else return[]}setMetadata(m,A){m.publisherDisplayName=A.publisherDisplayName||null,m.publisherId=A.publisherId||null,m.identifier.uuid=A.id,m.isMachineScoped=!!A.isMachineScoped,m.isBuiltin=m.type===0||!!A.isBuiltin}async removeUninstalledExtensions(){const m=await this.getUninstalledExtensions(),A=await this.scanAllUserExtensions(),_=new Set;for(const U of A)m[new v.ExtensionIdentifierWithVersion(U.identifier,U.manifest.version).key()]||_.add(U.identifier.id.toLowerCase());const w=(0,v.groupByExtension)(A,U=>U.identifier);await k.Promises.settled(w.map(async U=>{const $=U.sort((Y,M)=>i.rcompare(Y.manifest.version,M.manifest.version))[0];_.has($.identifier.id.toLowerCase())||await this.beforeRemovingExtension($)}));const O=A.filter(U=>m[new v.ExtensionIdentifierWithVersion(U.identifier,U.manifest.version).key()]);await k.Promises.settled(O.map(U=>this.removeUninstalledExtension(U)))}async removeOutdatedExtensions(){const m=await this.scanAllUserExtensions(),A=[],_=(0,v.groupByExtension)(m,w=>w.identifier);A.push(...(0,R.flatten)(_.map(w=>w.sort((O,U)=>i.rcompare(O.manifest.version,U.manifest.version)).slice(1)))),await k.Promises.settled(A.map(w=>this.removeExtension(w,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(m=>m.name)}joinErrors(m){const A=Array.isArray(m)?m:[m];return A.length===1?A[0]instanceof Error?A[0]:new Error(A[0]):A.reduce((_,w)=>new Error(`${_.message}${_.message?",":""}${w instanceof Error?w.message:w}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=P.normalize(P.join(L.FileAccess.asFileUri("",J).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(m){const A=[E.Promises.readFile(P.join(m,"package.json"),"utf8").then(U=>this.parseManifest(U)),E.Promises.readFile(P.join(m,"package.nls.json"),"utf8").then(void 0,U=>U.code!=="ENOENT"?Promise.reject(U):"{}").then(U=>JSON.parse(U))],[{manifest:_,metadata:w},O]=await Promise.all(A);return{manifest:(0,S.localizeManifest)(_,O),metadata:w}}parseManifest(m){return new Promise((A,_)=>{try{const w=JSON.parse(m),O=w.__metadata||null;A({manifest:w,metadata:O})}catch(w){_(new Error((0,p.localize)(4,null)))}})}};h=he([Q(1,c.IFileService),Q(2,a.ILogService),Q(3,f.INativeEnvironmentService),Q(4,t.IProductService)],h),e.ExtensionsScanner=h}),define(te[230],ne([0,1,38,8,15,9,4,31,16,59,7,30,19,64,125,78,13,196,28,34,171,172,228,160,229,173,76,14,5,10,42,20]),function(J,e,R,k,D,T,L,P,y,I,i,C,g,E,u,p,f,b,v,S,c,a,t,s,n,r,o,l,h,d,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const _="unsetUninstalled",w="downloading";let O=class extends b.AbstractExtensionManagementService{constructor(j,z,q,F,G,x,N){super(j,z,q);this.environmentService=F,this.downloadService=G,this.fileService=N;const W=this._register(x.createInstance(a.ExtensionsLifecycle));this.extensionsScanner=this._register(x.createInstance(n.ExtensionsScanner,Z=>W.postUninstall(Z))),this.manifestCache=this._register(new s.ExtensionsManifestCache(F,this)),this.extensionsDownloader=this._register(x.createInstance(c.ExtensionsDownloader));const X=this._register(new r.ExtensionsWatcher(this,N,F,q));this._register(X.onDidChangeExtensionsByAnotherSource(({added:Z,removed:B})=>{Z.length&&this._onDidInstallExtensions.fire(Z.map(H=>({identifier:H.identifier,operation:0,local:H}))),B.forEach(H=>this._onDidUninstallExtension.fire({identifier:H}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const j=await this.isAlpineLinux(),z=(0,v.getTargetPlatform)(j?"alpine":L.platform,P.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",z),z})()),this._targetPlatformPromise}async isAlpineLinux(){if(!L.isLinux)return!1;let j;try{j=(await this.fileService.readFile(i.URI.file("/etc/os-release"))).value.toString()}catch(z){try{j=(await this.fileService.readFile(i.URI.file("/usr/lib/os-release"))).value.toString()}catch(q){this.logService.debug("Error while getting the os-release file.",(0,k.getErrorMessage)(q))}}return!!j&&(j.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(j){this.logService.trace("ExtensionManagementService#zip",j.identifier.id);const z=await this.collectFiles(j),q=await(0,E.zip)((0,y.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)()).fsPath,z);return i.URI.file(q)}async unzip(j){return this.logService.trace("ExtensionManagementService#unzip",j.toString()),(await this.install(j)).identifier}async getManifest(j){const z=await this.downloadVsix(j),q=T.resolve(z.fsPath);return(0,t.getManifest)(q)}getInstalled(j=null){return this.extensionsScanner.scanExtensions(j)}async install(j,z={}){this.logService.trace("ExtensionManagementService#install",j.toString());const q=await this.downloadVsix(j),F=await(0,t.getManifest)(T.resolve(q.fsPath));if(F.engines&&F.engines.vscode&&!(0,o.isEngineValid)(F.engines.vscode,m.default.version,m.default.date))throw new Error(u.localize(0,null,(0,S.getGalleryExtensionId)(F.publisher,F.name),m.default.version));return this.installExtension(F,q,z)}async updateMetadata(j,z){return this.logService.trace("ExtensionManagementService#updateMetadata",j.identifier.id),j=await this.extensionsScanner.saveMetadataForLocalExtension(j,{...j.manifest.__metadata||{},...z}),this.manifestCache.invalidate(),j}async updateExtensionScope(j,z){return this.logService.trace("ExtensionManagementService#updateExtensionScope",j.identifier.id),j=await this.extensionsScanner.saveMetadataForLocalExtension(j,{...j.manifest.__metadata||{},isMachineScoped:z}),this.manifestCache.invalidate(),j}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(j){if(j.scheme===D.Schemas.file)return j;const z=(0,y.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)());return await this.downloadService.download(j,z),z}createInstallExtensionTask(j,z,q){return i.URI.isUri(z)?new Y(j,z,q,this.galleryService,this.extensionsScanner,this.logService):new $(z,q,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(j,z){return new M(j,z,this.extensionsScanner)}async collectFiles(j){const z=async F=>{let G=await g.Promises.readdir(F);G=G.map(W=>T.join(F,W));const x=await Promise.all(G.map(W=>g.Promises.stat(W)));let N=Promise.resolve([]);return x.forEach((W,X)=>{const Z=G[X];W.isFile()&&(N=N.then(B=>[...B,Z])),W.isDirectory()&&(N=N.then(B=>z(Z).then(H=>[...B,...H])))}),N};return(await z(j.location.fsPath)).map(F=>({path:`extension/${T.relative(j.location.fsPath,F)}`,localPath:F}))}};O=he([Q(0,v.IExtensionGalleryService),Q(1,A.ITelemetryService),Q(2,d.ILogService),Q(3,f.INativeEnvironmentService),Q(4,p.IDownloadService),Q(5,h.IInstantiationService),Q(6,l.IFileService)],O),e.ExtensionManagementService=O;class U extends b.AbstractExtensionTask{constructor(j,z,q,F){super();this.identifier=j,this.source=z,this.extensionsScanner=q,this.logService=F,this._operation=1}get operation(){return this._operation}async installExtension(j,z){try{const q=await this.unsetUninstalledAndGetLocal(j.identifierWithVersion);if(q)return j.metadata?this.extensionsScanner.saveMetadataForLocalExtension(q,j.metadata):q}catch(q){throw L.isMacintosh?new v.ExtensionManagementError(u.localize(1,null),_):new v.ExtensionManagementError(u.localize(2,null),_)}return this.extract(j,z)}async unsetUninstalledAndGetLocal(j){if(!await this.isUninstalled(j))return null;this.logService.trace("Removing the extension from uninstalled list:",j.id);const q=await this.extensionsScanner.setInstalled(j);return this.logService.info("Removed the extension from uninstalled list:",j.id),q}async isUninstalled(j){return!!(await this.extensionsScanner.getUninstalledExtensions())[j.key()]}async extract({zipPath:j,identifierWithVersion:z,metadata:q},F){let G=await this.extensionsScanner.extractUserExtension(z,j,q,F);return this.logService.info("Extracting completed.",z.id),G}}class $ extends U{constructor(j,z,q,F,G){super(j.identifier,j,F,G);this.gallery=j,this.options=z,this.extensionsDownloader=q}async doRun(j){const q=(await this.extensionsScanner.scanExtensions(null)).find(G=>(0,S.areSameExtensions)(G.identifier,this.gallery.identifier));q&&(this._operation=2);const F=await this.downloadInstallableExtension(this.gallery,this._operation);F.metadata.isMachineScoped=this.options.isMachineScoped||q?.isMachineScoped,F.metadata.isBuiltin=this.options.isBuiltin||q?.isBuiltin;try{const G=await this.installExtension(F,j);return q&&I.neq(q.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(q),G}catch(G){throw await this.deleteDownloadedVSIX(F.zipPath),G}}async deleteDownloadedVSIX(j){try{await this.extensionsDownloader.delete(i.URI.file(j))}catch(z){this.logService.warn("Error while deleting the downloaded vsix",j.toString(),(0,k.getErrorMessage)(z))}}async downloadInstallableExtension(j,z){const q={id:j.identifier.uuid,publisherId:j.publisherId,publisherDisplayName:j.publisherDisplayName};let F;try{this.logService.trace("Started downloading extension:",j.identifier.id),F=(await this.extensionsDownloader.downloadExtension(j,z)).fsPath,this.logService.info("Downloaded extension:",j.identifier.id,F)}catch(G){throw new v.ExtensionManagementError((0,b.joinErrors)(G).message,w)}try{const G=await(0,t.getManifest)(F);return{zipPath:F,identifierWithVersion:new S.ExtensionIdentifierWithVersion(j.identifier,G.version),metadata:q}}catch(G){throw await this.deleteDownloadedVSIX(F),new v.ExtensionManagementError((0,b.joinErrors)(G).message,b.INSTALL_ERROR_VALIDATING)}}}class Y extends U{constructor(j,z,q,F,G,x){super({id:(0,S.getGalleryExtensionId)(j.publisher,j.name)},z,G,x);this.manifest=j,this.location=z,this.options=q,this.galleryService=F}async doRun(j){const z=new S.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),F=(await this.extensionsScanner.scanExtensions(1)).find(x=>(0,S.areSameExtensions)(this.identifier,x.identifier)),G=await this.getMetadata(this.identifier.id,j);if(G.isMachineScoped=this.options.isMachineScoped||F?.isMachineScoped,G.isBuiltin=this.options.isBuiltin||F?.isBuiltin,F)if(this._operation=2,z.equals(new S.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version)))try{await this.extensionsScanner.removeExtension(F,"existing")}catch(x){throw new Error(u.localize(3,null,this.manifest.displayName||this.manifest.name))}else I.gt(F.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(F);else{const x=await this.unsetUninstalledAndGetLocal(z);if(x)try{await this.extensionsScanner.removeExtension(x,"existing")}catch(N){throw new Error(u.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:T.resolve(this.location.fsPath),identifierWithVersion:z,metadata:G},j)}async getMetadata(j,z){try{const q=(await this.galleryService.query({names:[j],pageSize:1},z)).firstPage[0];if(q)return{id:q.identifier.uuid,publisherDisplayName:q.publisherDisplayName,publisherId:q.publisherId}}catch(q){}return{}}}class M extends b.AbstractExtensionTask{constructor(j,z,q){super();this.extension=j,this.options=z,this.extensionsScanner=q}async doRun(j){const z=[],q=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const F=new S.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);z.push(...q.filter(G=>F.equals(new S.ExtensionIdentifierWithVersion(G.identifier,G.manifest.version))))}else z.push(...q.filter(F=>(0,S.areSameExtensions)(F.identifier,this.extension.identifier)));if(!z.length)throw new Error(u.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...z),this.options.remove)for(const F of z)try{j.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(F)}catch(G){throw new Error(u.localize(6,null,(0,R.toErrorMessage)(G)))}}}}),define(te[231],ne([0,1,81,56,32,21,8,3,2,9,4,30,33,72,239]),function(J,e,R,k,D,T,L,P,y,I,i,C,g,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class p{constructor(h){this.socket=h,this._errorListener=d=>{if(d){if(d.code==="EPIPE")return;(0,L.onUnexpectedError)(d)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(h){const d=m=>h(T.VSBuffer.wrap(m));return this.socket.on("data",d),{dispose:()=>this.socket.off("data",d)}}onClose(h){const d=m=>{h({type:0,hadError:m,error:void 0})};return this.socket.on("close",d),{dispose:()=>this.socket.off("close",d)}}onEnd(h){return this.socket.on("end",h),{dispose:()=>this.socket.off("end",h)}}write(h){if(!this.socket.destroyed)try{this.socket.write(h.buffer,d=>{if(d){if(d.code==="EPIPE")return;(0,L.onUnexpectedError)(d)}})}catch(d){if(d.code==="EPIPE")return;(0,L.onUnexpectedError)(d)}}end(){this.socket.end()}drain(){return new Promise((h,d)=>{if(this.socket.bufferSize===0){h();return}const m=()=>{this.socket.off("close",m),this.socket.off("end",m),this.socket.off("error",m),this.socket.off("timeout",m),this.socket.off("drain",m),h()};this.socket.on("close",m),this.socket.on("end",m),this.socket.on("error",m),this.socket.on("timeout",m),this.socket.on("drain",m)})}}e.NodeSocket=p;var f;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(f||(f={}));var b;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(b||(b={}));class v extends y.Disposable{constructor(h,d,m,A){super();this._onDidZlibFlush=this._register(new P.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new P.Emitter),this._onClose=this._register(new P.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=h,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=d,this._recordInflateBytes=A,d?(this._zlibInflate=u.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",_=>{console.error(_),(0,L.onUnexpectedError)(_),this._onClose.fire({type:0,hadError:!0,error:_})}),this._zlibInflate.on("data",_=>{this._pendingInflateData.push(_)}),m&&(this._zlibInflate.write(m.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=u.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",_=>{console.error(_),(0,L.onUnexpectedError)(_),this._onClose.fire({type:0,hadError:!0,error:_})}),this._zlibDeflate.on("data",_=>{this._pendingDeflateData.push(_)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new E.ChunkStream,this._register(this.socket.onData(_=>this._acceptChunk(_))),this._register(this.socket.onClose(_=>this._onClose.fire(_)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?T.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):T.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(h){return this._onData.event(h)}onClose(h){return this._onClose.event(h)}onEnd(h){return this.socket.onEnd(h)}write(h){this._totalOutgoingDataBytes+=h.byteLength,this._zlibDeflate?(this._zlibDeflate.write(h.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let d=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,d=d.slice(0,d.length-4),this._isEnded||this._write(T.VSBuffer.wrap(d),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(h,!1)}_write(h,d){let m=2;h.byteLength<126?m+=0:h.byteLength<2**16?m+=2:m+=8;const A=T.VSBuffer.alloc(m);if(d?A.writeUInt8(194,0):A.writeUInt8(130,0),h.byteLength<126)A.writeUInt8(h.byteLength,1);else if(h.byteLength<2**16){A.writeUInt8(126,1);let _=1;A.writeUInt8(h.byteLength>>>8&255,++_),A.writeUInt8(h.byteLength>>>0&255,++_)}else{A.writeUInt8(127,1);let _=1;A.writeUInt8(0,++_),A.writeUInt8(0,++_),A.writeUInt8(0,++_),A.writeUInt8(0,++_),A.writeUInt8(h.byteLength>>>24&255,++_),A.writeUInt8(h.byteLength>>>16&255,++_),A.writeUInt8(h.byteLength>>>8&255,++_),A.writeUInt8(h.byteLength>>>0&255,++_)}this._totalOutgoingWireBytes+=A.byteLength+h.byteLength,this.socket.write(T.VSBuffer.concat([A,h]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(h){if(h.byteLength!==0){for(this._totalIncomingWireBytes+=h.byteLength,this._incomingData.acceptChunk(h);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const d=this._incomingData.peek(this._state.readLen),m=d.readUInt8(0),A=(m&128)>>>7,_=(m&64)>>>6,w=d.readUInt8(1),O=(w&128)>>>7,U=w&127;this._state.state=2,this._state.readLen=2+(O?4:0)+(U===126?2:0)+(U===127?8:0),this._state.fin=A,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(_)),this._state.firstFrameOfMessage=Boolean(A),this._state.mask=0}else if(this._state.state===2){const d=this._incomingData.read(this._state.readLen),m=d.readUInt8(1),A=(m&128)>>>7;let _=m&127,w=1;_===126?_=d.readUInt8(++w)*2**8+d.readUInt8(++w):_===127&&(_=d.readUInt8(++w)*0+d.readUInt8(++w)*0+d.readUInt8(++w)*0+d.readUInt8(++w)*0+d.readUInt8(++w)*2**24+d.readUInt8(++w)*2**16+d.readUInt8(++w)*2**8+d.readUInt8(++w));let O=0;A&&(O=d.readUInt8(++w)*2**24+d.readUInt8(++w)*2**16+d.readUInt8(++w)*2**8+d.readUInt8(++w)),this._state.state=3,this._state.readLen=_,this._state.mask=O}else if(this._state.state===3){const d=this._incomingData.read(this._state.readLen);S(d,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(d.buffer)),this._zlibInflate.write(d.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const m=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=m.length,this._onData.fire(T.VSBuffer.wrap(m))})):(this._totalIncomingDataBytes+=d.byteLength,this._onData.fire(d))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await P.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=v;function S(l,h){if(h===0)return;let d=l.byteLength>>>2;for(let U=0;U<d;U++){const $=l.readUInt32BE(U*4);l.writeUInt32BE($^h,U*4)}let m=d*4,A=l.byteLength-m;const _=h>>>24&255,w=h>>>16&255,O=h>>>8&255;A>=1&&l.writeUInt8(l.readUInt8(m)^_,m),A>=2&&l.writeUInt8(l.readUInt8(m+1)^w,m+1),A>=3&&l.writeUInt8(l.readUInt8(m+2)^O,m+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function a(){const l=(0,C.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let h;return e.XDG_RUNTIME_DIR?h=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):h=(0,I.join)((0,D.tmpdir)(),`vscode-ipc-${l}.sock`),s(h),h}e.createRandomIPCHandle=a;function t(l,h,d){const m=(0,R.createHash)("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${m}-${d}-${h}-sock`;let A;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?A=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-${m.substr(0,8)}-${d}-${h}.sock`):A=(0,I.join)(l,`${d}-${h}.sock`),s(A),A}e.createStaticIPCHandle=t;function s(l){const h=c[i.platform];typeof h=="number"&&l.length>=h&&console.warn(`WARNING: IPC handle "${l}" is longer than ${h} chars, try a shorter --user-data-dir`)}class n extends g.IPCServer{constructor(h){super(n.toClientConnectionEvent(h));this.server=h}static toClientConnectionEvent(h){const d=P.Event.fromNodeEventEmitter(h,"connection");return P.Event.map(d,m=>({protocol:new E.Protocol(new p(m)),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(m,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=n;function r(l){return new Promise((h,d)=>{const m=(0,k.createServer)();m.on("error",d),m.listen(l,()=>{m.removeListener("error",d),h(new n(m))})})}e.serve=r;function o(l,h){return new Promise((d,m)=>{const A=(0,k.createConnection)(l,()=>{A.removeListener("error",m),d(E.Client.fromSocket(new p(A),h))});A.once("error",m)})}e.connect=o}),define(te[232],ne([0,1,56,231]),function(J,e,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,T,L,P){const y=i=>P(i,void 0),I=R.createConnection({host:D,port:T},()=>{I.removeListener("error",y);const i=Buffer.alloc(16);for(let u=0;u<16;u++)i[u]=Math.round(Math.random()*256);const C=i.toString("base64");let g=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${T}/?${L}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${C}`];I.write(g.join(`\r
`)+`\r
\r
`);const E=u=>{u.toString().indexOf(`\r
\r
`)>=0&&(I.off("data",E),P(void 0,new k.NodeSocket(I)))};I.on("data",E)});I.once("error",y)}}}),define(te[233],ne([0,1,56,107,232,6,2,22,10,29,184,61,87]),function(J,e,R,k,D,T,L,P,y,I,i,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function E(b,v,S,c,a){return new u(b,v,S,c,a).waitForReady()}class u extends L.Disposable{constructor(v,S,c,a,t){super();this.defaultTunnelHost=S,this.suggestedLocalPort=t,this.privacy=C.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=v,this._server=R.createServer(),this._barrier=new T.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=a,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(S=>{S()})}async waitForReady(){let v=await(0,k.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),S=null;return this._server.listen(v,this.defaultTunnelHost),await this._barrier.wait(),S=this._server.address(),S||(v=0,this._server.listen(v,this.defaultTunnelHost),await this._barrier.wait(),S=this._server.address()),this.tunnelLocalPort=S.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${S.port}`,this}async _onConnection(v){v.pause();const S=(0,C.isLocalhost)(this.tunnelRemoteHost)||(0,C.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,i.connectRemoteAgentTunnel)(this._options,S,this.tunnelRemotePort),a=c.getSocket().socket,t=c.readEntireBuffer();c.dispose(),t.byteLength>0&&v.write(t.buffer),v.on("end",()=>{this._socketsDispose.delete(v.localAddress),a.end()}),v.on("close",()=>a.end()),v.on("error",()=>{this._socketsDispose.delete(v.localAddress),a.destroy()}),a.on("end",()=>v.end()),a.on("close",()=>v.end()),a.on("error",()=>{v.destroy()}),v.pipe(a),a.pipe(v),this._socketsDispose.set(v.localAddress,()=>{v.end(),a.end()})}}let p=class extends C.AbstractTunnelService{constructor(v,S,c,a,t){super(S);this.socketFactory=v,this.signService=c,this.productService=a,this.configurationService=t}get defaultTunnelHost(){return this.configurationService.getValue("remote.localPortHost")==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(v,S,c,a,t,s,n){const r=this.getTunnelFromMap(S,c);if(r)return++r.refcount,r.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,S,c,a,t,s,n);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${S}:${c} on local port ${a}.`);const o={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:v,signService:this.signService,logService:this.logService,ipcLogger:null},l=E(o,this.defaultTunnelHost,S,c,a);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(S,c,l),l}}};p=he([Q(1,y.ILogService),Q(2,g.ISignService),Q(3,I.IProductService),Q(4,P.IConfigurationService)],p),e.BaseTunnelService=p;let f=class extends p{constructor(v,S,c,a){super(D.nodeSocketFactory,v,S,c,a)}};f=he([Q(0,y.ILogService),Q(1,g.ISignService),Q(2,I.IProductService),Q(3,P.IConfigurationService)],f),e.TunnelService=f}),define(te[240],ne([0,1,112,51,241,32,38,8,2,15,16,7,33,111,179,157,180,168,169,170,155,161,22,182,77,195,78,188,13,145,191,198,28,158,197,230,79,148,14,176,178,53,5,165,83,166,167,58,175,10,84,60,42,29,187,43,23,193,194,20,88,89,90,46,199,200,91,202,208,93,94,95,24,62,219,220,221,63,222,223,224,225,226,227,159,174,87,190,61,233,185,186]),function(J,e,R,k,D,T,L,P,y,I,i,C,g,E,u,p,f,b,v,S,c,a,t,s,n,r,o,l,h,d,m,A,_,w,O,U,$,Y,M,V,j,z,q,F,G,x,N,W,X,Z,B,H,ie,re,ae,ue,fe,ge,Ie,Pe,Ee,_e,De,Te,Fe,Ne,ze,xe,ee,oe,ce,ye,Se,Oe,ke,Ue,Ae,K,se,le,de,me,be,pe,we,Ce,Re,Le,nt,He,je,wt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Et extends y.Disposable{constructor(ve){super();this.configuration=ve,this.server=this._register(new E.Server),(0,D.gracefulify)(k),this.registerListeners()}registerListeners(){const ve=()=>this.dispose();process.once("exit",ve),R.ipcRenderer.once("vscode:electron-main->shared-process=exit",ve)}async open(){const ve=await this.initServices();(0,Se.registerConfiguration)(),ve.invokeFunction(Me=>{const qe=Me.get(Z.ILogService);qe.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Me),this.registerErrorHandler(qe)}),this._register((0,y.combinedDisposable)(ve.createInstance(u.CodeCacheCleaner,this.configuration.codeCachePath),ve.createInstance(f.LanguagePackCachedDataCleaner),ve.createInstance(S.StorageDataCleaner,this.configuration.backupWorkspacesPath),ve.createInstance(v.LogsDataCleaner),ve.createInstance(b.LocalizationsUpdater),ve.createInstance(p.DeprecatedExtensionsCleaner)))}async initServices(){const ve=new G.ServiceCollection,Me={_serviceBrand:void 0,...ie.default};ve.set(re.IProductService,Me);const qe=new g.StaticRouter(Ye=>Ye==="main"),Je=new x.MessagePortMainProcessService(this.server,qe);ve.set(N.IMainProcessService,Je);const $e=new d.NativeEnvironmentService(this.configuration.args,Me);ve.set(h.INativeEnvironmentService,$e);const it=new B.LogLevelChannelClient(this.server.getChannel("logLevel",qe)),Xe=new B.LoggerChannelClient(this.configuration.logLevel,it.onDidChangeLogLevel,Je.getChannel("logger"));ve.set(Z.ILoggerService,Xe);const at=this._register(new Z.MultiplexLogService([this._register(new Z.ConsoleLogger(this.configuration.logLevel)),this._register(Xe.createLogger((0,i.joinPath)(C.URI.file($e.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ge=this._register(new B.FollowerLogService(it,at));ve.set(Z.ILogService,Ge);const Qe=this._register(new V.FileService(Ge));ve.set(M.IFileService,Qe);const ot=this._register(new j.DiskFileSystemProvider(Ge));Qe.registerProvider(I.Schemas.file,ot);const Be=this._register(new s.ConfigurationService($e.settingsResource,Qe));ve.set(t.IConfigurationService,Be),await Be.initialize();const et=new ge.NativeStorageService(void 0,Je,$e);ve.set(fe.IStorageService,et),await et.initialize(),this._register((0,y.toDisposable)(()=>et.flush())),ve.set(ue.IRequestService,new z.SyncDescriptor(ae.RequestService)),ve.set(c.IChecksumService,new z.SyncDescriptor(a.ChecksumService));const rt=g.ProxyChannel.toService(Je.getChannel("nativeHost"),{context:this.configuration.windowId});ve.set(H.INativeHostService,rt),ve.set(o.IDownloadService,new z.SyncDescriptor(l.DownloadService));const ct=this._register(new pe.ActiveWindowManager(rt)),lt=new g.StaticRouter(Ye=>ct.getActiveClientId().then(ht=>Ye===ht));ve.set($.IExtensionRecommendationNotificationService,new Y.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",lt)));let Ke,st;const ut=[];if((0,Te.supportsTelemetry)(Me,$e)){st=new _e.TelemetryLogAppender(Xe,$e),ut.push(st);const{appRoot:Ye,extensionsPath:ht,installSourcePath:Ct}=$e;if(Me.aiConfig&&Me.aiConfig.asimovKey){const mt=new Fe.AppInsightsAppender("monacoworkbench",null,Me.aiConfig.asimovKey);this._register((0,y.toDisposable)(()=>mt.flush())),ut.push(mt)}Ke=new De.TelemetryService({appenders:ut,commonProperties:(0,Ie.resolveCommonProperties)(Qe,(0,T.release)(),(0,T.hostname)(),process.arch,Me.commit,Me.version,this.configuration.machineId,Me.msftInternalDomains,Ct),sendErrorTelemetry:!0,piiPaths:[Ye,ht]},Be)}else Ke=Te.NullTelemetryService,st=Te.NullAppender;this.server.registerChannel("telemetryAppender",new Ee.TelemetryAppenderChannel(st)),ve.set(Pe.ITelemetryService,Ke);const It=new Ne.CustomEndpointTelemetryService(Be,Ke,Xe,$e);return ve.set(Pe.ICustomEndpointTelemetryService,It),ve.set(_.IExtensionManagementService,new z.SyncDescriptor(U.ExtensionManagementService)),ve.set(_.IExtensionGalleryService,new z.SyncDescriptor(A.ExtensionGalleryService)),ve.set(_.IExtensionTipsService,new z.SyncDescriptor(O.ExtensionTipsService)),ve.set(W.ILocalizationsService,new z.SyncDescriptor(X.LocalizationsService)),ve.set(n.IDiagnosticsService,new z.SyncDescriptor(r.DiagnosticsService)),ve.set(Oe.IUserDataSyncAccountService,new z.SyncDescriptor(Oe.UserDataSyncAccountService)),ve.set(Se.IUserDataSyncLogService,new z.SyncDescriptor(Ae.UserDataSyncLogService)),ve.set(Se.IUserDataSyncUtilService,new Ue.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ye=>Ye.ctx!=="main"))),ve.set(_.IGlobalExtensionEnablementService,new z.SyncDescriptor(m.GlobalExtensionEnablementService)),ve.set(ce.IIgnoredExtensionsManagementService,new z.SyncDescriptor(ce.IgnoredExtensionsManagementService)),ve.set(oe.IExtensionsStorageSyncService,new z.SyncDescriptor(oe.ExtensionsStorageSyncService)),ve.set(Se.IUserDataSyncStoreManagementService,new z.SyncDescriptor(me.UserDataSyncStoreManagementService)),ve.set(Se.IUserDataSyncStoreService,new z.SyncDescriptor(me.UserDataSyncStoreService)),ve.set(K.IUserDataSyncMachinesService,new z.SyncDescriptor(K.UserDataSyncMachinesService)),ve.set(Se.IUserDataSyncBackupStoreService,new z.SyncDescriptor(ke.UserDataSyncBackupStoreService)),ve.set(Se.IUserDataAutoSyncEnablementService,new z.SyncDescriptor(ye.UserDataAutoSyncEnablementService)),ve.set(Se.IUserDataSyncResourceEnablementService,new z.SyncDescriptor(se.UserDataSyncResourceEnablementService)),ve.set(Se.IUserDataSyncService,new z.SyncDescriptor(le.UserDataSyncService)),ve.set(xe.ILocalPtyService,this._register(new ee.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Be.getValue("terminal.integrated.persistentSessionScrollback")??100},Be,$e,Ge,Ke))),ve.set(we.IExtensionHostStarter,this._register(new Ce.ExtensionHostStarter(Ge))),ve.set(Re.ISignService,new z.SyncDescriptor(Le.SignService)),ve.set(nt.ITunnelService,new z.SyncDescriptor(He.TunnelService)),ve.set(je.ISharedProcessTunnelService,new z.SyncDescriptor(wt.SharedProcessTunnelService)),new F.InstantiationService(ve)}initChannels(ve){const Me=new w.ExtensionManagementChannel(ve.get(_.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Me);const qe=g.ProxyChannel.fromService(ve.get(W.ILocalizationsService));this.server.registerChannel("localizations",qe);const Je=g.ProxyChannel.fromService(ve.get(n.IDiagnosticsService));this.server.registerChannel("diagnostics",Je);const $e=new w.ExtensionTipsChannel(ve.get(_.IExtensionTipsService));this.server.registerChannel("extensionTipsService",$e);const it=g.ProxyChannel.fromService(ve.get(c.IChecksumService));this.server.registerChannel("checksum",it);const Xe=new Ue.UserDataSyncMachinesServiceChannel(ve.get(K.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Xe);const at=g.ProxyChannel.fromService(ve.get(Pe.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",at);const Ge=new Ue.UserDataSyncAccountServiceChannel(ve.get(Oe.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ge);const Qe=new Ue.UserDataSyncStoreManagementServiceChannel(ve.get(Se.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Qe);const ot=new de.UserDataSyncChannel(ve.get(Se.IUserDataSyncService),ve.get(Z.ILogService));this.server.registerChannel("userDataSync",ot);const Be=this._register(ve.get(q.IInstantiationService).createInstance(be.UserDataAutoSyncService)),et=new Ue.UserDataAutoSyncChannel(Be);this.server.registerChannel("userDataAutoSync",et);const rt=ve.get(xe.ILocalPtyService),ct=g.ProxyChannel.fromService(rt);this.server.registerChannel(ze.TerminalIpcChannels.LocalPty,ct);const lt=g.ProxyChannel.fromService(ve.get(we.IExtensionHostStarter));this.server.registerChannel(we.ipcExtensionHostStarterChannelName,lt);const Ke=g.ProxyChannel.fromService(ve.get(je.ISharedProcessTunnelService));this.server.registerChannel(je.ipcSharedProcessTunnelChannelName,Ke)}registerErrorHandler(ve){window.addEventListener("unhandledrejection",Me=>{(0,P.onUnexpectedError)(Me.reason),Me.preventDefault()}),(0,P.setUnexpectedErrorHandler)(Me=>{const qe=(0,L.toErrorMessage)(Me,!0);!qe||ve.error(`[uncaught exception in sharedProcess]: ${qe}`)})}}async function bt(gt){const ve=new Et(gt);R.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ve.open(),R.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=bt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/5991e3c4b97eca5568069bf3e0910ab693ad3549/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
